/* AbstractPatternGenerator.c generated by valac 0.46.6, the Vala compiler
 * generated from AbstractPatternGenerator.vala, do not modify */

/* Handles working and solution data for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>

#define GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR (gnonograms_abstract_pattern_generator_get_type ())
#define GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGenerator))
#define GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGeneratorClass))
#define GNONOGRAMS_IS_ABSTRACT_PATTERN_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR))
#define GNONOGRAMS_IS_ABSTRACT_PATTERN_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR))
#define GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGeneratorClass))

typedef struct _GnonogramsAbstractPatternGenerator GnonogramsAbstractPatternGenerator;
typedef struct _GnonogramsAbstractPatternGeneratorClass GnonogramsAbstractPatternGeneratorClass;
typedef struct _GnonogramsAbstractPatternGeneratorPrivate GnonogramsAbstractPatternGeneratorPrivate;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
enum  {
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_0_PROPERTY,
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY,
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_ROWS_PROPERTY,
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_COLS_PROPERTY,
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY,
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_NUM_PROPERTIES
};
static GParamSpec* gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_NUM_PROPERTIES];
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))

struct _GnonogramsAbstractPatternGenerator {
	GObject parent_instance;
	GnonogramsAbstractPatternGeneratorPrivate * priv;
	GRand* rand_gen;
};

struct _GnonogramsAbstractPatternGeneratorClass {
	GObjectClass parent_class;
	GnonogramsMy2DCellArray* (*generate) (GnonogramsAbstractPatternGenerator* self);
	void (*harder) (GnonogramsAbstractPatternGenerator* self);
	void (*easier) (GnonogramsAbstractPatternGenerator* self);
	void (*set_parameters) (GnonogramsAbstractPatternGenerator* self);
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsAbstractPatternGeneratorPrivate {
	GnonogramsDimensions _dimensions;
	GnonogramsDifficulty _grade;
};

static gint GnonogramsAbstractPatternGenerator_private_offset;
static gpointer gnonograms_abstract_pattern_generator_parent_class = NULL;

GType gnonograms_abstract_pattern_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsAbstractPatternGenerator, g_object_unref)
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
GType gnonograms_dimensions_get_type (void) G_GNUC_CONST;
GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
void gnonograms_dimensions_free (GnonogramsDimensions* self);
GType gnonograms_difficulty_get_type (void) G_GNUC_CONST;
GnonogramsMy2DCellArray* gnonograms_abstract_pattern_generator_generate (GnonogramsAbstractPatternGenerator* self);
static GnonogramsMy2DCellArray* gnonograms_abstract_pattern_generator_real_generate (GnonogramsAbstractPatternGenerator* self);
void gnonograms_abstract_pattern_generator_harder (GnonogramsAbstractPatternGenerator* self);
static void gnonograms_abstract_pattern_generator_real_harder (GnonogramsAbstractPatternGenerator* self);
void gnonograms_abstract_pattern_generator_easier (GnonogramsAbstractPatternGenerator* self);
static void gnonograms_abstract_pattern_generator_real_easier (GnonogramsAbstractPatternGenerator* self);
void gnonograms_abstract_pattern_generator_set_parameters (GnonogramsAbstractPatternGenerator* self);
static void gnonograms_abstract_pattern_generator_real_set_parameters (GnonogramsAbstractPatternGenerator* self);
GnonogramsAbstractPatternGenerator* gnonograms_abstract_pattern_generator_construct (GType object_type);
void gnonograms_abstract_pattern_generator_get_dimensions (GnonogramsAbstractPatternGenerator* self,
                                                           GnonogramsDimensions * result);
void gnonograms_abstract_pattern_generator_set_dimensions (GnonogramsAbstractPatternGenerator* self,
                                                           GnonogramsDimensions * value);
guint gnonograms_abstract_pattern_generator_get_rows (GnonogramsAbstractPatternGenerator* self);
guint gnonograms_dimensions_rows (GnonogramsDimensions *self);
guint gnonograms_abstract_pattern_generator_get_cols (GnonogramsAbstractPatternGenerator* self);
guint gnonograms_dimensions_cols (GnonogramsDimensions *self);
GnonogramsDifficulty gnonograms_abstract_pattern_generator_get_grade (GnonogramsAbstractPatternGenerator* self);
void gnonograms_abstract_pattern_generator_set_grade (GnonogramsAbstractPatternGenerator* self,
                                                      GnonogramsDifficulty value);
static GObject * gnonograms_abstract_pattern_generator_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
static void gnonograms_abstract_pattern_generator_finalize (GObject * obj);
static void _vala_gnonograms_abstract_pattern_generator_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_gnonograms_abstract_pattern_generator_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);

static inline gpointer
gnonograms_abstract_pattern_generator_get_instance_private (GnonogramsAbstractPatternGenerator* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsAbstractPatternGenerator_private_offset);
}

static GnonogramsMy2DCellArray*
gnonograms_abstract_pattern_generator_real_generate (GnonogramsAbstractPatternGenerator* self)
{
	g_critical ("Type `%s' does not implement abstract method `gnonograms_abstract_pattern_generator_generate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GnonogramsMy2DCellArray*
gnonograms_abstract_pattern_generator_generate (GnonogramsAbstractPatternGenerator* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GET_CLASS (self)->generate (self);
}

static void
gnonograms_abstract_pattern_generator_real_harder (GnonogramsAbstractPatternGenerator* self)
{
}

void
gnonograms_abstract_pattern_generator_harder (GnonogramsAbstractPatternGenerator* self)
{
	g_return_if_fail (self != NULL);
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GET_CLASS (self)->harder (self);
}

static void
gnonograms_abstract_pattern_generator_real_easier (GnonogramsAbstractPatternGenerator* self)
{
}

void
gnonograms_abstract_pattern_generator_easier (GnonogramsAbstractPatternGenerator* self)
{
	g_return_if_fail (self != NULL);
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GET_CLASS (self)->easier (self);
}

static void
gnonograms_abstract_pattern_generator_real_set_parameters (GnonogramsAbstractPatternGenerator* self)
{
	g_critical ("Type `%s' does not implement abstract method `gnonograms_abstract_pattern_generator_set_parameters'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
gnonograms_abstract_pattern_generator_set_parameters (GnonogramsAbstractPatternGenerator* self)
{
	g_return_if_fail (self != NULL);
	GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GET_CLASS (self)->set_parameters (self);
}

GnonogramsAbstractPatternGenerator*
gnonograms_abstract_pattern_generator_construct (GType object_type)
{
	GnonogramsAbstractPatternGenerator * self = NULL;
	self = (GnonogramsAbstractPatternGenerator*) g_object_new (object_type, NULL);
	return self;
}

void
gnonograms_abstract_pattern_generator_get_dimensions (GnonogramsAbstractPatternGenerator* self,
                                                      GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

void
gnonograms_abstract_pattern_generator_set_dimensions (GnonogramsAbstractPatternGenerator* self,
                                                      GnonogramsDimensions * value)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->priv->_dimensions = _tmp0_;
	gnonograms_abstract_pattern_generator_set_parameters (self);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY]);
}

guint
gnonograms_abstract_pattern_generator_get_rows (GnonogramsAbstractPatternGenerator* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_abstract_pattern_generator_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = gnonograms_dimensions_rows (&_tmp1_);
	return result;
}

guint
gnonograms_abstract_pattern_generator_get_cols (GnonogramsAbstractPatternGenerator* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_abstract_pattern_generator_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = gnonograms_dimensions_cols (&_tmp1_);
	return result;
}

GnonogramsDifficulty
gnonograms_abstract_pattern_generator_get_grade (GnonogramsAbstractPatternGenerator* self)
{
	GnonogramsDifficulty result;
	GnonogramsDifficulty _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_grade;
	result = _tmp0_;
	return result;
}

void
gnonograms_abstract_pattern_generator_set_grade (GnonogramsAbstractPatternGenerator* self,
                                                 GnonogramsDifficulty value)
{
	g_return_if_fail (self != NULL);
	self->priv->_grade = value;
	gnonograms_abstract_pattern_generator_set_parameters (self);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY]);
}

static GObject *
gnonograms_abstract_pattern_generator_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsAbstractPatternGenerator * self;
	GRand* _tmp0_;
	parent_class = G_OBJECT_CLASS (gnonograms_abstract_pattern_generator_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGenerator);
	_tmp0_ = g_rand_new ();
	_g_rand_free0 (self->rand_gen);
	self->rand_gen = _tmp0_;
	return obj;
}

static void
gnonograms_abstract_pattern_generator_class_init (GnonogramsAbstractPatternGeneratorClass * klass,
                                                  gpointer klass_data)
{
	gnonograms_abstract_pattern_generator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsAbstractPatternGenerator_private_offset);
	((GnonogramsAbstractPatternGeneratorClass *) klass)->generate = (GnonogramsMy2DCellArray* (*) (GnonogramsAbstractPatternGenerator*)) gnonograms_abstract_pattern_generator_real_generate;
	((GnonogramsAbstractPatternGeneratorClass *) klass)->harder = (void (*) (GnonogramsAbstractPatternGenerator*)) gnonograms_abstract_pattern_generator_real_harder;
	((GnonogramsAbstractPatternGeneratorClass *) klass)->easier = (void (*) (GnonogramsAbstractPatternGenerator*)) gnonograms_abstract_pattern_generator_real_easier;
	((GnonogramsAbstractPatternGeneratorClass *) klass)->set_parameters = (void (*) (GnonogramsAbstractPatternGenerator*)) gnonograms_abstract_pattern_generator_real_set_parameters;
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_abstract_pattern_generator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_abstract_pattern_generator_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_abstract_pattern_generator_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_abstract_pattern_generator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_ROWS_PROPERTY, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_COLS_PROPERTY, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY, gnonograms_abstract_pattern_generator_properties[GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY] = g_param_spec_enum ("grade", "grade", "grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_abstract_pattern_generator_instance_init (GnonogramsAbstractPatternGenerator * self,
                                                     gpointer klass)
{
	GnonogramsDimensions _tmp0_ = {0};
	self->priv = gnonograms_abstract_pattern_generator_get_instance_private (self);
	memset (&_tmp0_, 0, sizeof (GnonogramsDimensions));
	_tmp0_.width = (guint) 0;
	_tmp0_.height = (guint) 0;
	self->priv->_dimensions = _tmp0_;
	self->priv->_grade = GNONOGRAMS_DIFFICULTY_EASY;
}

static void
gnonograms_abstract_pattern_generator_finalize (GObject * obj)
{
	GnonogramsAbstractPatternGenerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGenerator);
	_g_rand_free0 (self->rand_gen);
	G_OBJECT_CLASS (gnonograms_abstract_pattern_generator_parent_class)->finalize (obj);
}

GType
gnonograms_abstract_pattern_generator_get_type (void)
{
	static volatile gsize gnonograms_abstract_pattern_generator_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_abstract_pattern_generator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsAbstractPatternGeneratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_abstract_pattern_generator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsAbstractPatternGenerator), 0, (GInstanceInitFunc) gnonograms_abstract_pattern_generator_instance_init, NULL };
		GType gnonograms_abstract_pattern_generator_type_id;
		gnonograms_abstract_pattern_generator_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsAbstractPatternGenerator", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GnonogramsAbstractPatternGenerator_private_offset = g_type_add_instance_private (gnonograms_abstract_pattern_generator_type_id, sizeof (GnonogramsAbstractPatternGeneratorPrivate));
		g_once_init_leave (&gnonograms_abstract_pattern_generator_type_id__volatile, gnonograms_abstract_pattern_generator_type_id);
	}
	return gnonograms_abstract_pattern_generator_type_id__volatile;
}

static void
_vala_gnonograms_abstract_pattern_generator_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	GnonogramsAbstractPatternGenerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGenerator);
	switch (property_id) {
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_abstract_pattern_generator_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_abstract_pattern_generator_get_rows (self));
		break;
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_abstract_pattern_generator_get_cols (self));
		break;
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_abstract_pattern_generator_get_grade (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_abstract_pattern_generator_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	GnonogramsAbstractPatternGenerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_ABSTRACT_PATTERN_GENERATOR, GnonogramsAbstractPatternGenerator);
	switch (property_id) {
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_DIMENSIONS_PROPERTY:
		gnonograms_abstract_pattern_generator_set_dimensions (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_ABSTRACT_PATTERN_GENERATOR_GRADE_PROPERTY:
		gnonograms_abstract_pattern_generator_set_grade (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

