/* AbstractSolver.c generated by valac 0.46.6, the Vala compiler
 * generated from AbstractSolver.vala, do not modify */

/* Solver class for gnonograms
 * Finds solution for a set of clues.
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gio/gio.h>

#define GNONOGRAMS_TYPE_ABSTRACT_SOLVER (gnonograms_abstract_solver_get_type ())
#define GNONOGRAMS_ABSTRACT_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolver))
#define GNONOGRAMS_ABSTRACT_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolverClass))
#define GNONOGRAMS_IS_ABSTRACT_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER))
#define GNONOGRAMS_IS_ABSTRACT_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_ABSTRACT_SOLVER))
#define GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolverClass))

typedef struct _GnonogramsAbstractSolver GnonogramsAbstractSolver;
typedef struct _GnonogramsAbstractSolverClass GnonogramsAbstractSolverClass;
typedef struct _GnonogramsAbstractSolverPrivate GnonogramsAbstractSolverPrivate;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_TYPE_REGION (gnonograms_region_get_type ())
#define GNONOGRAMS_REGION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegion))
#define GNONOGRAMS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))
#define GNONOGRAMS_IS_REGION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_IS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_REGION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))

typedef struct _GnonogramsRegion GnonogramsRegion;
typedef struct _GnonogramsRegionClass GnonogramsRegionClass;

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())
enum  {
	GNONOGRAMS_ABSTRACT_SOLVER_0_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_N_REGIONS_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_CANCELLED_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_ROWS_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_COLS_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY,
	GNONOGRAMS_ABSTRACT_SOLVER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
#define _gnonograms_region_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_region_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsAbstractSolver {
	GObject parent_instance;
	GnonogramsAbstractSolverPrivate * priv;
	GnonogramsRegion** regions;
	gint regions_length1;
	gboolean should_check_solution;
	GnonogramsDimensions _dimensions;
};

struct _GnonogramsAbstractSolverClass {
	GObjectClass parent_class;
	gboolean (*initialize) (GnonogramsAbstractSolver* self, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* start_grid, GnonogramsMy2DCellArray* solution_grid);
	void (*reinitialize_regions) (GnonogramsAbstractSolver* self);
	gboolean (*valid) (GnonogramsAbstractSolver* self);
	gboolean (*solved) (GnonogramsAbstractSolver* self);
	gboolean (*differs_from_solution) (GnonogramsAbstractSolver* self, GnonogramsRegion* r);
	GeeArrayQueue* (*hint) (GnonogramsAbstractSolver* self, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* working);
	GeeArrayQueue* (*debug) (GnonogramsAbstractSolver* self, guint idx, gboolean is_column, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* working);
	GnonogramsDifficulty (*solve_it) (GnonogramsAbstractSolver* self);
	void (*configure_from_grade) (GnonogramsAbstractSolver* self, GnonogramsDifficulty grade);
};

struct _GnonogramsAbstractSolverPrivate {
	GnonogramsSolverState _state;
	GnonogramsMy2DCellArray* _grid;
	GnonogramsMy2DCellArray* _solution;
	GCancellable* _cancellable;
	gboolean _unique_only;
	gboolean _use_advanced;
	gboolean _advanced_only;
	gboolean _human_only;
};

static gint GnonogramsAbstractSolver_private_offset;
static gpointer gnonograms_abstract_solver_parent_class = NULL;

GType gnonograms_abstract_solver_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsAbstractSolver, g_object_unref)
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
gpointer gnonograms_region_ref (gpointer instance);
void gnonograms_region_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_region (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void gnonograms_value_set_region (GValue* value,
                                  gpointer v_object);
void gnonograms_value_take_region (GValue* value,
                                   gpointer v_object);
gpointer gnonograms_value_get_region (const GValue* value);
GType gnonograms_region_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRegion, gnonograms_region_unref)
gpointer gnonograms_move_ref (gpointer instance);
void gnonograms_move_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
gpointer gnonograms_value_get_move (const GValue* value);
GType gnonograms_move_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
GType gnonograms_difficulty_get_type (void) G_GNUC_CONST;
GType gnonograms_dimensions_get_type (void) G_GNUC_CONST;
GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
void gnonograms_dimensions_free (GnonogramsDimensions* self);
GType gnonograms_solver_state_get_type (void) G_GNUC_CONST;
#define GNONOGRAMS_ABSTRACT_SOLVER_MAX_PASSES ((guint) 200)
gboolean gnonograms_abstract_solver_initialize (GnonogramsAbstractSolver* self,
                                                gchar** row_clues,
                                                gint row_clues_length1,
                                                gchar** col_clues,
                                                gint col_clues_length1,
                                                GnonogramsMy2DCellArray* start_grid,
                                                GnonogramsMy2DCellArray* solution_grid);
static gboolean gnonograms_abstract_solver_real_initialize (GnonogramsAbstractSolver* self,
                                                     gchar** row_clues,
                                                     gint row_clues_length1,
                                                     gchar** col_clues,
                                                     gint col_clues_length1,
                                                     GnonogramsMy2DCellArray* start_grid,
                                                     GnonogramsMy2DCellArray* solution_grid);
guint gnonograms_abstract_solver_get_rows (GnonogramsAbstractSolver* self);
guint gnonograms_abstract_solver_get_cols (GnonogramsAbstractSolver* self);
GnonogramsMy2DCellArray* gnonograms_abstract_solver_get_solution (GnonogramsAbstractSolver* self);
void gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                      GnonogramsMy2DCellArray* ca);
GnonogramsMy2DCellArray* gnonograms_abstract_solver_get_grid (GnonogramsAbstractSolver* self);
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
void gnonograms_my2_dcell_array_set_all (GnonogramsMy2DCellArray* self,
                                         GnonogramsCellState s);
void gnonograms_region_initialize (GnonogramsRegion* self,
                                   guint index,
                                   gboolean is_column,
                                   guint n_cells,
                                   const gchar* clue);
void gnonograms_abstract_solver_set_state (GnonogramsAbstractSolver* self,
                                           GnonogramsSolverState value);
gboolean gnonograms_abstract_solver_valid (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_reinitialize_regions (GnonogramsAbstractSolver* self);
static void gnonograms_abstract_solver_real_reinitialize_regions (GnonogramsAbstractSolver* self);
void gnonograms_region_set_to_initial_state (GnonogramsRegion* self);
static gboolean gnonograms_abstract_solver_real_valid (GnonogramsAbstractSolver* self);
gboolean gnonograms_region_get_in_error (GnonogramsRegion* self);
gint gnonograms_region_get_block_total (GnonogramsRegion* self);
gboolean gnonograms_abstract_solver_solved (GnonogramsAbstractSolver* self);
static gboolean gnonograms_abstract_solver_real_solved (GnonogramsAbstractSolver* self);
gboolean gnonograms_region_get_is_completed (GnonogramsRegion* self);
gboolean gnonograms_abstract_solver_differs_from_solution (GnonogramsAbstractSolver* self,
                                                           GnonogramsRegion* r);
static gboolean gnonograms_abstract_solver_real_differs_from_solution (GnonogramsAbstractSolver* self,
                                                                GnonogramsRegion* r);
gboolean gnonograms_region_get_is_column (GnonogramsRegion* self);
guint gnonograms_region_get_index (GnonogramsRegion* self);
gint gnonograms_region_get_n_cells (GnonogramsRegion* self);
GnonogramsCellState gnonograms_region_get_cell_state (GnonogramsRegion* self,
                                                      guint index);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
GnonogramsDifficulty gnonograms_abstract_solver_solve_clues (GnonogramsAbstractSolver* self,
                                                             gchar** row_clues,
                                                             gint row_clues_length1,
                                                             gchar** col_clues,
                                                             gint col_clues_length1,
                                                             GnonogramsMy2DCellArray* start_grid,
                                                             GnonogramsMy2DCellArray* solution_grid);
GnonogramsDifficulty gnonograms_abstract_solver_solve_it (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_cancel (GnonogramsAbstractSolver* self);
GCancellable* gnonograms_abstract_solver_get_cancellable (GnonogramsAbstractSolver* self);
GeeArrayQueue* gnonograms_abstract_solver_hint (GnonogramsAbstractSolver* self,
                                                gchar** row_clues,
                                                gint row_clues_length1,
                                                gchar** col_clues,
                                                gint col_clues_length1,
                                                GnonogramsMy2DCellArray* working);
static GeeArrayQueue* gnonograms_abstract_solver_real_hint (GnonogramsAbstractSolver* self,
                                                     gchar** row_clues,
                                                     gint row_clues_length1,
                                                     gchar** col_clues,
                                                     gint col_clues_length1,
                                                     GnonogramsMy2DCellArray* working);
GeeArrayQueue* gnonograms_abstract_solver_debug (GnonogramsAbstractSolver* self,
                                                 guint idx,
                                                 gboolean is_column,
                                                 gchar** row_clues,
                                                 gint row_clues_length1,
                                                 gchar** col_clues,
                                                 gint col_clues_length1,
                                                 GnonogramsMy2DCellArray* working);
static GeeArrayQueue* gnonograms_abstract_solver_real_debug (GnonogramsAbstractSolver* self,
                                                      guint idx,
                                                      gboolean is_column,
                                                      gchar** row_clues,
                                                      gint row_clues_length1,
                                                      gchar** col_clues,
                                                      gint col_clues_length1,
                                                      GnonogramsMy2DCellArray* working);
static GnonogramsDifficulty gnonograms_abstract_solver_real_solve_it (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_configure_from_grade (GnonogramsAbstractSolver* self,
                                                      GnonogramsDifficulty grade);
static void gnonograms_abstract_solver_real_configure_from_grade (GnonogramsAbstractSolver* self,
                                                           GnonogramsDifficulty grade);
GnonogramsAbstractSolver* gnonograms_abstract_solver_construct (GType object_type);
guint gnonograms_abstract_solver_get_n_regions (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_get_dimensions (GnonogramsAbstractSolver* self,
                                                GnonogramsDimensions * result);
guint gnonograms_dimensions_length (GnonogramsDimensions *self);
GnonogramsSolverState gnonograms_abstract_solver_get_state (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_set_grid (GnonogramsAbstractSolver* self,
                                          GnonogramsMy2DCellArray* value);
void gnonograms_abstract_solver_set_solution (GnonogramsAbstractSolver* self,
                                              GnonogramsMy2DCellArray* value);
void gnonograms_abstract_solver_set_cancellable (GnonogramsAbstractSolver* self,
                                                 GCancellable* value);
gboolean gnonograms_abstract_solver_get_cancelled (GnonogramsAbstractSolver* self);
gboolean gnonograms_abstract_solver_get_unique_only (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_set_unique_only (GnonogramsAbstractSolver* self,
                                                 gboolean value);
gboolean gnonograms_abstract_solver_get_use_advanced (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_set_use_advanced (GnonogramsAbstractSolver* self,
                                                  gboolean value);
gboolean gnonograms_abstract_solver_get_advanced_only (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_set_advanced_only (GnonogramsAbstractSolver* self,
                                                   gboolean value);
gboolean gnonograms_abstract_solver_get_human_only (GnonogramsAbstractSolver* self);
void gnonograms_abstract_solver_set_human_only (GnonogramsAbstractSolver* self,
                                                gboolean value);
void gnonograms_abstract_solver_set_dimensions (GnonogramsAbstractSolver* self,
                                                GnonogramsDimensions * value);
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_new (GnonogramsDimensions* _dimensions,
                                                         GnonogramsCellState init);
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_construct (GType object_type,
                                                               GnonogramsDimensions* _dimensions,
                                                               GnonogramsCellState init);
GnonogramsRegion* gnonograms_region_new (GnonogramsMy2DCellArray* grid);
GnonogramsRegion* gnonograms_region_construct (GType object_type,
                                               GnonogramsMy2DCellArray* grid);
static void gnonograms_abstract_solver_finalize (GObject * obj);
static void _vala_gnonograms_abstract_solver_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_gnonograms_abstract_solver_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gnonograms_abstract_solver_get_instance_private (GnonogramsAbstractSolver* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsAbstractSolver_private_offset);
}

/** Set up solver for a particular puzzle. In addition to the clues, a starting point
      * and/or the correct solution may be provided (useful for debugging).
    **/
static gboolean
gnonograms_abstract_solver_real_initialize (GnonogramsAbstractSolver* self,
                                            gchar** row_clues,
                                            gint row_clues_length1,
                                            gchar** col_clues,
                                            gint col_clues_length1,
                                            GnonogramsMy2DCellArray* start_grid,
                                            GnonogramsMy2DCellArray* solution_grid)
{
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	guint _tmp2_;
	gint index = 0;
	gboolean result = FALSE;
	_tmp1_ = gnonograms_abstract_solver_get_rows (self);
	_tmp2_ = _tmp1_;
	if (((guint) row_clues_length1) == _tmp2_) {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_abstract_solver_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = ((guint) col_clues_length1) == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "row_clues.length == rows && col_clues.length == cols");
	self->should_check_solution = solution_grid != NULL;
	if (self->should_check_solution) {
		GnonogramsMy2DCellArray* _tmp5_;
		_tmp5_ = self->priv->_solution;
		gnonograms_my2_dcell_array_copy (_tmp5_, solution_grid);
	}
	if (start_grid != NULL) {
		GnonogramsMy2DCellArray* _tmp6_;
		_tmp6_ = self->priv->_grid;
		gnonograms_my2_dcell_array_copy (_tmp6_, start_grid);
	} else {
		GnonogramsMy2DCellArray* _tmp7_;
		_tmp7_ = self->priv->_grid;
		gnonograms_my2_dcell_array_set_all (_tmp7_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	}
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				guint _tmp10_;
				guint _tmp11_;
				GnonogramsRegion** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				GnonogramsRegion* _tmp14_;
				guint _tmp15_;
				guint _tmp16_;
				const gchar* _tmp17_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = r;
					r = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = gnonograms_abstract_solver_get_rows (self);
				_tmp11_ = _tmp10_;
				if (!(((guint) r) < _tmp11_)) {
					break;
				}
				_tmp12_ = self->regions;
				_tmp12__length1 = self->regions_length1;
				_tmp13_ = index;
				index = _tmp13_ + 1;
				_tmp14_ = _tmp12_[_tmp13_];
				_tmp15_ = gnonograms_abstract_solver_get_cols (self);
				_tmp16_ = _tmp15_;
				_tmp17_ = row_clues[r];
				gnonograms_region_initialize (_tmp14_, (guint) r, FALSE, _tmp16_, _tmp17_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				guint _tmp20_;
				guint _tmp21_;
				GnonogramsRegion** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				GnonogramsRegion* _tmp24_;
				guint _tmp25_;
				guint _tmp26_;
				const gchar* _tmp27_;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = c;
					c = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				_tmp20_ = gnonograms_abstract_solver_get_cols (self);
				_tmp21_ = _tmp20_;
				if (!(((guint) c) < _tmp21_)) {
					break;
				}
				_tmp22_ = self->regions;
				_tmp22__length1 = self->regions_length1;
				_tmp23_ = index;
				index = _tmp23_ + 1;
				_tmp24_ = _tmp22_[_tmp23_];
				_tmp25_ = gnonograms_abstract_solver_get_rows (self);
				_tmp26_ = _tmp25_;
				_tmp27_ = col_clues[c];
				gnonograms_region_initialize (_tmp24_, (guint) c, TRUE, _tmp26_, _tmp27_);
			}
		}
	}
	gnonograms_abstract_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
	result = gnonograms_abstract_solver_valid (self);
	return result;
}

gboolean
gnonograms_abstract_solver_initialize (GnonogramsAbstractSolver* self,
                                       gchar** row_clues,
                                       gint row_clues_length1,
                                       gchar** col_clues,
                                       gint col_clues_length1,
                                       GnonogramsMy2DCellArray* start_grid,
                                       GnonogramsMy2DCellArray* solution_grid)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->initialize (self, row_clues, row_clues_length1, col_clues, col_clues_length1, start_grid, solution_grid);
}

static void
gnonograms_abstract_solver_real_reinitialize_regions (GnonogramsAbstractSolver* self)
{
	gint index = 0;
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				GnonogramsRegion** _tmp4_;
				gint _tmp4__length1;
				gint _tmp5_;
				GnonogramsRegion* _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_abstract_solver_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->regions;
				_tmp4__length1 = self->regions_length1;
				_tmp5_ = index;
				index = _tmp5_ + 1;
				_tmp6_ = _tmp4_[_tmp5_];
				gnonograms_region_set_to_initial_state (_tmp6_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				guint _tmp9_;
				guint _tmp10_;
				GnonogramsRegion** _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				GnonogramsRegion* _tmp13_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = c;
					c = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = gnonograms_abstract_solver_get_cols (self);
				_tmp10_ = _tmp9_;
				if (!(((guint) c) < _tmp10_)) {
					break;
				}
				_tmp11_ = self->regions;
				_tmp11__length1 = self->regions_length1;
				_tmp12_ = index;
				index = _tmp12_ + 1;
				_tmp13_ = _tmp11_[_tmp12_];
				gnonograms_region_set_to_initial_state (_tmp13_);
			}
		}
	}
}

void
gnonograms_abstract_solver_reinitialize_regions (GnonogramsAbstractSolver* self)
{
	g_return_if_fail (self != NULL);
	GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->reinitialize_regions (self);
}

static gpointer
_gnonograms_region_ref0 (gpointer self)
{
	return self ? gnonograms_region_ref (self) : NULL;
}

static gboolean
gnonograms_abstract_solver_real_valid (GnonogramsAbstractSolver* self)
{
	GnonogramsRegion** _tmp0_;
	gint _tmp0__length1;
	gint row_total = 0;
	gint col_total = 0;
	gboolean result = FALSE;
	_tmp0_ = self->regions;
	_tmp0__length1 = self->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp0_;
		r_collection_length1 = _tmp0__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp1_;
			GnonogramsRegion* r = NULL;
			_tmp1_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp1_;
			{
				GnonogramsRegion* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp2_ = r;
				_tmp3_ = gnonograms_region_get_in_error (_tmp2_);
				_tmp4_ = _tmp3_;
				if (_tmp4_) {
					result = FALSE;
					_gnonograms_region_unref0 (r);
					return result;
				}
				_gnonograms_region_unref0 (r);
			}
		}
	}
	row_total = 0;
	col_total = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				guint _tmp7_;
				guint _tmp8_;
				GnonogramsRegion** _tmp9_;
				gint _tmp9__length1;
				GnonogramsRegion* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = r;
					r = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = gnonograms_abstract_solver_get_rows (self);
				_tmp8_ = _tmp7_;
				if (!(((guint) r) < _tmp8_)) {
					break;
				}
				_tmp9_ = self->regions;
				_tmp9__length1 = self->regions_length1;
				_tmp10_ = _tmp9_[r];
				_tmp11_ = gnonograms_region_get_block_total (_tmp10_);
				_tmp12_ = _tmp11_;
				row_total += _tmp12_;
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				guint _tmp15_;
				guint _tmp16_;
				GnonogramsRegion** _tmp17_;
				gint _tmp17__length1;
				guint _tmp18_;
				guint _tmp19_;
				GnonogramsRegion* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = c;
					c = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp15_ = gnonograms_abstract_solver_get_cols (self);
				_tmp16_ = _tmp15_;
				if (!(((guint) c) < _tmp16_)) {
					break;
				}
				_tmp17_ = self->regions;
				_tmp17__length1 = self->regions_length1;
				_tmp18_ = gnonograms_abstract_solver_get_rows (self);
				_tmp19_ = _tmp18_;
				_tmp20_ = _tmp17_[_tmp19_ + c];
				_tmp21_ = gnonograms_region_get_block_total (_tmp20_);
				_tmp22_ = _tmp21_;
				col_total += _tmp22_;
			}
		}
	}
	result = row_total == col_total;
	return result;
}

gboolean
gnonograms_abstract_solver_valid (GnonogramsAbstractSolver* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->valid (self);
}

static gboolean
gnonograms_abstract_solver_real_solved (GnonogramsAbstractSolver* self)
{
	GnonogramsRegion** _tmp0_;
	gint _tmp0__length1;
	gboolean result = FALSE;
	_tmp0_ = self->regions;
	_tmp0__length1 = self->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp0_;
		r_collection_length1 = _tmp0__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp1_;
			GnonogramsRegion* r = NULL;
			_tmp1_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp1_;
			{
				GnonogramsRegion* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp2_ = r;
				_tmp3_ = gnonograms_region_get_is_completed (_tmp2_);
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					result = FALSE;
					_gnonograms_region_unref0 (r);
					return result;
				}
				_gnonograms_region_unref0 (r);
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
gnonograms_abstract_solver_solved (GnonogramsAbstractSolver* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->solved (self);
}

static gboolean
gnonograms_abstract_solver_real_differs_from_solution (GnonogramsAbstractSolver* self,
                                                       GnonogramsRegion* r)
{
	gboolean is_column = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	guint index = 0U;
	guint _tmp2_;
	guint _tmp3_;
	gint n_cells = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint solution_state = 0;
	gint region_state = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (r != NULL, FALSE);
	_tmp0_ = gnonograms_region_get_is_column (r);
	_tmp1_ = _tmp0_;
	is_column = _tmp1_;
	_tmp2_ = gnonograms_region_get_index (r);
	_tmp3_ = _tmp2_;
	index = _tmp3_;
	_tmp4_ = gnonograms_region_get_n_cells (r);
	_tmp5_ = _tmp4_;
	n_cells = _tmp5_;
	{
		guint i = 0U;
		i = (guint) 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				guint _tmp8_ = 0U;
				guint _tmp9_ = 0U;
				GnonogramsMy2DCellArray* _tmp10_;
				if (!_tmp6_) {
					guint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				if (!(i < ((guint) n_cells))) {
					break;
				}
				region_state = (gint) gnonograms_region_get_cell_state (r, i);
				if (region_state == ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)) {
					continue;
				}
				if (is_column) {
					_tmp8_ = i;
				} else {
					_tmp8_ = index;
				}
				if (is_column) {
					_tmp9_ = index;
				} else {
					_tmp9_ = i;
				}
				_tmp10_ = self->priv->_solution;
				solution_state = (gint) gnonograms_my2_dcell_array_get_data_from_rc (_tmp10_, _tmp8_, _tmp9_);
				if (solution_state == ((gint) GNONOGRAMS_CELL_STATE_EMPTY)) {
					if (region_state == ((gint) GNONOGRAMS_CELL_STATE_EMPTY)) {
						continue;
					}
				} else {
					if (region_state != ((gint) GNONOGRAMS_CELL_STATE_EMPTY)) {
						continue;
					}
				}
				result = TRUE;
				return result;
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
gnonograms_abstract_solver_differs_from_solution (GnonogramsAbstractSolver* self,
                                                  GnonogramsRegion* r)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->differs_from_solution (self, r);
}

/** Initiate solving, specifying whether or not to use the advanced
      * procedures. Also specify whether in debugging mode and whether to solve one step
      * at a time (used for hinting if implemented).
    **/
GnonogramsDifficulty
gnonograms_abstract_solver_solve_clues (GnonogramsAbstractSolver* self,
                                        gchar** row_clues,
                                        gint row_clues_length1,
                                        gchar** col_clues,
                                        gint col_clues_length1,
                                        GnonogramsMy2DCellArray* start_grid,
                                        GnonogramsMy2DCellArray* solution_grid)
{
	GnonogramsDifficulty result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (gnonograms_abstract_solver_initialize (self, row_clues, (gint) row_clues_length1, col_clues, (gint) col_clues_length1, start_grid, solution_grid)) {
		result = gnonograms_abstract_solver_solve_it (self);
		return result;
	} else {
		gnonograms_abstract_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_ERROR);
		result = GNONOGRAMS_DIFFICULTY_UNDEFINED;
		return result;
	}
}

void
gnonograms_abstract_solver_cancel (GnonogramsAbstractSolver* self)
{
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_cancellable;
	g_cancellable_cancel (_tmp0_);
}

static GeeArrayQueue*
gnonograms_abstract_solver_real_hint (GnonogramsAbstractSolver* self,
                                      gchar** row_clues,
                                      gint row_clues_length1,
                                      gchar** col_clues,
                                      gint col_clues_length1,
                                      GnonogramsMy2DCellArray* working)
{
	GeeArrayQueue* _tmp0_;
	GeeArrayQueue* result = NULL;
	g_return_val_if_fail (working != NULL, NULL);
	_tmp0_ = gee_array_queue_new (GNONOGRAMS_TYPE_MOVE, (GBoxedCopyFunc) gnonograms_move_ref, (GDestroyNotify) gnonograms_move_unref, NULL, NULL, NULL);
	result = _tmp0_;
	return result;
}

GeeArrayQueue*
gnonograms_abstract_solver_hint (GnonogramsAbstractSolver* self,
                                 gchar** row_clues,
                                 gint row_clues_length1,
                                 gchar** col_clues,
                                 gint col_clues_length1,
                                 GnonogramsMy2DCellArray* working)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->hint (self, row_clues, row_clues_length1, col_clues, col_clues_length1, working);
}

static GeeArrayQueue*
gnonograms_abstract_solver_real_debug (GnonogramsAbstractSolver* self,
                                       guint idx,
                                       gboolean is_column,
                                       gchar** row_clues,
                                       gint row_clues_length1,
                                       gchar** col_clues,
                                       gint col_clues_length1,
                                       GnonogramsMy2DCellArray* working)
{
	GeeArrayQueue* _tmp0_;
	GeeArrayQueue* result = NULL;
	g_return_val_if_fail (working != NULL, NULL);
	_tmp0_ = gee_array_queue_new (GNONOGRAMS_TYPE_MOVE, (GBoxedCopyFunc) gnonograms_move_ref, (GDestroyNotify) gnonograms_move_unref, NULL, NULL, NULL);
	result = _tmp0_;
	return result;
}

GeeArrayQueue*
gnonograms_abstract_solver_debug (GnonogramsAbstractSolver* self,
                                  guint idx,
                                  gboolean is_column,
                                  gchar** row_clues,
                                  gint row_clues_length1,
                                  gchar** col_clues,
                                  gint col_clues_length1,
                                  GnonogramsMy2DCellArray* working)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->debug (self, idx, is_column, row_clues, row_clues_length1, col_clues, col_clues_length1, working);
}

static GnonogramsDifficulty
gnonograms_abstract_solver_real_solve_it (GnonogramsAbstractSolver* self)
{
	g_critical ("Type `%s' does not implement abstract method `gnonograms_abstract_solver_solve_it'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}

GnonogramsDifficulty
gnonograms_abstract_solver_solve_it (GnonogramsAbstractSolver* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->solve_it (self);
}

static void
gnonograms_abstract_solver_real_configure_from_grade (GnonogramsAbstractSolver* self,
                                                      GnonogramsDifficulty grade)
{
	g_critical ("Type `%s' does not implement abstract method `gnonograms_abstract_solver_configure_from_grade'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
gnonograms_abstract_solver_configure_from_grade (GnonogramsAbstractSolver* self,
                                                 GnonogramsDifficulty grade)
{
	g_return_if_fail (self != NULL);
	GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS (self)->configure_from_grade (self, grade);
}

GnonogramsAbstractSolver*
gnonograms_abstract_solver_construct (GType object_type)
{
	GnonogramsAbstractSolver * self = NULL;
	self = (GnonogramsAbstractSolver*) g_object_new (object_type, NULL);
	return self;
}

guint
gnonograms_abstract_solver_get_n_regions (GnonogramsAbstractSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_abstract_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = gnonograms_dimensions_length (&_tmp1_);
	return result;
}

GnonogramsSolverState
gnonograms_abstract_solver_get_state (GnonogramsAbstractSolver* self)
{
	GnonogramsSolverState result;
	GnonogramsSolverState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

void
gnonograms_abstract_solver_set_state (GnonogramsAbstractSolver* self,
                                      GnonogramsSolverState value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_abstract_solver_get_grid (GnonogramsAbstractSolver* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_abstract_solver_set_grid (GnonogramsAbstractSolver* self,
                                     GnonogramsMy2DCellArray* value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_grid (self) != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_grid);
		self->priv->_grid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_abstract_solver_get_solution (GnonogramsAbstractSolver* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_solution;
	result = _tmp0_;
	return result;
}

void
gnonograms_abstract_solver_set_solution (GnonogramsAbstractSolver* self,
                                         GnonogramsMy2DCellArray* value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_solution (self) != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_solution);
		self->priv->_solution = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY]);
	}
}

GCancellable*
gnonograms_abstract_solver_get_cancellable (GnonogramsAbstractSolver* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cancellable;
	result = _tmp0_;
	return result;
}

void
gnonograms_abstract_solver_set_cancellable (GnonogramsAbstractSolver* self,
                                            GCancellable* value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_cancellable (self) != value) {
		GCancellable* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_cancellable);
		self->priv->_cancellable = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY]);
	}
}

gboolean
gnonograms_abstract_solver_get_cancelled (GnonogramsAbstractSolver* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_cancellable;
	if (_tmp1_ != NULL) {
		GCancellable* _tmp2_;
		_tmp2_ = self->priv->_cancellable;
		_tmp0_ = g_cancellable_is_cancelled (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gboolean
gnonograms_abstract_solver_get_unique_only (GnonogramsAbstractSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_unique_only;
	return result;
}

void
gnonograms_abstract_solver_set_unique_only (GnonogramsAbstractSolver* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_unique_only (self) != value) {
		self->priv->_unique_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY]);
	}
}

gboolean
gnonograms_abstract_solver_get_use_advanced (GnonogramsAbstractSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_use_advanced;
	return result;
}

void
gnonograms_abstract_solver_set_use_advanced (GnonogramsAbstractSolver* self,
                                             gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_use_advanced (self) != value) {
		self->priv->_use_advanced = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY]);
	}
}

gboolean
gnonograms_abstract_solver_get_advanced_only (GnonogramsAbstractSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_advanced_only;
	return result;
}

void
gnonograms_abstract_solver_set_advanced_only (GnonogramsAbstractSolver* self,
                                              gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_advanced_only (self) != value) {
		self->priv->_advanced_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY]);
	}
}

gboolean
gnonograms_abstract_solver_get_human_only (GnonogramsAbstractSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_human_only;
	return result;
}

void
gnonograms_abstract_solver_set_human_only (GnonogramsAbstractSolver* self,
                                           gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_abstract_solver_get_human_only (self) != value) {
		self->priv->_human_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY]);
	}
}

guint
gnonograms_abstract_solver_get_rows (GnonogramsAbstractSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_abstract_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.height;
	return result;
}

guint
gnonograms_abstract_solver_get_cols (GnonogramsAbstractSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_abstract_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.width;
	return result;
}

void
gnonograms_abstract_solver_get_dimensions (GnonogramsAbstractSolver* self,
                                           GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->_dimensions;
	*result = _tmp0_;
	return;
}

void
gnonograms_abstract_solver_set_dimensions (GnonogramsAbstractSolver* self,
                                           GnonogramsDimensions * value)
{
	GnonogramsDimensions _tmp0_;
	GnonogramsDimensions _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsMy2DCellArray* _tmp3_;
	GnonogramsDimensions _tmp4_;
	GnonogramsMy2DCellArray* _tmp5_;
	GnonogramsMy2DCellArray* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	GnonogramsRegion** _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->_dimensions = _tmp0_;
	_tmp1_ = self->_dimensions;
	_tmp2_ = gnonograms_my2_dcell_array_new (&_tmp1_, GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp3_ = _tmp2_;
	gnonograms_abstract_solver_set_grid (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->_dimensions;
	_tmp5_ = gnonograms_my2_dcell_array_new (&_tmp4_, GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp6_ = _tmp5_;
	gnonograms_abstract_solver_set_solution (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = gnonograms_abstract_solver_get_n_regions (self);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_new0 (GnonogramsRegion*, _tmp8_ + 1);
	self->regions = (_vala_array_free (self->regions, self->regions_length1, (GDestroyNotify) gnonograms_region_unref), NULL);
	self->regions = _tmp9_;
	self->regions_length1 = _tmp8_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				guint _tmp12_;
				guint _tmp13_;
				GnonogramsRegion** _tmp14_;
				gint _tmp14__length1;
				GnonogramsMy2DCellArray* _tmp15_;
				GnonogramsRegion* _tmp16_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = i;
					i = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				_tmp12_ = gnonograms_abstract_solver_get_n_regions (self);
				_tmp13_ = _tmp12_;
				if (!(((guint) i) < _tmp13_)) {
					break;
				}
				_tmp14_ = self->regions;
				_tmp14__length1 = self->regions_length1;
				_tmp15_ = self->priv->_grid;
				_tmp16_ = gnonograms_region_new (_tmp15_);
				_gnonograms_region_unref0 (_tmp14_[i]);
				_tmp14_[i] = _tmp16_;
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY]);
}

static void
gnonograms_abstract_solver_class_init (GnonogramsAbstractSolverClass * klass,
                                       gpointer klass_data)
{
	gnonograms_abstract_solver_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsAbstractSolver_private_offset);
	((GnonogramsAbstractSolverClass *) klass)->initialize = (gboolean (*) (GnonogramsAbstractSolver*, gchar**, gint, gchar**, gint, GnonogramsMy2DCellArray*, GnonogramsMy2DCellArray*)) gnonograms_abstract_solver_real_initialize;
	((GnonogramsAbstractSolverClass *) klass)->reinitialize_regions = (void (*) (GnonogramsAbstractSolver*)) gnonograms_abstract_solver_real_reinitialize_regions;
	((GnonogramsAbstractSolverClass *) klass)->valid = (gboolean (*) (GnonogramsAbstractSolver*)) gnonograms_abstract_solver_real_valid;
	((GnonogramsAbstractSolverClass *) klass)->solved = (gboolean (*) (GnonogramsAbstractSolver*)) gnonograms_abstract_solver_real_solved;
	((GnonogramsAbstractSolverClass *) klass)->differs_from_solution = (gboolean (*) (GnonogramsAbstractSolver*, GnonogramsRegion*)) gnonograms_abstract_solver_real_differs_from_solution;
	((GnonogramsAbstractSolverClass *) klass)->hint = (GeeArrayQueue* (*) (GnonogramsAbstractSolver*, gchar**, gint, gchar**, gint, GnonogramsMy2DCellArray*)) gnonograms_abstract_solver_real_hint;
	((GnonogramsAbstractSolverClass *) klass)->debug = (GeeArrayQueue* (*) (GnonogramsAbstractSolver*, guint, gboolean, gchar**, gint, gchar**, gint, GnonogramsMy2DCellArray*)) gnonograms_abstract_solver_real_debug;
	((GnonogramsAbstractSolverClass *) klass)->solve_it = (GnonogramsDifficulty (*) (GnonogramsAbstractSolver*)) gnonograms_abstract_solver_real_solve_it;
	((GnonogramsAbstractSolverClass *) klass)->configure_from_grade = (void (*) (GnonogramsAbstractSolver*, GnonogramsDifficulty)) gnonograms_abstract_solver_real_configure_from_grade;
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_abstract_solver_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_abstract_solver_set_property;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_abstract_solver_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_N_REGIONS_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_N_REGIONS_PROPERTY] = g_param_spec_uint ("n-regions", "n-regions", "n-regions", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", GNONOGRAMS_TYPE_SOLVER_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY] = g_param_spec_object ("grid", "grid", "grid", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY] = g_param_spec_object ("solution", "solution", "solution", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_CANCELLED_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY] = g_param_spec_boolean ("unique-only", "unique-only", "unique-only", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY] = g_param_spec_boolean ("use-advanced", "use-advanced", "use-advanced", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY] = g_param_spec_boolean ("advanced-only", "advanced-only", "advanced-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY] = g_param_spec_boolean ("human-only", "human-only", "human-only", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_ROWS_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_COLS_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY, gnonograms_abstract_solver_properties[GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_abstract_solver_instance_init (GnonogramsAbstractSolver * self,
                                          gpointer klass)
{
	self->priv = gnonograms_abstract_solver_get_instance_private (self);
	self->priv->_unique_only = TRUE;
	self->priv->_use_advanced = FALSE;
	self->priv->_advanced_only = FALSE;
	self->priv->_human_only = TRUE;
}

static void
gnonograms_abstract_solver_finalize (GObject * obj)
{
	GnonogramsAbstractSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolver);
	self->regions = (_vala_array_free (self->regions, self->regions_length1, (GDestroyNotify) gnonograms_region_unref), NULL);
	_g_object_unref0 (self->priv->_grid);
	_g_object_unref0 (self->priv->_solution);
	_g_object_unref0 (self->priv->_cancellable);
	G_OBJECT_CLASS (gnonograms_abstract_solver_parent_class)->finalize (obj);
}

GType
gnonograms_abstract_solver_get_type (void)
{
	static volatile gsize gnonograms_abstract_solver_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_abstract_solver_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsAbstractSolverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_abstract_solver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsAbstractSolver), 0, (GInstanceInitFunc) gnonograms_abstract_solver_instance_init, NULL };
		GType gnonograms_abstract_solver_type_id;
		gnonograms_abstract_solver_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsAbstractSolver", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GnonogramsAbstractSolver_private_offset = g_type_add_instance_private (gnonograms_abstract_solver_type_id, sizeof (GnonogramsAbstractSolverPrivate));
		g_once_init_leave (&gnonograms_abstract_solver_type_id__volatile, gnonograms_abstract_solver_type_id);
	}
	return gnonograms_abstract_solver_type_id__volatile;
}

static void
_vala_gnonograms_abstract_solver_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	GnonogramsAbstractSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolver);
	switch (property_id) {
		case GNONOGRAMS_ABSTRACT_SOLVER_N_REGIONS_PROPERTY:
		g_value_set_uint (value, gnonograms_abstract_solver_get_n_regions (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_abstract_solver_get_state (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY:
		g_value_set_object (value, gnonograms_abstract_solver_get_grid (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY:
		g_value_set_object (value, gnonograms_abstract_solver_get_solution (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY:
		g_value_set_object (value, gnonograms_abstract_solver_get_cancellable (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_CANCELLED_PROPERTY:
		g_value_set_boolean (value, gnonograms_abstract_solver_get_cancelled (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_abstract_solver_get_unique_only (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY:
		g_value_set_boolean (value, gnonograms_abstract_solver_get_use_advanced (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_abstract_solver_get_advanced_only (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_abstract_solver_get_human_only (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_abstract_solver_get_rows (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_abstract_solver_get_cols (self));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_abstract_solver_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_abstract_solver_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	GnonogramsAbstractSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolver);
	switch (property_id) {
		case GNONOGRAMS_ABSTRACT_SOLVER_STATE_PROPERTY:
		gnonograms_abstract_solver_set_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_GRID_PROPERTY:
		gnonograms_abstract_solver_set_grid (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_SOLUTION_PROPERTY:
		gnonograms_abstract_solver_set_solution (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_CANCELLABLE_PROPERTY:
		gnonograms_abstract_solver_set_cancellable (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_UNIQUE_ONLY_PROPERTY:
		gnonograms_abstract_solver_set_unique_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_USE_ADVANCED_PROPERTY:
		gnonograms_abstract_solver_set_use_advanced (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_ADVANCED_ONLY_PROPERTY:
		gnonograms_abstract_solver_set_advanced_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_HUMAN_ONLY_PROPERTY:
		gnonograms_abstract_solver_set_human_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_ABSTRACT_SOLVER_DIMENSIONS_PROPERTY:
		gnonograms_abstract_solver_set_dimensions (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

