/* Constants.c generated by valac 0.46.6, the Vala compiler
 * generated from Constants.vala, do not modify */

/* Entry point for gnonograms  - initializes application and launches game
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

GType gnonograms_cell_get_type (void) G_GNUC_CONST;
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
void gnonograms_cell_free (GnonogramsCell* self);
#define GNONOGRAMS_MAXSIZE 50
#define GNONOGRAMS_MINSIZE 5
#define GNONOGRAMS_MINFONTSIZE 8.0
#define GNONOGRAMS_MAXFONTSIZE 36.0
#define GNONOGRAMS_FONT_ASPECT_RATIO 1.2
#define GNONOGRAMS_HEADER_HEIGHT ((gint) GTK_ICON_SIZE_LARGE_TOOLBAR)
#define GNONOGRAMS_GRID_BORDER 6
#define GNONOGRAMS_GRID_COLUMN_SPACING 6
#define GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO 0.3
#define GNONOGRAMS_USABLE_MONITOR_HEIGHT 0.85
#define GNONOGRAMS_USABLE_MONITOR_WIDTH 0.95
#define GNONOGRAMS_BLOCKSEPARATOR ", "
#define GNONOGRAMS_BLANKLABELTEXT N_ ("?")
#define GNONOGRAMS_GAMEFILEEXTENSION ".gno"
#define GNONOGRAMS_UNSAVED_FILENAME "Unsaved Game" GNONOGRAMS_GAMEFILEEXTENSION
#define GNONOGRAMS_UNTITLED_NAME N_ ("Untitled")
#define GNONOGRAMS_APP_ID "com.github.jeremypw.gnonograms"
#define GNONOGRAMS_APP_NAME "Gnonograms"
#define GNONOGRAMS_SETTING_FILLED_COLOR "#000000"
#define GNONOGRAMS_SETTING_EMPTY_COLOR "#fafafa"
#define GNONOGRAMS_SOLVING_FILLED_COLOR "#180297"
#define GNONOGRAMS_SOLVING_EMPTY_COLOR "#ffff00"
#define GNONOGRAMS_UNKNOWN_COLOR "#d4d4d4"
#define GNONOGRAMS_GRID_COLOR "#000000"
#define GNONOGRAMS_DARK_TEXT "#000000"
#define GNONOGRAMS_PALE_TEXT "#fafafa"
#define GNONOGRAMS_DARK_BACKGROUND "#180297"
#define GNONOGRAMS_PALE_BACKGROUND "#cdc9e0"
#define GNONOGRAMS_DARK_SHADOW "#1a1a1a"
#define GNONOGRAMS_PALE_SHADOW "#fafafa"

const GnonogramsCell GNONOGRAMS_NULL_CELL = {G_MAXUINT, G_MAXUINT, GNONOGRAMS_CELL_STATE_UNDEFINED};

