/* Enums.c generated by valac 0.46.6, the Vala compiler
 * generated from Enums.vala, do not modify */

/* Entry point for gnonograms  - initializes application and launches game
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_PATTERN_TYPE_CELL,
	GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT,
	GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED
} GnonogramsCellPatternType;

#define GNONOGRAMS_TYPE_CELL_PATTERN_TYPE (gnonograms_cell_pattern_type_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM,
	GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED
} GnonogramsGamePatternType;

#define GNONOGRAMS_TYPE_GAME_PATTERN_TYPE (gnonograms_game_pattern_type_get_type ())
typedef enum  {
	GNONOGRAMS_BUTTON_PRESS_LEFT_SINGLE,
	GNONOGRAMS_BUTTON_PRESS_LEFT_DOUBLE,
	GNONOGRAMS_BUTTON_PRESS_MIDDLE_SINGLE,
	GNONOGRAMS_BUTTON_PRESS_MIDDLE_DOUBLE,
	GNONOGRAMS_BUTTON_PRESS_RIGHT_SINGLE,
	GNONOGRAMS_BUTTON_PRESS_RIGHT_DOUBLE,
	GNONOGRAMS_BUTTON_PRESS_UNDEFINED
} GnonogramsButtonPress;

#define GNONOGRAMS_TYPE_BUTTON_PRESS (gnonograms_button_press_get_type ())
typedef enum  {
	GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER,
	GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED
} GnonogramsFileChooserAction;

#define GNONOGRAMS_TYPE_FILE_CHOOSER_ACTION (gnonograms_file_chooser_action_get_type ())

GType gnonograms_difficulty_get_type (void) G_GNUC_CONST;
gchar* gnonograms_difficulty_to_string (GnonogramsDifficulty self);
GnonogramsDifficulty* gnonograms_difficulty_all_human (gint* result_length1);
GType gnonograms_game_state_get_type (void) G_GNUC_CONST;
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GType gnonograms_solver_state_get_type (void) G_GNUC_CONST;
gboolean gnonograms_solver_state_solved (GnonogramsSolverState self);
GType gnonograms_cell_pattern_type_get_type (void) G_GNUC_CONST;
GType gnonograms_game_pattern_type_get_type (void) G_GNUC_CONST;
GType gnonograms_button_press_get_type (void) G_GNUC_CONST;
GType gnonograms_file_chooser_action_get_type (void) G_GNUC_CONST;

gchar*
gnonograms_difficulty_to_string (GnonogramsDifficulty self)
{
	gchar* result = NULL;
	switch (self) {
		case GNONOGRAMS_DIFFICULTY_TRIVIAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Trivial"));
			result = _tmp0_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_VERY_EASY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Very Easy"));
			result = _tmp1_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_EASY:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Easy"));
			result = _tmp2_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_MODERATE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Moderately difficult"));
			result = _tmp3_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_HARD:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Difficult"));
			result = _tmp4_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_CHALLENGING:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Very Difficult"));
			result = _tmp5_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_ADVANCED:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Advanced logic required"));
			result = _tmp6_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_MAXIMUM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Possibly ambiguous"));
			result = _tmp7_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_COMPUTER:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Super human"));
			result = _tmp8_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_UNDEFINED:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Undefined"));
			result = _tmp9_;
			return result;
		}
		default:
		{
			g_critical ("Enums.vala:57: grade to string - unexpected grade");
			g_assert_not_reached ();
		}
	}
}

GnonogramsDifficulty*
gnonograms_difficulty_all_human (gint* result_length1)
{
	GnonogramsDifficulty* _tmp0_;
	GnonogramsDifficulty* _tmp1_;
	gint _tmp1__length1;
	GnonogramsDifficulty* result = NULL;
	_tmp0_ = g_new0 (GnonogramsDifficulty, 6);
	_tmp0_[0] = GNONOGRAMS_DIFFICULTY_EASY;
	_tmp0_[1] = GNONOGRAMS_DIFFICULTY_MODERATE;
	_tmp0_[2] = GNONOGRAMS_DIFFICULTY_HARD;
	_tmp0_[3] = GNONOGRAMS_DIFFICULTY_CHALLENGING;
	_tmp0_[4] = GNONOGRAMS_DIFFICULTY_ADVANCED;
	_tmp0_[5] = GNONOGRAMS_DIFFICULTY_MAXIMUM;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 6;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

GType
gnonograms_difficulty_get_type (void)
{
	static volatile gsize gnonograms_difficulty_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_difficulty_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_DIFFICULTY_TRIVIAL, "GNONOGRAMS_DIFFICULTY_TRIVIAL", "trivial"}, {GNONOGRAMS_DIFFICULTY_VERY_EASY, "GNONOGRAMS_DIFFICULTY_VERY_EASY", "very-easy"}, {GNONOGRAMS_DIFFICULTY_EASY, "GNONOGRAMS_DIFFICULTY_EASY", "easy"}, {GNONOGRAMS_DIFFICULTY_MODERATE, "GNONOGRAMS_DIFFICULTY_MODERATE", "moderate"}, {GNONOGRAMS_DIFFICULTY_HARD, "GNONOGRAMS_DIFFICULTY_HARD", "hard"}, {GNONOGRAMS_DIFFICULTY_CHALLENGING, "GNONOGRAMS_DIFFICULTY_CHALLENGING", "challenging"}, {GNONOGRAMS_DIFFICULTY_ADVANCED, "GNONOGRAMS_DIFFICULTY_ADVANCED", "advanced"}, {GNONOGRAMS_DIFFICULTY_MAXIMUM, "GNONOGRAMS_DIFFICULTY_MAXIMUM", "maximum"}, {GNONOGRAMS_DIFFICULTY_COMPUTER, "GNONOGRAMS_DIFFICULTY_COMPUTER", "computer"}, {GNONOGRAMS_DIFFICULTY_UNDEFINED, "GNONOGRAMS_DIFFICULTY_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_difficulty_type_id;
		gnonograms_difficulty_type_id = g_enum_register_static ("GnonogramsDifficulty", values);
		g_once_init_leave (&gnonograms_difficulty_type_id__volatile, gnonograms_difficulty_type_id);
	}
	return gnonograms_difficulty_type_id__volatile;
}

GType
gnonograms_game_state_get_type (void)
{
	static volatile gsize gnonograms_game_state_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_game_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_GAME_STATE_SETTING, "GNONOGRAMS_GAME_STATE_SETTING", "setting"}, {GNONOGRAMS_GAME_STATE_SOLVING, "GNONOGRAMS_GAME_STATE_SOLVING", "solving"}, {GNONOGRAMS_GAME_STATE_GENERATING, "GNONOGRAMS_GAME_STATE_GENERATING", "generating"}, {GNONOGRAMS_GAME_STATE_UNDEFINED, "GNONOGRAMS_GAME_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_game_state_type_id;
		gnonograms_game_state_type_id = g_enum_register_static ("GnonogramsGameState", values);
		g_once_init_leave (&gnonograms_game_state_type_id__volatile, gnonograms_game_state_type_id);
	}
	return gnonograms_game_state_type_id__volatile;
}

GType
gnonograms_cell_state_get_type (void)
{
	static volatile gsize gnonograms_cell_state_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_cell_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_CELL_STATE_UNKNOWN, "GNONOGRAMS_CELL_STATE_UNKNOWN", "unknown"}, {GNONOGRAMS_CELL_STATE_EMPTY, "GNONOGRAMS_CELL_STATE_EMPTY", "empty"}, {GNONOGRAMS_CELL_STATE_FILLED, "GNONOGRAMS_CELL_STATE_FILLED", "filled"}, {GNONOGRAMS_CELL_STATE_COMPLETED, "GNONOGRAMS_CELL_STATE_COMPLETED", "completed"}, {GNONOGRAMS_CELL_STATE_UNDEFINED, "GNONOGRAMS_CELL_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_cell_state_type_id;
		gnonograms_cell_state_type_id = g_enum_register_static ("GnonogramsCellState", values);
		g_once_init_leave (&gnonograms_cell_state_type_id__volatile, gnonograms_cell_state_type_id);
	}
	return gnonograms_cell_state_type_id__volatile;
}

gboolean
gnonograms_solver_state_solved (GnonogramsSolverState self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	if (self == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self == GNONOGRAMS_SOLVER_STATE_ADVANCED;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self == GNONOGRAMS_SOLVER_STATE_AMBIGUOUS;
	}
	result = _tmp0_;
	return result;
}

GType
gnonograms_solver_state_get_type (void)
{
	static volatile gsize gnonograms_solver_state_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_solver_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_SOLVER_STATE_ERROR, "GNONOGRAMS_SOLVER_STATE_ERROR", "error"}, {GNONOGRAMS_SOLVER_STATE_CANCELLED, "GNONOGRAMS_SOLVER_STATE_CANCELLED", "cancelled"}, {GNONOGRAMS_SOLVER_STATE_NO_SOLUTION, "GNONOGRAMS_SOLVER_STATE_NO_SOLUTION", "no-solution"}, {GNONOGRAMS_SOLVER_STATE_SIMPLE, "GNONOGRAMS_SOLVER_STATE_SIMPLE", "simple"}, {GNONOGRAMS_SOLVER_STATE_ADVANCED, "GNONOGRAMS_SOLVER_STATE_ADVANCED", "advanced"}, {GNONOGRAMS_SOLVER_STATE_AMBIGUOUS, "GNONOGRAMS_SOLVER_STATE_AMBIGUOUS", "ambiguous"}, {GNONOGRAMS_SOLVER_STATE_UNDEFINED, "GNONOGRAMS_SOLVER_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_solver_state_type_id;
		gnonograms_solver_state_type_id = g_enum_register_static ("GnonogramsSolverState", values);
		g_once_init_leave (&gnonograms_solver_state_type_id__volatile, gnonograms_solver_state_type_id);
	}
	return gnonograms_solver_state_type_id__volatile;
}

GType
gnonograms_cell_pattern_type_get_type (void)
{
	static volatile gsize gnonograms_cell_pattern_type_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_cell_pattern_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_CELL_PATTERN_TYPE_CELL, "GNONOGRAMS_CELL_PATTERN_TYPE_CELL", "cell"}, {GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT, "GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT", "highlight"}, {GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED, "GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_cell_pattern_type_type_id;
		gnonograms_cell_pattern_type_type_id = g_enum_register_static ("GnonogramsCellPatternType", values);
		g_once_init_leave (&gnonograms_cell_pattern_type_type_id__volatile, gnonograms_cell_pattern_type_type_id);
	}
	return gnonograms_cell_pattern_type_type_id__volatile;
}

GType
gnonograms_game_pattern_type_get_type (void)
{
	static volatile gsize gnonograms_game_pattern_type_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_game_pattern_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM, "GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM", "simple-random"}, {GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED, "GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_game_pattern_type_type_id;
		gnonograms_game_pattern_type_type_id = g_enum_register_static ("GnonogramsGamePatternType", values);
		g_once_init_leave (&gnonograms_game_pattern_type_type_id__volatile, gnonograms_game_pattern_type_type_id);
	}
	return gnonograms_game_pattern_type_type_id__volatile;
}

GType
gnonograms_button_press_get_type (void)
{
	static volatile gsize gnonograms_button_press_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_button_press_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_BUTTON_PRESS_LEFT_SINGLE, "GNONOGRAMS_BUTTON_PRESS_LEFT_SINGLE", "left-single"}, {GNONOGRAMS_BUTTON_PRESS_LEFT_DOUBLE, "GNONOGRAMS_BUTTON_PRESS_LEFT_DOUBLE", "left-double"}, {GNONOGRAMS_BUTTON_PRESS_MIDDLE_SINGLE, "GNONOGRAMS_BUTTON_PRESS_MIDDLE_SINGLE", "middle-single"}, {GNONOGRAMS_BUTTON_PRESS_MIDDLE_DOUBLE, "GNONOGRAMS_BUTTON_PRESS_MIDDLE_DOUBLE", "middle-double"}, {GNONOGRAMS_BUTTON_PRESS_RIGHT_SINGLE, "GNONOGRAMS_BUTTON_PRESS_RIGHT_SINGLE", "right-single"}, {GNONOGRAMS_BUTTON_PRESS_RIGHT_DOUBLE, "GNONOGRAMS_BUTTON_PRESS_RIGHT_DOUBLE", "right-double"}, {GNONOGRAMS_BUTTON_PRESS_UNDEFINED, "GNONOGRAMS_BUTTON_PRESS_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_button_press_type_id;
		gnonograms_button_press_type_id = g_enum_register_static ("GnonogramsButtonPress", values);
		g_once_init_leave (&gnonograms_button_press_type_id__volatile, gnonograms_button_press_type_id);
	}
	return gnonograms_button_press_type_id__volatile;
}

GType
gnonograms_file_chooser_action_get_type (void)
{
	static volatile gsize gnonograms_file_chooser_action_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_file_chooser_action_type_id__volatile)) {
		static const GEnumValue values[] = {{GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN, "GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN", "open"}, {GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION, "GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION", "save-no-solution"}, {GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION, "GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION", "save-with-solution"}, {GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER, "GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER", "select-folder"}, {GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED, "GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED", "undefined"}, {0, NULL, NULL}};
		GType gnonograms_file_chooser_action_type_id;
		gnonograms_file_chooser_action_type_id = g_enum_register_static ("GnonogramsFileChooserAction", values);
		g_once_init_leave (&gnonograms_file_chooser_action_type_id__volatile, gnonograms_file_chooser_action_type_id);
	}
	return gnonograms_file_chooser_action_type_id__volatile;
}

