/* Filereader.c generated by valac 0.46.6, the Vala compiler
 * generated from Filereader.vala, do not modify */

/* Game file reader class for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Author:
 *  Jeremy Wootten  < jeremwootten@gmail.com >
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define GNONOGRAMS_TYPE_FILEREADER (gnonograms_filereader_get_type ())
#define GNONOGRAMS_FILEREADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereader))
#define GNONOGRAMS_FILEREADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereaderClass))
#define GNONOGRAMS_IS_FILEREADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_FILEREADER))
#define GNONOGRAMS_IS_FILEREADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_FILEREADER))
#define GNONOGRAMS_FILEREADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereaderClass))

typedef struct _GnonogramsFilereader GnonogramsFilereader;
typedef struct _GnonogramsFilereaderClass GnonogramsFilereaderClass;
typedef struct _GnonogramsFilereaderPrivate GnonogramsFilereaderPrivate;
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
enum  {
	GNONOGRAMS_FILEREADER_0_PROPERTY,
	GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY,
	GNONOGRAMS_FILEREADER_STATE_PROPERTY,
	GNONOGRAMS_FILEREADER_ROWS_PROPERTY,
	GNONOGRAMS_FILEREADER_COLS_PROPERTY,
	GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY,
	GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY,
	GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY,
	GNONOGRAMS_FILEREADER_WORKING_PROPERTY,
	GNONOGRAMS_FILEREADER_NAME_PROPERTY,
	GNONOGRAMS_FILEREADER_DATE_PROPERTY,
	GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY,
	GNONOGRAMS_FILEREADER_LICENSE_PROPERTY,
	GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY,
	GNONOGRAMS_FILEREADER_MOVES_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY,
	GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY,
	GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY,
	GNONOGRAMS_FILEREADER_VALID_PROPERTY,
	GNONOGRAMS_FILEREADER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GNONOGRAMS_TYPE_FILTER_INFO (gnonograms_filter_info_get_type ())
typedef struct _GnonogramsFilterInfo GnonogramsFilterInfo;
typedef enum  {
	GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER,
	GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED
} GnonogramsFileChooserAction;

#define GNONOGRAMS_TYPE_FILE_CHOOSER_ACTION (gnonograms_file_chooser_action_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GnonogramsFilereader {
	GObject parent_instance;
	GnonogramsFilereaderPrivate * priv;
	gchar* err_msg;
};

struct _GnonogramsFilereaderClass {
	GObjectClass parent_class;
};

struct _GnonogramsFilereaderPrivate {
	GFile* _game_file;
	GnonogramsGameState _state;
	gint _rows;
	gint _cols;
	gchar** _row_clues;
	gint _row_clues_length1;
	gint __row_clues_size_;
	gchar** _col_clues;
	gint _col_clues_length1;
	gint __col_clues_size_;
	gchar** _solution;
	gint _solution_length1;
	gint __solution_size_;
	gchar** _working;
	gint _working_length1;
	gint __working_size_;
	gchar* _name;
	gchar* _date;
	GnonogramsDifficulty _difficulty;
	gchar* _license;
	gchar* _original_path;
	gchar* _moves;
	gboolean _has_dimensions;
	gboolean _has_row_clues;
	gboolean _has_col_clues;
	gboolean _has_solution;
	gboolean _has_working;
	gboolean _has_state;
	gboolean _is_readonly;
};

struct _GnonogramsFilterInfo {
	gchar* name;
	gchar* pattern;
};

static gint GnonogramsFilereader_private_offset;
static gpointer gnonograms_filereader_parent_class = NULL;

GType gnonograms_filereader_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsFilereader, g_object_unref)
GType gnonograms_game_state_get_type (void) G_GNUC_CONST;
GType gnonograms_difficulty_get_type (void) G_GNUC_CONST;
GnonogramsFilereader* gnonograms_filereader_new (GtkWindow* parent,
                                                 const gchar* load_dir_path,
                                                 GFile* game,
                                                 GError** error);
GnonogramsFilereader* gnonograms_filereader_construct (GType object_type,
                                                       GtkWindow* parent,
                                                       const gchar* load_dir_path,
                                                       GFile* game,
                                                       GError** error);
static GFile* gnonograms_filereader_get_load_game_file (GnonogramsFilereader* self,
                                                 GtkWindow* parent,
                                                 const gchar* load_dir_path);
void gnonograms_filereader_set_game_file (GnonogramsFilereader* self,
                                          GFile* value);
GFile* gnonograms_filereader_get_game_file (GnonogramsFilereader* self);
static void gnonograms_filereader_parse_gnonogram_game_file (GnonogramsFilereader* self,
                                                      GDataInputStream* stream,
                                                      GError** error);
GType gnonograms_filter_info_get_type (void) G_GNUC_CONST;
GnonogramsFilterInfo* gnonograms_filter_info_dup (const GnonogramsFilterInfo* self);
void gnonograms_filter_info_free (GnonogramsFilterInfo* self);
void gnonograms_filter_info_copy (const GnonogramsFilterInfo* self,
                                  GnonogramsFilterInfo* dest);
void gnonograms_filter_info_destroy (GnonogramsFilterInfo* self);
#define GNONOGRAMS_GAMEFILEEXTENSION ".gno"
GType gnonograms_file_chooser_action_get_type (void) G_GNUC_CONST;
gchar* gnonograms_utils_get_file_path (GtkWindow* parent,
                                       GnonogramsFileChooserAction action,
                                       const gchar* dialogname,
                                       GnonogramsFilterInfo* filters,
                                       gint filters_length1,
                                       const gchar* start_path,
                                       gboolean* save_solution);
static void _vala_GnonogramsFilterInfo_array_free (GnonogramsFilterInfo * array,
                                            gint array_length);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static gboolean gnonograms_filereader_parse_gnonogram_headings_and_bodies (GnonogramsFilereader* self,
                                                                    gchar** headings,
                                                                    gint headings_length1,
                                                                    gchar** bodies,
                                                                    gint bodies_length1);
static gboolean gnonograms_filereader_get_gnonogram_dimensions (GnonogramsFilereader* self,
                                                         const gchar* body);
static gchar** gnonograms_filereader_get_gnonogram_clues (GnonogramsFilereader* self,
                                                   const gchar* body,
                                                   gint max_block,
                                                   gint* result_length1);
gint gnonograms_filereader_get_cols (GnonogramsFilereader* self);
static void gnonograms_filereader_set_row_clues (GnonogramsFilereader* self,
                                          gchar** value,
                                          gint value_length1);
gchar** gnonograms_filereader_get_row_clues (GnonogramsFilereader* self,
                                             gint* result_length1);
gint gnonograms_filereader_get_rows (GnonogramsFilereader* self);
static void gnonograms_filereader_set_has_row_clues (GnonogramsFilereader* self,
                                              gboolean value);
static void gnonograms_filereader_set_col_clues (GnonogramsFilereader* self,
                                          gchar** value,
                                          gint value_length1);
gchar** gnonograms_filereader_get_col_clues (GnonogramsFilereader* self,
                                             gint* result_length1);
static void gnonograms_filereader_set_has_col_clues (GnonogramsFilereader* self,
                                              gboolean value);
static gboolean gnonograms_filereader_get_gnonogram_cellstate_array (GnonogramsFilereader* self,
                                                              const gchar* body,
                                                              gboolean is_solution);
static gboolean gnonograms_filereader_get_gnonogram_state (GnonogramsFilereader* self,
                                                    const gchar* body);
static gboolean gnonograms_filereader_get_game_description (GnonogramsFilereader* self,
                                                     const gchar* body);
static gboolean gnonograms_filereader_get_readonly (GnonogramsFilereader* self,
                                             const gchar* body);
static gboolean gnonograms_filereader_get_original_game_path (GnonogramsFilereader* self,
                                                       const gchar* body);
static void gnonograms_filereader_set_moves (GnonogramsFilereader* self,
                                      const gchar* value);
gchar** gnonograms_utils_remove_blank_lines (gchar** sa,
                                             gint sa_length1,
                                             gint* result_length1);
static void gnonograms_filereader_set_rows (GnonogramsFilereader* self,
                                     gint value);
static void gnonograms_filereader_set_cols (GnonogramsFilereader* self,
                                     gint value);
static void gnonograms_filereader_set_has_dimensions (GnonogramsFilereader* self,
                                               gboolean value);
static gchar* gnonograms_filereader_parse_gnonogram_clue (GnonogramsFilereader* self,
                                                   const gchar* line,
                                                   gint maxblock);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GnonogramsCellState* gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                                                   gint* result_length1);
static void gnonograms_filereader_set_solution (GnonogramsFilereader* self,
                                         gchar** value,
                                         gint value_length1);
static void gnonograms_filereader_set_has_solution (GnonogramsFilereader* self,
                                             gboolean value);
static void gnonograms_filereader_set_working (GnonogramsFilereader* self,
                                        gchar** value,
                                        gint value_length1);
static void gnonograms_filereader_set_has_working (GnonogramsFilereader* self,
                                            gboolean value);
static void gnonograms_filereader_set_state (GnonogramsFilereader* self,
                                      GnonogramsGameState value);
static void gnonograms_filereader_set_name (GnonogramsFilereader* self,
                                     const gchar* value);
static void gnonograms_filereader_set_date (GnonogramsFilereader* self,
                                     const gchar* value);
static void gnonograms_filereader_set_difficulty (GnonogramsFilereader* self,
                                           GnonogramsDifficulty value);
static void gnonograms_filereader_set_is_readonly (GnonogramsFilereader* self,
                                            gboolean value);
static void gnonograms_filereader_set_original_path (GnonogramsFilereader* self,
                                              const gchar* value);
#define GNONOGRAMS_BLOCKSEPARATOR ", "
GnonogramsGameState gnonograms_filereader_get_state (GnonogramsFilereader* self);
static gchar** _vala_array_dup2 (gchar** self,
                          int length);
static gchar** _vala_array_dup3 (gchar** self,
                          int length);
gchar** gnonograms_filereader_get_solution (GnonogramsFilereader* self,
                                            gint* result_length1);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
gchar** gnonograms_filereader_get_working (GnonogramsFilereader* self,
                                           gint* result_length1);
static gchar** _vala_array_dup5 (gchar** self,
                          int length);
const gchar* gnonograms_filereader_get_name (GnonogramsFilereader* self);
const gchar* gnonograms_filereader_get_date (GnonogramsFilereader* self);
GnonogramsDifficulty gnonograms_filereader_get_difficulty (GnonogramsFilereader* self);
const gchar* gnonograms_filereader_get_license (GnonogramsFilereader* self);
static void gnonograms_filereader_set_license (GnonogramsFilereader* self,
                                        const gchar* value);
const gchar* gnonograms_filereader_get_original_path (GnonogramsFilereader* self);
const gchar* gnonograms_filereader_get_moves (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_dimensions (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_row_clues (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_col_clues (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_solution (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_working (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_has_state (GnonogramsFilereader* self);
static void gnonograms_filereader_set_has_state (GnonogramsFilereader* self,
                                          gboolean value);
gboolean gnonograms_filereader_get_is_readonly (GnonogramsFilereader* self);
gboolean gnonograms_filereader_get_valid (GnonogramsFilereader* self);
static void gnonograms_filereader_finalize (GObject * obj);
static void _vala_gnonograms_filereader_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gnonograms_filereader_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
gnonograms_filereader_get_instance_private (GnonogramsFilereader* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsFilereader_private_offset);
}

GnonogramsFilereader*
gnonograms_filereader_construct (GType object_type,
                                 GtkWindow* parent,
                                 const gchar* load_dir_path,
                                 GFile* game,
                                 GError** error)
{
	GnonogramsFilereader * self = NULL;
	GFile* _tmp2_;
	GDataInputStream* stream = NULL;
	GError* _inner_error0_ = NULL;
	self = (GnonogramsFilereader*) g_object_new (object_type, "game-file", game, NULL);
	if (game == NULL) {
		GFile* _tmp0_;
		GFile* _tmp1_;
		_tmp0_ = gnonograms_filereader_get_load_game_file (self, parent, load_dir_path);
		_tmp1_ = _tmp0_;
		gnonograms_filereader_set_game_file (self, _tmp1_);
		_g_object_unref0 (_tmp1_);
	}
	_tmp2_ = self->priv->_game_file;
	if (_tmp2_ == NULL) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Load game file dialog cancelled");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	{
		GFileInputStream* fstream = NULL;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GFileInputStream* _tmp6_;
		GDataInputStream* _tmp7_;
		_tmp4_ = self->priv->_game_file;
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
		fstream = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp6_ = fstream;
		_tmp7_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
		_g_object_unref0 (stream);
		stream = _tmp7_;
		_g_object_unref0 (fstream);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Unable to open data stream");
		_inner_error0_ = _tmp8_;
		_g_error_free0 (e);
		goto __finally5;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (stream);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_object_unref0 (stream);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	gnonograms_filereader_parse_gnonogram_game_file (self, stream, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (stream);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_object_unref0 (stream);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_g_object_unref0 (stream);
	return self;
}

GnonogramsFilereader*
gnonograms_filereader_new (GtkWindow* parent,
                           const gchar* load_dir_path,
                           GFile* game,
                           GError** error)
{
	return gnonograms_filereader_construct (GNONOGRAMS_TYPE_FILEREADER, parent, load_dir_path, game, error);
}

/** PRIVATE **/
static void
_vala_GnonogramsFilterInfo_array_free (GnonogramsFilterInfo * array,
                                       gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			gnonograms_filter_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static GFile*
gnonograms_filereader_get_load_game_file (GnonogramsFilereader* self,
                                          GtkWindow* parent,
                                          const gchar* load_dir_path)
{
	GnonogramsFilterInfo info = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GnonogramsFilterInfo _tmp2_ = {0};
	GnonogramsFilterInfo* filters = NULL;
	GnonogramsFilterInfo _tmp3_;
	GnonogramsFilterInfo _tmp4_;
	GnonogramsFilterInfo _tmp5_ = {0};
	GnonogramsFilterInfo* _tmp6_;
	gint filters_length1;
	gint _filters_size_;
	gchar* path = NULL;
	GnonogramsFilterInfo* _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	GFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (_ ("Gnonogram puzzles"));
	_tmp1_ = g_strdup ("*" GNONOGRAMS_GAMEFILEEXTENSION);
	_g_free0 (_tmp2_.name);
	_tmp2_.name = _tmp0_;
	_g_free0 (_tmp2_.pattern);
	_tmp2_.pattern = _tmp1_;
	info = _tmp2_;
	_tmp3_ = info;
	_tmp4_ = _tmp3_;
	gnonograms_filter_info_copy (&_tmp4_, &_tmp5_);
	_tmp6_ = g_new0 (GnonogramsFilterInfo, 1);
	_tmp6_[0] = _tmp5_;
	filters = _tmp6_;
	filters_length1 = 1;
	_filters_size_ = filters_length1;
	_tmp7_ = filters;
	_tmp7__length1 = filters_length1;
	_tmp8_ = gnonograms_utils_get_file_path (parent, GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN, _ ("Choose a puzzle"), _tmp7_, (gint) _tmp7__length1, load_dir_path, NULL);
	path = _tmp8_;
	_tmp10_ = path;
	if (_tmp10_ == NULL) {
		_tmp9_ = TRUE;
	} else {
		const gchar* _tmp11_;
		_tmp11_ = path;
		_tmp9_ = g_strcmp0 (_tmp11_, "") == 0;
	}
	if (_tmp9_) {
		result = NULL;
		_g_free0 (path);
		filters = (_vala_GnonogramsFilterInfo_array_free (filters, filters_length1), NULL);
		gnonograms_filter_info_destroy (&info);
		return result;
	} else {
		const gchar* _tmp12_;
		GFile* _tmp13_;
		_tmp12_ = path;
		_tmp13_ = g_file_new_for_path (_tmp12_);
		result = _tmp13_;
		_g_free0 (path);
		filters = (_vala_GnonogramsFilterInfo_array_free (filters, filters_length1), NULL);
		gnonograms_filter_info_destroy (&info);
		return result;
	}
	_g_free0 (path);
	filters = (_vala_GnonogramsFilterInfo_array_free (filters, filters_length1), NULL);
	gnonograms_filter_info_destroy (&info);
}

static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
gnonograms_filereader_parse_gnonogram_game_file (GnonogramsFilereader* self,
                                                 GDataInputStream* stream,
                                                 GError** error)
{
	gsize header_length = 0UL;
	gsize body_length = 0UL;
	gchar** headings = NULL;
	gchar** _tmp0_;
	gint headings_length1;
	gint _headings_size_;
	gchar** bodies = NULL;
	gchar** _tmp1_;
	gint bodies_length1;
	gint _bodies_size_;
	gsize _tmp2_ = 0UL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (stream != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	headings = _tmp0_;
	headings_length1 = 0;
	_headings_size_ = headings_length1;
	_tmp1_ = g_new0 (gchar*, 0 + 1);
	bodies = _tmp1_;
	bodies_length1 = 0;
	_bodies_size_ = bodies_length1;
	_tmp3_ = g_data_input_stream_read_upto (stream, "[", (gssize) 1, &_tmp2_, NULL, &_inner_error0_);
	header_length = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp4_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	g_data_input_stream_read_byte (stream, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		while (TRUE) {
			gchar* _tmp5_ = NULL;
			gsize _tmp6_ = 0UL;
			gchar* _tmp7_;
			gchar** _tmp8_;
			gint _tmp8__length1;
			gchar* _tmp9_;
			gchar* _tmp10_ = NULL;
			gsize _tmp11_ = 0UL;
			gchar* _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
			gchar* _tmp14_;
			gboolean _tmp15_ = FALSE;
			_tmp7_ = g_data_input_stream_read_upto (stream, "]", (gssize) 1, &_tmp6_, NULL, &_inner_error0_);
			header_length = _tmp6_;
			_tmp5_ = _tmp7_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch6_g_error;
			}
			_tmp8_ = headings;
			_tmp8__length1 = headings_length1;
			_tmp9_ = _tmp5_;
			_tmp5_ = NULL;
			_vala_array_add4 (&headings, &headings_length1, &_headings_size_, _tmp9_);
			g_data_input_stream_read_byte (stream, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (_tmp5_);
				goto __catch6_g_error;
			}
			_tmp12_ = g_data_input_stream_read_upto (stream, "[", (gssize) 1, &_tmp11_, NULL, &_inner_error0_);
			body_length = _tmp11_;
			_tmp10_ = _tmp12_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (_tmp5_);
				goto __catch6_g_error;
			}
			_tmp13_ = bodies;
			_tmp13__length1 = bodies_length1;
			_tmp14_ = _tmp10_;
			_tmp10_ = NULL;
			_vala_array_add5 (&bodies, &bodies_length1, &_bodies_size_, _tmp14_);
			g_data_input_stream_read_byte (stream, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (_tmp10_);
				_g_free0 (_tmp5_);
				goto __catch6_g_error;
			}
			if (header_length == ((gsize) 0)) {
				_tmp15_ = TRUE;
			} else {
				_tmp15_ = body_length == ((gsize) 0);
			}
			if (_tmp15_) {
				_g_free0 (_tmp10_);
				_g_free0 (_tmp5_);
				break;
			}
			_g_free0 (_tmp10_);
			_g_free0 (_tmp5_);
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp16_ = headings;
	_tmp16__length1 = headings_length1;
	_tmp17_ = bodies;
	_tmp17__length1 = bodies_length1;
	if (!gnonograms_filereader_parse_gnonogram_headings_and_bodies (self, _tmp16_, (gint) _tmp16__length1, _tmp17_, (gint) _tmp17__length1)) {
		const gchar* _tmp18_;
		GError* _tmp19_;
		_tmp18_ = self->err_msg;
		_tmp19_ = g_error_new (G_IO_ERROR, G_IO_ERROR_INVALID_DATA, "Game file could not be parsed - %s", _tmp18_);
		_inner_error0_ = _tmp19_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
			headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	bodies = (_vala_array_free (bodies, bodies_length1, (GDestroyNotify) g_free), NULL);
	headings = (_vala_array_free (headings, headings_length1, (GDestroyNotify) g_free), NULL);
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gboolean
gnonograms_filereader_parse_gnonogram_headings_and_bodies (GnonogramsFilereader* self,
                                                           gchar** headings,
                                                           gint headings_length1,
                                                           gchar** bodies,
                                                           gint bodies_length1)
{
	gboolean in_error = FALSE;
	gint index = 0;
	gint hl = 0;
	gint bl = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	in_error = FALSE;
	index = 0;
	hl = headings_length1;
	bl = bodies_length1;
	if (hl < 3) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = bl < 3;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = hl != bl;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		gchar** heading_collection = NULL;
		gint heading_collection_length1 = 0;
		gint _heading_collection_size_ = 0;
		gint heading_it = 0;
		heading_collection = headings;
		heading_collection_length1 = headings_length1;
		for (heading_it = 0; heading_it < heading_collection_length1; heading_it = heading_it + 1) {
			gchar* _tmp2_;
			gchar* heading = NULL;
			_tmp2_ = g_strdup (heading_collection[heading_it]);
			heading = _tmp2_;
			{
				gchar* body = NULL;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gint _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				GQuark _tmp16_ = 0U;
				static GQuark _tmp15_label0 = 0;
				static GQuark _tmp15_label1 = 0;
				static GQuark _tmp15_label2 = 0;
				static GQuark _tmp15_label3 = 0;
				static GQuark _tmp15_label4 = 0;
				static GQuark _tmp15_label5 = 0;
				static GQuark _tmp15_label6 = 0;
				static GQuark _tmp15_label7 = 0;
				static GQuark _tmp15_label8 = 0;
				static GQuark _tmp15_label9 = 0;
				_tmp3_ = bodies[index];
				_tmp4_ = g_strdup (_tmp3_);
				body = _tmp4_;
				_tmp5_ = index;
				index = _tmp5_ + 1;
				_tmp6_ = heading;
				if (_tmp6_ == NULL) {
					_g_free0 (body);
					_g_free0 (heading);
					continue;
				}
				_tmp7_ = heading;
				_tmp8_ = strlen (_tmp7_);
				_tmp9_ = _tmp8_;
				if (_tmp9_ > 3) {
					const gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp10_ = heading;
					_tmp11_ = string_slice (_tmp10_, (glong) 0, (glong) 3);
					_g_free0 (heading);
					heading = _tmp11_;
				}
				_tmp12_ = heading;
				_tmp13_ = g_utf8_strup (_tmp12_, (gssize) -1);
				_tmp14_ = _tmp13_;
				_tmp16_ = (NULL == _tmp14_) ? 0 : g_quark_from_string (_tmp14_);
				g_free (_tmp14_);
				if (_tmp16_ == ((0 != _tmp15_label0) ? _tmp15_label0 : (_tmp15_label0 = g_quark_from_static_string ("DIM")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp17_;
							_tmp17_ = body;
							in_error = !gnonograms_filereader_get_gnonogram_dimensions (self, _tmp17_);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label1) ? _tmp15_label1 : (_tmp15_label1 = g_quark_from_static_string ("ROW")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp18_;
							gint _tmp19_;
							gint _tmp20_ = 0;
							gchar** _tmp21_;
							gchar** _tmp22_;
							gint _tmp22__length1;
							gchar** _tmp23_;
							gint _tmp23__length1;
							gchar** _tmp24_;
							gint _tmp24__length1;
							gint _tmp25_;
							_tmp18_ = body;
							_tmp19_ = self->priv->_cols;
							_tmp21_ = gnonograms_filereader_get_gnonogram_clues (self, _tmp18_, _tmp19_, &_tmp20_);
							_tmp22_ = _tmp21_;
							_tmp22__length1 = _tmp20_;
							gnonograms_filereader_set_row_clues (self, _tmp22_, _tmp20_);
							_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
							_tmp23_ = gnonograms_filereader_get_row_clues (self, &_tmp23__length1);
							_tmp24_ = _tmp23_;
							_tmp24__length1 = _tmp23__length1;
							_tmp25_ = self->priv->_rows;
							if (_tmp24__length1 != _tmp25_) {
								const gchar* _tmp26_;
								gchar* _tmp27_;
								_tmp26_ = self->err_msg;
								_tmp27_ = g_strconcat ("Wrong number of row clues - ", _tmp26_, NULL);
								_g_free0 (self->err_msg);
								self->err_msg = _tmp27_;
								in_error = TRUE;
							} else {
								gnonograms_filereader_set_has_row_clues (self, TRUE);
							}
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label2) ? _tmp15_label2 : (_tmp15_label2 = g_quark_from_static_string ("COL")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp28_;
							gint _tmp29_;
							gint _tmp30_ = 0;
							gchar** _tmp31_;
							gchar** _tmp32_;
							gint _tmp32__length1;
							gchar** _tmp33_;
							gint _tmp33__length1;
							gchar** _tmp34_;
							gint _tmp34__length1;
							gint _tmp35_;
							_tmp28_ = body;
							_tmp29_ = self->priv->_rows;
							_tmp31_ = gnonograms_filereader_get_gnonogram_clues (self, _tmp28_, _tmp29_, &_tmp30_);
							_tmp32_ = _tmp31_;
							_tmp32__length1 = _tmp30_;
							gnonograms_filereader_set_col_clues (self, _tmp32_, _tmp30_);
							_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) g_free), NULL);
							_tmp33_ = gnonograms_filereader_get_col_clues (self, &_tmp33__length1);
							_tmp34_ = _tmp33_;
							_tmp34__length1 = _tmp33__length1;
							_tmp35_ = self->priv->_cols;
							if (_tmp34__length1 != _tmp35_) {
								const gchar* _tmp36_;
								gchar* _tmp37_;
								_tmp36_ = self->err_msg;
								_tmp37_ = g_strconcat ("Wrong number of column clues -", _tmp36_, NULL);
								_g_free0 (self->err_msg);
								self->err_msg = _tmp37_;
								in_error = TRUE;
							} else {
								gnonograms_filereader_set_has_col_clues (self, TRUE);
							}
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label3) ? _tmp15_label3 : (_tmp15_label3 = g_quark_from_static_string ("SOL")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp38_;
							_tmp38_ = body;
							in_error = !gnonograms_filereader_get_gnonogram_cellstate_array (self, _tmp38_, TRUE);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label4) ? _tmp15_label4 : (_tmp15_label4 = g_quark_from_static_string ("WOR")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp39_;
							_tmp39_ = body;
							in_error = !gnonograms_filereader_get_gnonogram_cellstate_array (self, _tmp39_, FALSE);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label5) ? _tmp15_label5 : (_tmp15_label5 = g_quark_from_static_string ("STA")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp40_;
							_tmp40_ = body;
							in_error = !gnonograms_filereader_get_gnonogram_state (self, _tmp40_);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label6) ? _tmp15_label6 : (_tmp15_label6 = g_quark_from_static_string ("DES")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp41_;
							_tmp41_ = body;
							in_error = !gnonograms_filereader_get_game_description (self, _tmp41_);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label7) ? _tmp15_label7 : (_tmp15_label7 = g_quark_from_static_string ("LOC")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp42_;
							_tmp42_ = body;
							in_error = !gnonograms_filereader_get_readonly (self, _tmp42_);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label8) ? _tmp15_label8 : (_tmp15_label8 = g_quark_from_static_string ("ORI")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp43_;
							_tmp43_ = body;
							in_error = !gnonograms_filereader_get_original_game_path (self, _tmp43_);
							break;
						}
					}
				} else if (_tmp16_ == ((0 != _tmp15_label9) ? _tmp15_label9 : (_tmp15_label9 = g_quark_from_static_string ("HIS")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp44_;
							_tmp44_ = body;
							gnonograms_filereader_set_moves (self, _tmp44_);
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							break;
						}
					}
				}
				_g_free0 (body);
				_g_free0 (heading);
			}
		}
	}
	result = !in_error;
	return result;
}

static gboolean
gnonograms_filereader_get_gnonogram_dimensions (GnonogramsFilereader* self,
                                                const gchar* body)
{
	gchar** s = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint s_length1;
	gint _s_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (body == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("No dimensions given");
		_g_free0 (self->err_msg);
		self->err_msg = _tmp0_;
		result = FALSE;
		return result;
	}
	_tmp2_ = _tmp1_ = g_strsplit (body, "\n", 0);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	_tmp5_ = gnonograms_utils_remove_blank_lines (_tmp3_, (gint) _vala_array_length (_tmp1_), &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	s = _tmp6_;
	s_length1 = _tmp6__length1;
	_s_size_ = s_length1;
	_tmp7_ = s;
	_tmp7__length1 = s_length1;
	if (_tmp7__length1 != 2) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup ("Wrong number of dimensions");
		_g_free0 (self->err_msg);
		self->err_msg = _tmp8_;
		result = FALSE;
		s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp9_ = s;
	_tmp9__length1 = s_length1;
	_tmp10_ = _tmp9_[0];
	gnonograms_filereader_set_rows (self, atoi (_tmp10_));
	_tmp11_ = s;
	_tmp11__length1 = s_length1;
	_tmp12_ = _tmp11_[1];
	gnonograms_filereader_set_cols (self, atoi (_tmp12_));
	gnonograms_filereader_set_has_dimensions (self, TRUE);
	_tmp14_ = self->priv->_rows;
	if (_tmp14_ > 0) {
		gint _tmp15_;
		_tmp15_ = self->priv->_cols;
		_tmp13_ = _tmp15_ > 0;
	} else {
		_tmp13_ = FALSE;
	}
	result = _tmp13_;
	s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
gnonograms_filereader_get_gnonogram_clues (GnonogramsFilereader* self,
                                           const gchar* body,
                                           gint max_block,
                                           gint* result_length1)
{
	gchar** clues = NULL;
	gchar** _tmp0_;
	gint clues_length1;
	gint _clues_size_;
	gchar** clue_strings = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint clue_strings_length1;
	gint _clue_strings_size_;
	gboolean _tmp10_ = FALSE;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	clues = _tmp0_;
	clues_length1 = 0;
	_clues_size_ = clues_length1;
	if (body == NULL) {
		gchar* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		_tmp1_ = g_strdup ("No clues given");
		_g_free0 (self->err_msg);
		self->err_msg = _tmp1_;
		_tmp2_ = g_new0 (gchar*, 0 + 1);
		_tmp3_ = _tmp2_;
		_tmp3__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp3__length1;
		}
		result = _tmp3_;
		clues = (_vala_array_free (clues, clues_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp5_ = _tmp4_ = g_strsplit (body, "\n", 0);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _vala_array_length (_tmp4_);
	_tmp8_ = gnonograms_utils_remove_blank_lines (_tmp6_, (gint) _vala_array_length (_tmp4_), &_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = _tmp7_;
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
	clue_strings = _tmp9_;
	clue_strings_length1 = _tmp9__length1;
	_clue_strings_size_ = clue_strings_length1;
	_tmp11_ = clue_strings;
	_tmp11__length1 = clue_strings_length1;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		gchar** _tmp12_;
		gint _tmp12__length1;
		_tmp12_ = clue_strings;
		_tmp12__length1 = clue_strings_length1;
		_tmp10_ = _tmp12__length1 < 1;
	}
	if (_tmp10_) {
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		_tmp13_ = g_strdup (_ ("Missing clues"));
		_g_free0 (self->err_msg);
		self->err_msg = _tmp13_;
		_tmp14_ = g_new0 (gchar*, 0 + 1);
		_tmp15_ = _tmp14_;
		_tmp15__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp15__length1;
		}
		result = _tmp15_;
		clue_strings = (_vala_array_free (clue_strings, clue_strings_length1, (GDestroyNotify) g_free), NULL);
		clues = (_vala_array_free (clues, clues_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp16_ = clue_strings;
	_tmp16__length1 = clue_strings_length1;
	{
		gchar** clue_string_collection = NULL;
		gint clue_string_collection_length1 = 0;
		gint _clue_string_collection_size_ = 0;
		gint clue_string_it = 0;
		clue_string_collection = _tmp16_;
		clue_string_collection_length1 = _tmp16__length1;
		for (clue_string_it = 0; clue_string_it < clue_string_collection_length1; clue_string_it = clue_string_it + 1) {
			gchar* _tmp17_;
			gchar* clue_string = NULL;
			_tmp17_ = g_strdup (clue_string_collection[clue_string_it]);
			clue_string = _tmp17_;
			{
				gchar* clue = NULL;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				const gchar* _tmp20_;
				_tmp18_ = clue_string;
				_tmp19_ = gnonograms_filereader_parse_gnonogram_clue (self, _tmp18_, max_block);
				clue = _tmp19_;
				_tmp20_ = clue;
				if (_tmp20_ == NULL) {
					gchar* _tmp21_;
					gchar** _tmp22_;
					gchar** _tmp23_;
					gint _tmp23__length1;
					_tmp21_ = g_strdup (_ ("Invalid clue"));
					_g_free0 (self->err_msg);
					self->err_msg = _tmp21_;
					_tmp22_ = g_new0 (gchar*, 0 + 1);
					_tmp23_ = _tmp22_;
					_tmp23__length1 = 0;
					if (result_length1) {
						*result_length1 = _tmp23__length1;
					}
					result = _tmp23_;
					_g_free0 (clue);
					_g_free0 (clue_string);
					clue_strings = (_vala_array_free (clue_strings, clue_strings_length1, (GDestroyNotify) g_free), NULL);
					clues = (_vala_array_free (clues, clues_length1, (GDestroyNotify) g_free), NULL);
					return result;
				} else {
					gchar** _tmp24_;
					gint _tmp24__length1;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					_tmp24_ = clues;
					_tmp24__length1 = clues_length1;
					_tmp25_ = clue;
					_tmp26_ = g_strdup (_tmp25_);
					_vala_array_add6 (&clues, &clues_length1, &_clues_size_, _tmp26_);
				}
				_g_free0 (clue);
				_g_free0 (clue_string);
			}
		}
	}
	_tmp27_ = clues;
	_tmp27__length1 = clues_length1;
	if (result_length1) {
		*result_length1 = _tmp27__length1;
	}
	result = _tmp27_;
	clue_strings = (_vala_array_free (clue_strings, clue_strings_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gboolean
gnonograms_filereader_get_gnonogram_cellstate_array (GnonogramsFilereader* self,
                                                     const gchar* body,
                                                     gboolean is_solution)
{
	gchar** row_strings = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint row_strings_length1;
	gint _row_strings_size_;
	gboolean _tmp7_ = FALSE;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (body == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("Solution grid or working grid missing"));
		_g_free0 (self->err_msg);
		self->err_msg = _tmp0_;
		result = FALSE;
		return result;
	}
	_tmp2_ = _tmp1_ = g_strsplit (body, "\n", 0);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	_tmp5_ = gnonograms_utils_remove_blank_lines (_tmp3_, (gint) _vala_array_length (_tmp1_), &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	row_strings = _tmp6_;
	row_strings_length1 = _tmp6__length1;
	_row_strings_size_ = row_strings_length1;
	_tmp8_ = row_strings;
	_tmp8__length1 = row_strings_length1;
	if (_tmp8_ == NULL) {
		_tmp7_ = TRUE;
	} else {
		gchar** _tmp9_;
		gint _tmp9__length1;
		gint _tmp10_;
		_tmp9_ = row_strings;
		_tmp9__length1 = row_strings_length1;
		_tmp10_ = self->priv->_rows;
		_tmp7_ = _tmp9__length1 != _tmp10_;
	}
	if (_tmp7_) {
		gchar* _tmp11_;
		_tmp11_ = g_strdup (_ ("Wrong number of rows in solution or working grid"));
		_g_free0 (self->err_msg);
		self->err_msg = _tmp11_;
		result = FALSE;
		row_strings = (_vala_array_free (row_strings, row_strings_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp12_ = row_strings;
	_tmp12__length1 = row_strings_length1;
	{
		gchar** row_collection = NULL;
		gint row_collection_length1 = 0;
		gint _row_collection_size_ = 0;
		gint row_it = 0;
		row_collection = _tmp12_;
		row_collection_length1 = _tmp12__length1;
		for (row_it = 0; row_it < row_collection_length1; row_it = row_it + 1) {
			gchar* _tmp13_;
			gchar* row = NULL;
			_tmp13_ = g_strdup (row_collection[row_it]);
			row = _tmp13_;
			{
				GnonogramsCellState* states = NULL;
				const gchar* _tmp14_;
				gint _tmp15_ = 0;
				GnonogramsCellState* _tmp16_;
				gint states_length1;
				gint _states_size_;
				GnonogramsCellState* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				_tmp14_ = row;
				_tmp16_ = gnonograms_utils_cellstate_array_from_string (_tmp14_, &_tmp15_);
				states = _tmp16_;
				states_length1 = _tmp15_;
				_states_size_ = states_length1;
				_tmp17_ = states;
				_tmp17__length1 = states_length1;
				_tmp18_ = self->priv->_cols;
				if (_tmp17__length1 != _tmp18_) {
					gchar* _tmp19_;
					_tmp19_ = g_strdup (_ ("Wrong number of columns in solution or working grid"));
					_g_free0 (self->err_msg);
					self->err_msg = _tmp19_;
					result = FALSE;
					states = (g_free (states), NULL);
					_g_free0 (row);
					row_strings = (_vala_array_free (row_strings, row_strings_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				if (is_solution) {
					GnonogramsCellState* _tmp20_;
					gint _tmp20__length1;
					_tmp20_ = states;
					_tmp20__length1 = states_length1;
					{
						GnonogramsCellState* state_collection = NULL;
						gint state_collection_length1 = 0;
						gint _state_collection_size_ = 0;
						gint state_it = 0;
						state_collection = _tmp20_;
						state_collection_length1 = _tmp20__length1;
						for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
							GnonogramsCellState state = 0;
							state = state_collection[state_it];
							{
								GnonogramsCellState _tmp21_;
								_tmp21_ = state;
								if (!(((GNONOGRAMS_CELL_STATE_EMPTY | GNONOGRAMS_CELL_STATE_FILLED) & _tmp21_) == _tmp21_)) {
									gchar* _tmp22_;
									_tmp22_ = g_strdup (_ ("Invalid cell state"));
									_g_free0 (self->err_msg);
									self->err_msg = _tmp22_;
									result = FALSE;
									states = (g_free (states), NULL);
									_g_free0 (row);
									row_strings = (_vala_array_free (row_strings, row_strings_length1, (GDestroyNotify) g_free), NULL);
									return result;
								}
							}
						}
					}
				}
				states = (g_free (states), NULL);
				_g_free0 (row);
			}
		}
	}
	if (is_solution) {
		gchar** _tmp23_;
		gint _tmp23__length1;
		_tmp23_ = row_strings;
		_tmp23__length1 = row_strings_length1;
		gnonograms_filereader_set_solution (self, _tmp23_, _tmp23__length1);
		gnonograms_filereader_set_has_solution (self, TRUE);
	} else {
		gchar** _tmp24_;
		gint _tmp24__length1;
		_tmp24_ = row_strings;
		_tmp24__length1 = row_strings_length1;
		gnonograms_filereader_set_working (self, _tmp24_, _tmp24__length1);
		gnonograms_filereader_set_has_working (self, TRUE);
	}
	result = TRUE;
	row_strings = (_vala_array_free (row_strings, row_strings_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
gnonograms_filereader_get_gnonogram_state (GnonogramsFilereader* self,
                                           const gchar* body)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_filereader_set_state (self, GNONOGRAMS_GAME_STATE_SOLVING);
	if (body != NULL) {
		gchar** s = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gint _tmp3_ = 0;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint s_length1;
		gint _s_size_;
		gboolean _tmp6_ = FALSE;
		gchar** _tmp7_;
		gint _tmp7__length1;
		_tmp1_ = _tmp0_ = g_strsplit (body, "\n", 0);
		_tmp2_ = _tmp1_;
		_tmp2__length1 = _vala_array_length (_tmp0_);
		_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _tmp3_;
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
		s = _tmp5_;
		s_length1 = _tmp5__length1;
		_s_size_ = s_length1;
		_tmp7_ = s;
		_tmp7__length1 = s_length1;
		if (_tmp7_ != NULL) {
			gchar** _tmp8_;
			gint _tmp8__length1;
			_tmp8_ = s;
			_tmp8__length1 = s_length1;
			_tmp6_ = _tmp8__length1 == 1;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			gchar* state_string = NULL;
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
			_tmp9_ = s;
			_tmp9__length1 = s_length1;
			_tmp10_ = _tmp9_[0];
			_tmp11_ = g_strdup (_tmp10_);
			state_string = _tmp11_;
			_tmp12_ = state_string;
			_tmp13_ = g_utf8_strup (_tmp12_, (gssize) -1);
			_tmp14_ = _tmp13_;
			_tmp15_ = string_contains (_tmp14_, "SETTING");
			_g_free0 (_tmp14_);
			if (_tmp15_) {
				gnonograms_filereader_set_state (self, GNONOGRAMS_GAME_STATE_SETTING);
			}
			_g_free0 (state_string);
		}
		s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
	}
	result = TRUE;
	return result;
}

/** First four lines of description must be in order @name, @date, @score (difficulty or grade).
      * Missing data must be represented by blank lines.
    **/
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gboolean
gnonograms_filereader_get_game_description (GnonogramsFilereader* self,
                                            const gchar* body)
{
	gchar** s = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint s_length1;
	gint _s_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (body == NULL) {
		result = TRUE;
		return result;
	}
	_tmp1_ = _tmp0_ = g_strsplit (body, "\n", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	s = _tmp5_;
	s_length1 = _tmp5__length1;
	_s_size_ = s_length1;
	_tmp6_ = s;
	_tmp6__length1 = s_length1;
	if (_tmp6__length1 >= 1) {
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp7_ = s;
		_tmp7__length1 = s_length1;
		_tmp8_ = _tmp7_[0];
		_tmp9_ = g_uri_unescape_string (_tmp8_, NULL);
		_tmp10_ = _tmp9_;
		gnonograms_filereader_set_name (self, _tmp10_);
		_g_free0 (_tmp10_);
	}
	_tmp11_ = s;
	_tmp11__length1 = s_length1;
	if (_tmp11__length1 >= 2) {
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		_tmp12_ = s;
		_tmp12__length1 = s_length1;
		_tmp13_ = _tmp12_[1];
		gnonograms_filereader_set_date (self, _tmp13_);
	}
	_tmp14_ = s;
	_tmp14__length1 = s_length1;
	if (_tmp14__length1 >= 3) {
		gchar* grade = NULL;
		gchar** _tmp15_;
		gint _tmp15__length1;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp15_ = s;
		_tmp15__length1 = s_length1;
		_tmp16_ = _tmp15_[2];
		_tmp17_ = string_strip (_tmp16_);
		grade = _tmp17_;
		_tmp19_ = grade;
		_tmp20_ = strlen (_tmp19_);
		_tmp21_ = _tmp20_;
		if (_tmp21_ == 1) {
			const gchar* _tmp22_;
			_tmp22_ = grade;
			_tmp18_ = g_ascii_isdigit (string_get (_tmp22_, (glong) 0));
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			const gchar* _tmp23_;
			_tmp23_ = grade;
			gnonograms_filereader_set_difficulty (self, (GnonogramsDifficulty) atoi (_tmp23_));
		} else {
			gnonograms_filereader_set_difficulty (self, GNONOGRAMS_DIFFICULTY_UNDEFINED);
		}
		_g_free0 (grade);
	}
	result = TRUE;
	s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gboolean
bool_try_parse (const gchar* str,
                gboolean* _result_)
{
	gboolean _vala__result_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	if (g_strcmp0 (str, "true") == 0) {
		_vala__result_ = TRUE;
		result = TRUE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		return result;
	} else {
		if (g_strcmp0 (str, "false") == 0) {
			_vala__result_ = FALSE;
			result = TRUE;
			if (_result_) {
				*_result_ = _vala__result_;
			}
			return result;
		} else {
			_vala__result_ = FALSE;
			result = FALSE;
			if (_result_) {
				*_result_ = _vala__result_;
			}
			return result;
		}
	}
	if (_result_) {
		*_result_ = _vala__result_;
	}
}

static gboolean
gnonograms_filereader_get_readonly (GnonogramsFilereader* self,
                                    const gchar* body)
{
	gchar** s = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint s_length1;
	gint _s_size_;
	gboolean _result_ = FALSE;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (body == NULL) {
		result = TRUE;
		return result;
	}
	_tmp1_ = _tmp0_ = g_strsplit (body, "\n", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	s = _tmp5_;
	s_length1 = _tmp5__length1;
	_s_size_ = s_length1;
	_result_ = TRUE;
	_tmp6_ = s;
	_tmp6__length1 = s_length1;
	if (_tmp6__length1 >= 1) {
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		_tmp7_ = s;
		_tmp7__length1 = s_length1;
		_tmp8_ = _tmp7_[0];
		_tmp9_ = g_utf8_strdown (_tmp8_, (gssize) -1);
		_tmp10_ = _tmp9_;
		bool_try_parse (_tmp10_, &_tmp11_);
		_result_ = _tmp11_;
		_g_free0 (_tmp10_);
	}
	gnonograms_filereader_set_is_readonly (self, _result_);
	result = TRUE;
	s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gboolean
gnonograms_filereader_get_original_game_path (GnonogramsFilereader* self,
                                              const gchar* body)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp11_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	_result_ = _tmp0_;
	if (body != NULL) {
		gchar** s = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gint _tmp4_ = 0;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gint s_length1;
		gint _s_size_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		_tmp2_ = _tmp1_ = g_strsplit (body, "\n", 0);
		_tmp3_ = _tmp2_;
		_tmp3__length1 = _vala_array_length (_tmp1_);
		_tmp5_ = gnonograms_utils_remove_blank_lines (_tmp3_, (gint) _vala_array_length (_tmp1_), &_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp6__length1 = _tmp4_;
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
		s = _tmp6_;
		s_length1 = _tmp6__length1;
		_s_size_ = s_length1;
		_tmp7_ = s;
		_tmp7__length1 = s_length1;
		if (_tmp7__length1 >= 1) {
			gchar** _tmp8_;
			gint _tmp8__length1;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp8_ = s;
			_tmp8__length1 = s_length1;
			_tmp9_ = _tmp8_[0];
			_tmp10_ = g_strdup (_tmp9_);
			_g_free0 (_result_);
			_result_ = _tmp10_;
		}
		s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp11_ = _result_;
	gnonograms_filereader_set_original_path (self, _tmp11_);
	result = TRUE;
	_g_free0 (_result_);
	return result;
}

static gchar*
gnonograms_filereader_parse_gnonogram_clue (GnonogramsFilereader* self,
                                            const gchar* line,
                                            gint maxblock)
{
	gchar** blocks = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint blocks_length1;
	gint _blocks_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint b = 0;
	gint zero_count = 0;
	gint remaining_space = 0;
	GString* sb = NULL;
	GString* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GString* _tmp18_;
	GString* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GString* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (line != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit_set (line, ", ", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp5_;
	blocks_length1 = _tmp5__length1;
	_blocks_size_ = blocks_length1;
	_tmp6_ = blocks;
	_tmp6__length1 = blocks_length1;
	if (_tmp6_ == NULL) {
		result = NULL;
		blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	zero_count = 0;
	remaining_space = maxblock;
	_tmp7_ = g_string_new ("");
	sb = _tmp7_;
	_tmp8_ = blocks;
	_tmp8__length1 = blocks_length1;
	{
		gchar** block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp8_;
		block_collection_length1 = _tmp8__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gchar* _tmp9_;
			gchar* block = NULL;
			_tmp9_ = g_strdup (block_collection[block_it]);
			block = _tmp9_;
			{
				const gchar* _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp13_ = FALSE;
				GString* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				GString* _tmp17_;
				_tmp10_ = block;
				b = atoi (_tmp10_);
				if (b == 0) {
					_tmp11_ = zero_count > 0;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					_g_free0 (block);
					continue;
				} else {
					gint _tmp12_;
					_tmp12_ = zero_count;
					zero_count = _tmp12_ + 1;
				}
				if (b < 0) {
					_tmp13_ = TRUE;
				} else {
					_tmp13_ = b > remaining_space;
				}
				if (_tmp13_) {
					result = NULL;
					_g_free0 (block);
					_g_string_free0 (sb);
					blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_tmp14_ = sb;
				_tmp15_ = g_strdup_printf ("%i", b);
				_tmp16_ = _tmp15_;
				g_string_append (_tmp14_, _tmp16_);
				_g_free0 (_tmp16_);
				if (b > 0) {
					remaining_space -= b + 1;
				}
				_tmp17_ = sb;
				g_string_append (_tmp17_, GNONOGRAMS_BLOCKSEPARATOR);
				_g_free0 (block);
			}
		}
	}
	_tmp18_ = sb;
	_tmp19_ = sb;
	_tmp20_ = strlen (GNONOGRAMS_BLOCKSEPARATOR);
	_tmp21_ = _tmp20_;
	g_string_truncate (_tmp18_, (gsize) (_tmp19_->len - _tmp21_));
	_tmp22_ = sb;
	_tmp23_ = _tmp22_->str;
	_tmp24_ = g_strdup (_tmp23_);
	result = _tmp24_;
	_g_string_free0 (sb);
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

GFile*
gnonograms_filereader_get_game_file (GnonogramsFilereader* self)
{
	GFile* result;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_game_file;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_filereader_set_game_file (GnonogramsFilereader* self,
                                     GFile* value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_game_file (self) != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_game_file);
		self->priv->_game_file = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY]);
	}
}

GnonogramsGameState
gnonograms_filereader_get_state (GnonogramsFilereader* self)
{
	GnonogramsGameState result;
	GnonogramsGameState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_state (GnonogramsFilereader* self,
                                 GnonogramsGameState value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_STATE_PROPERTY]);
	}
}

gint
gnonograms_filereader_get_rows (GnonogramsFilereader* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_rows;
	return result;
}

static void
gnonograms_filereader_set_rows (GnonogramsFilereader* self,
                                gint value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_rows (self) != value) {
		self->priv->_rows = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ROWS_PROPERTY]);
	}
}

gint
gnonograms_filereader_get_cols (GnonogramsFilereader* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_cols;
	return result;
}

static void
gnonograms_filereader_set_cols (GnonogramsFilereader* self,
                                gint value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_cols (self) != value) {
		self->priv->_cols = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_COLS_PROPERTY]);
	}
}

gchar**
gnonograms_filereader_get_row_clues (GnonogramsFilereader* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_row_clues;
	_tmp0__length1 = self->priv->_row_clues_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup2 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static void
gnonograms_filereader_set_row_clues (GnonogramsFilereader* self,
                                     gchar** value,
                                     gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_row_clues (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup2 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_row_clues = (_vala_array_free (self->priv->_row_clues, self->priv->_row_clues_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_row_clues = _tmp0_;
		self->priv->_row_clues_length1 = _tmp0__length1;
		self->priv->__row_clues_size_ = self->priv->_row_clues_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY]);
	}
}

gchar**
gnonograms_filereader_get_col_clues (GnonogramsFilereader* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_col_clues;
	_tmp0__length1 = self->priv->_col_clues_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup3 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static void
gnonograms_filereader_set_col_clues (GnonogramsFilereader* self,
                                     gchar** value,
                                     gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_col_clues (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup3 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_col_clues = (_vala_array_free (self->priv->_col_clues, self->priv->_col_clues_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_col_clues = _tmp0_;
		self->priv->_col_clues_length1 = _tmp0__length1;
		self->priv->__col_clues_size_ = self->priv->_col_clues_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY]);
	}
}

gchar**
gnonograms_filereader_get_solution (GnonogramsFilereader* self,
                                    gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_solution;
	_tmp0__length1 = self->priv->_solution_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static void
gnonograms_filereader_set_solution (GnonogramsFilereader* self,
                                    gchar** value,
                                    gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_solution (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup4 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_solution = (_vala_array_free (self->priv->_solution, self->priv->_solution_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_solution = _tmp0_;
		self->priv->_solution_length1 = _tmp0__length1;
		self->priv->__solution_size_ = self->priv->_solution_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY]);
	}
}

gchar**
gnonograms_filereader_get_working (GnonogramsFilereader* self,
                                   gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_working;
	_tmp0__length1 = self->priv->_working_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup5 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static void
gnonograms_filereader_set_working (GnonogramsFilereader* self,
                                   gchar** value,
                                   gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_working (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_working = (_vala_array_free (self->priv->_working, self->priv->_working_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_working = _tmp0_;
		self->priv->_working_length1 = _tmp0__length1;
		self->priv->__working_size_ = self->priv->_working_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_WORKING_PROPERTY]);
	}
}

const gchar*
gnonograms_filereader_get_name (GnonogramsFilereader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_name (GnonogramsFilereader* self,
                                const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gnonograms_filereader_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_NAME_PROPERTY]);
	}
}

const gchar*
gnonograms_filereader_get_date (GnonogramsFilereader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_date (GnonogramsFilereader* self,
                                const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gnonograms_filereader_get_date (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_DATE_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_filereader_get_difficulty (GnonogramsFilereader* self)
{
	GnonogramsDifficulty result;
	GnonogramsDifficulty _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_difficulty;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_difficulty (GnonogramsFilereader* self,
                                      GnonogramsDifficulty value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_difficulty (self) != value) {
		self->priv->_difficulty = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY]);
	}
}

const gchar*
gnonograms_filereader_get_license (GnonogramsFilereader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_license;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_license (GnonogramsFilereader* self,
                                   const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gnonograms_filereader_get_license (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_license);
		self->priv->_license = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_LICENSE_PROPERTY]);
	}
}

const gchar*
gnonograms_filereader_get_original_path (GnonogramsFilereader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_original_path;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_original_path (GnonogramsFilereader* self,
                                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gnonograms_filereader_get_original_path (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_original_path);
		self->priv->_original_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY]);
	}
}

const gchar*
gnonograms_filereader_get_moves (GnonogramsFilereader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_moves;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filereader_set_moves (GnonogramsFilereader* self,
                                 const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gnonograms_filereader_get_moves (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_moves);
		self->priv->_moves = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_MOVES_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_dimensions (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_dimensions;
	return result;
}

static void
gnonograms_filereader_set_has_dimensions (GnonogramsFilereader* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_dimensions (self) != value) {
		self->priv->_has_dimensions = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_row_clues (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_row_clues;
	return result;
}

static void
gnonograms_filereader_set_has_row_clues (GnonogramsFilereader* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_row_clues (self) != value) {
		self->priv->_has_row_clues = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_col_clues (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_col_clues;
	return result;
}

static void
gnonograms_filereader_set_has_col_clues (GnonogramsFilereader* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_col_clues (self) != value) {
		self->priv->_has_col_clues = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_solution (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_solution;
	return result;
}

static void
gnonograms_filereader_set_has_solution (GnonogramsFilereader* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_solution (self) != value) {
		self->priv->_has_solution = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_working (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_working;
	return result;
}

static void
gnonograms_filereader_set_has_working (GnonogramsFilereader* self,
                                       gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_working (self) != value) {
		self->priv->_has_working = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_has_state (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_state;
	return result;
}

static void
gnonograms_filereader_set_has_state (GnonogramsFilereader* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_has_state (self) != value) {
		self->priv->_has_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_is_readonly (GnonogramsFilereader* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_readonly;
	return result;
}

static void
gnonograms_filereader_set_is_readonly (GnonogramsFilereader* self,
                                       gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_filereader_get_is_readonly (self) != value) {
		self->priv->_is_readonly = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY]);
	}
}

gboolean
gnonograms_filereader_get_valid (GnonogramsFilereader* self)
{
	gboolean result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->err_msg;
	result = g_strcmp0 (_tmp0_, "") == 0;
	return result;
}

static void
gnonograms_filereader_class_init (GnonogramsFilereaderClass * klass,
                                  gpointer klass_data)
{
	gnonograms_filereader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsFilereader_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_filereader_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_filereader_set_property;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_filereader_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY] = g_param_spec_object ("game-file", "game-file", "game-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_STATE_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", GNONOGRAMS_TYPE_GAME_STATE, GNONOGRAMS_GAME_STATE_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_ROWS_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_COLS_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY] = g_param_spec_boxed ("row-clues", "row-clues", "row-clues", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY] = g_param_spec_boxed ("col-clues", "col-clues", "col-clues", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY] = g_param_spec_boxed ("solution", "solution", "solution", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_WORKING_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_WORKING_PROPERTY] = g_param_spec_boxed ("working", "working", "working", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_NAME_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_DATE_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_DATE_PROPERTY] = g_param_spec_string ("date", "date", "date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY] = g_param_spec_enum ("difficulty", "difficulty", "difficulty", GNONOGRAMS_TYPE_DIFFICULTY, GNONOGRAMS_DIFFICULTY_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_LICENSE_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_LICENSE_PROPERTY] = g_param_spec_string ("license", "license", "license", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY] = g_param_spec_string ("original-path", "original-path", "original-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_MOVES_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_MOVES_PROPERTY] = g_param_spec_string ("moves", "moves", "moves", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY] = g_param_spec_boolean ("has-dimensions", "has-dimensions", "has-dimensions", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY] = g_param_spec_boolean ("has-row-clues", "has-row-clues", "has-row-clues", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY] = g_param_spec_boolean ("has-col-clues", "has-col-clues", "has-col-clues", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY] = g_param_spec_boolean ("has-solution", "has-solution", "has-solution", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY] = g_param_spec_boolean ("has-working", "has-working", "has-working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY] = g_param_spec_boolean ("has-state", "has-state", "has-state", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY] = g_param_spec_boolean ("is-readonly", "is-readonly", "is-readonly", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEREADER_VALID_PROPERTY, gnonograms_filereader_properties[GNONOGRAMS_FILEREADER_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gnonograms_filereader_instance_init (GnonogramsFilereader * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	self->priv = gnonograms_filereader_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->err_msg = _tmp0_;
	self->priv->_game_file = NULL;
	self->priv->_state = GNONOGRAMS_GAME_STATE_UNDEFINED;
	self->priv->_rows = 0;
	self->priv->_cols = 0;
	_tmp1_ = g_strdup ("");
	self->priv->_name = _tmp1_;
	_tmp2_ = g_strdup ("");
	self->priv->_date = _tmp2_;
	self->priv->_difficulty = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	_tmp3_ = g_strdup ("");
	self->priv->_license = _tmp3_;
	_tmp4_ = g_strdup ("");
	self->priv->_original_path = _tmp4_;
	_tmp5_ = g_strdup ("");
	self->priv->_moves = _tmp5_;
	self->priv->_has_dimensions = FALSE;
	self->priv->_has_row_clues = FALSE;
	self->priv->_has_col_clues = FALSE;
	self->priv->_has_solution = FALSE;
	self->priv->_has_working = FALSE;
	self->priv->_has_state = FALSE;
	self->priv->_is_readonly = TRUE;
}

static void
gnonograms_filereader_finalize (GObject * obj)
{
	GnonogramsFilereader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereader);
	_g_free0 (self->err_msg);
	_g_object_unref0 (self->priv->_game_file);
	self->priv->_row_clues = (_vala_array_free (self->priv->_row_clues, self->priv->_row_clues_length1, (GDestroyNotify) g_free), NULL);
	self->priv->_col_clues = (_vala_array_free (self->priv->_col_clues, self->priv->_col_clues_length1, (GDestroyNotify) g_free), NULL);
	self->priv->_solution = (_vala_array_free (self->priv->_solution, self->priv->_solution_length1, (GDestroyNotify) g_free), NULL);
	self->priv->_working = (_vala_array_free (self->priv->_working, self->priv->_working_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_date);
	_g_free0 (self->priv->_license);
	_g_free0 (self->priv->_original_path);
	_g_free0 (self->priv->_moves);
	G_OBJECT_CLASS (gnonograms_filereader_parent_class)->finalize (obj);
}

GType
gnonograms_filereader_get_type (void)
{
	static volatile gsize gnonograms_filereader_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_filereader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsFilereaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_filereader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsFilereader), 0, (GInstanceInitFunc) gnonograms_filereader_instance_init, NULL };
		GType gnonograms_filereader_type_id;
		gnonograms_filereader_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsFilereader", &g_define_type_info, 0);
		GnonogramsFilereader_private_offset = g_type_add_instance_private (gnonograms_filereader_type_id, sizeof (GnonogramsFilereaderPrivate));
		g_once_init_leave (&gnonograms_filereader_type_id__volatile, gnonograms_filereader_type_id);
	}
	return gnonograms_filereader_type_id__volatile;
}

static void
_vala_gnonograms_filereader_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsFilereader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereader);
	switch (property_id) {
		case GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY:
		g_value_set_object (value, gnonograms_filereader_get_game_file (self));
		break;
		case GNONOGRAMS_FILEREADER_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_filereader_get_state (self));
		break;
		case GNONOGRAMS_FILEREADER_ROWS_PROPERTY:
		g_value_set_int (value, gnonograms_filereader_get_rows (self));
		break;
		case GNONOGRAMS_FILEREADER_COLS_PROPERTY:
		g_value_set_int (value, gnonograms_filereader_get_cols (self));
		break;
		case GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filereader_get_row_clues (self, &length));
		}
		break;
		case GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filereader_get_col_clues (self, &length));
		}
		break;
		case GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filereader_get_solution (self, &length));
		}
		break;
		case GNONOGRAMS_FILEREADER_WORKING_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filereader_get_working (self, &length));
		}
		break;
		case GNONOGRAMS_FILEREADER_NAME_PROPERTY:
		g_value_set_string (value, gnonograms_filereader_get_name (self));
		break;
		case GNONOGRAMS_FILEREADER_DATE_PROPERTY:
		g_value_set_string (value, gnonograms_filereader_get_date (self));
		break;
		case GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY:
		g_value_set_enum (value, gnonograms_filereader_get_difficulty (self));
		break;
		case GNONOGRAMS_FILEREADER_LICENSE_PROPERTY:
		g_value_set_string (value, gnonograms_filereader_get_license (self));
		break;
		case GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY:
		g_value_set_string (value, gnonograms_filereader_get_original_path (self));
		break;
		case GNONOGRAMS_FILEREADER_MOVES_PROPERTY:
		g_value_set_string (value, gnonograms_filereader_get_moves (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_dimensions (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_row_clues (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_col_clues (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_solution (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_working (self));
		break;
		case GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_has_state (self));
		break;
		case GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_is_readonly (self));
		break;
		case GNONOGRAMS_FILEREADER_VALID_PROPERTY:
		g_value_set_boolean (value, gnonograms_filereader_get_valid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_filereader_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsFilereader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereader);
	switch (property_id) {
		case GNONOGRAMS_FILEREADER_GAME_FILE_PROPERTY:
		gnonograms_filereader_set_game_file (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_FILEREADER_STATE_PROPERTY:
		gnonograms_filereader_set_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_FILEREADER_ROWS_PROPERTY:
		gnonograms_filereader_set_rows (self, g_value_get_int (value));
		break;
		case GNONOGRAMS_FILEREADER_COLS_PROPERTY:
		gnonograms_filereader_set_cols (self, g_value_get_int (value));
		break;
		case GNONOGRAMS_FILEREADER_ROW_CLUES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filereader_set_row_clues (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEREADER_COL_CLUES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filereader_set_col_clues (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEREADER_SOLUTION_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filereader_set_solution (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEREADER_WORKING_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filereader_set_working (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEREADER_NAME_PROPERTY:
		gnonograms_filereader_set_name (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEREADER_DATE_PROPERTY:
		gnonograms_filereader_set_date (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEREADER_DIFFICULTY_PROPERTY:
		gnonograms_filereader_set_difficulty (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_FILEREADER_LICENSE_PROPERTY:
		gnonograms_filereader_set_license (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEREADER_ORIGINAL_PATH_PROPERTY:
		gnonograms_filereader_set_original_path (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEREADER_MOVES_PROPERTY:
		gnonograms_filereader_set_moves (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_DIMENSIONS_PROPERTY:
		gnonograms_filereader_set_has_dimensions (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_ROW_CLUES_PROPERTY:
		gnonograms_filereader_set_has_row_clues (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_COL_CLUES_PROPERTY:
		gnonograms_filereader_set_has_col_clues (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_SOLUTION_PROPERTY:
		gnonograms_filereader_set_has_solution (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_WORKING_PROPERTY:
		gnonograms_filereader_set_has_working (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_HAS_STATE_PROPERTY:
		gnonograms_filereader_set_has_state (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEREADER_IS_READONLY_PROPERTY:
		gnonograms_filereader_set_is_readonly (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

