/* Model.c generated by valac 0.46.6, the Vala compiler
 * generated from Model.vala, do not modify */

/* Handles working and solution data for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;
typedef struct _GnonogramsModelPrivate GnonogramsModelPrivate;
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
enum  {
	GNONOGRAMS_MODEL_0_PROPERTY,
	GNONOGRAMS_MODEL_GAME_STATE_PROPERTY,
	GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY,
	GNONOGRAMS_MODEL_ROWS_PROPERTY,
	GNONOGRAMS_MODEL_COLS_PROPERTY,
	GNONOGRAMS_MODEL_DISPLAY_DATA_PROPERTY,
	GNONOGRAMS_MODEL_IS_FINISHED_PROPERTY,
	GNONOGRAMS_MODEL_NUM_PROPERTIES
};
static GParamSpec* gnonograms_model_properties[GNONOGRAMS_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
enum  {
	GNONOGRAMS_MODEL_CHANGED_SIGNAL,
	GNONOGRAMS_MODEL_NUM_SIGNALS
};
static guint gnonograms_model_signals[GNONOGRAMS_MODEL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsModel {
	GObject parent_instance;
	GnonogramsModelPrivate * priv;
};

struct _GnonogramsModelClass {
	GObjectClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsModelPrivate {
	GnonogramsGameState _game_state;
	GnonogramsDimensions _dimensions;
	GnonogramsMy2DCellArray* _solution_data;
	GnonogramsMy2DCellArray* _working_data;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

static gint GnonogramsModel_private_offset;
static gpointer gnonograms_model_parent_class = NULL;

GType gnonograms_model_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
GType gnonograms_game_state_get_type (void) G_GNUC_CONST;
GType gnonograms_dimensions_get_type (void) G_GNUC_CONST;
GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
void gnonograms_dimensions_free (GnonogramsDimensions* self);
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
gint gnonograms_model_count_errors (GnonogramsModel* self);
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
guint gnonograms_model_get_rows (GnonogramsModel* self);
guint gnonograms_model_get_cols (GnonogramsModel* self);
static GnonogramsMy2DCellArray* gnonograms_model_get_working_data (GnonogramsModel* self);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
static GnonogramsMy2DCellArray* gnonograms_model_get_solution_data (GnonogramsModel* self);
static gint gnonograms_model_count_state (GnonogramsModel* self,
                                   GnonogramsGameState game_state,
                                   GnonogramsCellState cell_state);
void gnonograms_model_clear (GnonogramsModel* self);
void gnonograms_model_blank_solution (GnonogramsModel* self);
void gnonograms_model_blank_working (GnonogramsModel* self);
void gnonograms_my2_dcell_array_set_all (GnonogramsMy2DCellArray* self,
                                         GnonogramsCellState s);
gboolean gnonograms_model_is_blank (GnonogramsModel* self,
                                    GnonogramsGameState state);
gboolean gnonograms_model_working_matches_clues (GnonogramsModel* self);
gchar** gnonograms_model_get_row_clues (GnonogramsModel* self,
                                        gint* result_length1);
gchar* gnonograms_model_get_label_text_from_working (GnonogramsModel* self,
                                                     guint idx,
                                                     gboolean is_column);
gchar** gnonograms_model_get_col_clues (GnonogramsModel* self,
                                        gint* result_length1);
static gchar** gnonograms_model_get_clues (GnonogramsModel* self,
                                    gboolean is_column,
                                    gint* result_length1);
gchar* gnonograms_model_get_label_text_from_solution (GnonogramsModel* self,
                                                      guint idx,
                                                      gboolean is_column);
gchar* gnonograms_my2_dcell_array_data2text (GnonogramsMy2DCellArray* self,
                                             guint idx,
                                             guint length,
                                             gboolean iscolumn);
gpointer gnonograms_block_ref (gpointer instance);
void gnonograms_block_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
gpointer gnonograms_value_get_block (const GValue* value);
GType gnonograms_block_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
GeeArrayList* gnonograms_model_get_complete_blocks_from_working (GnonogramsModel* self,
                                                                 guint index,
                                                                 gboolean is_column);
void gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState** sa,
                                           gint* sa_length1,
                                           guint start);
GeeArrayList* gnonograms_utils_complete_block_array_from_cellstate_array (GnonogramsCellState* cellstates,
                                                                          gint cellstates_length1);
gboolean gnonograms_model_get_complete (GnonogramsModel* self,
                                        guint idx,
                                        gboolean is_column);
GType gnonograms_cell_get_type (void) G_GNUC_CONST;
GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
void gnonograms_cell_free (GnonogramsCell* self);
void gnonograms_model_set_data_from_cell (GnonogramsModel* self,
                                          GnonogramsCell* cell);
GnonogramsMy2DCellArray* gnonograms_model_get_display_data (GnonogramsModel* self);
void gnonograms_my2_dcell_array_set_data_from_cell (GnonogramsMy2DCellArray* self,
                                                    GnonogramsCell* c);
void gnonograms_model_set_data_from_rc (GnonogramsModel* self,
                                        guint r,
                                        guint c,
                                        GnonogramsCellState state);
void gnonograms_my2_dcell_array_set_data_from_rc (GnonogramsMy2DCellArray* self,
                                                  guint r,
                                                  guint c,
                                                  GnonogramsCellState s);
void gnonograms_model_set_solution_from_array (GnonogramsModel* self,
                                               GnonogramsMy2DCellArray* array);
void gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                      GnonogramsMy2DCellArray* ca);
void gnonograms_model_set_working_from_array (GnonogramsModel* self,
                                              GnonogramsMy2DCellArray* array);
GnonogramsCellState gnonograms_model_get_data_for_cell (GnonogramsModel* self,
                                                        GnonogramsCell* cell);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_for_cell (GnonogramsMy2DCellArray* self,
                                                                  GnonogramsCell* cell);
GnonogramsCellState gnonograms_model_get_data_from_rc (GnonogramsModel* self,
                                                       guint r,
                                                       guint c);
static void gnonograms_model_set_row_data_from_string_array (GnonogramsModel* self,
                                                      gchar** row_data_strings,
                                                      gint row_data_strings_length1,
                                                      GnonogramsMy2DCellArray* array);
void gnonograms_my2_dcell_array_set_row (GnonogramsMy2DCellArray* self,
                                         guint row,
                                         GnonogramsCellState* sa,
                                         gint sa_length1,
                                         guint start);
GnonogramsCellState* gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                                                   gint* result_length1);
void gnonograms_model_set_working_data_from_string_array (GnonogramsModel* self,
                                                          gchar** row_data_strings,
                                                          gint row_data_strings_length1);
void gnonograms_model_set_solution_data_from_string_array (GnonogramsModel* self,
                                                           gchar** row_data_strings,
                                                           gint row_data_strings_length1);
void gnonograms_model_copy_to_working_data (GnonogramsModel* self,
                                            GnonogramsMy2DCellArray* grid);
void gnonograms_model_copy_to_solution_data (GnonogramsModel* self,
                                             GnonogramsMy2DCellArray* grid);
GnonogramsMy2DCellArray* gnonograms_model_copy_working_data (GnonogramsModel* self);
void gnonograms_model_get_dimensions (GnonogramsModel* self,
                                      GnonogramsDimensions * result);
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_new (GnonogramsDimensions* _dimensions,
                                                         GnonogramsCellState init);
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_construct (GType object_type,
                                                               GnonogramsDimensions* _dimensions,
                                                               GnonogramsCellState init);
GnonogramsMy2DCellArray* gnonograms_model_copy_solution_data (GnonogramsModel* self);
GnonogramsModel* gnonograms_model_new (void);
GnonogramsModel* gnonograms_model_construct (GType object_type);
GnonogramsGameState gnonograms_model_get_game_state (GnonogramsModel* self);
void gnonograms_model_set_game_state (GnonogramsModel* self,
                                      GnonogramsGameState value);
void gnonograms_model_set_dimensions (GnonogramsModel* self,
                                      GnonogramsDimensions * value);
static gboolean _gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                                       const GnonogramsDimensions * s2);
gboolean gnonograms_model_get_is_finished (GnonogramsModel* self);
static void gnonograms_model_set_solution_data (GnonogramsModel* self,
                                         GnonogramsMy2DCellArray* value);
static void gnonograms_model_set_working_data (GnonogramsModel* self,
                                        GnonogramsMy2DCellArray* value);
static GObject * gnonograms_model_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _gnonograms_model___lambda4_ (GnonogramsModel* self);
static void __gnonograms_model___lambda4__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_model___lambda5_ (GnonogramsModel* self);
static void __gnonograms_model___lambda5__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void gnonograms_model_finalize (GObject * obj);
static void _vala_gnonograms_model_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_gnonograms_model_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gnonograms_model_get_instance_private (GnonogramsModel* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsModel_private_offset);
}

gint
gnonograms_model_count_errors (GnonogramsModel* self)
{
	GnonogramsCellState cs = 0;
	gint count = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_model_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsMy2DCellArray* _tmp8_;
							gboolean _tmp9_ = FALSE;
							GnonogramsCellState _tmp10_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_model_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->_working_data;
							cs = gnonograms_my2_dcell_array_get_data_from_rc (_tmp8_, (guint) r, (guint) c);
							_tmp10_ = cs;
							if (_tmp10_ != GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GnonogramsCellState _tmp11_;
								GnonogramsMy2DCellArray* _tmp12_;
								_tmp11_ = cs;
								_tmp12_ = self->priv->_solution_data;
								_tmp9_ = _tmp11_ != gnonograms_my2_dcell_array_get_data_from_rc (_tmp12_, (guint) r, (guint) c);
							} else {
								_tmp9_ = FALSE;
							}
							if (_tmp9_) {
								gint _tmp13_;
								_tmp13_ = count;
								count = _tmp13_ + 1;
							}
						}
					}
				}
			}
		}
	}
	result = count;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gint
gnonograms_model_count_state (GnonogramsModel* self,
                              GnonogramsGameState game_state,
                              GnonogramsCellState cell_state)
{
	gint count = 0;
	GnonogramsCellState cs = 0;
	GnonogramsMy2DCellArray* _tmp0_ = NULL;
	GnonogramsMy2DCellArray* arr = NULL;
	GnonogramsMy2DCellArray* _tmp3_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	if (game_state == GNONOGRAMS_GAME_STATE_SOLVING) {
		GnonogramsMy2DCellArray* _tmp1_;
		_tmp1_ = self->priv->_working_data;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsMy2DCellArray* _tmp2_;
		_tmp2_ = self->priv->_solution_data;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	arr = _tmp3_;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				guint _tmp6_;
				guint _tmp7_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = r;
					r = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = gnonograms_model_get_rows (self);
				_tmp7_ = _tmp6_;
				if (!(((guint) r) < _tmp7_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp8_ = FALSE;
						_tmp8_ = TRUE;
						while (TRUE) {
							guint _tmp10_;
							guint _tmp11_;
							GnonogramsMy2DCellArray* _tmp12_;
							GnonogramsCellState _tmp13_;
							if (!_tmp8_) {
								gint _tmp9_;
								_tmp9_ = c;
								c = _tmp9_ + 1;
							}
							_tmp8_ = FALSE;
							_tmp10_ = gnonograms_model_get_cols (self);
							_tmp11_ = _tmp10_;
							if (!(((guint) c) < _tmp11_)) {
								break;
							}
							_tmp12_ = arr;
							cs = gnonograms_my2_dcell_array_get_data_from_rc (_tmp12_, (guint) r, (guint) c);
							_tmp13_ = cs;
							if (_tmp13_ == cell_state) {
								gint _tmp14_;
								_tmp14_ = count;
								count = _tmp14_ + 1;
							}
						}
					}
				}
			}
		}
	}
	result = count;
	_g_object_unref0 (arr);
	return result;
}

void
gnonograms_model_clear (GnonogramsModel* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_model_blank_solution (self);
	gnonograms_model_blank_working (self);
}

void
gnonograms_model_blank_solution (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_solution_data;
	gnonograms_my2_dcell_array_set_all (_tmp0_, GNONOGRAMS_CELL_STATE_EMPTY);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_blank_working (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_set_all (_tmp0_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

gboolean
gnonograms_model_is_blank (GnonogramsModel* self,
                           GnonogramsGameState state)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (state == GNONOGRAMS_GAME_STATE_SOLVING) {
		result = (gnonograms_model_count_state (self, state, GNONOGRAMS_CELL_STATE_EMPTY) + gnonograms_model_count_state (self, state, GNONOGRAMS_CELL_STATE_FILLED)) == 0;
		return result;
	} else {
		result = gnonograms_model_count_state (self, state, GNONOGRAMS_CELL_STATE_FILLED) == 0;
		return result;
	}
}

gboolean
gnonograms_model_working_matches_clues (GnonogramsModel* self)
{
	gint index = 0;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint _tmp8_ = 0;
	gchar** _tmp9_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	index = 0;
	_tmp1_ = gnonograms_model_get_row_clues (self, &_tmp0_);
	{
		gchar** clue_collection = NULL;
		gint clue_collection_length1 = 0;
		gint _clue_collection_size_ = 0;
		gint clue_it = 0;
		clue_collection = _tmp1_;
		clue_collection_length1 = _tmp0_;
		for (clue_it = 0; clue_it < clue_collection_length1; clue_it = clue_it + 1) {
			gchar* _tmp2_;
			gchar* clue = NULL;
			_tmp2_ = g_strdup (clue_collection[clue_it]);
			clue = _tmp2_;
			{
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gboolean _tmp6_;
				gint _tmp7_;
				_tmp3_ = clue;
				_tmp4_ = gnonograms_model_get_label_text_from_working (self, (guint) index, FALSE);
				_tmp5_ = _tmp4_;
				_tmp6_ = g_strcmp0 (_tmp3_, _tmp5_) != 0;
				_g_free0 (_tmp5_);
				if (_tmp6_) {
					result = FALSE;
					_g_free0 (clue);
					clue_collection = (_vala_array_free (clue_collection, clue_collection_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_tmp7_ = index;
				index = _tmp7_ + 1;
				_g_free0 (clue);
			}
		}
		clue_collection = (_vala_array_free (clue_collection, clue_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	index = 0;
	_tmp9_ = gnonograms_model_get_col_clues (self, &_tmp8_);
	{
		gchar** clue_collection = NULL;
		gint clue_collection_length1 = 0;
		gint _clue_collection_size_ = 0;
		gint clue_it = 0;
		clue_collection = _tmp9_;
		clue_collection_length1 = _tmp8_;
		for (clue_it = 0; clue_it < clue_collection_length1; clue_it = clue_it + 1) {
			gchar* _tmp10_;
			gchar* clue = NULL;
			_tmp10_ = g_strdup (clue_collection[clue_it]);
			clue = _tmp10_;
			{
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
				gint _tmp15_;
				_tmp11_ = clue;
				_tmp12_ = gnonograms_model_get_label_text_from_working (self, (guint) index, TRUE);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strcmp0 (_tmp11_, _tmp13_) != 0;
				_g_free0 (_tmp13_);
				if (_tmp14_) {
					result = FALSE;
					_g_free0 (clue);
					clue_collection = (_vala_array_free (clue_collection, clue_collection_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_tmp15_ = index;
				index = _tmp15_ + 1;
				_g_free0 (clue);
			}
		}
		clue_collection = (_vala_array_free (clue_collection, clue_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = TRUE;
	return result;
}

gchar**
gnonograms_model_get_row_clues (GnonogramsModel* self,
                                gint* result_length1)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = gnonograms_model_get_clues (self, FALSE, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp0_;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

gchar**
gnonograms_model_get_col_clues (GnonogramsModel* self,
                                gint* result_length1)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = gnonograms_model_get_clues (self, TRUE, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp0_;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static gchar**
gnonograms_model_get_clues (GnonogramsModel* self,
                            gboolean is_column,
                            gint* result_length1)
{
	guint _tmp0_ = 0U;
	guint dim = 0U;
	gchar** texts = NULL;
	gchar** _tmp5_;
	gint texts_length1;
	gint _texts_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (is_column) {
		guint _tmp1_;
		guint _tmp2_;
		_tmp1_ = gnonograms_model_get_cols (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_model_get_rows (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	}
	dim = _tmp0_;
	_tmp5_ = g_new0 (gchar*, dim + 1);
	texts = _tmp5_;
	texts_length1 = dim;
	_texts_size_ = texts_length1;
	{
		guint index = 0U;
		index = (guint) 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar* _tmp9_;
				if (!_tmp6_) {
					guint _tmp7_;
					_tmp7_ = index;
					index = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				if (!(index < dim)) {
					break;
				}
				_tmp8_ = texts;
				_tmp8__length1 = texts_length1;
				_tmp9_ = gnonograms_model_get_label_text_from_solution (self, index, is_column);
				_g_free0 (_tmp8_[index]);
				_tmp8_[index] = _tmp9_;
			}
		}
	}
	_tmp10_ = texts;
	_tmp10__length1 = texts_length1;
	if (result_length1) {
		*result_length1 = _tmp10__length1;
	}
	result = _tmp10_;
	return result;
}

gchar*
gnonograms_model_get_label_text_from_solution (GnonogramsModel* self,
                                               guint idx,
                                               gboolean is_column)
{
	guint _tmp0_ = 0U;
	guint length = 0U;
	GnonogramsMy2DCellArray* _tmp5_;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (is_column) {
		guint _tmp1_;
		guint _tmp2_;
		_tmp1_ = gnonograms_model_get_rows (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_model_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	}
	length = _tmp0_;
	_tmp5_ = self->priv->_solution_data;
	_tmp6_ = gnonograms_my2_dcell_array_data2text (_tmp5_, idx, length, is_column);
	result = _tmp6_;
	return result;
}

gchar*
gnonograms_model_get_label_text_from_working (GnonogramsModel* self,
                                              guint idx,
                                              gboolean is_column)
{
	guint _tmp0_ = 0U;
	guint length = 0U;
	GnonogramsMy2DCellArray* _tmp5_;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (is_column) {
		guint _tmp1_;
		guint _tmp2_;
		_tmp1_ = gnonograms_model_get_rows (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_model_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	}
	length = _tmp0_;
	_tmp5_ = self->priv->_working_data;
	_tmp6_ = gnonograms_my2_dcell_array_data2text (_tmp5_, idx, length, is_column);
	result = _tmp6_;
	return result;
}

GeeArrayList*
gnonograms_model_get_complete_blocks_from_working (GnonogramsModel* self,
                                                   guint index,
                                                   gboolean is_column)
{
	guint _tmp0_ = 0U;
	GnonogramsCellState* csa = NULL;
	GnonogramsCellState* _tmp5_;
	gint csa_length1;
	gint _csa_size_;
	GnonogramsMy2DCellArray* _tmp6_;
	GnonogramsCellState* _tmp7_;
	gint _tmp7__length1;
	GeeArrayList* _tmp8_;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (is_column) {
		guint _tmp1_;
		guint _tmp2_;
		_tmp1_ = gnonograms_model_get_rows (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_model_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = g_new0 (GnonogramsCellState, _tmp0_);
	csa = _tmp5_;
	csa_length1 = _tmp0_;
	_csa_size_ = csa_length1;
	_tmp6_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_get_array (_tmp6_, index, is_column, &csa, (gint*) (&csa_length1), (guint) 0);
	_tmp7_ = csa;
	_tmp7__length1 = csa_length1;
	_tmp8_ = gnonograms_utils_complete_block_array_from_cellstate_array (_tmp7_, (gint) _tmp7__length1);
	result = _tmp8_;
	csa = (g_free (csa), NULL);
	return result;
}

gboolean
gnonograms_model_get_complete (GnonogramsModel* self,
                               guint idx,
                               gboolean is_column)
{
	guint _tmp0_ = 0U;
	GnonogramsCellState* csa = NULL;
	GnonogramsCellState* _tmp5_;
	gint csa_length1;
	gint _csa_size_;
	GnonogramsMy2DCellArray* _tmp6_;
	GnonogramsCellState* _tmp7_;
	gint _tmp7__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (is_column) {
		guint _tmp1_;
		guint _tmp2_;
		_tmp1_ = gnonograms_model_get_rows (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_model_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = g_new0 (GnonogramsCellState, _tmp0_);
	csa = _tmp5_;
	csa_length1 = _tmp0_;
	_csa_size_ = csa_length1;
	_tmp6_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_get_array (_tmp6_, idx, is_column, &csa, (gint*) (&csa_length1), (guint) 0);
	_tmp7_ = csa;
	_tmp7__length1 = csa_length1;
	{
		GnonogramsCellState* cs_collection = NULL;
		gint cs_collection_length1 = 0;
		gint _cs_collection_size_ = 0;
		gint cs_it = 0;
		cs_collection = _tmp7_;
		cs_collection_length1 = _tmp7__length1;
		for (cs_it = 0; cs_it < cs_collection_length1; cs_it = cs_it + 1) {
			GnonogramsCellState cs = 0;
			cs = cs_collection[cs_it];
			{
				GnonogramsCellState _tmp8_;
				_tmp8_ = cs;
				if (_tmp8_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
					result = FALSE;
					csa = (g_free (csa), NULL);
					return result;
				}
			}
		}
	}
	result = TRUE;
	csa = (g_free (csa), NULL);
	return result;
}

void
gnonograms_model_set_data_from_cell (GnonogramsModel* self,
                                     GnonogramsCell* cell)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsCell _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	_tmp0_ = gnonograms_model_get_display_data (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = *cell;
	gnonograms_my2_dcell_array_set_data_from_cell (_tmp1_, &_tmp2_);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_set_data_from_rc (GnonogramsModel* self,
                                   guint r,
                                   guint c,
                                   GnonogramsCellState state)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gnonograms_model_get_display_data (self);
	_tmp1_ = _tmp0_;
	gnonograms_my2_dcell_array_set_data_from_rc (_tmp1_, r, c, state);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_set_solution_from_array (GnonogramsModel* self,
                                          GnonogramsMy2DCellArray* array)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (array != NULL);
	_tmp0_ = self->priv->_solution_data;
	gnonograms_my2_dcell_array_copy (_tmp0_, array);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_set_working_from_array (GnonogramsModel* self,
                                         GnonogramsMy2DCellArray* array)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (array != NULL);
	_tmp0_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_copy (_tmp0_, array);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

GnonogramsCellState
gnonograms_model_get_data_for_cell (GnonogramsModel* self,
                                    GnonogramsCell* cell)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCellState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (cell != NULL, 0);
	_tmp0_ = gnonograms_model_get_display_data (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = *cell;
	result = gnonograms_my2_dcell_array_get_data_for_cell (_tmp1_, &_tmp2_);
	return result;
}

GnonogramsCellState
gnonograms_model_get_data_from_rc (GnonogramsModel* self,
                                   guint r,
                                   guint c)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsCellState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gnonograms_model_get_display_data (self);
	_tmp1_ = _tmp0_;
	result = gnonograms_my2_dcell_array_get_data_from_rc (_tmp1_, r, c);
	return result;
}

static void
gnonograms_model_set_row_data_from_string_array (GnonogramsModel* self,
                                                 gchar** row_data_strings,
                                                 gint row_data_strings_length1,
                                                 GnonogramsMy2DCellArray* array)
{
	guint _tmp0_;
	guint _tmp1_;
	gint row = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (array != NULL);
	_tmp0_ = gnonograms_model_get_rows (self);
	_tmp1_ = _tmp0_;
	_vala_assert (((guint) row_data_strings_length1) == _tmp1_, "row_data_strings.length == rows");
	row = 0;
	{
		gchar** row_string_collection = NULL;
		gint row_string_collection_length1 = 0;
		gint _row_string_collection_size_ = 0;
		gint row_string_it = 0;
		row_string_collection = row_data_strings;
		row_string_collection_length1 = row_data_strings_length1;
		for (row_string_it = 0; row_string_it < row_string_collection_length1; row_string_it = row_string_it + 1) {
			gchar* _tmp2_;
			gchar* row_string = NULL;
			_tmp2_ = g_strdup (row_string_collection[row_string_it]);
			row_string = _tmp2_;
			{
				const gchar* _tmp3_;
				gint _tmp4_ = 0;
				GnonogramsCellState* _tmp5_;
				GnonogramsCellState* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				_tmp3_ = row_string;
				_tmp5_ = gnonograms_utils_cellstate_array_from_string (_tmp3_, &_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp6__length1 = _tmp4_;
				gnonograms_my2_dcell_array_set_row (array, (guint) row, _tmp6_, (gint) _tmp4_, (guint) 0);
				_tmp6_ = (g_free (_tmp6_), NULL);
				_tmp7_ = row;
				row = _tmp7_ + 1;
				_g_free0 (row_string);
			}
		}
	}
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_set_working_data_from_string_array (GnonogramsModel* self,
                                                     gchar** row_data_strings,
                                                     gint row_data_strings_length1)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_working_data;
	gnonograms_model_set_row_data_from_string_array (self, row_data_strings, (gint) row_data_strings_length1, _tmp0_);
}

void
gnonograms_model_set_solution_data_from_string_array (GnonogramsModel* self,
                                                      gchar** row_data_strings,
                                                      gint row_data_strings_length1)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_solution_data;
	gnonograms_model_set_row_data_from_string_array (self, row_data_strings, (gint) row_data_strings_length1, _tmp0_);
}

void
gnonograms_model_copy_to_working_data (GnonogramsModel* self,
                                       GnonogramsMy2DCellArray* grid)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (grid != NULL);
	_tmp0_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_copy (_tmp0_, grid);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

void
gnonograms_model_copy_to_solution_data (GnonogramsModel* self,
                                        GnonogramsMy2DCellArray* grid)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (grid != NULL);
	_tmp0_ = self->priv->_solution_data;
	gnonograms_my2_dcell_array_copy (_tmp0_, grid);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

GnonogramsMy2DCellArray*
gnonograms_model_copy_working_data (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* grid = NULL;
	GnonogramsDimensions _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsMy2DCellArray* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_dimensions;
	_tmp1_ = gnonograms_my2_dcell_array_new (&_tmp0_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	grid = _tmp1_;
	_tmp2_ = self->priv->_working_data;
	gnonograms_my2_dcell_array_copy (grid, _tmp2_);
	result = grid;
	return result;
}

GnonogramsMy2DCellArray*
gnonograms_model_copy_solution_data (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* grid = NULL;
	GnonogramsDimensions _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsMy2DCellArray* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_dimensions;
	_tmp1_ = gnonograms_my2_dcell_array_new (&_tmp0_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	grid = _tmp1_;
	_tmp2_ = self->priv->_solution_data;
	gnonograms_my2_dcell_array_copy (grid, _tmp2_);
	result = grid;
	return result;
}

GnonogramsModel*
gnonograms_model_construct (GType object_type)
{
	GnonogramsModel * self = NULL;
	self = (GnonogramsModel*) g_object_new (object_type, NULL);
	return self;
}

GnonogramsModel*
gnonograms_model_new (void)
{
	return gnonograms_model_construct (GNONOGRAMS_TYPE_MODEL);
}

GnonogramsGameState
gnonograms_model_get_game_state (GnonogramsModel* self)
{
	GnonogramsGameState result;
	GnonogramsGameState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_game_state;
	result = _tmp0_;
	return result;
}

void
gnonograms_model_set_game_state (GnonogramsModel* self,
                                 GnonogramsGameState value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_model_get_game_state (self) != value) {
		self->priv->_game_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_model_properties[GNONOGRAMS_MODEL_GAME_STATE_PROPERTY]);
	}
}

void
gnonograms_model_get_dimensions (GnonogramsModel* self,
                                 GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                              const GnonogramsDimensions * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_model_set_dimensions (GnonogramsModel* self,
                                 GnonogramsDimensions * value)
{
	GnonogramsDimensions old_value;
	g_return_if_fail (self != NULL);
	gnonograms_model_get_dimensions (self, &old_value);
	if (_gnonograms_dimensions_equal (value, &old_value) != TRUE) {
		GnonogramsDimensions _tmp0_;
		_tmp0_ = *value;
		self->priv->_dimensions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_model_properties[GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY]);
	}
}

guint
gnonograms_model_get_rows (GnonogramsModel* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = _tmp0_.height;
	return result;
}

guint
gnonograms_model_get_cols (GnonogramsModel* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = _tmp0_.width;
	return result;
}

GnonogramsMy2DCellArray*
gnonograms_model_get_display_data (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_ = NULL;
	GnonogramsGameState _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_game_state;
	if (_tmp1_ == GNONOGRAMS_GAME_STATE_SETTING) {
		GnonogramsMy2DCellArray* _tmp2_;
		_tmp2_ = self->priv->_solution_data;
		_tmp0_ = _tmp2_;
	} else {
		GnonogramsMy2DCellArray* _tmp3_;
		_tmp3_ = self->priv->_working_data;
		_tmp0_ = _tmp3_;
	}
	result = _tmp0_;
	return result;
}

gboolean
gnonograms_model_get_is_finished (GnonogramsModel* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gnonograms_model_count_state (self, GNONOGRAMS_GAME_STATE_SOLVING, GNONOGRAMS_CELL_STATE_UNKNOWN) == 0;
	return result;
}

static GnonogramsMy2DCellArray*
gnonograms_model_get_solution_data (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_solution_data;
	result = _tmp0_;
	return result;
}

static void
gnonograms_model_set_solution_data (GnonogramsModel* self,
                                    GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_solution_data);
	self->priv->_solution_data = _tmp0_;
}

static GnonogramsMy2DCellArray*
gnonograms_model_get_working_data (GnonogramsModel* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_working_data;
	result = _tmp0_;
	return result;
}

static void
gnonograms_model_set_working_data (GnonogramsModel* self,
                                   GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_working_data);
	self->priv->_working_data = _tmp0_;
}

static void
_gnonograms_model___lambda4_ (GnonogramsModel* self)
{
	GnonogramsDimensions _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsDimensions _tmp3_;
	GnonogramsMy2DCellArray* _tmp4_;
	GnonogramsMy2DCellArray* _tmp5_;
	_tmp0_ = self->priv->_dimensions;
	_tmp1_ = gnonograms_my2_dcell_array_new (&_tmp0_, GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp2_ = _tmp1_;
	gnonograms_model_set_solution_data (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
	_tmp3_ = self->priv->_dimensions;
	_tmp4_ = gnonograms_my2_dcell_array_new (&_tmp3_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	_tmp5_ = _tmp4_;
	gnonograms_model_set_working_data (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

static void
__gnonograms_model___lambda4__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_model___lambda4_ ((GnonogramsModel*) self);
}

static void
_gnonograms_model___lambda5_ (GnonogramsModel* self)
{
	g_signal_emit (self, gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL], 0);
}

static void
__gnonograms_model___lambda5__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_model___lambda5_ ((GnonogramsModel*) self);
}

static GObject *
gnonograms_model_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsModel * self;
	parent_class = G_OBJECT_CLASS (gnonograms_model_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_MODEL, GnonogramsModel);
	g_signal_connect_object ((GObject*) self, "notify::dimensions", (GCallback) __gnonograms_model___lambda4__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::game-state", (GCallback) __gnonograms_model___lambda5__g_object_notify, self, 0);
	return obj;
}

static void
gnonograms_model_class_init (GnonogramsModelClass * klass,
                             gpointer klass_data)
{
	gnonograms_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_model_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_model_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_GAME_STATE_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_GAME_STATE_PROPERTY] = g_param_spec_enum ("game-state", "game-state", "game-state", GNONOGRAMS_TYPE_GAME_STATE, GNONOGRAMS_GAME_STATE_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_ROWS_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_COLS_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_DISPLAY_DATA_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_DISPLAY_DATA_PROPERTY] = g_param_spec_object ("display-data", "display-data", "display-data", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MODEL_IS_FINISHED_PROPERTY, gnonograms_model_properties[GNONOGRAMS_MODEL_IS_FINISHED_PROPERTY] = g_param_spec_boolean ("is-finished", "is-finished", "is-finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** PUBLIC **/
	gnonograms_model_signals[GNONOGRAMS_MODEL_CHANGED_SIGNAL] = g_signal_new ("changed", GNONOGRAMS_TYPE_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
gnonograms_model_instance_init (GnonogramsModel * self,
                                gpointer klass)
{
	self->priv = gnonograms_model_get_instance_private (self);
	self->priv->_game_state = GNONOGRAMS_GAME_STATE_UNDEFINED;
}

static void
gnonograms_model_finalize (GObject * obj)
{
	GnonogramsModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_MODEL, GnonogramsModel);
	_g_object_unref0 (self->priv->_solution_data);
	_g_object_unref0 (self->priv->_working_data);
	G_OBJECT_CLASS (gnonograms_model_parent_class)->finalize (obj);
}

GType
gnonograms_model_get_type (void)
{
	static volatile gsize gnonograms_model_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsModel), 0, (GInstanceInitFunc) gnonograms_model_instance_init, NULL };
		GType gnonograms_model_type_id;
		gnonograms_model_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsModel", &g_define_type_info, 0);
		GnonogramsModel_private_offset = g_type_add_instance_private (gnonograms_model_type_id, sizeof (GnonogramsModelPrivate));
		g_once_init_leave (&gnonograms_model_type_id__volatile, gnonograms_model_type_id);
	}
	return gnonograms_model_type_id__volatile;
}

static void
_vala_gnonograms_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GnonogramsModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_MODEL, GnonogramsModel);
	switch (property_id) {
		case GNONOGRAMS_MODEL_GAME_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_model_get_game_state (self));
		break;
		case GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_model_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_MODEL_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_model_get_rows (self));
		break;
		case GNONOGRAMS_MODEL_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_model_get_cols (self));
		break;
		case GNONOGRAMS_MODEL_DISPLAY_DATA_PROPERTY:
		g_value_set_object (value, gnonograms_model_get_display_data (self));
		break;
		case GNONOGRAMS_MODEL_IS_FINISHED_PROPERTY:
		g_value_set_boolean (value, gnonograms_model_get_is_finished (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_model_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GnonogramsModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_MODEL, GnonogramsModel);
	switch (property_id) {
		case GNONOGRAMS_MODEL_GAME_STATE_PROPERTY:
		gnonograms_model_set_game_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_MODEL_DIMENSIONS_PROPERTY:
		gnonograms_model_set_dimensions (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

