/* My2DCellArray.c generated by valac 0.46.6, the Vala compiler
 * generated from My2DCellArray.vala, do not modify */

/* Two dimensional array of cell states allowing access and updating by row and column regions.
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
typedef struct _GnonogramsMy2DCellArrayPrivate GnonogramsMy2DCellArrayPrivate;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
enum  {
	GNONOGRAMS_MY2_DCELL_ARRAY_0_PROPERTY,
	GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY,
	GNONOGRAMS_MY2_DCELL_ARRAY_ROWS_PROPERTY,
	GNONOGRAMS_MY2_DCELL_ARRAY_COLS_PROPERTY,
	GNONOGRAMS_MY2_DCELL_ARRAY_AREA_PROPERTY,
	GNONOGRAMS_MY2_DCELL_ARRAY_NUM_PROPERTIES
};
static GParamSpec* gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_NUM_PROPERTIES];

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR (gnonograms_my2_dcell_array_iterator_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIterator))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))

typedef struct _GnonogramsMy2DCellArrayIterator GnonogramsMy2DCellArrayIterator;
typedef struct _GnonogramsMy2DCellArrayIteratorClass GnonogramsMy2DCellArrayIteratorClass;
typedef struct _GnonogramsMy2DCellArrayIteratorPrivate GnonogramsMy2DCellArrayIteratorPrivate;
typedef struct _GnonogramsMy2DCellArrayParamSpecIterator GnonogramsMy2DCellArrayParamSpecIterator;

struct _GnonogramsMy2DCellArray {
	GObject parent_instance;
	GnonogramsMy2DCellArrayPrivate * priv;
};

struct _GnonogramsMy2DCellArrayClass {
	GObjectClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsMy2DCellArrayPrivate {
	GnonogramsDimensions _dimensions;
	GnonogramsCellState* data;
	gint data_length1;
	gint data_length2;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsMy2DCellArrayIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsMy2DCellArrayIteratorPrivate * priv;
};

struct _GnonogramsMy2DCellArrayIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsMy2DCellArrayIterator *self);
};

struct _GnonogramsMy2DCellArrayIteratorPrivate {
	guint _row_limit;
	guint _col_limit;
	GnonogramsCellState* _data;
	gint _data_length1;
	gint _data_length2;
	guint row_index;
	guint col_index;
};

struct _GnonogramsMy2DCellArrayParamSpecIterator {
	GParamSpec parent_instance;
};

static gint GnonogramsMy2DCellArray_private_offset;
static gpointer gnonograms_my2_dcell_array_parent_class = NULL;
static gint GnonogramsMy2DCellArrayIterator_private_offset;
static gpointer gnonograms_my2_dcell_array_iterator_parent_class = NULL;

GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
GType gnonograms_dimensions_get_type (void) G_GNUC_CONST;
GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
void gnonograms_dimensions_free (GnonogramsDimensions* self);
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_new (GnonogramsDimensions* _dimensions,
                                                         GnonogramsCellState init);
GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_construct (GType object_type,
                                                               GnonogramsDimensions* _dimensions,
                                                               GnonogramsCellState init);
void gnonograms_my2_dcell_array_set_all (GnonogramsMy2DCellArray* self,
                                         GnonogramsCellState s);
GType gnonograms_cell_get_type (void) G_GNUC_CONST;
GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
void gnonograms_cell_free (GnonogramsCell* self);
void gnonograms_my2_dcell_array_set_data_from_cell (GnonogramsMy2DCellArray* self,
                                                    GnonogramsCell* c);
void gnonograms_my2_dcell_array_set_data_from_rc (GnonogramsMy2DCellArray* self,
                                                  guint r,
                                                  guint c,
                                                  GnonogramsCellState s);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_for_cell (GnonogramsMy2DCellArray* self,
                                                                  GnonogramsCell* cell);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
void gnonograms_my2_dcell_array_get_row (GnonogramsMy2DCellArray* self,
                                         guint row,
                                         GnonogramsCellState** sa,
                                         gint* sa_length1,
                                         guint start);
void gnonograms_my2_dcell_array_set_row (GnonogramsMy2DCellArray* self,
                                         guint row,
                                         GnonogramsCellState* sa,
                                         gint sa_length1,
                                         guint start);
void gnonograms_my2_dcell_array_get_col (GnonogramsMy2DCellArray* self,
                                         guint col,
                                         GnonogramsCellState** sa,
                                         gint* sa_length1,
                                         guint start);
void gnonograms_my2_dcell_array_set_col (GnonogramsMy2DCellArray* self,
                                         guint col,
                                         GnonogramsCellState* sa,
                                         gint sa_length1,
                                         guint start);
void gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState** sa,
                                           gint* sa_length1,
                                           guint start);
void gnonograms_my2_dcell_array_set_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState* sa,
                                           gint sa_length1,
                                           guint start);
guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
gchar* gnonograms_my2_dcell_array_data2text (GnonogramsMy2DCellArray* self,
                                             guint idx,
                                             guint length,
                                             gboolean iscolumn);
gchar* gnonograms_utils_block_string_from_cellstate_array (GnonogramsCellState* cellstates,
                                                           gint cellstates_length1);
void gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                      GnonogramsMy2DCellArray* ca);
gchar* gnonograms_my2_dcell_array_to_string (GnonogramsMy2DCellArray* self);
gchar* gnonograms_utils_string_from_cellstate_array (GnonogramsCellState* cs,
                                                     gint cs_length1);
gpointer gnonograms_my2_dcell_array_iterator_ref (gpointer instance);
void gnonograms_my2_dcell_array_iterator_unref (gpointer instance);
GParamSpec* gnonograms_my2_dcell_array_param_spec_iterator (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags);
void gnonograms_my2_dcell_array_value_set_iterator (GValue* value,
                                                    gpointer v_object);
void gnonograms_my2_dcell_array_value_take_iterator (GValue* value,
                                                     gpointer v_object);
gpointer gnonograms_my2_dcell_array_value_get_iterator (const GValue* value);
GType gnonograms_my2_dcell_array_iterator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArrayIterator, gnonograms_my2_dcell_array_iterator_unref)
GnonogramsMy2DCellArrayIterator* gnonograms_my2_dcell_array_iterator (GnonogramsMy2DCellArray* self);
void gnonograms_my2_dcell_array_get_dimensions (GnonogramsMy2DCellArray* self,
                                                GnonogramsDimensions * result);
GnonogramsMy2DCellArrayIterator* gnonograms_my2_dcell_array_iterator_new (GnonogramsCellState* data,
                                                                          gint data_length1,
                                                                          gint data_length2,
                                                                          GnonogramsDimensions* dimensions);
GnonogramsMy2DCellArrayIterator* gnonograms_my2_dcell_array_iterator_construct (GType object_type,
                                                                                GnonogramsCellState* data,
                                                                                gint data_length1,
                                                                                gint data_length2,
                                                                                GnonogramsDimensions* dimensions);
static void gnonograms_my2_dcell_array_set_dimensions (GnonogramsMy2DCellArray* self,
                                                GnonogramsDimensions * value);
static gboolean _gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                                       const GnonogramsDimensions * s2);
guint gnonograms_my2_dcell_array_get_area (GnonogramsMy2DCellArray* self);
guint gnonograms_dimensions_area (GnonogramsDimensions *self);
static GObject * gnonograms_my2_dcell_array_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void gnonograms_my2_dcell_array_iterator_set_data (GnonogramsMy2DCellArrayIterator* self,
                                                   GnonogramsCellState* value,
                                                   gint value_length1,
                                                   gint value_length2);
static void gnonograms_my2_dcell_array_iterator_set_row_limit (GnonogramsMy2DCellArrayIterator* self,
                                                        guint value);
static void gnonograms_my2_dcell_array_iterator_set_col_limit (GnonogramsMy2DCellArrayIterator* self,
                                                        guint value);
gboolean gnonograms_my2_dcell_array_iterator_next (GnonogramsMy2DCellArrayIterator* self);
static guint gnonograms_my2_dcell_array_iterator_get_col_limit (GnonogramsMy2DCellArrayIterator* self);
void gnonograms_my2_dcell_array_iterator_get (GnonogramsMy2DCellArrayIterator* self,
                                              GnonogramsCell* result);
static GnonogramsCellState* gnonograms_my2_dcell_array_iterator_get_data (GnonogramsMy2DCellArrayIterator* self,
                                                                   gint* result_length1,
                                                                   gint* result_length2);
static guint gnonograms_my2_dcell_array_iterator_get_row_limit (GnonogramsMy2DCellArrayIterator* self);
static GnonogramsCellState* _vala_array_dup1 (GnonogramsCellState* self,
                                       int length);
static void gnonograms_my2_dcell_array_iterator_finalize (GnonogramsMy2DCellArrayIterator * obj);
static void gnonograms_my2_dcell_array_finalize (GObject * obj);
static void _vala_gnonograms_my2_dcell_array_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_gnonograms_my2_dcell_array_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
gnonograms_my2_dcell_array_get_instance_private (GnonogramsMy2DCellArray* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsMy2DCellArray_private_offset);
}

GnonogramsMy2DCellArray*
gnonograms_my2_dcell_array_construct (GType object_type,
                                      GnonogramsDimensions* _dimensions,
                                      GnonogramsCellState init)
{
	GnonogramsMy2DCellArray * self = NULL;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (_dimensions != NULL, NULL);
	_tmp0_ = *_dimensions;
	self = (GnonogramsMy2DCellArray*) g_object_new (object_type, "dimensions", &_tmp0_, NULL);
	gnonograms_my2_dcell_array_set_all (self, init);
	return self;
}

GnonogramsMy2DCellArray*
gnonograms_my2_dcell_array_new (GnonogramsDimensions* _dimensions,
                                GnonogramsCellState init)
{
	return gnonograms_my2_dcell_array_construct (GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, _dimensions, init);
}

void
gnonograms_my2_dcell_array_set_data_from_cell (GnonogramsMy2DCellArray* self,
                                               GnonogramsCell* c)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsCell _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell _tmp3_;
	GnonogramsCellState _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->data;
	_tmp0__length1 = self->priv->data_length1;
	_tmp0__length2 = self->priv->data_length2;
	_tmp1_ = *c;
	_tmp2_ = *c;
	_tmp3_ = *c;
	_tmp4_ = _tmp3_.state;
	_tmp0_[(_tmp1_.row * _tmp0__length2) + _tmp2_.col] = _tmp4_;
}

void
gnonograms_my2_dcell_array_set_data_from_rc (GnonogramsMy2DCellArray* self,
                                             guint r,
                                             guint c,
                                             GnonogramsCellState s)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->data;
	_tmp0__length1 = self->priv->data_length1;
	_tmp0__length2 = self->priv->data_length2;
	_tmp0_[(r * _tmp0__length2) + c] = s;
}

GnonogramsCellState
gnonograms_my2_dcell_array_get_data_for_cell (GnonogramsMy2DCellArray* self,
                                              GnonogramsCell* cell)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsCell _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCellState _tmp3_;
	GnonogramsCellState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (cell != NULL, 0);
	_tmp0_ = self->priv->data;
	_tmp0__length1 = self->priv->data_length1;
	_tmp0__length2 = self->priv->data_length2;
	_tmp1_ = *cell;
	_tmp2_ = *cell;
	_tmp3_ = _tmp0_[(_tmp1_.row * _tmp0__length2) + _tmp2_.col];
	result = _tmp3_;
	return result;
}

GnonogramsCellState
gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                             guint r,
                                             guint c)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsCellState _tmp1_;
	GnonogramsCellState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->data;
	_tmp0__length1 = self->priv->data_length1;
	_tmp0__length2 = self->priv->data_length2;
	_tmp1_ = _tmp0_[(r * _tmp0__length2) + c];
	result = _tmp1_;
	return result;
}

void
gnonograms_my2_dcell_array_get_row (GnonogramsMy2DCellArray* self,
                                    guint row,
                                    GnonogramsCellState** sa,
                                    gint* sa_length1,
                                    guint start)
{
	g_return_if_fail (self != NULL);
	{
		guint c = 0U;
		c = start;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				GnonogramsCellState _tmp3_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = c;
					c = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(c < (start + (*sa_length1)))) {
					break;
				}
				_tmp2_ = self->priv->data;
				_tmp2__length1 = self->priv->data_length1;
				_tmp2__length2 = self->priv->data_length2;
				_tmp3_ = _tmp2_[(row * _tmp2__length2) + c];
				(*sa)[c] = _tmp3_;
			}
		}
	}
}

void
gnonograms_my2_dcell_array_set_row (GnonogramsMy2DCellArray* self,
                                    guint row,
                                    GnonogramsCellState* sa,
                                    gint sa_length1,
                                    guint start)
{
	g_return_if_fail (self != NULL);
	{
		guint c = 0U;
		c = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				GnonogramsCellState _tmp3_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = c;
					c = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(c < ((guint) sa_length1))) {
					break;
				}
				_tmp2_ = self->priv->data;
				_tmp2__length1 = self->priv->data_length1;
				_tmp2__length2 = self->priv->data_length2;
				_tmp3_ = sa[c];
				_tmp2_[(row * _tmp2__length2) + (c + start)] = _tmp3_;
			}
		}
	}
}

void
gnonograms_my2_dcell_array_get_col (GnonogramsMy2DCellArray* self,
                                    guint col,
                                    GnonogramsCellState** sa,
                                    gint* sa_length1,
                                    guint start)
{
	g_return_if_fail (self != NULL);
	{
		guint r = 0U;
		r = start;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				GnonogramsCellState _tmp3_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(r < (start + (*sa_length1)))) {
					break;
				}
				_tmp2_ = self->priv->data;
				_tmp2__length1 = self->priv->data_length1;
				_tmp2__length2 = self->priv->data_length2;
				_tmp3_ = _tmp2_[(r * _tmp2__length2) + col];
				(*sa)[r] = _tmp3_;
			}
		}
	}
}

void
gnonograms_my2_dcell_array_set_col (GnonogramsMy2DCellArray* self,
                                    guint col,
                                    GnonogramsCellState* sa,
                                    gint sa_length1,
                                    guint start)
{
	g_return_if_fail (self != NULL);
	{
		guint r = 0U;
		r = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				GnonogramsCellState _tmp3_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(r < ((guint) sa_length1))) {
					break;
				}
				_tmp2_ = self->priv->data;
				_tmp2__length1 = self->priv->data_length1;
				_tmp2__length2 = self->priv->data_length2;
				_tmp3_ = sa[r];
				_tmp2_[((r + start) * _tmp2__length2) + col] = _tmp3_;
			}
		}
	}
}

void
gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                      guint idx,
                                      gboolean iscolumn,
                                      GnonogramsCellState** sa,
                                      gint* sa_length1,
                                      guint start)
{
	g_return_if_fail (self != NULL);
	if (iscolumn) {
		gnonograms_my2_dcell_array_get_col (self, idx, sa, (gint*) (sa_length1), start);
	} else {
		gnonograms_my2_dcell_array_get_row (self, idx, sa, (gint*) (sa_length1), start);
	}
}

void
gnonograms_my2_dcell_array_set_array (GnonogramsMy2DCellArray* self,
                                      guint idx,
                                      gboolean iscolumn,
                                      GnonogramsCellState* sa,
                                      gint sa_length1,
                                      guint start)
{
	g_return_if_fail (self != NULL);
	if (iscolumn) {
		gnonograms_my2_dcell_array_set_col (self, idx, sa, (gint) sa_length1, start);
	} else {
		gnonograms_my2_dcell_array_set_row (self, idx, sa, (gint) sa_length1, start);
	}
}

void
gnonograms_my2_dcell_array_set_all (GnonogramsMy2DCellArray* self,
                                    GnonogramsCellState s)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_my2_dcell_array_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsCellState* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_my2_dcell_array_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->data;
							_tmp8__length1 = self->priv->data_length1;
							_tmp8__length2 = self->priv->data_length2;
							_tmp8_[(r * _tmp8__length2) + c] = s;
						}
					}
				}
			}
		}
	}
}

gchar*
gnonograms_my2_dcell_array_data2text (GnonogramsMy2DCellArray* self,
                                      guint idx,
                                      guint length,
                                      gboolean iscolumn)
{
	GnonogramsCellState* arr = NULL;
	GnonogramsCellState* _tmp0_;
	gint arr_length1;
	gint _arr_size_;
	GnonogramsCellState* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (GnonogramsCellState, length);
	arr = _tmp0_;
	arr_length1 = length;
	_arr_size_ = arr_length1;
	gnonograms_my2_dcell_array_get_array (self, idx, iscolumn, &arr, (gint*) (&arr_length1), (guint) 0);
	_tmp1_ = arr;
	_tmp1__length1 = arr_length1;
	_tmp2_ = gnonograms_utils_block_string_from_cellstate_array (_tmp1_, (gint) _tmp1__length1);
	result = _tmp2_;
	arr = (g_free (arr), NULL);
	return result;
}

void
gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                 GnonogramsMy2DCellArray* ca)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (ca != NULL);
	{
		guint r = 0U;
		r = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				guint _tmp5_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_my2_dcell_array_get_rows (ca);
				_tmp3_ = _tmp2_;
				_tmp4_ = gnonograms_my2_dcell_array_get_rows (self);
				_tmp5_ = _tmp4_;
				if (!(r < MIN (_tmp3_, _tmp5_))) {
					break;
				}
				{
					guint c = 0U;
					c = (guint) 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint _tmp8_;
							guint _tmp9_;
							guint _tmp10_;
							guint _tmp11_;
							GnonogramsCellState* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							if (!_tmp6_) {
								guint _tmp7_;
								_tmp7_ = c;
								c = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = gnonograms_my2_dcell_array_get_cols (ca);
							_tmp9_ = _tmp8_;
							_tmp10_ = gnonograms_my2_dcell_array_get_cols (self);
							_tmp11_ = _tmp10_;
							if (!(c < MIN (_tmp9_, _tmp11_))) {
								break;
							}
							_tmp12_ = self->priv->data;
							_tmp12__length1 = self->priv->data_length1;
							_tmp12__length2 = self->priv->data_length2;
							_tmp12_[(r * _tmp12__length2) + c] = gnonograms_my2_dcell_array_get_data_from_rc (ca, r, c);
						}
					}
				}
			}
		}
	}
}

gchar*
gnonograms_my2_dcell_array_to_string (GnonogramsMy2DCellArray* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GnonogramsCellState* arr = NULL;
	guint _tmp1_;
	guint _tmp2_;
	GnonogramsCellState* _tmp3_;
	gint arr_length1;
	gint _arr_size_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	_tmp1_ = gnonograms_my2_dcell_array_get_cols (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_new0 (GnonogramsCellState, _tmp2_);
	arr = _tmp3_;
	arr_length1 = _tmp2_;
	_arr_size_ = arr_length1;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				guint _tmp6_;
				guint _tmp7_;
				GString* _tmp8_;
				GnonogramsCellState* _tmp9_;
				gint _tmp9__length1;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GString* _tmp12_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = r;
					r = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = gnonograms_my2_dcell_array_get_rows (self);
				_tmp7_ = _tmp6_;
				if (!(((guint) r) < _tmp7_)) {
					break;
				}
				gnonograms_my2_dcell_array_get_row (self, (guint) r, &arr, (gint*) (&arr_length1), (guint) 0);
				_tmp8_ = sb;
				_tmp9_ = arr;
				_tmp9__length1 = arr_length1;
				_tmp10_ = gnonograms_utils_string_from_cellstate_array (_tmp9_, (gint) _tmp9__length1);
				_tmp11_ = _tmp10_;
				g_string_append (_tmp8_, _tmp11_);
				_g_free0 (_tmp11_);
				_tmp12_ = sb;
				g_string_append (_tmp12_, "\n");
			}
		}
	}
	_tmp13_ = sb;
	_tmp14_ = _tmp13_->str;
	_tmp15_ = g_strdup (_tmp14_);
	result = _tmp15_;
	arr = (g_free (arr), NULL);
	_g_string_free0 (sb);
	return result;
}

GnonogramsMy2DCellArrayIterator*
gnonograms_my2_dcell_array_iterator (GnonogramsMy2DCellArray* self)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsDimensions _tmp1_;
	GnonogramsMy2DCellArrayIterator* _tmp2_;
	GnonogramsMy2DCellArrayIterator* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->data;
	_tmp0__length1 = self->priv->data_length1;
	_tmp0__length2 = self->priv->data_length2;
	_tmp1_ = self->priv->_dimensions;
	_tmp2_ = gnonograms_my2_dcell_array_iterator_new (_tmp0_, _tmp0__length1, _tmp0__length2, &_tmp1_);
	result = _tmp2_;
	return result;
}

void
gnonograms_my2_dcell_array_get_dimensions (GnonogramsMy2DCellArray* self,
                                           GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                              const GnonogramsDimensions * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

static void
gnonograms_my2_dcell_array_set_dimensions (GnonogramsMy2DCellArray* self,
                                           GnonogramsDimensions * value)
{
	GnonogramsDimensions old_value;
	g_return_if_fail (self != NULL);
	gnonograms_my2_dcell_array_get_dimensions (self, &old_value);
	if (_gnonograms_dimensions_equal (value, &old_value) != TRUE) {
		GnonogramsDimensions _tmp0_;
		_tmp0_ = *value;
		self->priv->_dimensions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY]);
	}
}

guint
gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = _tmp0_.height;
	return result;
}

guint
gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = _tmp0_.width;
	return result;
}

guint
gnonograms_my2_dcell_array_get_area (GnonogramsMy2DCellArray* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = gnonograms_dimensions_area (&_tmp0_);
	return result;
}

static GObject *
gnonograms_my2_dcell_array_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsMy2DCellArray * self;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsCellState* _tmp4_;
	parent_class = G_OBJECT_CLASS (gnonograms_my2_dcell_array_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray);
	_tmp0_ = gnonograms_my2_dcell_array_get_rows (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gnonograms_my2_dcell_array_get_cols (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_new0 (GnonogramsCellState, _tmp1_ * _tmp3_);
	self->priv->data = (g_free (self->priv->data), NULL);
	self->priv->data = _tmp4_;
	self->priv->data_length1 = _tmp1_;
	self->priv->data_length2 = _tmp3_;
	return obj;
}

static inline gpointer
gnonograms_my2_dcell_array_iterator_get_instance_private (GnonogramsMy2DCellArrayIterator* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsMy2DCellArrayIterator_private_offset);
}

GnonogramsMy2DCellArrayIterator*
gnonograms_my2_dcell_array_iterator_construct (GType object_type,
                                               GnonogramsCellState* data,
                                               gint data_length1,
                                               gint data_length2,
                                               GnonogramsDimensions* dimensions)
{
	GnonogramsMy2DCellArrayIterator* self = NULL;
	GnonogramsDimensions _tmp0_;
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (dimensions != NULL, NULL);
	self = (GnonogramsMy2DCellArrayIterator*) g_type_create_instance (object_type);
	gnonograms_my2_dcell_array_iterator_set_data (self, data, data_length1, data_length2);
	_tmp0_ = *dimensions;
	gnonograms_my2_dcell_array_iterator_set_row_limit (self, _tmp0_.height - 1);
	_tmp1_ = *dimensions;
	gnonograms_my2_dcell_array_iterator_set_col_limit (self, _tmp1_.width - 1);
	return self;
}

GnonogramsMy2DCellArrayIterator*
gnonograms_my2_dcell_array_iterator_new (GnonogramsCellState* data,
                                         gint data_length1,
                                         gint data_length2,
                                         GnonogramsDimensions* dimensions)
{
	return gnonograms_my2_dcell_array_iterator_construct (GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, data, data_length1, data_length2, dimensions);
}

gboolean
gnonograms_my2_dcell_array_iterator_next (GnonogramsMy2DCellArrayIterator* self)
{
	guint _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_col_limit;
	result = self->priv->col_index <= _tmp0_;
	return result;
}

void
gnonograms_my2_dcell_array_iterator_get (GnonogramsMy2DCellArrayIterator* self,
                                         GnonogramsCell* result)
{
	GnonogramsCell cell = {0};
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsCellState* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	GnonogramsCellState _tmp2_;
	GnonogramsCell _tmp3_ = {0};
	guint _tmp4_;
	guint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gnonograms_my2_dcell_array_iterator_get_data (self, &_tmp0__length1, &_tmp0__length2);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp1__length2 = _tmp0__length2;
	_tmp2_ = _tmp1_[(self->priv->row_index * _tmp1__length2) + self->priv->col_index];
	_tmp3_.row = self->priv->row_index;
	_tmp3_.col = self->priv->col_index;
	_tmp3_.state = _tmp2_;
	cell = _tmp3_;
	_tmp4_ = self->priv->row_index;
	self->priv->row_index = _tmp4_ + 1;
	_tmp5_ = self->priv->_row_limit;
	if (self->priv->row_index > _tmp5_) {
		guint _tmp6_;
		self->priv->row_index = (guint) 0;
		_tmp6_ = self->priv->col_index;
		self->priv->col_index = _tmp6_ + 1;
	}
	*result = cell;
	return;
}

static guint
gnonograms_my2_dcell_array_iterator_get_row_limit (GnonogramsMy2DCellArrayIterator* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_row_limit;
	return result;
}

static void
gnonograms_my2_dcell_array_iterator_set_row_limit (GnonogramsMy2DCellArrayIterator* self,
                                                   guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_row_limit = value;
}

static guint
gnonograms_my2_dcell_array_iterator_get_col_limit (GnonogramsMy2DCellArrayIterator* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_col_limit;
	return result;
}

static void
gnonograms_my2_dcell_array_iterator_set_col_limit (GnonogramsMy2DCellArrayIterator* self,
                                                   guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_col_limit = value;
}

static GnonogramsCellState*
gnonograms_my2_dcell_array_iterator_get_data (GnonogramsMy2DCellArrayIterator* self,
                                              gint* result_length1,
                                              gint* result_length2)
{
	GnonogramsCellState* result;
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GnonogramsCellState* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data;
	_tmp0__length1 = self->priv->_data_length1;
	_tmp0__length2 = self->priv->_data_length2;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp1__length2 = _tmp0__length2;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	if (result_length2) {
		*result_length2 = _tmp1__length2;
	}
	result = _tmp1_;
	return result;
}

static GnonogramsCellState*
_vala_array_dup1 (GnonogramsCellState* self,
                  int length)
{
	return g_memdup (self, length * sizeof (GnonogramsCellState));
}

static void
gnonograms_my2_dcell_array_iterator_set_data (GnonogramsMy2DCellArrayIterator* self,
                                              GnonogramsCellState* value,
                                              gint value_length1,
                                              gint value_length2)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1 * value_length2) : ((gpointer) value);
	_tmp0__length1 = value_length1;
	_tmp0__length2 = value_length2;
	self->priv->_data = (g_free (self->priv->_data), NULL);
	self->priv->_data = _tmp0_;
	self->priv->_data_length1 = _tmp0__length1;
	self->priv->_data_length2 = _tmp0__length2;
}

static void
gnonograms_my2_dcell_array_value_iterator_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_my2_dcell_array_value_iterator_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_my2_dcell_array_iterator_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_my2_dcell_array_value_iterator_copy_value (const GValue* src_value,
                                                      GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_my2_dcell_array_iterator_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_my2_dcell_array_value_iterator_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_my2_dcell_array_value_iterator_collect_value (GValue* value,
                                                         guint n_collect_values,
                                                         GTypeCValue* collect_values,
                                                         guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsMy2DCellArrayIterator * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_my2_dcell_array_iterator_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_my2_dcell_array_value_iterator_lcopy_value (const GValue* value,
                                                       guint n_collect_values,
                                                       GTypeCValue* collect_values,
                                                       guint collect_flags)
{
	GnonogramsMy2DCellArrayIterator ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_my2_dcell_array_iterator_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gnonograms_my2_dcell_array_param_spec_iterator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags)
{
	GnonogramsMy2DCellArrayParamSpecIterator* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gnonograms_my2_dcell_array_value_get_iterator (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR), NULL);
	return value->data[0].v_pointer;
}

void
gnonograms_my2_dcell_array_value_set_iterator (GValue* value,
                                               gpointer v_object)
{
	GnonogramsMy2DCellArrayIterator * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_my2_dcell_array_iterator_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_my2_dcell_array_iterator_unref (old);
	}
}

void
gnonograms_my2_dcell_array_value_take_iterator (GValue* value,
                                                gpointer v_object)
{
	GnonogramsMy2DCellArrayIterator * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_my2_dcell_array_iterator_unref (old);
	}
}

static void
gnonograms_my2_dcell_array_iterator_class_init (GnonogramsMy2DCellArrayIteratorClass * klass,
                                                gpointer klass_data)
{
	gnonograms_my2_dcell_array_iterator_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsMy2DCellArrayIteratorClass *) klass)->finalize = gnonograms_my2_dcell_array_iterator_finalize;
	g_type_class_adjust_private_offset (klass, &GnonogramsMy2DCellArrayIterator_private_offset);
}

static void
gnonograms_my2_dcell_array_iterator_instance_init (GnonogramsMy2DCellArrayIterator * self,
                                                   gpointer klass)
{
	self->priv = gnonograms_my2_dcell_array_iterator_get_instance_private (self);
	self->priv->row_index = (guint) 0;
	self->priv->col_index = (guint) 0;
	self->ref_count = 1;
}

static void
gnonograms_my2_dcell_array_iterator_finalize (GnonogramsMy2DCellArrayIterator * obj)
{
	GnonogramsMy2DCellArrayIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIterator);
	g_signal_handlers_destroy (self);
	self->priv->_data = (g_free (self->priv->_data), NULL);
}

GType
gnonograms_my2_dcell_array_iterator_get_type (void)
{
	static volatile gsize gnonograms_my2_dcell_array_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_my2_dcell_array_iterator_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gnonograms_my2_dcell_array_value_iterator_init, gnonograms_my2_dcell_array_value_iterator_free_value, gnonograms_my2_dcell_array_value_iterator_copy_value, gnonograms_my2_dcell_array_value_iterator_peek_pointer, "p", gnonograms_my2_dcell_array_value_iterator_collect_value, "p", gnonograms_my2_dcell_array_value_iterator_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsMy2DCellArrayIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_my2_dcell_array_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsMy2DCellArrayIterator), 0, (GInstanceInitFunc) gnonograms_my2_dcell_array_iterator_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gnonograms_my2_dcell_array_iterator_type_id;
		gnonograms_my2_dcell_array_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsMy2DCellArrayIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GnonogramsMy2DCellArrayIterator_private_offset = g_type_add_instance_private (gnonograms_my2_dcell_array_iterator_type_id, sizeof (GnonogramsMy2DCellArrayIteratorPrivate));
		g_once_init_leave (&gnonograms_my2_dcell_array_iterator_type_id__volatile, gnonograms_my2_dcell_array_iterator_type_id);
	}
	return gnonograms_my2_dcell_array_iterator_type_id__volatile;
}

gpointer
gnonograms_my2_dcell_array_iterator_ref (gpointer instance)
{
	GnonogramsMy2DCellArrayIterator * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gnonograms_my2_dcell_array_iterator_unref (gpointer instance)
{
	GnonogramsMy2DCellArrayIterator * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
gnonograms_my2_dcell_array_class_init (GnonogramsMy2DCellArrayClass * klass,
                                       gpointer klass_data)
{
	gnonograms_my2_dcell_array_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsMy2DCellArray_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_my2_dcell_array_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_my2_dcell_array_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_my2_dcell_array_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_my2_dcell_array_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY, gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MY2_DCELL_ARRAY_ROWS_PROPERTY, gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MY2_DCELL_ARRAY_COLS_PROPERTY, gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_MY2_DCELL_ARRAY_AREA_PROPERTY, gnonograms_my2_dcell_array_properties[GNONOGRAMS_MY2_DCELL_ARRAY_AREA_PROPERTY] = g_param_spec_uint ("area", "area", "area", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gnonograms_my2_dcell_array_instance_init (GnonogramsMy2DCellArray * self,
                                          gpointer klass)
{
	self->priv = gnonograms_my2_dcell_array_get_instance_private (self);
}

static void
gnonograms_my2_dcell_array_finalize (GObject * obj)
{
	GnonogramsMy2DCellArray * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray);
	self->priv->data = (g_free (self->priv->data), NULL);
	G_OBJECT_CLASS (gnonograms_my2_dcell_array_parent_class)->finalize (obj);
}

/*** NOTE:  This class does not range check coordinates passed as parameters - that is the responsibility
   *        of the calling function.
***/
GType
gnonograms_my2_dcell_array_get_type (void)
{
	static volatile gsize gnonograms_my2_dcell_array_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_my2_dcell_array_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsMy2DCellArrayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_my2_dcell_array_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsMy2DCellArray), 0, (GInstanceInitFunc) gnonograms_my2_dcell_array_instance_init, NULL };
		GType gnonograms_my2_dcell_array_type_id;
		gnonograms_my2_dcell_array_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsMy2DCellArray", &g_define_type_info, 0);
		GnonogramsMy2DCellArray_private_offset = g_type_add_instance_private (gnonograms_my2_dcell_array_type_id, sizeof (GnonogramsMy2DCellArrayPrivate));
		g_once_init_leave (&gnonograms_my2_dcell_array_type_id__volatile, gnonograms_my2_dcell_array_type_id);
	}
	return gnonograms_my2_dcell_array_type_id__volatile;
}

static void
_vala_gnonograms_my2_dcell_array_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	GnonogramsMy2DCellArray * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray);
	switch (property_id) {
		case GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_my2_dcell_array_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_MY2_DCELL_ARRAY_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_my2_dcell_array_get_rows (self));
		break;
		case GNONOGRAMS_MY2_DCELL_ARRAY_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_my2_dcell_array_get_cols (self));
		break;
		case GNONOGRAMS_MY2_DCELL_ARRAY_AREA_PROPERTY:
		g_value_set_uint (value, gnonograms_my2_dcell_array_get_area (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_my2_dcell_array_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	GnonogramsMy2DCellArray * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray);
	switch (property_id) {
		case GNONOGRAMS_MY2_DCELL_ARRAY_DIMENSIONS_PROPERTY:
		gnonograms_my2_dcell_array_set_dimensions (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

