/* Structs.c generated by valac 0.46.6, the Vala compiler
 * generated from Structs.vala, do not modify */

/* Entry point for gnonograms  - initializes application and launches game
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <stdlib.h>
#include <string.h>

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
typedef struct _GnonogramsBlockPrivate GnonogramsBlockPrivate;
typedef struct _GnonogramsParamSpecBlock GnonogramsParamSpecBlock;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_FILTER_INFO (gnonograms_filter_info_get_type ())
typedef struct _GnonogramsFilterInfo GnonogramsFilterInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GnonogramsBlock {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsBlockPrivate * priv;
	gint length;
	gboolean is_complete;
	gboolean is_error;
};

struct _GnonogramsBlockClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsBlock *self);
};

struct _GnonogramsParamSpecBlock {
	GParamSpec parent_instance;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsFilterInfo {
	gchar* name;
	gchar* pattern;
};

static gpointer gnonograms_block_parent_class = NULL;

gpointer gnonograms_block_ref (gpointer instance);
void gnonograms_block_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
gpointer gnonograms_value_get_block (const GValue* value);
GType gnonograms_block_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
GnonogramsBlock* gnonograms_block_new (gint len,
                                       gboolean complete,
                                       gboolean _error_);
GnonogramsBlock* gnonograms_block_construct (GType object_type,
                                             gint len,
                                             gboolean complete,
                                             gboolean _error_);
GnonogramsBlock* gnonograms_block_new_null (void);
GnonogramsBlock* gnonograms_block_construct_null (GType object_type);
gboolean gnonograms_block_is_null (GnonogramsBlock* self);
static void gnonograms_block_finalize (GnonogramsBlock * obj);
GType gnonograms_cell_get_type (void) G_GNUC_CONST;
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
void gnonograms_cell_free (GnonogramsCell* self);
gboolean gnonograms_cell_same_coords (GnonogramsCell *self,
                                      GnonogramsCell* c);
void gnonograms_cell_copy (GnonogramsCell *self,
                           GnonogramsCell* b);
gboolean gnonograms_cell_equal (GnonogramsCell *self,
                                GnonogramsCell* b);
void gnonograms_cell_inverse (GnonogramsCell *self,
                              GnonogramsCell* result);
void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
gchar* gnonograms_cell_to_string (GnonogramsCell *self);
GType gnonograms_dimensions_get_type (void) G_GNUC_CONST;
GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
void gnonograms_dimensions_free (GnonogramsDimensions* self);
guint gnonograms_dimensions_rows (GnonogramsDimensions *self);
guint gnonograms_dimensions_cols (GnonogramsDimensions *self);
guint gnonograms_dimensions_area (GnonogramsDimensions *self);
guint gnonograms_dimensions_length (GnonogramsDimensions *self);
gboolean gnonograms_dimensions_equal (GnonogramsDimensions *self,
                                      GnonogramsDimensions* other);
GType gnonograms_filter_info_get_type (void) G_GNUC_CONST;
GnonogramsFilterInfo* gnonograms_filter_info_dup (const GnonogramsFilterInfo* self);
void gnonograms_filter_info_free (GnonogramsFilterInfo* self);
void gnonograms_filter_info_copy (const GnonogramsFilterInfo* self,
                                  GnonogramsFilterInfo* dest);
void gnonograms_filter_info_destroy (GnonogramsFilterInfo* self);

GnonogramsBlock*
gnonograms_block_construct (GType object_type,
                            gint len,
                            gboolean complete,
                            gboolean _error_)
{
	GnonogramsBlock* self = NULL;
	self = (GnonogramsBlock*) g_type_create_instance (object_type);
	self->length = len;
	self->is_complete = complete;
	self->is_error = _error_;
	return self;
}

GnonogramsBlock*
gnonograms_block_new (gint len,
                      gboolean complete,
                      gboolean _error_)
{
	return gnonograms_block_construct (GNONOGRAMS_TYPE_BLOCK, len, complete, _error_);
}

GnonogramsBlock*
gnonograms_block_construct_null (GType object_type)
{
	GnonogramsBlock* self = NULL;
	self = (GnonogramsBlock*) g_type_create_instance (object_type);
	self->length = -1;
	self->is_complete = FALSE;
	self->is_error = FALSE;
	return self;
}

GnonogramsBlock*
gnonograms_block_new_null (void)
{
	return gnonograms_block_construct_null (GNONOGRAMS_TYPE_BLOCK);
}

gboolean
gnonograms_block_is_null (GnonogramsBlock* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->length < 0;
	return result;
}

static void
gnonograms_value_block_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_value_block_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_block_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_value_block_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_block_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_value_block_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_value_block_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsBlock * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_block_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_value_block_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	GnonogramsBlock ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_block_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gnonograms_param_spec_block (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	GnonogramsParamSpecBlock* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_TYPE_BLOCK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gnonograms_value_get_block (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_BLOCK), NULL);
	return value->data[0].v_pointer;
}

void
gnonograms_value_set_block (GValue* value,
                            gpointer v_object)
{
	GnonogramsBlock * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_BLOCK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_TYPE_BLOCK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_block_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_block_unref (old);
	}
}

void
gnonograms_value_take_block (GValue* value,
                             gpointer v_object)
{
	GnonogramsBlock * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_BLOCK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_TYPE_BLOCK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_block_unref (old);
	}
}

static void
gnonograms_block_class_init (GnonogramsBlockClass * klass,
                             gpointer klass_data)
{
	gnonograms_block_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsBlockClass *) klass)->finalize = gnonograms_block_finalize;
}

static void
gnonograms_block_instance_init (GnonogramsBlock * self,
                                gpointer klass)
{
	self->ref_count = 1;
}

static void
gnonograms_block_finalize (GnonogramsBlock * obj)
{
	GnonogramsBlock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock);
	g_signal_handlers_destroy (self);
}

GType
gnonograms_block_get_type (void)
{
	static volatile gsize gnonograms_block_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_block_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gnonograms_value_block_init, gnonograms_value_block_free_value, gnonograms_value_block_copy_value, gnonograms_value_block_peek_pointer, "p", gnonograms_value_block_collect_value, "p", gnonograms_value_block_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsBlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsBlock), 0, (GInstanceInitFunc) gnonograms_block_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gnonograms_block_type_id;
		gnonograms_block_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsBlock", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gnonograms_block_type_id__volatile, gnonograms_block_type_id);
	}
	return gnonograms_block_type_id__volatile;
}

gpointer
gnonograms_block_ref (gpointer instance)
{
	GnonogramsBlock * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gnonograms_block_unref (gpointer instance)
{
	GnonogramsBlock * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_BLOCK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

gboolean
gnonograms_cell_same_coords (GnonogramsCell *self,
                             GnonogramsCell* c)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsCell _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp1_ = *c;
	if ((*self).row == _tmp1_.row) {
		GnonogramsCell _tmp2_;
		_tmp2_ = *c;
		_tmp0_ = (*self).col == _tmp2_.col;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
gnonograms_cell_copy (GnonogramsCell *self,
                      GnonogramsCell* b)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCellState _tmp3_;
	g_return_if_fail (b != NULL);
	_tmp0_ = *b;
	(*self).row = _tmp0_.row;
	_tmp1_ = *b;
	(*self).col = _tmp1_.col;
	_tmp2_ = *b;
	_tmp3_ = _tmp2_.state;
	(*self).state = _tmp3_;
}

gboolean
gnonograms_cell_equal (GnonogramsCell *self,
                       GnonogramsCell* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GnonogramsCell _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (b != NULL, FALSE);
	_tmp2_ = *b;
	if ((*self).row == _tmp2_.row) {
		GnonogramsCell _tmp3_;
		_tmp3_ = *b;
		_tmp1_ = (*self).col == _tmp3_.col;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GnonogramsCellState _tmp4_;
		GnonogramsCell _tmp5_;
		GnonogramsCellState _tmp6_;
		_tmp4_ = (*self).state;
		_tmp5_ = *b;
		_tmp6_ = _tmp5_.state;
		_tmp0_ = _tmp4_ == _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
gnonograms_cell_inverse (GnonogramsCell *self,
                         GnonogramsCell* result)
{
	GnonogramsCell c = {0};
	GnonogramsCell _tmp0_ = {0};
	GnonogramsCellState _tmp1_;
	_tmp0_.row = (*self).row;
	_tmp0_.col = (*self).col;
	_tmp0_.state = GNONOGRAMS_CELL_STATE_UNKNOWN;
	c = _tmp0_;
	_tmp1_ = (*self).state;
	if (_tmp1_ == GNONOGRAMS_CELL_STATE_EMPTY) {
		c.state = GNONOGRAMS_CELL_STATE_FILLED;
	} else {
		c.state = GNONOGRAMS_CELL_STATE_EMPTY;
	}
	*result = c;
	return;
}

void
gnonograms_cell_clone (GnonogramsCell *self,
                       GnonogramsCell* result)
{
	GnonogramsCellState _tmp0_;
	GnonogramsCell _tmp1_ = {0};
	_tmp0_ = (*self).state;
	_tmp1_.row = (*self).row;
	_tmp1_.col = (*self).col;
	_tmp1_.state = _tmp0_;
	*result = _tmp1_;
	return;
}

gchar*
gnonograms_cell_to_string (GnonogramsCell *self)
{
	GnonogramsCellState _tmp0_;
	GEnumValue* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	_tmp0_ = (*self).state;
	_tmp1_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_CELL_STATE), _tmp0_);
	_tmp2_ = g_strdup_printf ("Row %u, Col %u, State %s", (*self).row, (*self).col, (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
	result = _tmp2_;
	return result;
}

GnonogramsCell*
gnonograms_cell_dup (const GnonogramsCell* self)
{
	GnonogramsCell* dup;
	dup = g_new0 (GnonogramsCell, 1);
	memcpy (dup, self, sizeof (GnonogramsCell));
	return dup;
}

void
gnonograms_cell_free (GnonogramsCell* self)
{
	g_free (self);
}

GType
gnonograms_cell_get_type (void)
{
	static volatile gsize gnonograms_cell_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_cell_type_id__volatile)) {
		GType gnonograms_cell_type_id;
		gnonograms_cell_type_id = g_boxed_type_register_static ("GnonogramsCell", (GBoxedCopyFunc) gnonograms_cell_dup, (GBoxedFreeFunc) gnonograms_cell_free);
		g_once_init_leave (&gnonograms_cell_type_id__volatile, gnonograms_cell_type_id);
	}
	return gnonograms_cell_type_id__volatile;
}

guint
gnonograms_dimensions_rows (GnonogramsDimensions *self)
{
	guint result = 0U;
	result = (*self).height;
	return result;
}

guint
gnonograms_dimensions_cols (GnonogramsDimensions *self)
{
	guint result = 0U;
	result = (*self).width;
	return result;
}

guint
gnonograms_dimensions_area (GnonogramsDimensions *self)
{
	guint result = 0U;
	result = (*self).width * (*self).height;
	return result;
}

guint
gnonograms_dimensions_length (GnonogramsDimensions *self)
{
	guint result = 0U;
	result = (*self).width + (*self).height;
	return result;
}

gboolean
gnonograms_dimensions_equal (GnonogramsDimensions *self,
                             GnonogramsDimensions* other)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsDimensions _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp1_ = *other;
	if ((*self).width == _tmp1_.width) {
		GnonogramsDimensions _tmp2_;
		_tmp2_ = *other;
		_tmp0_ = (*self).height == _tmp2_.height;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

GnonogramsDimensions*
gnonograms_dimensions_dup (const GnonogramsDimensions* self)
{
	GnonogramsDimensions* dup;
	dup = g_new0 (GnonogramsDimensions, 1);
	memcpy (dup, self, sizeof (GnonogramsDimensions));
	return dup;
}

void
gnonograms_dimensions_free (GnonogramsDimensions* self)
{
	g_free (self);
}

GType
gnonograms_dimensions_get_type (void)
{
	static volatile gsize gnonograms_dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_dimensions_type_id__volatile)) {
		GType gnonograms_dimensions_type_id;
		gnonograms_dimensions_type_id = g_boxed_type_register_static ("GnonogramsDimensions", (GBoxedCopyFunc) gnonograms_dimensions_dup, (GBoxedFreeFunc) gnonograms_dimensions_free);
		g_once_init_leave (&gnonograms_dimensions_type_id__volatile, gnonograms_dimensions_type_id);
	}
	return gnonograms_dimensions_type_id__volatile;
}

void
gnonograms_filter_info_copy (const GnonogramsFilterInfo* self,
                             GnonogramsFilterInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).pattern;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).pattern);
	(*dest).pattern = _tmp3_;
}

void
gnonograms_filter_info_destroy (GnonogramsFilterInfo* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).pattern);
}

GnonogramsFilterInfo*
gnonograms_filter_info_dup (const GnonogramsFilterInfo* self)
{
	GnonogramsFilterInfo* dup;
	dup = g_new0 (GnonogramsFilterInfo, 1);
	gnonograms_filter_info_copy (self, dup);
	return dup;
}

void
gnonograms_filter_info_free (GnonogramsFilterInfo* self)
{
	gnonograms_filter_info_destroy (self);
	g_free (self);
}

GType
gnonograms_filter_info_get_type (void)
{
	static volatile gsize gnonograms_filter_info_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_filter_info_type_id__volatile)) {
		GType gnonograms_filter_info_type_id;
		gnonograms_filter_info_type_id = g_boxed_type_register_static ("GnonogramsFilterInfo", (GBoxedCopyFunc) gnonograms_filter_info_dup, (GBoxedFreeFunc) gnonograms_filter_info_free);
		g_once_init_leave (&gnonograms_filter_info_type_id__volatile, gnonograms_filter_info_type_id);
	}
	return gnonograms_filter_info_type_id__volatile;
}

