/* utils.c generated by valac 0.46.6, the Vala compiler
 * generated from utils.vala, do not modify */

/* Utility functions for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
#define _gnonograms_block_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_block_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER,
	GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED
} GnonogramsFileChooserAction;

#define GNONOGRAMS_TYPE_FILE_CHOOSER_ACTION (gnonograms_file_chooser_action_get_type ())

#define GNONOGRAMS_TYPE_FILTER_INFO (gnonograms_filter_info_get_type ())
typedef struct _GnonogramsFilterInfo GnonogramsFilterInfo;

struct _GnonogramsFilterInfo {
	gchar* name;
	gchar* pattern;
};

gchar** gnonograms_utils_remove_blank_lines (gchar** sa,
                                             gint sa_length1,
                                             gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gint* gnonograms_utils_block_array_from_clue (const gchar* s,
                                              gint* result_length1);
gpointer gnonograms_block_ref (gpointer instance);
void gnonograms_block_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
gpointer gnonograms_value_get_block (const GValue* value);
GType gnonograms_block_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
GeeArrayList* gnonograms_utils_block_struct_array_from_clue (const gchar* s);
GnonogramsBlock* gnonograms_block_new (gint len,
                                       gboolean complete,
                                       gboolean _error_);
GnonogramsBlock* gnonograms_block_construct (GType object_type,
                                             gint len,
                                             gboolean complete,
                                             gboolean _error_);
gint gnonograms_utils_blockextent_from_clue (const gchar* s);
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
gint gnonograms_utils_freedom_from_array (GnonogramsCellState* arr,
                                          gint arr_length1);
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
gchar** gnonograms_utils_row_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                                  gint* result_length1);
guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
gchar* gnonograms_my2_dcell_array_data2text (GnonogramsMy2DCellArray* self,
                                             guint idx,
                                             guint length,
                                             gboolean iscolumn);
gchar** gnonograms_utils_col_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                                  gint* result_length1);
GeeArrayList* gnonograms_utils_complete_block_array_from_cellstate_array (GnonogramsCellState* cellstates,
                                                                          gint cellstates_length1);
GnonogramsBlock* gnonograms_block_new_null (void);
GnonogramsBlock* gnonograms_block_construct_null (GType object_type);
gchar* gnonograms_utils_block_string_from_cellstate_array (GnonogramsCellState* cellstates,
                                                           gint cellstates_length1);
#define GNONOGRAMS_BLOCKSEPARATOR ", "
#define GNONOGRAMS_BLANKLABELTEXT N_ ("?")
GnonogramsCellState* gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                                                   gint* result_length1);
static void _vala_array_add2 (GnonogramsCellState* * array,
                       int* length,
                       int* size,
                       GnonogramsCellState value);
gchar* gnonograms_utils_string_from_cellstate_array (GnonogramsCellState* cs,
                                                     gint cs_length1);
gint gnonograms_utils_show_dlg (const gchar* primary_text,
                                GtkMessageType type,
                                const gchar* secondary_text,
                                GtkWindow* parent);
void gnonograms_utils_show_error_dialog (const gchar* primary_text,
                                         const gchar* secondary_text,
                                         GtkWindow* parent);
gboolean gnonograms_utils_show_confirm_dialog (const gchar* primary_text,
                                               const gchar* secondary_text,
                                               GtkWindow* parent);
GType gnonograms_file_chooser_action_get_type (void) G_GNUC_CONST;
GType gnonograms_filter_info_get_type (void) G_GNUC_CONST;
GnonogramsFilterInfo* gnonograms_filter_info_dup (const GnonogramsFilterInfo* self);
void gnonograms_filter_info_free (GnonogramsFilterInfo* self);
void gnonograms_filter_info_copy (const GnonogramsFilterInfo* self,
                                  GnonogramsFilterInfo* dest);
void gnonograms_filter_info_destroy (GnonogramsFilterInfo* self);
gchar* gnonograms_utils_get_file_path (GtkWindow* parent,
                                       GnonogramsFileChooserAction action,
                                       const gchar* dialogname,
                                       GnonogramsFilterInfo* filters,
                                       gint filters_length1,
                                       const gchar* start_path,
                                       gboolean* save_solution);
void gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                        GdkWindow* window,
                                        GdkRectangle* result);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

gchar**
gnonograms_utils_remove_blank_lines (gchar** sa,
                                     gint sa_length1,
                                     gint* result_length1)
{
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result = NULL;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	_result_ = _tmp0_;
	_result__length1 = 0;
	__result__size_ = _result__length1;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = sa;
		s_collection_length1 = sa_length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp1_;
			gchar* s = NULL;
			_tmp1_ = g_strdup (s_collection[s_it]);
			s = _tmp1_;
			{
				gchar* ss = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				_tmp2_ = s;
				_tmp3_ = string_strip (_tmp2_);
				ss = _tmp3_;
				_tmp4_ = ss;
				if (g_strcmp0 (_tmp4_, "") != 0) {
					gchar** _tmp5_;
					gint _tmp5__length1;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					_tmp5_ = _result_;
					_tmp5__length1 = _result__length1;
					_tmp6_ = ss;
					_tmp7_ = g_strdup (_tmp6_);
					_vala_array_add1 (&_result_, &_result__length1, &__result__size_, _tmp7_);
				}
				_g_free0 (ss);
				_g_free0 (s);
			}
		}
	}
	_tmp8_ = _result_;
	_tmp8__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

gint*
gnonograms_utils_block_array_from_clue (const gchar* s,
                                        gint* result_length1)
{
	gchar** blocks = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint blocks_length1;
	gint _blocks_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit_set (s, ", ", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp5_;
	blocks_length1 = _tmp5__length1;
	_blocks_size_ = blocks_length1;
	_tmp6_ = blocks;
	_tmp6__length1 = blocks_length1;
	if (_tmp6__length1 == 0) {
		gint* _tmp7_;
		gint* _tmp8_;
		gint _tmp8__length1;
		_tmp7_ = g_new0 (gint, 1);
		_tmp7_[0] = 0;
		_tmp8_ = _tmp7_;
		_tmp8__length1 = 1;
		if (result_length1) {
			*result_length1 = _tmp8__length1;
		}
		result = _tmp8_;
		blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		gint* block_array = NULL;
		gchar** _tmp9_;
		gint _tmp9__length1;
		gint* _tmp10_;
		gint block_array_length1;
		gint _block_array_size_;
		gint index = 0;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gint* _tmp16_;
		gint _tmp16__length1;
		_tmp9_ = blocks;
		_tmp9__length1 = blocks_length1;
		_tmp10_ = g_new0 (gint, _tmp9__length1);
		block_array = _tmp10_;
		block_array_length1 = _tmp9__length1;
		_block_array_size_ = block_array_length1;
		index = 0;
		_tmp11_ = blocks;
		_tmp11__length1 = blocks_length1;
		{
			gchar** block_collection = NULL;
			gint block_collection_length1 = 0;
			gint _block_collection_size_ = 0;
			gint block_it = 0;
			block_collection = _tmp11_;
			block_collection_length1 = _tmp11__length1;
			for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
				gchar* _tmp12_;
				gchar* block = NULL;
				_tmp12_ = g_strdup (block_collection[block_it]);
				block = _tmp12_;
				{
					gint* _tmp13_;
					gint _tmp13__length1;
					gint _tmp14_;
					const gchar* _tmp15_;
					_tmp13_ = block_array;
					_tmp13__length1 = block_array_length1;
					_tmp14_ = index;
					index = _tmp14_ + 1;
					_tmp15_ = block;
					_tmp13_[_tmp14_] = atoi (_tmp15_);
					_g_free0 (block);
				}
			}
		}
		_tmp16_ = block_array;
		_tmp16__length1 = block_array_length1;
		if (result_length1) {
			*result_length1 = _tmp16__length1;
		}
		result = _tmp16_;
		blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
}

GeeArrayList*
gnonograms_utils_block_struct_array_from_clue (const gchar* s)
{
	gchar** blocks = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint blocks_length1;
	gint _blocks_size_;
	GeeArrayList* block_array = NULL;
	GeeArrayList* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit_set (s, ", ", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp5_;
	blocks_length1 = _tmp5__length1;
	_blocks_size_ = blocks_length1;
	_tmp6_ = gee_array_list_new (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref, NULL, NULL, NULL);
	block_array = _tmp6_;
	_tmp7_ = blocks;
	_tmp7__length1 = blocks_length1;
	{
		gchar** block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp7_;
		block_collection_length1 = _tmp7__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gchar* _tmp8_;
			gchar* block = NULL;
			_tmp8_ = g_strdup (block_collection[block_it]);
			block = _tmp8_;
			{
				GeeArrayList* _tmp9_;
				const gchar* _tmp10_;
				GnonogramsBlock* _tmp11_;
				GnonogramsBlock* _tmp12_;
				_tmp9_ = block_array;
				_tmp10_ = block;
				_tmp11_ = gnonograms_block_new (atoi (_tmp10_), FALSE, FALSE);
				_tmp12_ = _tmp11_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
				_gnonograms_block_unref0 (_tmp12_);
				_g_free0 (block);
			}
		}
	}
	result = block_array;
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gint
gnonograms_utils_blockextent_from_clue (const gchar* s)
{
	gint* blocks = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint blocks_length1;
	gint _blocks_size_;
	gint extent = 0;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result = 0;
	if (s == NULL) {
		result = 0;
		return result;
	}
	_tmp1_ = gnonograms_utils_block_array_from_clue (s, &_tmp0_);
	blocks = _tmp1_;
	blocks_length1 = _tmp0_;
	_blocks_size_ = blocks_length1;
	extent = 0;
	_tmp2_ = blocks;
	_tmp2__length1 = blocks_length1;
	{
		gint* block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp2_;
		block_collection_length1 = _tmp2__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gint block = 0;
			block = block_collection[block_it];
			{
				extent += block + 1;
			}
		}
	}
	_tmp3_ = extent;
	extent = _tmp3_ - 1;
	result = extent;
	blocks = (g_free (blocks), NULL);
	return result;
}

gint
gnonograms_utils_freedom_from_array (GnonogramsCellState* arr,
                                     gint arr_length1)
{
	gint filled = 0;
	gint blocks = 0;
	gint length = 0;
	gint result = 0;
	filled = 0;
	blocks = 0;
	length = arr_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < length)) {
					break;
				}
				_tmp2_ = arr[i];
				if (_tmp2_ == GNONOGRAMS_CELL_STATE_FILLED) {
					gint _tmp3_;
					gboolean _tmp4_ = FALSE;
					_tmp3_ = filled;
					filled = _tmp3_ + 1;
					if (i == 0) {
						_tmp4_ = TRUE;
					} else {
						GnonogramsCellState _tmp5_;
						_tmp5_ = arr[i - 1];
						_tmp4_ = _tmp5_ == GNONOGRAMS_CELL_STATE_EMPTY;
					}
					if (_tmp4_) {
						gint _tmp6_;
						_tmp6_ = blocks;
						blocks = _tmp6_ + 1;
					}
				}
			}
		}
	}
	result = (length - filled) - (blocks - 1);
	return result;
}

gchar**
gnonograms_utils_row_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                          gint* result_length1)
{
	guint rows = 0U;
	guint _tmp0_;
	guint _tmp1_;
	guint cols = 0U;
	guint _tmp2_;
	guint _tmp3_;
	gchar** clues = NULL;
	gchar** _tmp4_;
	gint clues_length1;
	gint _clues_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result = NULL;
	g_return_val_if_fail (array != NULL, NULL);
	_tmp0_ = gnonograms_my2_dcell_array_get_rows (array);
	_tmp1_ = _tmp0_;
	rows = _tmp1_;
	_tmp2_ = gnonograms_my2_dcell_array_get_cols (array);
	_tmp3_ = _tmp2_;
	cols = _tmp3_;
	_tmp4_ = g_new0 (gchar*, rows + 1);
	clues = _tmp4_;
	clues_length1 = rows;
	_clues_size_ = clues_length1;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = r;
					r = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(((guint) r) < rows)) {
					break;
				}
				_tmp7_ = clues;
				_tmp7__length1 = clues_length1;
				_tmp8_ = gnonograms_my2_dcell_array_data2text (array, (guint) r, cols, FALSE);
				_g_free0 (_tmp7_[r]);
				_tmp7_[r] = _tmp8_;
			}
		}
	}
	_tmp9_ = clues;
	_tmp9__length1 = clues_length1;
	if (result_length1) {
		*result_length1 = _tmp9__length1;
	}
	result = _tmp9_;
	return result;
}

gchar**
gnonograms_utils_col_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                          gint* result_length1)
{
	guint rows = 0U;
	guint _tmp0_;
	guint _tmp1_;
	guint cols = 0U;
	guint _tmp2_;
	guint _tmp3_;
	gchar** clues = NULL;
	gchar** _tmp4_;
	gint clues_length1;
	gint _clues_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result = NULL;
	g_return_val_if_fail (array != NULL, NULL);
	_tmp0_ = gnonograms_my2_dcell_array_get_rows (array);
	_tmp1_ = _tmp0_;
	rows = _tmp1_;
	_tmp2_ = gnonograms_my2_dcell_array_get_cols (array);
	_tmp3_ = _tmp2_;
	cols = _tmp3_;
	_tmp4_ = g_new0 (gchar*, cols + 1);
	clues = _tmp4_;
	clues_length1 = cols;
	_clues_size_ = clues_length1;
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = c;
					c = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(((guint) c) < cols)) {
					break;
				}
				_tmp7_ = clues;
				_tmp7__length1 = clues_length1;
				_tmp8_ = gnonograms_my2_dcell_array_data2text (array, (guint) c, rows, TRUE);
				_g_free0 (_tmp7_[c]);
				_tmp7_[c] = _tmp8_;
			}
		}
	}
	_tmp9_ = clues;
	_tmp9__length1 = clues_length1;
	if (result_length1) {
		*result_length1 = _tmp9__length1;
	}
	result = _tmp9_;
	return result;
}

GeeArrayList*
gnonograms_utils_complete_block_array_from_cellstate_array (GnonogramsCellState* cellstates,
                                                            gint cellstates_length1)
{
	GeeArrayList* blocks = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gboolean valid = FALSE;
	GnonogramsCellState previous_state = 0;
	GeeArrayList* result = NULL;
	_tmp0_ = gee_array_list_new (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref, NULL, NULL, NULL);
	blocks = _tmp0_;
	count = 0;
	valid = TRUE;
	previous_state = GNONOGRAMS_CELL_STATE_UNKNOWN;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cellstates;
		state_collection_length1 = cellstates_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			GnonogramsCellState state = 0;
			state = state_collection[state_it];
			{
				GnonogramsCellState _tmp1_;
				GnonogramsCellState _tmp11_;
				_tmp1_ = state;
				switch (_tmp1_) {
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						if (count > 0) {
							GeeArrayList* _tmp2_;
							GnonogramsBlock* _tmp3_;
							GnonogramsBlock* _tmp4_;
							_tmp2_ = blocks;
							_tmp3_ = gnonograms_block_new (count, TRUE, FALSE);
							_tmp4_ = _tmp3_;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, _tmp4_);
							_gnonograms_block_unref0 (_tmp4_);
							count = 0;
						} else {
							valid = TRUE;
						}
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						if (valid) {
							gint _tmp5_;
							_tmp5_ = count;
							count = _tmp5_ + 1;
						}
						break;
					}
					case GNONOGRAMS_CELL_STATE_UNKNOWN:
					{
						gboolean _tmp6_ = FALSE;
						if (valid) {
							_tmp6_ = TRUE;
						} else {
							GnonogramsCellState _tmp7_;
							_tmp7_ = previous_state;
							_tmp6_ = _tmp7_ != GNONOGRAMS_CELL_STATE_UNKNOWN;
						}
						if (_tmp6_) {
							GeeArrayList* _tmp8_;
							GnonogramsBlock* _tmp9_;
							GnonogramsBlock* _tmp10_;
							valid = FALSE;
							count = 0;
							_tmp8_ = blocks;
							_tmp9_ = gnonograms_block_new_null ();
							_tmp10_ = _tmp9_;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp10_);
							_gnonograms_block_unref0 (_tmp10_);
						}
						break;
					}
					default:
					{
						break;
					}
				}
				_tmp11_ = state;
				previous_state = _tmp11_;
			}
		}
	}
	if (count > 0) {
		GeeArrayList* _tmp12_;
		GnonogramsBlock* _tmp13_;
		GnonogramsBlock* _tmp14_;
		_tmp12_ = blocks;
		_tmp13_ = gnonograms_block_new (count, TRUE, FALSE);
		_tmp14_ = _tmp13_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp14_);
		_gnonograms_block_unref0 (_tmp14_);
	}
	result = blocks;
	return result;
}

gchar*
gnonograms_utils_block_string_from_cellstate_array (GnonogramsCellState* cellstates,
                                                    gint cellstates_length1)
{
	GString* sb = NULL;
	GString* _tmp0_;
	gint count = 0;
	gint blocks = 0;
	gboolean counting = FALSE;
	GnonogramsCellState count_state = 0;
	GnonogramsCellState _tmp23_;
	GString* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* result = NULL;
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	count = 0;
	blocks = 0;
	counting = FALSE;
	count_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cellstates;
		state_collection_length1 = cellstates_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			GnonogramsCellState state = 0;
			state = state_collection[state_it];
			{
				GnonogramsCellState _tmp1_;
				_tmp1_ = state;
				switch (_tmp1_) {
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						GnonogramsCellState _tmp2_;
						_tmp2_ = count_state;
						if (_tmp2_ == GNONOGRAMS_CELL_STATE_FILLED) {
							GString* _tmp3_;
							gchar* _tmp4_;
							gchar* _tmp5_;
							gchar* _tmp6_;
							gchar* _tmp7_;
							gint _tmp8_;
							_tmp3_ = sb;
							_tmp4_ = g_strdup_printf ("%i", count);
							_tmp5_ = _tmp4_;
							_tmp6_ = g_strconcat (_tmp5_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
							_tmp7_ = _tmp6_;
							g_string_append (_tmp3_, _tmp7_);
							_g_free0 (_tmp7_);
							_g_free0 (_tmp5_);
							_tmp8_ = blocks;
							blocks = _tmp8_ + 1;
						} else {
							GnonogramsCellState _tmp9_;
							_tmp9_ = count_state;
							if (_tmp9_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GString* _tmp10_;
								_tmp10_ = sb;
								g_string_append (_tmp10_, "?" GNONOGRAMS_BLOCKSEPARATOR);
							}
						}
						counting = FALSE;
						count_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
						count = 0;
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						GnonogramsCellState _tmp11_;
						gint _tmp14_;
						_tmp11_ = count_state;
						if (_tmp11_ == GNONOGRAMS_CELL_STATE_UNDEFINED) {
							count = 0;
							counting = TRUE;
						} else {
							GnonogramsCellState _tmp12_;
							_tmp12_ = count_state;
							if (_tmp12_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GString* _tmp13_;
								_tmp13_ = sb;
								g_string_append (_tmp13_, "?" GNONOGRAMS_BLOCKSEPARATOR);
								count = 0;
							}
						}
						count_state = GNONOGRAMS_CELL_STATE_FILLED;
						_tmp14_ = count;
						count = _tmp14_ + 1;
						break;
					}
					case GNONOGRAMS_CELL_STATE_UNKNOWN:
					{
						GnonogramsCellState _tmp15_;
						_tmp15_ = count_state;
						if (_tmp15_ == GNONOGRAMS_CELL_STATE_UNDEFINED) {
							counting = TRUE;
						} else {
							GnonogramsCellState _tmp16_;
							_tmp16_ = count_state;
							if (_tmp16_ == GNONOGRAMS_CELL_STATE_FILLED) {
								GString* _tmp17_;
								gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
								gchar* _tmp21_;
								_tmp17_ = sb;
								_tmp18_ = g_strdup_printf ("%i", count);
								_tmp19_ = _tmp18_;
								_tmp20_ = g_strconcat (_tmp19_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
								_tmp21_ = _tmp20_;
								g_string_append (_tmp17_, _tmp21_);
								_g_free0 (_tmp21_);
								_g_free0 (_tmp19_);
								count = 0;
							}
						}
						count_state = GNONOGRAMS_CELL_STATE_UNKNOWN;
						break;
					}
					default:
					{
						gchar* _tmp22_;
						_tmp22_ = g_strdup (_ (GNONOGRAMS_BLANKLABELTEXT));
						result = _tmp22_;
						_g_string_free0 (sb);
						return result;
					}
				}
			}
		}
	}
	_tmp23_ = count_state;
	if (_tmp23_ == GNONOGRAMS_CELL_STATE_FILLED) {
		GString* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gint _tmp29_;
		_tmp24_ = sb;
		_tmp25_ = g_strdup_printf ("%i", count);
		_tmp26_ = _tmp25_;
		_tmp27_ = g_strconcat (_tmp26_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
		_tmp28_ = _tmp27_;
		g_string_append (_tmp24_, _tmp28_);
		_g_free0 (_tmp28_);
		_g_free0 (_tmp26_);
		_tmp29_ = blocks;
		blocks = _tmp29_ + 1;
	} else {
		GnonogramsCellState _tmp30_;
		_tmp30_ = count_state;
		if (_tmp30_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
			GString* _tmp31_;
			gint _tmp32_;
			_tmp31_ = sb;
			g_string_append (_tmp31_, "?" GNONOGRAMS_BLOCKSEPARATOR);
			_tmp32_ = blocks;
			blocks = _tmp32_ + 1;
		}
	}
	if (blocks == 0) {
		GString* _tmp33_;
		_tmp33_ = sb;
		g_string_append (_tmp33_, "0");
	} else {
		GString* _tmp34_;
		GString* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		_tmp34_ = sb;
		_tmp35_ = sb;
		_tmp36_ = strlen (GNONOGRAMS_BLOCKSEPARATOR);
		_tmp37_ = _tmp36_;
		g_string_truncate (_tmp34_, (gsize) (_tmp35_->len - _tmp37_));
	}
	_tmp38_ = sb;
	_tmp39_ = _tmp38_->str;
	_tmp40_ = g_strdup (_tmp39_);
	result = _tmp40_;
	_g_string_free0 (sb);
	return result;
}

static void
_vala_array_add2 (GnonogramsCellState* * array,
                  int* length,
                  int* size,
                  GnonogramsCellState value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GnonogramsCellState, *array, *size);
	}
	(*array)[(*length)++] = value;
}

GnonogramsCellState*
gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                              gint* result_length1)
{
	GnonogramsCellState* cs = NULL;
	GnonogramsCellState* _tmp0_;
	gint cs_length1;
	gint _cs_size_;
	gchar** blocks = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint blocks_length1;
	gint _blocks_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GnonogramsCellState* _tmp11_;
	gint _tmp11__length1;
	GnonogramsCellState* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp0_ = g_new0 (GnonogramsCellState, 0);
	cs = _tmp0_;
	cs_length1 = 0;
	_cs_size_ = cs_length1;
	_tmp2_ = _tmp1_ = g_strsplit_set (s, GNONOGRAMS_BLOCKSEPARATOR, 0);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	_tmp5_ = gnonograms_utils_remove_blank_lines (_tmp3_, (gint) _vala_array_length (_tmp1_), &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp6_;
	blocks_length1 = _tmp6__length1;
	_blocks_size_ = blocks_length1;
	_tmp7_ = blocks;
	_tmp7__length1 = blocks_length1;
	{
		gchar** block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp7_;
		block_collection_length1 = _tmp7__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gchar* _tmp8_;
			gchar* block = NULL;
			_tmp8_ = g_strdup (block_collection[block_it]);
			block = _tmp8_;
			{
				GnonogramsCellState* _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				_tmp9_ = cs;
				_tmp9__length1 = cs_length1;
				_tmp10_ = block;
				_vala_array_add2 (&cs, &cs_length1, &_cs_size_, (GnonogramsCellState) CLAMP (atoi (_tmp10_), 0, (gint) GNONOGRAMS_CELL_STATE_UNDEFINED));
				_g_free0 (block);
			}
		}
	}
	_tmp11_ = cs;
	_tmp11__length1 = cs_length1;
	if (result_length1) {
		*result_length1 = _tmp11__length1;
	}
	result = _tmp11_;
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gchar*
gnonograms_utils_string_from_cellstate_array (GnonogramsCellState* cs,
                                              gint cs_length1)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cs;
		state_collection_length1 = cs_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			guint state = 0U;
			state = (guint) state_collection[state_it];
			{
				GString* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GString* _tmp4_;
				_tmp1_ = sb;
				_tmp2_ = g_strdup_printf ("%u", state);
				_tmp3_ = _tmp2_;
				g_string_append (_tmp1_, _tmp3_);
				_g_free0 (_tmp3_);
				_tmp4_ = sb;
				g_string_append (_tmp4_, " ");
			}
		}
	}
	_tmp5_ = sb;
	_tmp6_ = _tmp5_->str;
	_tmp7_ = g_strdup (_tmp6_);
	result = _tmp7_;
	_g_string_free0 (sb);
	return result;
}

gint
gnonograms_utils_show_dlg (const gchar* primary_text,
                           GtkMessageType type,
                           const gchar* secondary_text,
                           GtkWindow* parent)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	GtkButtonsType buttons = 0;
	const gchar* _tmp5_ = NULL;
	GraniteMessageDialog* dialog = NULL;
	const gchar* _tmp6_;
	GtkButtonsType _tmp7_;
	GraniteMessageDialog* _tmp8_;
	GraniteMessageDialog* _tmp12_;
	gint response = 0;
	GraniteMessageDialog* _tmp13_;
	GraniteMessageDialog* _tmp14_;
	gint result = 0;
	g_return_val_if_fail (primary_text != NULL, 0);
	_tmp0_ = g_strdup ("");
	icon_name = _tmp0_;
	buttons = GTK_BUTTONS_CLOSE;
	switch (type) {
		case GTK_MESSAGE_INFO:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("dialog-information");
			_g_free0 (icon_name);
			icon_name = _tmp1_;
			break;
		}
		case GTK_MESSAGE_WARNING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("dialog-warning");
			_g_free0 (icon_name);
			icon_name = _tmp2_;
			break;
		}
		case GTK_MESSAGE_ERROR:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("dialog-error");
			_g_free0 (icon_name);
			icon_name = _tmp3_;
			break;
		}
		case GTK_MESSAGE_QUESTION:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("dialog-question");
			_g_free0 (icon_name);
			icon_name = _tmp4_;
			buttons = GTK_BUTTONS_NONE;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp5_ = secondary_text;
	if (_tmp5_ == NULL) {
		_tmp5_ = "";
	}
	_tmp6_ = icon_name;
	_tmp7_ = buttons;
	_tmp8_ = granite_message_dialog_new_with_image_from_icon_name (primary_text, _tmp5_, _tmp6_, _tmp7_);
	g_object_ref_sink (_tmp8_);
	dialog = _tmp8_;
	if (type == GTK_MESSAGE_QUESTION) {
		GraniteMessageDialog* _tmp9_;
		GraniteMessageDialog* _tmp10_;
		GraniteMessageDialog* _tmp11_;
		_tmp9_ = dialog;
		gtk_dialog_add_button ((GtkDialog*) _tmp9_, "YES", (gint) GTK_RESPONSE_YES);
		_tmp10_ = dialog;
		gtk_dialog_add_button ((GtkDialog*) _tmp10_, "NO", (gint) GTK_RESPONSE_NO);
		_tmp11_ = dialog;
		gtk_dialog_set_default_response ((GtkDialog*) _tmp11_, (gint) GTK_RESPONSE_NO);
	}
	_tmp12_ = dialog;
	gtk_window_set_position ((GtkWindow*) _tmp12_, GTK_WIN_POS_MOUSE);
	_tmp13_ = dialog;
	response = gtk_dialog_run ((GtkDialog*) _tmp13_);
	_tmp14_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp14_);
	result = response;
	_g_object_unref0 (dialog);
	_g_free0 (icon_name);
	return result;
}

void
gnonograms_utils_show_error_dialog (const gchar* primary_text,
                                    const gchar* secondary_text,
                                    GtkWindow* parent)
{
	g_return_if_fail (primary_text != NULL);
	gnonograms_utils_show_dlg (primary_text, GTK_MESSAGE_ERROR, secondary_text, parent);
}

gboolean
gnonograms_utils_show_confirm_dialog (const gchar* primary_text,
                                      const gchar* secondary_text,
                                      GtkWindow* parent)
{
	gint response = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (primary_text != NULL, FALSE);
	response = gnonograms_utils_show_dlg (primary_text, GTK_MESSAGE_QUESTION, secondary_text, parent);
	result = response == ((gint) GTK_RESPONSE_YES);
	return result;
}

/** The @action parameter also indicates the default setting for saving the solution.
      * The user selected option is returned in @save_solution.
     **/
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gchar*
gnonograms_utils_get_file_path (GtkWindow* parent,
                                GnonogramsFileChooserAction action,
                                const gchar* dialogname,
                                GnonogramsFilterInfo* filters,
                                gint filters_length1,
                                const gchar* start_path,
                                gboolean* save_solution)
{
	gboolean _vala_save_solution = FALSE;
	gchar* file_path = NULL;
	gchar* button_label = NULL;
	gchar* _tmp0_;
	GtkFileChooserAction gtk_action = 0;
	GtkFileChooserDialog* dialog = NULL;
	GtkFileChooserAction _tmp4_;
	const gchar* _tmp5_;
	GtkFileChooserDialog* _tmp6_;
	GtkFileChooserDialog* _tmp19_;
	GtkSwitch* save_solution_switch = NULL;
	GFile* start = NULL;
	GFile* _tmp35_;
	GtkFileChooserDialog* _tmp36_;
	GFile* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gint response = 0;
	GtkFileChooserDialog* _tmp40_;
	GtkFileChooserDialog* _tmp55_;
	gboolean _tmp56_ = FALSE;
	GtkFileChooserAction _tmp57_;
	gchar* result = NULL;
	g_return_val_if_fail (dialogname != NULL, NULL);
	file_path = NULL;
	_vala_save_solution = action == GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION;
	_tmp0_ = g_strdup ("Error");
	button_label = _tmp0_;
	gtk_action = GTK_FILE_CHOOSER_ACTION_SAVE;
	switch (action) {
		case GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN:
		{
			gchar* _tmp1_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_OPEN;
			_tmp1_ = g_strdup (_ ("Open"));
			_g_free0 (button_label);
			button_label = _tmp1_;
			break;
		}
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION:
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION:
		{
			gchar* _tmp2_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_SAVE;
			_tmp2_ = g_strdup (_ ("Save"));
			_g_free0 (button_label);
			button_label = _tmp2_;
			break;
		}
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER:
		{
			gchar* _tmp3_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER;
			_tmp3_ = g_strdup (_ ("Apply"));
			_g_free0 (button_label);
			button_label = _tmp3_;
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp4_ = gtk_action;
	_tmp5_ = button_label;
	_tmp6_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (dialogname, parent, _tmp4_, _ ("Cancel"), GTK_RESPONSE_CANCEL, _tmp5_, GTK_RESPONSE_ACCEPT, NULL, NULL);
	g_object_ref_sink (_tmp6_);
	dialog = _tmp6_;
	{
		GnonogramsFilterInfo* info_collection = NULL;
		gint info_collection_length1 = 0;
		gint _info_collection_size_ = 0;
		gint info_it = 0;
		info_collection = filters;
		info_collection_length1 = filters_length1;
		for (info_it = 0; info_it < info_collection_length1; info_it = info_it + 1) {
			GnonogramsFilterInfo _tmp7_;
			GnonogramsFilterInfo _tmp8_ = {0};
			GnonogramsFilterInfo info = {0};
			_tmp7_ = info_collection[info_it];
			gnonograms_filter_info_copy (&_tmp7_, &_tmp8_);
			info = _tmp8_;
			{
				GtkFileFilter* fc = NULL;
				GtkFileFilter* _tmp9_;
				GtkFileFilter* _tmp10_;
				GnonogramsFilterInfo _tmp11_;
				const gchar* _tmp12_;
				GtkFileFilter* _tmp13_;
				GnonogramsFilterInfo _tmp14_;
				const gchar* _tmp15_;
				GtkFileChooserDialog* _tmp16_;
				GtkFileFilter* _tmp17_;
				GtkFileFilter* _tmp18_;
				_tmp9_ = gtk_file_filter_new ();
				g_object_ref_sink (_tmp9_);
				fc = _tmp9_;
				_tmp10_ = fc;
				_tmp11_ = info;
				_tmp12_ = _tmp11_.name;
				gtk_file_filter_set_name (_tmp10_, _tmp12_);
				_tmp13_ = fc;
				_tmp14_ = info;
				_tmp15_ = _tmp14_.pattern;
				gtk_file_filter_add_pattern (_tmp13_, _tmp15_);
				_tmp16_ = dialog;
				_tmp17_ = fc;
				_tmp18_ = _g_object_ref0 (_tmp17_);
				gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp16_, _tmp18_);
				_g_object_unref0 (fc);
				gnonograms_filter_info_destroy (&info);
			}
		}
	}
	_tmp19_ = dialog;
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp19_, FALSE);
	save_solution_switch = NULL;
	if (action != GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN) {
		GtkGrid* grid = NULL;
		GtkGrid* _tmp20_;
		GtkGrid* _tmp21_;
		GtkGrid* _tmp22_;
		GtkSwitch* _tmp23_;
		GtkSwitch* _tmp24_;
		GtkLabel* save_solution_label = NULL;
		GtkLabel* _tmp25_;
		GtkGrid* _tmp26_;
		GtkLabel* _tmp27_;
		GtkGrid* _tmp28_;
		GtkSwitch* _tmp29_;
		GtkFileChooserDialog* _tmp30_;
		GtkWidget* _tmp31_;
		GtkGrid* _tmp32_;
		GtkGrid* _tmp33_;
		_tmp20_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp20_);
		grid = _tmp20_;
		_tmp21_ = grid;
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp21_, GTK_ORIENTATION_HORIZONTAL);
		_tmp22_ = grid;
		gtk_grid_set_column_spacing (_tmp22_, 6);
		_tmp23_ = (GtkSwitch*) gtk_switch_new ();
		g_object_ref_sink (_tmp23_);
		_g_object_unref0 (save_solution_switch);
		save_solution_switch = _tmp23_;
		_tmp24_ = save_solution_switch;
		gtk_switch_set_state (_tmp24_, _vala_save_solution);
		_tmp25_ = (GtkLabel*) gtk_label_new (_ ("Save solution too"));
		g_object_ref_sink (_tmp25_);
		save_solution_label = _tmp25_;
		_tmp26_ = grid;
		_tmp27_ = save_solution_label;
		gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
		_tmp28_ = grid;
		_tmp29_ = save_solution_switch;
		gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
		_tmp30_ = dialog;
		_tmp31_ = gtk_dialog_get_action_area ((GtkDialog*) _tmp30_);
		_tmp32_ = grid;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp32_);
		_tmp33_ = grid;
		gtk_widget_show_all ((GtkWidget*) _tmp33_);
		_g_object_unref0 (save_solution_label);
		_g_object_unref0 (grid);
	}
	if (start_path == NULL) {
		const gchar* _tmp34_;
		_tmp34_ = g_get_home_dir ();
		start_path = _tmp34_;
	}
	_tmp35_ = g_file_new_for_commandline_arg (start_path);
	start = _tmp35_;
	_tmp36_ = dialog;
	_tmp37_ = start;
	_tmp38_ = g_file_get_path (_tmp37_);
	_tmp39_ = _tmp38_;
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp36_, _tmp39_);
	_g_free0 (_tmp39_);
	_tmp40_ = dialog;
	response = gtk_dialog_run ((GtkDialog*) _tmp40_);
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserAction _tmp41_;
		GtkSwitch* _tmp51_;
		_tmp41_ = gtk_action;
		if (_tmp41_ == GTK_FILE_CHOOSER_ACTION_SAVE) {
			GtkFileChooserDialog* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			GtkFileChooserDialog* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			_tmp42_ = dialog;
			_tmp43_ = gtk_file_chooser_get_current_folder ((GtkFileChooser*) _tmp42_);
			_tmp44_ = _tmp43_;
			_tmp45_ = dialog;
			_tmp46_ = gtk_file_chooser_get_current_name ((GtkFileChooser*) _tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = g_build_path (G_DIR_SEPARATOR_S, _tmp44_, _tmp47_, NULL);
			_g_free0 (file_path);
			file_path = _tmp48_;
			_g_free0 (_tmp47_);
			_g_free0 (_tmp44_);
		} else {
			GtkFileChooserDialog* _tmp49_;
			gchar* _tmp50_;
			_tmp49_ = dialog;
			_tmp50_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp49_);
			_g_free0 (file_path);
			file_path = _tmp50_;
		}
		_tmp51_ = save_solution_switch;
		if (_tmp51_ != NULL) {
			GtkSwitch* _tmp52_;
			gboolean _tmp53_;
			gboolean _tmp54_;
			_tmp52_ = save_solution_switch;
			_tmp53_ = gtk_switch_get_state (_tmp52_);
			_tmp54_ = _tmp53_;
			_vala_save_solution = _tmp54_;
		}
	}
	_tmp55_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp55_);
	_tmp57_ = gtk_action;
	if (_tmp57_ == GTK_FILE_CHOOSER_ACTION_SAVE) {
		const gchar* _tmp58_;
		_tmp58_ = file_path;
		_tmp56_ = _tmp58_ != NULL;
	} else {
		_tmp56_ = FALSE;
	}
	if (_tmp56_) {
		GFile* file = NULL;
		const gchar* _tmp59_;
		GFile* _tmp60_;
		gboolean _tmp61_ = FALSE;
		GFile* _tmp62_;
		_tmp59_ = file_path;
		_tmp60_ = g_file_new_for_commandline_arg (_tmp59_);
		file = _tmp60_;
		_tmp62_ = file;
		if (g_file_query_exists (_tmp62_, NULL)) {
			const gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			_tmp63_ = file_path;
			_tmp64_ = g_strdup_printf (_ ("Overwrite %s"), _tmp63_);
			_tmp65_ = _tmp64_;
			_tmp61_ = !gnonograms_utils_show_confirm_dialog (_tmp65_, _ ("This action will destroy contents of that file"), NULL);
			_g_free0 (_tmp65_);
		} else {
			_tmp61_ = FALSE;
		}
		if (_tmp61_) {
			_g_free0 (file_path);
			file_path = NULL;
		}
		_g_object_unref0 (file);
	}
	result = file_path;
	_g_object_unref0 (start);
	_g_object_unref0 (save_solution_switch);
	_g_object_unref0 (dialog);
	_g_free0 (button_label);
	if (save_solution) {
		*save_solution = _vala_save_solution;
	}
	return result;
}

void
gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                   GdkWindow* window,
                                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkMonitor* monitor = NULL;
	GdkMonitor* _tmp2_;
	GdkMonitor* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = gdk_display_get_monitor_at_window (display, window);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	monitor = _tmp3_;
	gdk_monitor_get_geometry (monitor, &_tmp4_);
	rect = _tmp4_;
	*result = rect;
	_g_object_unref0 (monitor);
	_g_object_unref0 (display);
	return;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

