/* Cellgrid.c generated by valac 0.46.6, the Vala compiler
 * generated from Cellgrid.vala, do not modify */

/* Draws grid of cells and detects pointer motion over it.
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */
/*************/
/** PRIVATE **/
/*************/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>

#define GNONOGRAMS_TYPE_CELL_GRID (gnonograms_cell_grid_get_type ())
#define GNONOGRAMS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid))
#define GNONOGRAMS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))
#define GNONOGRAMS_IS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_IS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_CELL_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))

typedef struct _GnonogramsCellGrid GnonogramsCellGrid;
typedef struct _GnonogramsCellGridClass GnonogramsCellGridClass;
typedef struct _GnonogramsCellGridPrivate GnonogramsCellGridPrivate;

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_PATTERN_TYPE_CELL,
	GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT,
	GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED
} GnonogramsCellPatternType;

#define GNONOGRAMS_TYPE_CELL_PATTERN_TYPE (gnonograms_cell_pattern_type_get_type ())

#define GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN (gnonograms_cell_grid_cell_pattern_get_type ())
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern))
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPatternClass))
#define GNONOGRAMS_CELL_GRID_IS_CELL_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN))
#define GNONOGRAMS_CELL_GRID_IS_CELL_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN))
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPatternClass))

typedef struct _GnonogramsCellGridCellPattern GnonogramsCellGridCellPattern;
typedef struct _GnonogramsCellGridCellPatternClass GnonogramsCellGridCellPatternClass;
enum  {
	GNONOGRAMS_CELL_GRID_0_PROPERTY,
	GNONOGRAMS_CELL_GRID_MODEL_PROPERTY,
	GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY,
	GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY,
	GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY,
	GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY,
	GNONOGRAMS_CELL_GRID_GAME_STATE_PROPERTY,
	GNONOGRAMS_CELL_GRID_NUM_PROPERTIES
};
static GParamSpec* gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR (gnonograms_my2_dcell_array_iterator_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIterator))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))

typedef struct _GnonogramsMy2DCellArrayIterator GnonogramsMy2DCellArrayIterator;
typedef struct _GnonogramsMy2DCellArrayIteratorClass GnonogramsMy2DCellArrayIteratorClass;
#define _gnonograms_my2_dcell_array_iterator_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_my2_dcell_array_iterator_unref (var), NULL)))
typedef struct _GnonogramsCellGridCellPatternPrivate GnonogramsCellGridCellPatternPrivate;
enum  {
	GNONOGRAMS_CELL_GRID_CELL_PATTERN_0_PROPERTY,
	GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY,
	GNONOGRAMS_CELL_GRID_CELL_PATTERN_NUM_PROPERTIES
};
static GParamSpec* gnonograms_cell_grid_cell_pattern_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	GNONOGRAMS_CELL_GRID_CURSOR_MOVED_SIGNAL,
	GNONOGRAMS_CELL_GRID_NUM_SIGNALS
};
static guint gnonograms_cell_grid_signals[GNONOGRAMS_CELL_GRID_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsCellGrid {
	GtkDrawingArea parent_instance;
	GnonogramsCellGridPrivate * priv;
};

struct _GnonogramsCellGridClass {
	GtkDrawingAreaClass parent_class;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsCellGridPrivate {
	GnonogramsModel* _model;
	GnonogramsCell _current_cell;
	GnonogramsCell _previous_cell;
	gboolean _frozen;
	GdkRGBA* colors;
	gint colors_length1;
	gint colors_length2;
	GnonogramsCellPatternType _cell_pattern_type;
	gboolean dirty;
	gdouble alloc_width;
	gdouble alloc_height;
	gdouble cell_body_width;
	gdouble cell_body_height;
	gdouble cell_width;
	gdouble cell_height;
	GdkRGBA grid_color;
	GdkRGBA fill_color;
	GdkRGBA empty_color;
	GdkRGBA unknown_color;
	GnonogramsCellGridCellPattern* filled_cell_pattern;
	GnonogramsCellGridCellPattern* empty_cell_pattern;
	GnonogramsCellGridCellPattern* unknown_cell_pattern;
	GnonogramsCellGridCellPattern* highlight_pattern;
};

struct _GnonogramsCellGridCellPattern {
	GObject parent_instance;
	GnonogramsCellGridCellPatternPrivate * priv;
	cairo_pattern_t* pattern;
};

struct _GnonogramsCellGridCellPatternClass {
	GObjectClass parent_class;
};

struct _GnonogramsCellGridCellPatternPrivate {
	gdouble _size;
	gdouble x0;
	gdouble y0;
	cairo_matrix_t matrix;
};

static gint GnonogramsCellGrid_private_offset;
static gpointer gnonograms_cell_grid_parent_class = NULL;
static gint GnonogramsCellGridCellPattern_private_offset;
static gpointer gnonograms_cell_grid_cell_pattern_parent_class = NULL;

GType gnonograms_cell_grid_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGrid, g_object_unref)
GType gnonograms_model_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
GType gnonograms_cell_get_type (void) G_GNUC_CONST;
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
void gnonograms_cell_free (GnonogramsCell* self);
GType gnonograms_cell_pattern_type_get_type (void) G_GNUC_CONST;
static GType gnonograms_cell_grid_cell_pattern_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGridCellPattern, g_object_unref)
#define GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH 3.0
#define GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH 1.0
static void gnonograms_cell_grid_set_colors (GnonogramsCellGrid* self);
GType gnonograms_game_state_get_type (void) G_GNUC_CONST;
#define GNONOGRAMS_UNKNOWN_COLOR "#d4d4d4"
#define GNONOGRAMS_SETTING_EMPTY_COLOR "#fafafa"
#define GNONOGRAMS_SETTING_FILLED_COLOR "#000000"
#define GNONOGRAMS_SOLVING_EMPTY_COLOR "#ffff00"
#define GNONOGRAMS_SOLVING_FILLED_COLOR "#180297"
GnonogramsCellGrid* gnonograms_cell_grid_new (GnonogramsModel* model);
GnonogramsCellGrid* gnonograms_cell_grid_construct (GType object_type,
                                                    GnonogramsModel* model);
static void gnonograms_cell_grid_on_size_allocate (GnonogramsCellGrid* self,
                                            GtkAllocation* rect);
static void gnonograms_cell_grid_dimensions_updated (GnonogramsCellGrid* self);
static guint gnonograms_cell_grid_get_cols (GnonogramsCellGrid* self);
static guint gnonograms_cell_grid_get_rows (GnonogramsCellGrid* self);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new_highlight (gdouble wd,
                                                                                gdouble ht);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct_highlight (GType object_type,
                                                                                      gdouble wd,
                                                                                      gdouble ht);
static gboolean gnonograms_cell_grid_on_draw_event (GnonogramsCellGrid* self,
                                             cairo_t* cr);
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
static GnonogramsMy2DCellArray* gnonograms_cell_grid_get_array (GnonogramsCellGrid* self);
gpointer gnonograms_my2_dcell_array_iterator_ref (gpointer instance);
void gnonograms_my2_dcell_array_iterator_unref (gpointer instance);
GParamSpec* gnonograms_my2_dcell_array_param_spec_iterator (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags);
void gnonograms_my2_dcell_array_value_set_iterator (GValue* value,
                                                    gpointer v_object);
void gnonograms_my2_dcell_array_value_take_iterator (GValue* value,
                                                     gpointer v_object);
gpointer gnonograms_my2_dcell_array_value_get_iterator (const GValue* value);
GType gnonograms_my2_dcell_array_iterator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArrayIterator, gnonograms_my2_dcell_array_iterator_unref)
GnonogramsMy2DCellArrayIterator* gnonograms_my2_dcell_array_iterator (GnonogramsMy2DCellArray* self);
gboolean gnonograms_my2_dcell_array_iterator_next (GnonogramsMy2DCellArrayIterator* self);
void gnonograms_my2_dcell_array_iterator_get (GnonogramsMy2DCellArrayIterator* self,
                                              GnonogramsCell* result);
void gnonograms_cell_grid_get_current_cell (GnonogramsCellGrid* self,
                                            GnonogramsCell * result);
static void gnonograms_cell_grid_draw_cell (GnonogramsCellGrid* self,
                                     cairo_t* cr,
                                     GnonogramsCell* cell,
                                     gboolean highlight,
                                     gboolean mark);
static void gnonograms_cell_grid_draw_grid (GnonogramsCellGrid* self,
                                     cairo_t* cr);
static gboolean gnonograms_cell_grid_on_pointer_moved (GnonogramsCellGrid* self,
                                                GdkEventMotion* e);
GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
gboolean gnonograms_cell_equal (GnonogramsCell *self,
                                GnonogramsCell* b);
static void gnonograms_cell_grid_update_current_cell (GnonogramsCellGrid* self,
                                               GnonogramsCell* target);
void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
void gnonograms_cell_grid_set_previous_cell (GnonogramsCellGrid* self,
                                             GnonogramsCell * value);
void gnonograms_cell_grid_set_current_cell (GnonogramsCellGrid* self,
                                            GnonogramsCell * value);
gboolean gnonograms_cell_grid_get_frozen (GnonogramsCellGrid* self);
static void gnonograms_cell_grid_cell_pattern_move_to (GnonogramsCellGridCellPattern* self,
                                                gdouble x,
                                                gdouble y);
static gboolean gnonograms_cell_grid_on_leave_notify (GnonogramsCellGrid* self);
GnonogramsModel* gnonograms_cell_grid_get_model (GnonogramsCellGrid* self);
static void gnonograms_cell_grid_set_model (GnonogramsCellGrid* self,
                                     GnonogramsModel* value);
static gboolean _gnonograms_cell_equal (const GnonogramsCell * s1,
                                 const GnonogramsCell * s2);
void gnonograms_cell_grid_get_previous_cell (GnonogramsCellGrid* self,
                                             GnonogramsCell * result);
void gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                      gboolean value);
GnonogramsCellPatternType gnonograms_cell_grid_get_cell_pattern_type (GnonogramsCellGrid* self);
void gnonograms_cell_grid_set_cell_pattern_type (GnonogramsCellGrid* self,
                                                 GnonogramsCellPatternType value);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new_cell (GdkRGBA* color);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct_cell (GType object_type,
                                                                                 GdkRGBA* color);
void gnonograms_cell_grid_set_game_state (GnonogramsCellGrid* self,
                                          GnonogramsGameState value);
guint gnonograms_model_get_rows (GnonogramsModel* self);
guint gnonograms_model_get_cols (GnonogramsModel* self);
GnonogramsMy2DCellArray* gnonograms_model_get_display_data (GnonogramsModel* self);
static void g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * gnonograms_cell_grid_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
#define GNONOGRAMS_GRID_COLOR "#000000"
static gboolean _gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                GdkEventMotion* event,
                                                                                gpointer self);
static gboolean _gnonograms_cell_grid_on_draw_event_gtk_widget_draw (GtkWidget* _sender,
                                                              cairo_t* cr,
                                                              gpointer self);
static void _gnonograms_cell_grid_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self);
static gboolean _gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                              GdkEventCrossing* event,
                                                                              gpointer self);
static void _gnonograms_cell_grid___lambda10_ (GnonogramsCellGrid* self);
static void __gnonograms_cell_grid___lambda10__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gnonograms_cell_grid_dimensions_updated_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void _gnonograms_cell_grid___lambda11_ (GnonogramsCellGrid* self);
static void __gnonograms_cell_grid___lambda11__gnonograms_model_changed (GnonogramsModel* _sender,
                                                                  gpointer self);
static void gnonograms_cell_grid_cell_pattern_set_size (GnonogramsCellGridCellPattern* self,
                                                 gdouble value);
static gdouble gnonograms_cell_grid_cell_pattern_get_size (GnonogramsCellGridCellPattern* self);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new (void);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct (GType object_type);
static GObject * gnonograms_cell_grid_cell_pattern_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void gnonograms_cell_grid_cell_pattern_finalize (GObject * obj);
static void _vala_gnonograms_cell_grid_cell_pattern_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_gnonograms_cell_grid_cell_pattern_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static void gnonograms_cell_grid_finalize (GObject * obj);
static void _vala_gnonograms_cell_grid_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gnonograms_cell_grid_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

extern const GnonogramsCell GNONOGRAMS_NULL_CELL;

static inline gpointer
gnonograms_cell_grid_get_instance_private (GnonogramsCellGrid* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsCellGrid_private_offset);
}

static void
gnonograms_cell_grid_set_colors (GnonogramsCellGrid* self)
{
	gint setting = 0;
	GdkRGBA* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GdkRGBA* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	GdkRGBA* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint solving = 0;
	GdkRGBA* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GdkRGBA* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GdkRGBA* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	g_return_if_fail (self != NULL);
	setting = (gint) GNONOGRAMS_GAME_STATE_SETTING;
	_tmp0_ = self->priv->colors;
	_tmp0__length1 = self->priv->colors_length1;
	_tmp0__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp0_[(setting * _tmp0__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)], GNONOGRAMS_UNKNOWN_COLOR);
	_tmp1_ = self->priv->colors;
	_tmp1__length1 = self->priv->colors_length1;
	_tmp1__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp1_[(setting * _tmp1__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)], GNONOGRAMS_SETTING_EMPTY_COLOR);
	_tmp2_ = self->priv->colors;
	_tmp2__length1 = self->priv->colors_length1;
	_tmp2__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp2_[(setting * _tmp2__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)], GNONOGRAMS_SETTING_FILLED_COLOR);
	solving = (gint) GNONOGRAMS_GAME_STATE_SOLVING;
	_tmp3_ = self->priv->colors;
	_tmp3__length1 = self->priv->colors_length1;
	_tmp3__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp3_[(solving * _tmp3__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)], GNONOGRAMS_UNKNOWN_COLOR);
	_tmp4_ = self->priv->colors;
	_tmp4__length1 = self->priv->colors_length1;
	_tmp4__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp4_[(solving * _tmp4__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)], GNONOGRAMS_SOLVING_EMPTY_COLOR);
	_tmp5_ = self->priv->colors;
	_tmp5__length1 = self->priv->colors_length1;
	_tmp5__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp5_[(solving * _tmp5__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)], GNONOGRAMS_SOLVING_FILLED_COLOR);
}

GnonogramsCellGrid*
gnonograms_cell_grid_construct (GType object_type,
                                GnonogramsModel* model)
{
	GnonogramsCellGrid * self = NULL;
	g_return_val_if_fail (model != NULL, NULL);
	self = (GnonogramsCellGrid*) g_object_new (object_type, "model", model, NULL);
	return self;
}

GnonogramsCellGrid*
gnonograms_cell_grid_new (GnonogramsModel* model)
{
	return gnonograms_cell_grid_construct (GNONOGRAMS_TYPE_CELL_GRID, model);
}

/*** Signal Handlers ***/
static void
gnonograms_cell_grid_on_size_allocate (GnonogramsCellGrid* self,
                                       GtkAllocation* rect)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (rect != NULL);
	_tmp0_ = *rect;
	self->priv->alloc_width = (gdouble) _tmp0_.width;
	_tmp1_ = *rect;
	self->priv->alloc_height = (gdouble) _tmp1_.height;
	gnonograms_cell_grid_dimensions_updated (self);
}

static void
gnonograms_cell_grid_dimensions_updated (GnonogramsCellGrid* self)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsCellGridCellPattern* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gnonograms_cell_grid_get_cols (self);
	_tmp1_ = _tmp0_;
	self->priv->cell_width = self->priv->alloc_width / ((gdouble) _tmp1_);
	_tmp2_ = gnonograms_cell_grid_get_rows (self);
	_tmp3_ = _tmp2_;
	self->priv->cell_height = self->priv->alloc_height / ((gdouble) _tmp3_);
	self->priv->cell_body_width = self->priv->cell_width;
	self->priv->cell_body_height = self->priv->cell_height;
	_tmp4_ = gnonograms_cell_grid_cell_pattern_new_highlight (self->priv->cell_width, self->priv->cell_height);
	_g_object_unref0 (self->priv->highlight_pattern);
	self->priv->highlight_pattern = _tmp4_;
}

static gboolean
gnonograms_cell_grid_on_draw_event (GnonogramsCellGrid* self,
                                    cairo_t* cr)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	self->priv->dirty = FALSE;
	_tmp0_ = gnonograms_cell_grid_get_array (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		{
			GnonogramsMy2DCellArrayIterator* _c_it = NULL;
			GnonogramsMy2DCellArray* _tmp2_;
			GnonogramsMy2DCellArray* _tmp3_;
			GnonogramsMy2DCellArrayIterator* _tmp4_;
			_tmp2_ = gnonograms_cell_grid_get_array (self);
			_tmp3_ = _tmp2_;
			_tmp4_ = gnonograms_my2_dcell_array_iterator (_tmp3_);
			_c_it = _tmp4_;
			while (TRUE) {
				GnonogramsMy2DCellArrayIterator* _tmp5_;
				GnonogramsCell c = {0};
				GnonogramsMy2DCellArrayIterator* _tmp6_;
				GnonogramsCell _tmp7_ = {0};
				gboolean _tmp8_ = FALSE;
				GnonogramsCell _tmp9_;
				GnonogramsCell _tmp10_;
				gboolean highlight = FALSE;
				GnonogramsCell _tmp13_;
				_tmp5_ = _c_it;
				if (!gnonograms_my2_dcell_array_iterator_next (_tmp5_)) {
					break;
				}
				_tmp6_ = _c_it;
				gnonograms_my2_dcell_array_iterator_get (_tmp6_, &_tmp7_);
				c = _tmp7_;
				_tmp9_ = c;
				_tmp10_ = self->priv->_current_cell;
				if (_tmp9_.row == _tmp10_.row) {
					GnonogramsCell _tmp11_;
					GnonogramsCell _tmp12_;
					_tmp11_ = c;
					_tmp12_ = self->priv->_current_cell;
					_tmp8_ = _tmp11_.col == _tmp12_.col;
				} else {
					_tmp8_ = FALSE;
				}
				highlight = _tmp8_;
				_tmp13_ = c;
				gnonograms_cell_grid_draw_cell (self, cr, &_tmp13_, highlight, FALSE);
			}
			_gnonograms_my2_dcell_array_iterator_unref0 (_c_it);
		}
	}
	gnonograms_cell_grid_draw_grid (self, cr);
	result = TRUE;
	return result;
}

static gboolean
gnonograms_cell_grid_on_pointer_moved (GnonogramsCellGrid* self,
                                       GdkEventMotion* e)
{
	gboolean _tmp0_ = FALSE;
	guint r = 0U;
	guint c = 0U;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsCell cell = {0};
	GnonogramsMy2DCellArray* _tmp6_;
	GnonogramsMy2DCellArray* _tmp7_;
	GnonogramsCell _tmp8_ = {0};
	GnonogramsCell _tmp9_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->x < ((gdouble) 0)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = e->y < ((gdouble) 0);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	r = (guint) (e->y / self->priv->cell_height);
	c = (guint) (e->x / self->priv->cell_width);
	_tmp2_ = gnonograms_cell_grid_get_rows (self);
	_tmp3_ = _tmp2_;
	if (r >= _tmp3_) {
		_tmp1_ = TRUE;
	} else {
		guint _tmp4_;
		guint _tmp5_;
		_tmp4_ = gnonograms_cell_grid_get_cols (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = c >= _tmp5_;
	}
	if (_tmp1_) {
		result = TRUE;
		return result;
	}
	_tmp6_ = gnonograms_cell_grid_get_array (self);
	_tmp7_ = _tmp6_;
	_tmp8_.row = r;
	_tmp8_.col = c;
	_tmp8_.state = gnonograms_my2_dcell_array_get_data_from_rc (_tmp7_, r, c);
	cell = _tmp8_;
	_tmp9_ = self->priv->_current_cell;
	if (!gnonograms_cell_equal (&cell, &_tmp9_)) {
		GnonogramsCell _tmp10_;
		_tmp10_ = cell;
		gnonograms_cell_grid_update_current_cell (self, &_tmp10_);
	}
	result = TRUE;
	return result;
}

/*** --------------------------------------------------- ***/
static void
gnonograms_cell_grid_update_current_cell (GnonogramsCellGrid* self,
                                          GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_ = {0};
	GnonogramsCell _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = self->priv->_current_cell;
	gnonograms_cell_clone (&_tmp0_, &_tmp1_);
	gnonograms_cell_grid_set_previous_cell (self, &_tmp1_);
	gnonograms_cell_clone (target, &_tmp2_);
	gnonograms_cell_grid_set_current_cell (self, &_tmp2_);
}

static void
gnonograms_cell_grid_draw_grid (GnonogramsCellGrid* self,
                                cairo_t* cr)
{
	gdouble x1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y1 = 0.0;
	gdouble y2 = 0.0;
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->grid_color;
	gdk_cairo_set_source_rgba (cr, &_tmp0_);
	cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE);
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH);
	y1 = (gdouble) 0;
	x1 = (gdouble) 0;
	x2 = self->priv->alloc_width;
	while (TRUE) {
		if (!(y1 < self->priv->alloc_height)) {
			break;
		}
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x2, y1);
		cairo_stroke (cr);
		y1 += self->priv->cell_height;
	}
	x1 = (gdouble) 0;
	y1 = (gdouble) 0;
	y2 = self->priv->alloc_height;
	while (TRUE) {
		if (!(x1 < self->priv->alloc_width)) {
			break;
		}
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x1, y2);
		cairo_stroke (cr);
		x1 += self->priv->cell_width;
	}
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH);
	y1 = (gdouble) 0;
	x1 = (gdouble) 0;
	x2 = self->priv->alloc_width;
	while (TRUE) {
		if (!(y1 < self->priv->alloc_height)) {
			break;
		}
		y1 += 5.0 * self->priv->cell_height;
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x2, y1);
		cairo_stroke (cr);
	}
	x1 = (gdouble) 0;
	y1 = (gdouble) 0;
	y2 = self->priv->alloc_height;
	while (TRUE) {
		if (!(x1 < self->priv->alloc_width)) {
			break;
		}
		x1 += 5.0 * self->priv->cell_width;
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x1, y2);
		cairo_stroke (cr);
	}
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH);
	y1 = GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH / 2;
	x1 = (gdouble) 0;
	x2 = self->priv->alloc_width;
	cairo_move_to (cr, x1, y1);
	cairo_line_to (cr, x2, y1);
	cairo_stroke (cr);
	y1 = self->priv->alloc_height - (GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH / 2);
	cairo_move_to (cr, x1, y1);
	cairo_line_to (cr, x2, y1);
	cairo_stroke (cr);
	x1 = GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH / 2;
	y1 = (gdouble) 0;
	y2 = self->priv->alloc_height;
	cairo_move_to (cr, x1, y1);
	cairo_line_to (cr, x1, y2);
	cairo_stroke (cr);
	x1 = self->priv->alloc_width - (GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH / 2);
	cairo_move_to (cr, x1, y1);
	cairo_line_to (cr, x1, y2);
	cairo_stroke (cr);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gnonograms_cell_grid_draw_cell (GnonogramsCellGrid* self,
                                cairo_t* cr,
                                GnonogramsCell* cell,
                                gboolean highlight,
                                gboolean mark)
{
	gboolean _tmp0_;
	gdouble x = 0.0;
	GnonogramsCell _tmp1_;
	gdouble y = 0.0;
	GnonogramsCell _tmp2_;
	GnonogramsCellGridCellPattern* cell_pattern = NULL;
	GnonogramsCell _tmp3_;
	GnonogramsCellState _tmp4_;
	GnonogramsCellGridCellPattern* _tmp11_;
	GnonogramsCellGridCellPattern* _tmp12_;
	cairo_pattern_t* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	g_return_if_fail (cell != NULL);
	_tmp0_ = self->priv->_frozen;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = *cell;
	x = _tmp1_.col * self->priv->cell_width;
	_tmp2_ = *cell;
	y = _tmp2_.row * self->priv->cell_height;
	_tmp3_ = *cell;
	_tmp4_ = _tmp3_.state;
	switch (_tmp4_) {
		case GNONOGRAMS_CELL_STATE_EMPTY:
		{
			GnonogramsCellGridCellPattern* _tmp5_;
			GnonogramsCellGridCellPattern* _tmp6_;
			_tmp5_ = self->priv->empty_cell_pattern;
			_tmp6_ = _g_object_ref0 (_tmp5_);
			_g_object_unref0 (cell_pattern);
			cell_pattern = _tmp6_;
			break;
		}
		case GNONOGRAMS_CELL_STATE_FILLED:
		{
			GnonogramsCellGridCellPattern* _tmp7_;
			GnonogramsCellGridCellPattern* _tmp8_;
			_tmp7_ = self->priv->filled_cell_pattern;
			_tmp8_ = _g_object_ref0 (_tmp7_);
			_g_object_unref0 (cell_pattern);
			cell_pattern = _tmp8_;
			break;
		}
		default:
		{
			GnonogramsCellGridCellPattern* _tmp9_;
			GnonogramsCellGridCellPattern* _tmp10_;
			_tmp9_ = self->priv->unknown_cell_pattern;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			_g_object_unref0 (cell_pattern);
			cell_pattern = _tmp10_;
			break;
		}
	}
	cairo_save (cr);
	_tmp11_ = cell_pattern;
	gnonograms_cell_grid_cell_pattern_move_to (_tmp11_, x, y);
	cairo_set_line_width (cr, 0.0);
	cairo_rectangle (cr, x, y, self->priv->cell_body_width, self->priv->cell_body_height);
	_tmp12_ = cell_pattern;
	_tmp13_ = _tmp12_->pattern;
	cairo_set_source (cr, _tmp13_);
	cairo_fill (cr);
	cairo_restore (cr);
	if (highlight) {
		GnonogramsCellGridCellPattern* _tmp14_;
		GnonogramsCellGridCellPattern* _tmp15_;
		cairo_pattern_t* _tmp16_;
		cairo_save (cr);
		_tmp14_ = self->priv->highlight_pattern;
		gnonograms_cell_grid_cell_pattern_move_to (_tmp14_, x, y);
		cairo_rectangle (cr, x, y, self->priv->cell_body_width, self->priv->cell_body_width);
		cairo_clip (cr);
		_tmp15_ = self->priv->highlight_pattern;
		_tmp16_ = _tmp15_->pattern;
		cairo_set_source (cr, _tmp16_);
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
		cairo_paint (cr);
		cairo_restore (cr);
	}
	_g_object_unref0 (cell_pattern);
}

static gboolean
gnonograms_cell_grid_on_leave_notify (GnonogramsCellGrid* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_cell_grid_set_previous_cell (self, &GNONOGRAMS_NULL_CELL);
	gnonograms_cell_grid_set_current_cell (self, &GNONOGRAMS_NULL_CELL);
	result = FALSE;
	return result;
}

GnonogramsModel*
gnonograms_cell_grid_get_model (GnonogramsCellGrid* self)
{
	GnonogramsModel* result;
	GnonogramsModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	result = _tmp0_;
	return result;
}

static void
gnonograms_cell_grid_set_model (GnonogramsCellGrid* self,
                                GnonogramsModel* value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_cell_grid_get_model (self) != value) {
		GnonogramsModel* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_model);
		self->priv->_model = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_MODEL_PROPERTY]);
	}
}

void
gnonograms_cell_grid_get_current_cell (GnonogramsCellGrid* self,
                                       GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_cell_equal (const GnonogramsCell * s1,
                        const GnonogramsCell * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->row != s2->row) {
		return FALSE;
	}
	if (s1->col != s2->col) {
		return FALSE;
	}
	if (s1->state != s2->state) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_cell_grid_set_current_cell (GnonogramsCellGrid* self,
                                       GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_cell_grid_get_current_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_current_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY]);
	}
}

void
gnonograms_cell_grid_get_previous_cell (GnonogramsCellGrid* self,
                                        GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_previous_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_cell_grid_set_previous_cell (GnonogramsCellGrid* self,
                                        GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_cell_grid_get_previous_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_previous_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY]);
	}
}

gboolean
gnonograms_cell_grid_get_frozen (GnonogramsCellGrid* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_frozen;
	return result;
}

void
gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_cell_grid_get_frozen (self) != value) {
		self->priv->_frozen = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY]);
	}
}

GnonogramsCellPatternType
gnonograms_cell_grid_get_cell_pattern_type (GnonogramsCellGrid* self)
{
	GnonogramsCellPatternType result;
	GnonogramsCellPatternType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_cell_pattern_type;
	result = _tmp0_;
	return result;
}

void
gnonograms_cell_grid_set_cell_pattern_type (GnonogramsCellGrid* self,
                                            GnonogramsCellPatternType value)
{
	g_return_if_fail (self != NULL);
	switch (value) {
		case GNONOGRAMS_CELL_PATTERN_TYPE_CELL:
		{
			GdkRGBA _tmp0_;
			GnonogramsCellGridCellPattern* _tmp1_;
			GdkRGBA _tmp2_;
			GnonogramsCellGridCellPattern* _tmp3_;
			GdkRGBA _tmp4_;
			GnonogramsCellGridCellPattern* _tmp5_;
			_tmp0_ = self->priv->fill_color;
			_tmp1_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp0_);
			_g_object_unref0 (self->priv->filled_cell_pattern);
			self->priv->filled_cell_pattern = _tmp1_;
			_tmp2_ = self->priv->empty_color;
			_tmp3_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp2_);
			_g_object_unref0 (self->priv->empty_cell_pattern);
			self->priv->empty_cell_pattern = _tmp3_;
			_tmp4_ = self->priv->unknown_color;
			_tmp5_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp4_);
			_g_object_unref0 (self->priv->unknown_cell_pattern);
			self->priv->unknown_cell_pattern = _tmp5_;
			self->priv->_cell_pattern_type = value;
			break;
		}
		default:
		{
			GnonogramsCellPatternType _tmp6_;
			_tmp6_ = self->priv->_cell_pattern_type;
			if (_tmp6_ != GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED) {
				GnonogramsCellPatternType _tmp7_;
				_tmp7_ = self->priv->_cell_pattern_type;
				gnonograms_cell_grid_set_cell_pattern_type (self, _tmp7_);
			}
			break;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY]);
}

void
gnonograms_cell_grid_set_game_state (GnonogramsCellGrid* self,
                                     GnonogramsGameState value)
{
	GdkRGBA* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GdkRGBA _tmp1_;
	GdkRGBA* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	GdkRGBA _tmp3_;
	GdkRGBA* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GdkRGBA _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->colors;
	_tmp0__length1 = self->priv->colors_length1;
	_tmp0__length2 = self->priv->colors_length2;
	_tmp1_ = _tmp0_[(((gint) value) * _tmp0__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)];
	self->priv->unknown_color = _tmp1_;
	_tmp2_ = self->priv->colors;
	_tmp2__length1 = self->priv->colors_length1;
	_tmp2__length2 = self->priv->colors_length2;
	_tmp3_ = _tmp2_[(((gint) value) * _tmp2__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)];
	self->priv->fill_color = _tmp3_;
	_tmp4_ = self->priv->colors;
	_tmp4__length1 = self->priv->colors_length1;
	_tmp4__length2 = self->priv->colors_length2;
	_tmp5_ = _tmp4_[(((gint) value) * _tmp4__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)];
	self->priv->empty_color = _tmp5_;
	gnonograms_cell_grid_set_cell_pattern_type (self, GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_GAME_STATE_PROPERTY]);
}

static guint
gnonograms_cell_grid_get_rows (GnonogramsCellGrid* self)
{
	guint result;
	GnonogramsModel* _tmp0_;
	guint _tmp1_ = 0U;
	GnonogramsModel* _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_model;
	_vala_assert (_tmp0_ != NULL, "model != null");
	_tmp2_ = self->priv->_model;
	if (_tmp2_ != NULL) {
		GnonogramsModel* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		_tmp3_ = self->priv->_model;
		_tmp4_ = gnonograms_model_get_rows (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = (guint) 0;
	}
	result = _tmp1_;
	return result;
}

static guint
gnonograms_cell_grid_get_cols (GnonogramsCellGrid* self)
{
	guint result;
	guint _tmp0_ = 0U;
	GnonogramsModel* _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = self->priv->_model;
	if (_tmp1_ != NULL) {
		GnonogramsModel* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		_tmp2_ = self->priv->_model;
		_tmp3_ = gnonograms_model_get_cols (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = (guint) 0;
	}
	result = _tmp0_;
	return result;
}

static GnonogramsMy2DCellArray*
gnonograms_cell_grid_get_array (GnonogramsCellGrid* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	if (_tmp0_ != NULL) {
		GnonogramsModel* _tmp1_;
		GnonogramsMy2DCellArray* _tmp2_;
		GnonogramsMy2DCellArray* _tmp3_;
		_tmp1_ = self->priv->_model;
		_tmp2_ = gnonograms_model_get_display_data (_tmp1_);
		_tmp3_ = _tmp2_;
		result = _tmp3_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), data2);
}

static gboolean
_gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                       GdkEventMotion* event,
                                                                       gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_pointer_moved ((GnonogramsCellGrid*) self, event);
	return result;
}

static gboolean
_gnonograms_cell_grid_on_draw_event_gtk_widget_draw (GtkWidget* _sender,
                                                     cairo_t* cr,
                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_draw_event ((GnonogramsCellGrid*) self, cr);
	return result;
}

static void
_gnonograms_cell_grid_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self)
{
	gnonograms_cell_grid_on_size_allocate ((GnonogramsCellGrid*) self, allocation);
}

static gboolean
_gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                     GdkEventCrossing* event,
                                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_leave_notify ((GnonogramsCellGrid*) self);
	return result;
}

static void
_gnonograms_cell_grid___lambda10_ (GnonogramsCellGrid* self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
__gnonograms_cell_grid___lambda10__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_gnonograms_cell_grid___lambda10_ ((GnonogramsCellGrid*) self);
}

static void
_gnonograms_cell_grid_dimensions_updated_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
	gnonograms_cell_grid_dimensions_updated ((GnonogramsCellGrid*) self);
}

static void
_gnonograms_cell_grid___lambda11_ (GnonogramsCellGrid* self)
{
	if (!self->priv->dirty) {
		self->priv->dirty = TRUE;
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
}

static void
__gnonograms_cell_grid___lambda11__gnonograms_model_changed (GnonogramsModel* _sender,
                                                             gpointer self)
{
	_gnonograms_cell_grid___lambda11_ ((GnonogramsCellGrid*) self);
}

static GObject *
gnonograms_cell_grid_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsCellGrid * self;
	GdkRGBA* _tmp0_;
	GnonogramsModel* _tmp1_;
	GnonogramsModel* _tmp2_;
	parent_class = G_OBJECT_CLASS (gnonograms_cell_grid_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	self->priv->_current_cell = GNONOGRAMS_NULL_CELL;
	_tmp0_ = g_new0 (GdkRGBA, 2 * 3);
	self->priv->colors = (g_free (self->priv->colors), NULL);
	self->priv->colors = _tmp0_;
	self->priv->colors_length1 = 2;
	self->priv->colors_length2 = 3;
	gdk_rgba_parse (&self->priv->grid_color, GNONOGRAMS_GRID_COLOR);
	gnonograms_cell_grid_set_game_state (self, GNONOGRAMS_GAME_STATE_SETTING);
	gnonograms_cell_grid_set_cell_pattern_type (self, GNONOGRAMS_CELL_PATTERN_TYPE_CELL);
	gnonograms_cell_grid_set_colors (self);
	gtk_widget_add_events ((GtkWidget*) self, (gint) (((((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_KEY_PRESS_MASK) | GDK_KEY_RELEASE_MASK) | GDK_LEAVE_NOTIFY_MASK));
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _gnonograms_cell_grid_on_draw_event_gtk_widget_draw, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _gnonograms_cell_grid_on_size_allocate_gtk_widget_size_allocate, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) _gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::current-cell", (GCallback) __gnonograms_cell_grid___lambda10__g_object_notify, self, 0);
	_tmp1_ = self->priv->_model;
	g_signal_connect_object ((GObject*) _tmp1_, "notify::dimensions", (GCallback) _gnonograms_cell_grid_dimensions_updated_g_object_notify, self, 0);
	_tmp2_ = self->priv->_model;
	g_signal_connect_object (_tmp2_, "changed", (GCallback) __gnonograms_cell_grid___lambda11__gnonograms_model_changed, self, 0);
	return obj;
}

static inline gpointer
gnonograms_cell_grid_cell_pattern_get_instance_private (GnonogramsCellGridCellPattern* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsCellGridCellPattern_private_offset);
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct_cell (GType object_type,
                                                  GdkRGBA* color)
{
	GnonogramsCellGridCellPattern * self = NULL;
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	cairo_pattern_t* _tmp3_;
	g_return_val_if_fail (color != NULL, NULL);
	self = (GnonogramsCellGridCellPattern*) g_object_new (object_type, NULL);
	_tmp0_ = *color;
	red = _tmp0_.red;
	_tmp1_ = *color;
	green = _tmp1_.green;
	_tmp2_ = *color;
	blue = _tmp2_.blue;
	_tmp3_ = cairo_pattern_create_rgba (red, green, blue, 1.0);
	_cairo_pattern_destroy0 (self->pattern);
	self->pattern = _tmp3_;
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new_cell (GdkRGBA* color)
{
	return gnonograms_cell_grid_cell_pattern_construct_cell (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, color);
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct_highlight (GType object_type,
                                                       gdouble wd,
                                                       gdouble ht)
{
	GnonogramsCellGridCellPattern * self = NULL;
	gdouble r = 0.0;
	cairo_surface_t* surface = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* context = NULL;
	cairo_t* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	self = (GnonogramsCellGridCellPattern*) g_object_new (object_type, NULL);
	r = (wd + ht) / 4.0;
	gnonograms_cell_grid_cell_pattern_set_size (self, 2 * r);
	_tmp0_ = self->priv->_size;
	_tmp1_ = self->priv->_size;
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (gint) _tmp0_, (gint) _tmp1_);
	surface = _tmp2_;
	_tmp3_ = cairo_create (surface);
	context = _tmp3_;
	cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
	_tmp4_ = self->priv->_size;
	_tmp5_ = self->priv->_size;
	cairo_rectangle (context, (gdouble) 0, (gdouble) 0, _tmp4_, _tmp5_);
	cairo_fill (context);
	cairo_arc (context, r, r, r - 2.0, (gdouble) 0, 2 * G_PI);
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.5);
	cairo_set_operator (context, CAIRO_OPERATOR_SOURCE);
	cairo_fill (context);
	_tmp6_ = cairo_pattern_create_for_surface (surface);
	_cairo_pattern_destroy0 (self->pattern);
	self->pattern = _tmp6_;
	_tmp7_ = self->pattern;
	cairo_pattern_set_extend (_tmp7_, CAIRO_EXTEND_NONE);
	_tmp8_ = self->pattern;
	_tmp9_ = self->priv->matrix;
	cairo_pattern_set_matrix (_tmp8_, &_tmp9_);
	_cairo_destroy0 (context);
	_cairo_surface_destroy0 (surface);
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new_highlight (gdouble wd,
                                                 gdouble ht)
{
	return gnonograms_cell_grid_cell_pattern_construct_highlight (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, wd, ht);
}

static void
gnonograms_cell_grid_cell_pattern_move_to (GnonogramsCellGridCellPattern* self,
                                           gdouble x,
                                           gdouble y)
{
	gdouble xx = 0.0;
	gdouble yy = 0.0;
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	g_return_if_fail (self != NULL);
	xx = x - self->priv->x0;
	yy = y - self->priv->y0;
	cairo_matrix_translate (&self->priv->matrix, -xx, -yy);
	_tmp0_ = self->pattern;
	_tmp1_ = self->priv->matrix;
	cairo_pattern_set_matrix (_tmp0_, &_tmp1_);
	self->priv->x0 = x;
	self->priv->y0 = y;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct (GType object_type)
{
	GnonogramsCellGridCellPattern * self = NULL;
	self = (GnonogramsCellGridCellPattern*) g_object_new (object_type, NULL);
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new (void)
{
	return gnonograms_cell_grid_cell_pattern_construct (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN);
}

static gdouble
gnonograms_cell_grid_cell_pattern_get_size (GnonogramsCellGridCellPattern* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_size;
	return result;
}

static void
gnonograms_cell_grid_cell_pattern_set_size (GnonogramsCellGridCellPattern* self,
                                            gdouble value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_cell_grid_cell_pattern_get_size (self) != value) {
		self->priv->_size = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_cell_pattern_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY]);
	}
}

static GObject *
gnonograms_cell_grid_cell_pattern_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsCellGridCellPattern * self;
	parent_class = G_OBJECT_CLASS (gnonograms_cell_grid_cell_pattern_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern);
	cairo_matrix_init_identity (&self->priv->matrix);
	return obj;
}

static void
gnonograms_cell_grid_cell_pattern_class_init (GnonogramsCellGridCellPatternClass * klass,
                                              gpointer klass_data)
{
	gnonograms_cell_grid_cell_pattern_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsCellGridCellPattern_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_cell_grid_cell_pattern_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_cell_grid_cell_pattern_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_cell_grid_cell_pattern_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_cell_grid_cell_pattern_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY, gnonograms_cell_grid_cell_pattern_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY] = g_param_spec_double ("size", "size", "size", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gnonograms_cell_grid_cell_pattern_instance_init (GnonogramsCellGridCellPattern * self,
                                                 gpointer klass)
{
	self->priv = gnonograms_cell_grid_cell_pattern_get_instance_private (self);
	self->priv->x0 = (gdouble) 0;
	self->priv->y0 = (gdouble) 0;
}

static void
gnonograms_cell_grid_cell_pattern_finalize (GObject * obj)
{
	GnonogramsCellGridCellPattern * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern);
	_cairo_pattern_destroy0 (self->pattern);
	G_OBJECT_CLASS (gnonograms_cell_grid_cell_pattern_parent_class)->finalize (obj);
}

/*** Private classes ***/
static GType
gnonograms_cell_grid_cell_pattern_get_type (void)
{
	static volatile gsize gnonograms_cell_grid_cell_pattern_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_cell_grid_cell_pattern_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsCellGridCellPatternClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_cell_grid_cell_pattern_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsCellGridCellPattern), 0, (GInstanceInitFunc) gnonograms_cell_grid_cell_pattern_instance_init, NULL };
		GType gnonograms_cell_grid_cell_pattern_type_id;
		gnonograms_cell_grid_cell_pattern_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsCellGridCellPattern", &g_define_type_info, 0);
		GnonogramsCellGridCellPattern_private_offset = g_type_add_instance_private (gnonograms_cell_grid_cell_pattern_type_id, sizeof (GnonogramsCellGridCellPatternPrivate));
		g_once_init_leave (&gnonograms_cell_grid_cell_pattern_type_id__volatile, gnonograms_cell_grid_cell_pattern_type_id);
	}
	return gnonograms_cell_grid_cell_pattern_type_id__volatile;
}

static void
_vala_gnonograms_cell_grid_cell_pattern_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	GnonogramsCellGridCellPattern * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY:
		g_value_set_double (value, gnonograms_cell_grid_cell_pattern_get_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_cell_grid_cell_pattern_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	GnonogramsCellGridCellPattern * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_SIZE_PROPERTY:
		gnonograms_cell_grid_cell_pattern_set_size (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
gnonograms_cell_grid_class_init (GnonogramsCellGridClass * klass,
                                 gpointer klass_data)
{
	gnonograms_cell_grid_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsCellGrid_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_cell_grid_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_cell_grid_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_cell_grid_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_cell_grid_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_MODEL_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", GNONOGRAMS_TYPE_MODEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY] = g_param_spec_boxed ("current-cell", "current-cell", "current-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY] = g_param_spec_boxed ("previous-cell", "previous-cell", "previous-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY] = g_param_spec_boolean ("frozen", "frozen", "frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY] = g_param_spec_enum ("cell-pattern-type", "cell-pattern-type", "cell-pattern-type", GNONOGRAMS_TYPE_CELL_PATTERN_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_GAME_STATE_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_GAME_STATE_PROPERTY] = g_param_spec_enum ("game-state", "game-state", "game-state", GNONOGRAMS_TYPE_GAME_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	/*** PUBLIC ***/
	gnonograms_cell_grid_signals[GNONOGRAMS_CELL_GRID_CURSOR_MOVED_SIGNAL] = g_signal_new ("cursor-moved", GNONOGRAMS_TYPE_CELL_GRID, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED, G_TYPE_NONE, 2, GNONOGRAMS_TYPE_CELL, GNONOGRAMS_TYPE_CELL);
}

static void
gnonograms_cell_grid_instance_init (GnonogramsCellGrid * self,
                                    gpointer klass)
{
	self->priv = gnonograms_cell_grid_get_instance_private (self);
	self->priv->dirty = FALSE;
}

static void
gnonograms_cell_grid_finalize (GObject * obj)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	_g_object_unref0 (self->priv->_model);
	self->priv->colors = (g_free (self->priv->colors), NULL);
	_g_object_unref0 (self->priv->filled_cell_pattern);
	_g_object_unref0 (self->priv->empty_cell_pattern);
	_g_object_unref0 (self->priv->unknown_cell_pattern);
	_g_object_unref0 (self->priv->highlight_pattern);
	G_OBJECT_CLASS (gnonograms_cell_grid_parent_class)->finalize (obj);
}

GType
gnonograms_cell_grid_get_type (void)
{
	static volatile gsize gnonograms_cell_grid_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_cell_grid_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsCellGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_cell_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsCellGrid), 0, (GInstanceInitFunc) gnonograms_cell_grid_instance_init, NULL };
		GType gnonograms_cell_grid_type_id;
		gnonograms_cell_grid_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GnonogramsCellGrid", &g_define_type_info, 0);
		GnonogramsCellGrid_private_offset = g_type_add_instance_private (gnonograms_cell_grid_type_id, sizeof (GnonogramsCellGridPrivate));
		g_once_init_leave (&gnonograms_cell_grid_type_id__volatile, gnonograms_cell_grid_type_id);
	}
	return gnonograms_cell_grid_type_id__volatile;
}

static void
_vala_gnonograms_cell_grid_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_MODEL_PROPERTY:
		g_value_set_object (value, gnonograms_cell_grid_get_model (self));
		break;
		case GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_cell_grid_get_current_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_cell_grid_get_previous_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY:
		g_value_set_boolean (value, gnonograms_cell_grid_get_frozen (self));
		break;
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY:
		g_value_set_enum (value, gnonograms_cell_grid_get_cell_pattern_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_cell_grid_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_MODEL_PROPERTY:
		gnonograms_cell_grid_set_model (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY:
		gnonograms_cell_grid_set_current_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY:
		gnonograms_cell_grid_set_previous_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY:
		gnonograms_cell_grid_set_frozen (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY:
		gnonograms_cell_grid_set_cell_pattern_type (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_CELL_GRID_GAME_STATE_PROPERTY:
		gnonograms_cell_grid_set_game_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

