/* Label.c generated by valac 0.46.6, the Vala compiler
 * generated from Label.vala, do not modify */

/* Displays clues for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

#define GNONOGRAMS_TYPE_CLUE (gnonograms_clue_get_type ())
#define GNONOGRAMS_CLUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CLUE, GnonogramsClue))
#define GNONOGRAMS_CLUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CLUE, GnonogramsClueClass))
#define GNONOGRAMS_IS_CLUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CLUE))
#define GNONOGRAMS_IS_CLUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CLUE))
#define GNONOGRAMS_CLUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CLUE, GnonogramsClueClass))

typedef struct _GnonogramsClue GnonogramsClue;
typedef struct _GnonogramsClueClass GnonogramsClueClass;
typedef struct _GnonogramsCluePrivate GnonogramsCluePrivate;

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
enum  {
	GNONOGRAMS_CLUE_0_PROPERTY,
	GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY,
	GNONOGRAMS_CLUE_SIZE_PROPERTY,
	GNONOGRAMS_CLUE_FONTHEIGHT_PROPERTY,
	GNONOGRAMS_CLUE_CLUE_PROPERTY,
	GNONOGRAMS_CLUE_NUM_PROPERTIES
};
static GParamSpec* gnonograms_clue_properties[GNONOGRAMS_CLUE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GnonogramsBlockPrivate GnonogramsBlockPrivate;
#define _gnonograms_block_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_block_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GnonogramsClue {
	GtkLabel parent_instance;
	GnonogramsCluePrivate * priv;
};

struct _GnonogramsClueClass {
	GtkLabelClass parent_class;
};

struct _GnonogramsCluePrivate {
	gboolean _vertical_text;
	GeeList* clue_blocks;
	GeeList* grid_blocks;
	gdouble fontsize;
	gchar* _clue;
	guint _size;
};

struct _GnonogramsBlock {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsBlockPrivate * priv;
	gint length;
	gboolean is_complete;
	gboolean is_error;
};

struct _GnonogramsBlockClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsBlock *self);
};

static gint GnonogramsClue_private_offset;
static gpointer gnonograms_clue_parent_class = NULL;

GType gnonograms_clue_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsClue, g_object_unref)
gpointer gnonograms_block_ref (gpointer instance);
void gnonograms_block_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
gpointer gnonograms_value_get_block (const GValue* value);
GType gnonograms_block_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
#define GNONOGRAMS_CLUE_ATTR_TEMPLATE "<span size='%i' weight='%s' strikethrough='%s'>"
#define GNONOGRAMS_CLUE_TIP_TEMPLATE "<span size='%i'>"
GnonogramsClue* gnonograms_clue_new (gboolean _vertical_text);
GnonogramsClue* gnonograms_clue_construct (GType object_type,
                                           gboolean _vertical_text);
static void __lambda6_ (GnonogramsClue* self);
static void gnonograms_clue_update_markup (GnonogramsClue* self,
                                    gdouble fs);
static void ___lambda6__gtk_widget_size_allocate (GtkWidget* _sender,
                                           GtkAllocation* allocation,
                                           gpointer self);
static void __lambda7_ (GnonogramsClue* self);
static void ___lambda7__gtk_widget_realize (GtkWidget* _sender,
                                     gpointer self);
void gnonograms_clue_highlight (GnonogramsClue* self,
                                gboolean is_highlight);
void gnonograms_clue_clear_formatting (GnonogramsClue* self);
void gnonograms_clue_update_complete (GnonogramsClue* self,
                                      GeeList* _grid_blocks);
gboolean gnonograms_block_is_null (GnonogramsBlock* self);
const gchar* gnonograms_clue_get_clue (GnonogramsClue* self);
gboolean gnonograms_clue_get_vertical_text (GnonogramsClue* self);
static gchar* gnonograms_clue_get_markup (GnonogramsClue* self);
static void gnonograms_clue_update_tooltip (GnonogramsClue* self);
static guint gnonograms_clue_get_size (GnonogramsClue* self);
gint gnonograms_utils_blockextent_from_clue (const gchar* s);
static void gnonograms_clue_set_vertical_text (GnonogramsClue* self,
                                        gboolean value);
void gnonograms_clue_set_size (GnonogramsClue* self,
                               guint value);
void gnonograms_clue_set_fontheight (GnonogramsClue* self,
                                     gdouble value);
void gnonograms_clue_set_clue (GnonogramsClue* self,
                               const gchar* value);
GeeArrayList* gnonograms_utils_block_struct_array_from_clue (const gchar* s);
static GObject * gnonograms_clue_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void gnonograms_clue_finalize (GObject * obj);
static void _vala_gnonograms_clue_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_gnonograms_clue_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
gnonograms_clue_get_instance_private (GnonogramsClue* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsClue_private_offset);
}

static void
__lambda6_ (GnonogramsClue* self)
{
	gnonograms_clue_update_markup (self, self->priv->fontsize);
}

static void
___lambda6__gtk_widget_size_allocate (GtkWidget* _sender,
                                      GtkAllocation* allocation,
                                      gpointer self)
{
	__lambda6_ ((GnonogramsClue*) self);
}

static void
__lambda7_ (GnonogramsClue* self)
{
	gnonograms_clue_update_markup (self, self->priv->fontsize);
}

static void
___lambda7__gtk_widget_realize (GtkWidget* _sender,
                                gpointer self)
{
	__lambda7_ ((GnonogramsClue*) self);
}

GnonogramsClue*
gnonograms_clue_construct (GType object_type,
                           gboolean _vertical_text)
{
	GnonogramsClue * self = NULL;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	if (_vertical_text) {
		_tmp0_ = (gfloat) 0.5;
	} else {
		_tmp0_ = (gfloat) 1.0;
	}
	if (_vertical_text) {
		_tmp1_ = (gfloat) 1.0;
	} else {
		_tmp1_ = (gfloat) 0.5;
	}
	self = (GnonogramsClue*) g_object_new (object_type, "vertical-text", _vertical_text, "xalign", _tmp0_, "yalign", _tmp1_, NULL);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda6__gtk_widget_size_allocate, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda7__gtk_widget_realize, self, G_CONNECT_AFTER);
	return self;
}

GnonogramsClue*
gnonograms_clue_new (gboolean _vertical_text)
{
	return gnonograms_clue_construct (GNONOGRAMS_TYPE_CLUE, _vertical_text);
}

void
gnonograms_clue_highlight (GnonogramsClue* self,
                           gboolean is_highlight)
{
	g_return_if_fail (self != NULL);
	if (is_highlight) {
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED, TRUE);
	} else {
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_NORMAL, TRUE);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_clue_clear_formatting (GnonogramsClue* self)
{
	GtkStyleContext* sc = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	sc = _tmp1_;
	gtk_style_context_remove_class (sc, "warn");
	gtk_style_context_remove_class (sc, "dim");
	_g_object_unref0 (sc);
}

void
gnonograms_clue_update_complete (GnonogramsClue* self,
                                 GeeList* _grid_blocks)
{
	GeeList* _tmp0_;
	GtkStyleContext* sc = NULL;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	guint complete = 0U;
	guint errors = 0U;
	guint grid_complete = 0U;
	guint grid_null = 0U;
	GeeList* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_grid_blocks != NULL);
	_tmp0_ = _g_object_ref0 (_grid_blocks);
	_g_object_unref0 (self->priv->grid_blocks);
	self->priv->grid_blocks = _tmp0_;
	{
		GeeList* _block_list = NULL;
		GeeList* _tmp1_;
		GeeList* _tmp2_;
		gint _block_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _block_index = 0;
		_tmp1_ = self->priv->clue_blocks;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_block_list = _tmp2_;
		_tmp3_ = _block_list;
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_block_size = _tmp5_;
		_block_index = -1;
		while (TRUE) {
			GnonogramsBlock* block = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			GnonogramsBlock* _tmp8_;
			GnonogramsBlock* _tmp9_;
			_block_index = _block_index + 1;
			if (!(_block_index < _block_size)) {
				break;
			}
			_tmp6_ = _block_list;
			_tmp7_ = gee_list_get (_tmp6_, _block_index);
			block = (GnonogramsBlock*) _tmp7_;
			_tmp8_ = block;
			_tmp8_->is_complete = FALSE;
			_tmp9_ = block;
			_tmp9_->is_error = FALSE;
			_gnonograms_block_unref0 (block);
		}
		_g_object_unref0 (_block_list);
	}
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp11_ = _g_object_ref0 (_tmp10_);
	sc = _tmp11_;
	_tmp12_ = sc;
	gtk_style_context_remove_class (_tmp12_, "warn");
	_tmp13_ = sc;
	gtk_style_context_remove_class (_tmp13_, "dim");
	complete = (guint) 0;
	errors = (guint) 0;
	grid_complete = (guint) 0;
	grid_null = (guint) 0;
	{
		GeeList* _b_list = NULL;
		GeeList* _tmp14_;
		GeeList* _tmp15_;
		gint _b_size = 0;
		GeeList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _b_index = 0;
		_tmp14_ = self->priv->grid_blocks;
		_tmp15_ = _g_object_ref0 (_tmp14_);
		_b_list = _tmp15_;
		_tmp16_ = _b_list;
		_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
		_tmp18_ = _tmp17_;
		_b_size = _tmp18_;
		_b_index = -1;
		while (TRUE) {
			GnonogramsBlock* b = NULL;
			GeeList* _tmp19_;
			gpointer _tmp20_;
			GnonogramsBlock* _tmp21_;
			_b_index = _b_index + 1;
			if (!(_b_index < _b_size)) {
				break;
			}
			_tmp19_ = _b_list;
			_tmp20_ = gee_list_get (_tmp19_, _b_index);
			b = (GnonogramsBlock*) _tmp20_;
			_tmp21_ = b;
			if (_tmp21_->is_complete) {
				guint _tmp22_;
				_tmp22_ = grid_complete;
				grid_complete = _tmp22_ + 1;
			} else {
				GnonogramsBlock* _tmp23_;
				_tmp23_ = b;
				if (gnonograms_block_is_null (_tmp23_)) {
					guint _tmp24_;
					_tmp24_ = grid_null;
					grid_null = _tmp24_ + 1;
				}
			}
			_gnonograms_block_unref0 (b);
		}
		_g_object_unref0 (_b_list);
	}
	_tmp25_ = self->priv->grid_blocks;
	_tmp26_ = gee_collection_get_is_empty ((GeeCollection*) _tmp25_);
	_tmp27_ = _tmp26_;
	if (!_tmp27_) {
		gint clue_index = 0;
		gint grid_index = 0;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp53_ = FALSE;
		GeeList* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		GeeList* _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		GeeList* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
		GeeList* _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		clue_index = 0;
		grid_index = 0;
		while (TRUE) {
			GeeList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			GnonogramsBlock* block = NULL;
			GeeList* _tmp31_;
			gpointer _tmp32_;
			GnonogramsBlock* _tmp33_;
			gint _tmp49_;
			gint _tmp50_;
			_tmp28_ = self->priv->grid_blocks;
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
			_tmp30_ = _tmp29_;
			if (!(grid_index < _tmp30_)) {
				break;
			}
			_tmp31_ = self->priv->grid_blocks;
			_tmp32_ = gee_list_get (_tmp31_, grid_index);
			block = (GnonogramsBlock*) _tmp32_;
			_tmp33_ = block;
			if (gnonograms_block_is_null (_tmp33_)) {
				_gnonograms_block_unref0 (block);
				break;
			} else {
				GeeList* _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				_tmp34_ = self->priv->clue_blocks;
				_tmp35_ = gee_collection_get_size ((GeeCollection*) _tmp34_);
				_tmp36_ = _tmp35_;
				if (clue_index < _tmp36_) {
					GnonogramsBlock* clue_block = NULL;
					GeeList* _tmp37_;
					gpointer _tmp38_;
					GnonogramsBlock* _tmp39_;
					GnonogramsBlock* _tmp40_;
					_tmp37_ = self->priv->clue_blocks;
					_tmp38_ = gee_list_get (_tmp37_, clue_index);
					clue_block = (GnonogramsBlock*) _tmp38_;
					_tmp39_ = clue_block;
					_tmp40_ = block;
					if (_tmp39_->length == _tmp40_->length) {
						GnonogramsBlock* _tmp41_;
						GnonogramsBlock* _tmp42_;
						guint _tmp43_;
						GnonogramsBlock* _tmp44_;
						_tmp41_ = clue_block;
						_tmp41_->is_complete = TRUE;
						_tmp42_ = block;
						_tmp42_->is_complete = FALSE;
						_tmp43_ = complete;
						complete = _tmp43_ + 1;
						_tmp44_ = clue_block;
						_tmp44_->is_error = FALSE;
					} else {
						GnonogramsBlock* _tmp45_;
						GnonogramsBlock* _tmp46_;
						guint _tmp47_;
						_tmp45_ = clue_block;
						_tmp45_->is_complete = FALSE;
						_tmp46_ = clue_block;
						_tmp46_->is_error = TRUE;
						_tmp47_ = errors;
						errors = _tmp47_ + 1;
					}
					_gnonograms_block_unref0 (clue_block);
				} else {
					guint _tmp48_;
					_tmp48_ = errors;
					errors = _tmp48_ + 1;
					_gnonograms_block_unref0 (block);
					break;
				}
			}
			_tmp49_ = clue_index;
			clue_index = _tmp49_ + 1;
			_tmp50_ = grid_index;
			grid_index = _tmp50_ + 1;
			_gnonograms_block_unref0 (block);
		}
		if (errors > ((guint) 0)) {
			GtkStyleContext* _tmp51_;
			_tmp51_ = sc;
			gtk_style_context_add_class (_tmp51_, "warn");
		}
		_tmp54_ = self->priv->clue_blocks;
		_tmp55_ = gee_collection_get_size ((GeeCollection*) _tmp54_);
		_tmp56_ = _tmp55_;
		if (complete == ((guint) _tmp56_)) {
			_tmp53_ = errors == ((guint) 0);
		} else {
			_tmp53_ = FALSE;
		}
		if (_tmp53_) {
			_tmp52_ = grid_null == ((guint) 0);
		} else {
			_tmp52_ = FALSE;
		}
		if (_tmp52_) {
			GtkStyleContext* _tmp57_;
			gnonograms_clue_update_markup (self, self->priv->fontsize);
			_tmp57_ = sc;
			gtk_style_context_add_class (_tmp57_, "dim");
			_g_object_unref0 (sc);
			return;
		}
		_tmp58_ = self->priv->grid_blocks;
		_tmp59_ = gee_collection_get_size ((GeeCollection*) _tmp58_);
		_tmp60_ = _tmp59_;
		if (grid_index >= _tmp60_) {
			gnonograms_clue_update_markup (self, self->priv->fontsize);
			_g_object_unref0 (sc);
			return;
		}
		_tmp61_ = self->priv->clue_blocks;
		_tmp62_ = gee_collection_get_size ((GeeCollection*) _tmp61_);
		_tmp63_ = _tmp62_;
		clue_index = _tmp63_ - 1;
		_tmp64_ = self->priv->grid_blocks;
		_tmp65_ = gee_collection_get_size ((GeeCollection*) _tmp64_);
		_tmp66_ = _tmp65_;
		grid_index = _tmp66_ - 1;
		while (TRUE) {
			GnonogramsBlock* block = NULL;
			GeeList* _tmp67_;
			gpointer _tmp68_;
			GnonogramsBlock* _tmp69_;
			gint _tmp84_;
			gint _tmp85_;
			if (!(grid_index >= 0)) {
				break;
			}
			_tmp67_ = self->priv->grid_blocks;
			_tmp68_ = gee_list_get (_tmp67_, grid_index);
			block = (GnonogramsBlock*) _tmp68_;
			_tmp69_ = block;
			if (gnonograms_block_is_null (_tmp69_)) {
				_gnonograms_block_unref0 (block);
				break;
			} else {
				if (clue_index >= 0) {
					GnonogramsBlock* clue_block = NULL;
					GeeList* _tmp70_;
					gpointer _tmp71_;
					gboolean _tmp72_ = FALSE;
					GnonogramsBlock* _tmp73_;
					GnonogramsBlock* _tmp75_;
					GnonogramsBlock* _tmp76_;
					_tmp70_ = self->priv->clue_blocks;
					_tmp71_ = gee_list_get (_tmp70_, clue_index);
					clue_block = (GnonogramsBlock*) _tmp71_;
					_tmp73_ = clue_block;
					if (_tmp73_->is_complete) {
						_tmp72_ = TRUE;
					} else {
						GnonogramsBlock* _tmp74_;
						_tmp74_ = clue_block;
						_tmp72_ = _tmp74_->is_error;
					}
					if (_tmp72_) {
						_gnonograms_block_unref0 (clue_block);
						_gnonograms_block_unref0 (block);
						break;
					}
					_tmp75_ = clue_block;
					_tmp76_ = block;
					if (_tmp75_->length == _tmp76_->length) {
						GnonogramsBlock* _tmp77_;
						GnonogramsBlock* _tmp78_;
						guint _tmp79_;
						_tmp77_ = clue_block;
						_tmp77_->is_complete = TRUE;
						_tmp78_ = block;
						_tmp78_->is_complete = FALSE;
						_tmp79_ = complete;
						complete = _tmp79_ + 1;
					} else {
						GnonogramsBlock* _tmp80_;
						GnonogramsBlock* _tmp81_;
						guint _tmp82_;
						_tmp80_ = clue_block;
						_tmp80_->is_complete = FALSE;
						_tmp81_ = clue_block;
						_tmp81_->is_error = TRUE;
						_tmp82_ = errors;
						errors = _tmp82_ + 1;
					}
					_gnonograms_block_unref0 (clue_block);
				} else {
					guint _tmp83_;
					_tmp83_ = errors;
					errors = _tmp83_ + 1;
					_gnonograms_block_unref0 (block);
					break;
				}
			}
			_tmp84_ = clue_index;
			clue_index = _tmp84_ - 1;
			_tmp85_ = grid_index;
			grid_index = _tmp85_ - 1;
			_gnonograms_block_unref0 (block);
		}
		if (grid_complete > complete) {
			{
				GeeList* _b_list = NULL;
				GeeList* _tmp86_;
				GeeList* _tmp87_;
				gint _b_size = 0;
				GeeList* _tmp88_;
				gint _tmp89_;
				gint _tmp90_;
				gint _b_index = 0;
				_tmp86_ = self->priv->grid_blocks;
				_tmp87_ = _g_object_ref0 (_tmp86_);
				_b_list = _tmp87_;
				_tmp88_ = _b_list;
				_tmp89_ = gee_collection_get_size ((GeeCollection*) _tmp88_);
				_tmp90_ = _tmp89_;
				_b_size = _tmp90_;
				_b_index = -1;
				while (TRUE) {
					GnonogramsBlock* b = NULL;
					GeeList* _tmp91_;
					gpointer _tmp92_;
					gboolean _tmp93_ = FALSE;
					GnonogramsBlock* _tmp94_;
					_b_index = _b_index + 1;
					if (!(_b_index < _b_size)) {
						break;
					}
					_tmp91_ = _b_list;
					_tmp92_ = gee_list_get (_tmp91_, _b_index);
					b = (GnonogramsBlock*) _tmp92_;
					_tmp94_ = b;
					if (_tmp94_->is_complete) {
						GnonogramsBlock* _tmp95_;
						_tmp95_ = b;
						_tmp93_ = !gnonograms_block_is_null (_tmp95_);
					} else {
						_tmp93_ = FALSE;
					}
					if (_tmp93_) {
						gboolean found = FALSE;
						gint len = 0;
						GnonogramsBlock* _tmp96_;
						found = FALSE;
						_tmp96_ = b;
						len = _tmp96_->length;
						{
							GeeList* _cb_list = NULL;
							GeeList* _tmp97_;
							GeeList* _tmp98_;
							gint _cb_size = 0;
							GeeList* _tmp99_;
							gint _tmp100_;
							gint _tmp101_;
							gint _cb_index = 0;
							_tmp97_ = self->priv->clue_blocks;
							_tmp98_ = _g_object_ref0 (_tmp97_);
							_cb_list = _tmp98_;
							_tmp99_ = _cb_list;
							_tmp100_ = gee_collection_get_size ((GeeCollection*) _tmp99_);
							_tmp101_ = _tmp100_;
							_cb_size = _tmp101_;
							_cb_index = -1;
							while (TRUE) {
								GnonogramsBlock* cb = NULL;
								GeeList* _tmp102_;
								gpointer _tmp103_;
								gboolean _tmp104_ = FALSE;
								GnonogramsBlock* _tmp105_;
								_cb_index = _cb_index + 1;
								if (!(_cb_index < _cb_size)) {
									break;
								}
								_tmp102_ = _cb_list;
								_tmp103_ = gee_list_get (_tmp102_, _cb_index);
								cb = (GnonogramsBlock*) _tmp103_;
								_tmp105_ = cb;
								if (!_tmp105_->is_complete) {
									GnonogramsBlock* _tmp106_;
									_tmp106_ = cb;
									_tmp104_ = _tmp106_->length == len;
								} else {
									_tmp104_ = FALSE;
								}
								if (_tmp104_) {
									found = TRUE;
								}
								_gnonograms_block_unref0 (cb);
							}
							_g_object_unref0 (_cb_list);
						}
						if (!found) {
							guint _tmp107_;
							_tmp107_ = errors;
							errors = _tmp107_ + 1;
						}
					}
					_gnonograms_block_unref0 (b);
				}
				_g_object_unref0 (_b_list);
			}
		}
	} else {
		const gchar* _tmp108_;
		const gchar* _tmp109_;
		_tmp108_ = gnonograms_clue_get_clue (self);
		_tmp109_ = _tmp108_;
		if (g_strcmp0 (_tmp109_, "0") != 0) {
			guint _tmp110_;
			_tmp110_ = errors;
			errors = _tmp110_ + 1;
		}
	}
	if (errors > ((guint) 0)) {
		GtkStyleContext* _tmp111_;
		_tmp111_ = sc;
		gtk_style_context_add_class (_tmp111_, "warn");
	}
	gnonograms_clue_update_markup (self, self->priv->fontsize);
	_g_object_unref0 (sc);
}

static void
gnonograms_clue_update_markup (GnonogramsClue* self,
                               gdouble fs)
{
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gint alloc = 0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* markup = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp13_;
	PangoLayout* _tmp14_;
	gint w = 0;
	gint h = 0;
	PangoLayout* _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gboolean _tmp19_;
	gint size = 0;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_vertical_text;
	if (_tmp1_) {
		_tmp0_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	} else {
		_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	}
	alloc = _tmp0_;
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = alloc < 10;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = self->priv->fontsize < ((gdouble) 1000);
	}
	if (_tmp2_) {
		return;
	}
	_tmp4_ = g_strdup_printf ("<span size='%i'>", (gint) fs);
	_tmp5_ = _tmp4_;
	_tmp6_ = gnonograms_clue_get_markup (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, "</span>", NULL);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	markup = _tmp11_;
	_tmp12_ = markup;
	gtk_label_set_markup ((GtkLabel*) self, _tmp12_);
	_tmp13_ = gtk_label_get_layout ((GtkLabel*) self);
	_tmp14_ = _g_object_ref0 (_tmp13_);
	layout = _tmp14_;
	_tmp15_ = layout;
	pango_layout_get_size (_tmp15_, &_tmp16_, &_tmp17_);
	w = _tmp16_;
	h = _tmp17_;
	_tmp19_ = self->priv->_vertical_text;
	if (_tmp19_) {
		_tmp18_ = h;
	} else {
		_tmp18_ = w;
	}
	size = (gint) (_tmp18_ / 1024);
	if ((size - alloc) > 6) {
		gnonograms_clue_update_markup (self, fs * 0.9);
	} else {
		gnonograms_clue_update_tooltip (self);
	}
	_g_object_unref0 (layout);
	_g_free0 (markup);
}

static void
gnonograms_clue_update_tooltip (GnonogramsClue* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf (GNONOGRAMS_CLUE_TIP_TEMPLATE, ((gint) self->priv->fontsize) / 2);
	_tmp1_ = _tmp0_;
	_tmp2_ = gnonograms_clue_get_size (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_clue;
	_tmp5_ = g_strdup_printf (_ ("Freedom = %u"), _tmp3_ - gnonograms_utils_blockextent_from_clue (_tmp4_));
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp1_, _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, "</span>", NULL);
	_tmp10_ = _tmp9_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) self, _tmp10_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp1_);
}

static gchar*
gnonograms_clue_get_markup (GnonogramsClue* self)
{
	gchar* attrib = NULL;
	gchar* _tmp0_;
	gchar* weight = NULL;
	gchar* _tmp1_;
	gchar* strikethrough = NULL;
	gchar* _tmp2_;
	gboolean warn = FALSE;
	GtkStyleContext* _tmp3_;
	GString* sb = NULL;
	GString* _tmp4_;
	gboolean _tmp31_;
	GString* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	attrib = _tmp0_;
	_tmp1_ = g_strdup ("bold");
	weight = _tmp1_;
	_tmp2_ = g_strdup ("false");
	strikethrough = _tmp2_;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	warn = gtk_style_context_has_class (_tmp3_, "warn");
	_tmp4_ = g_string_new ("");
	sb = _tmp4_;
	{
		GeeList* _clue_block_list = NULL;
		GeeList* _tmp5_;
		GeeList* _tmp6_;
		gint _clue_block_size = 0;
		GeeList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _clue_block_index = 0;
		_tmp5_ = self->priv->clue_blocks;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_clue_block_list = _tmp6_;
		_tmp7_ = _clue_block_list;
		_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_clue_block_size = _tmp9_;
		_clue_block_index = -1;
		while (TRUE) {
			GnonogramsBlock* clue_block = NULL;
			GeeList* _tmp10_;
			gpointer _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GString* _tmp21_;
			const gchar* _tmp22_;
			GString* _tmp23_;
			GnonogramsBlock* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			GString* _tmp27_;
			gboolean _tmp28_;
			_clue_block_index = _clue_block_index + 1;
			if (!(_clue_block_index < _clue_block_size)) {
				break;
			}
			_tmp10_ = _clue_block_list;
			_tmp11_ = gee_list_get (_tmp10_, _clue_block_index);
			clue_block = (GnonogramsBlock*) _tmp11_;
			_tmp12_ = g_strdup ("false");
			_g_free0 (strikethrough);
			strikethrough = _tmp12_;
			if (warn) {
				gchar* _tmp13_;
				_tmp13_ = g_strdup ("normal");
				_g_free0 (weight);
				weight = _tmp13_;
			} else {
				GnonogramsBlock* _tmp14_;
				_tmp14_ = clue_block;
				if (_tmp14_->is_complete) {
					gchar* _tmp15_;
					gchar* _tmp16_;
					_tmp15_ = g_strdup ("true");
					_g_free0 (strikethrough);
					strikethrough = _tmp15_;
					_tmp16_ = g_strdup ("light");
					_g_free0 (weight);
					weight = _tmp16_;
				} else {
					gchar* _tmp17_;
					_tmp17_ = g_strdup ("bold");
					_g_free0 (weight);
					weight = _tmp17_;
				}
			}
			_tmp18_ = weight;
			_tmp19_ = strikethrough;
			_tmp20_ = g_strdup_printf ("<span weight='%s' strikethrough='%s'>", _tmp18_, _tmp19_);
			_g_free0 (attrib);
			attrib = _tmp20_;
			_tmp21_ = sb;
			_tmp22_ = attrib;
			g_string_append (_tmp21_, _tmp22_);
			_tmp23_ = sb;
			_tmp24_ = clue_block;
			_tmp25_ = g_strdup_printf ("%i", _tmp24_->length);
			_tmp26_ = _tmp25_;
			g_string_append (_tmp23_, _tmp26_);
			_g_free0 (_tmp26_);
			_tmp27_ = sb;
			g_string_append (_tmp27_, "</span>");
			_tmp28_ = self->priv->_vertical_text;
			if (_tmp28_) {
				GString* _tmp29_;
				_tmp29_ = sb;
				g_string_append (_tmp29_, "\n");
			} else {
				GString* _tmp30_;
				_tmp30_ = sb;
				g_string_append (_tmp30_, ", ");
			}
			_gnonograms_block_unref0 (clue_block);
		}
		_g_object_unref0 (_clue_block_list);
	}
	_tmp31_ = self->priv->_vertical_text;
	if (_tmp31_) {
		GString* _tmp32_;
		GString* _tmp33_;
		_tmp32_ = sb;
		_tmp33_ = sb;
		g_string_truncate (_tmp32_, (gsize) (_tmp33_->len - 1));
	} else {
		GString* _tmp34_;
		GString* _tmp35_;
		_tmp34_ = sb;
		_tmp35_ = sb;
		g_string_truncate (_tmp34_, (gsize) (_tmp35_->len - 2));
	}
	_tmp36_ = sb;
	_tmp37_ = _tmp36_->str;
	_tmp38_ = g_strdup (_tmp37_);
	result = _tmp38_;
	_g_string_free0 (sb);
	_g_free0 (strikethrough);
	_g_free0 (weight);
	_g_free0 (attrib);
	return result;
}

gboolean
gnonograms_clue_get_vertical_text (GnonogramsClue* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_vertical_text;
	return result;
}

static void
gnonograms_clue_set_vertical_text (GnonogramsClue* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_clue_get_vertical_text (self) != value) {
		self->priv->_vertical_text = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_clue_properties[GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY]);
	}
}

static guint
gnonograms_clue_get_size (GnonogramsClue* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_size;
	return result;
}

void
gnonograms_clue_set_size (GnonogramsClue* self,
                          guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_size = value;
	gnonograms_clue_update_tooltip (self);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_clue_properties[GNONOGRAMS_CLUE_SIZE_PROPERTY]);
}

void
gnonograms_clue_set_fontheight (GnonogramsClue* self,
                                gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->fontsize = (gdouble) ((gint) (1024 * value));
	gnonograms_clue_update_markup (self, self->priv->fontsize);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_clue_properties[GNONOGRAMS_CLUE_FONTHEIGHT_PROPERTY]);
}

const gchar*
gnonograms_clue_get_clue (GnonogramsClue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_clue;
	result = _tmp0_;
	return result;
}

void
gnonograms_clue_set_clue (GnonogramsClue* self,
                          const gchar* value)
{
	gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_clue);
	self->priv->_clue = _tmp0_;
	_tmp1_ = gnonograms_utils_block_struct_array_from_clue (value);
	_g_object_unref0 (self->priv->clue_blocks);
	self->priv->clue_blocks = (GeeList*) _tmp1_;
	gnonograms_clue_update_markup (self, self->priv->fontsize);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_clue_properties[GNONOGRAMS_CLUE_CLUE_PROPERTY]);
}

static GObject *
gnonograms_clue_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsClue * self;
	parent_class = G_OBJECT_CLASS (gnonograms_clue_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CLUE, GnonogramsClue);
	gnonograms_clue_set_clue (self, "0");
	gtk_widget_set_has_tooltip ((GtkWidget*) self, TRUE);
	gtk_label_set_use_markup ((GtkLabel*) self, TRUE);
	return obj;
}

static void
gnonograms_clue_class_init (GnonogramsClueClass * klass,
                            gpointer klass_data)
{
	gnonograms_clue_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsClue_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_clue_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_clue_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_clue_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_clue_finalize;
	/** PUBLIC **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY, gnonograms_clue_properties[GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY] = g_param_spec_boolean ("vertical-text", "vertical-text", "vertical-text", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CLUE_SIZE_PROPERTY, gnonograms_clue_properties[GNONOGRAMS_CLUE_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CLUE_FONTHEIGHT_PROPERTY, gnonograms_clue_properties[GNONOGRAMS_CLUE_FONTHEIGHT_PROPERTY] = g_param_spec_double ("fontheight", "fontheight", "fontheight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CLUE_CLUE_PROPERTY, gnonograms_clue_properties[GNONOGRAMS_CLUE_CLUE_PROPERTY] = g_param_spec_string ("clue", "clue", "clue", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_clue_instance_init (GnonogramsClue * self,
                               gpointer klass)
{
	self->priv = gnonograms_clue_get_instance_private (self);
}

static void
gnonograms_clue_finalize (GObject * obj)
{
	GnonogramsClue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CLUE, GnonogramsClue);
	_g_object_unref0 (self->priv->clue_blocks);
	_g_object_unref0 (self->priv->grid_blocks);
	_g_free0 (self->priv->_clue);
	G_OBJECT_CLASS (gnonograms_clue_parent_class)->finalize (obj);
}

GType
gnonograms_clue_get_type (void)
{
	static volatile gsize gnonograms_clue_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_clue_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsClueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_clue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsClue), 0, (GInstanceInitFunc) gnonograms_clue_instance_init, NULL };
		GType gnonograms_clue_type_id;
		gnonograms_clue_type_id = g_type_register_static (gtk_label_get_type (), "GnonogramsClue", &g_define_type_info, 0);
		GnonogramsClue_private_offset = g_type_add_instance_private (gnonograms_clue_type_id, sizeof (GnonogramsCluePrivate));
		g_once_init_leave (&gnonograms_clue_type_id__volatile, gnonograms_clue_type_id);
	}
	return gnonograms_clue_type_id__volatile;
}

static void
_vala_gnonograms_clue_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsClue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CLUE, GnonogramsClue);
	switch (property_id) {
		case GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY:
		g_value_set_boolean (value, gnonograms_clue_get_vertical_text (self));
		break;
		case GNONOGRAMS_CLUE_SIZE_PROPERTY:
		g_value_set_uint (value, gnonograms_clue_get_size (self));
		break;
		case GNONOGRAMS_CLUE_CLUE_PROPERTY:
		g_value_set_string (value, gnonograms_clue_get_clue (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_clue_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsClue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CLUE, GnonogramsClue);
	switch (property_id) {
		case GNONOGRAMS_CLUE_VERTICAL_TEXT_PROPERTY:
		gnonograms_clue_set_vertical_text (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_CLUE_SIZE_PROPERTY:
		gnonograms_clue_set_size (self, g_value_get_uint (value));
		break;
		case GNONOGRAMS_CLUE_FONTHEIGHT_PROPERTY:
		gnonograms_clue_set_fontheight (self, g_value_get_double (value));
		break;
		case GNONOGRAMS_CLUE_CLUE_PROPERTY:
		gnonograms_clue_set_clue (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

