/* ViewModeButton.c generated by valac 0.46.6, the Vala compiler
 * generated from ViewModeButton.vala, do not modify */

/* View class for gnonograms - displays user interface
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <granite.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define GNONOGRAMS_TYPE_VIEW_MODE_BUTTON (gnonograms_view_mode_button_get_type ())
#define GNONOGRAMS_VIEW_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton))
#define GNONOGRAMS_VIEW_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButtonClass))
#define GNONOGRAMS_IS_VIEW_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON))
#define GNONOGRAMS_IS_VIEW_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON))
#define GNONOGRAMS_VIEW_MODE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButtonClass))

typedef struct _GnonogramsViewModeButton GnonogramsViewModeButton;
typedef struct _GnonogramsViewModeButtonClass GnonogramsViewModeButtonClass;
typedef struct _GnonogramsViewModeButtonPrivate GnonogramsViewModeButtonPrivate;
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())
enum  {
	GNONOGRAMS_VIEW_MODE_BUTTON_0_PROPERTY,
	GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY,
	GNONOGRAMS_VIEW_MODE_BUTTON_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_MODE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_mode_button_properties[GNONOGRAMS_VIEW_MODE_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GnonogramsViewModeButton {
	GraniteWidgetsModeButton parent_instance;
	GnonogramsViewModeButtonPrivate * priv;
};

struct _GnonogramsViewModeButtonClass {
	GraniteWidgetsModeButtonClass parent_class;
};

struct _GnonogramsViewModeButtonPrivate {
	GnonogramsGameState _mode;
	gint setting_index;
	gint solving_index;
	gint generating_index;
	GtkImage* setting_icon;
	GtkImage* solving_icon;
	GtkImage* generating_icon;
};

static gint GnonogramsViewModeButton_private_offset;
static gpointer gnonograms_view_mode_button_parent_class = NULL;

GType gnonograms_view_mode_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewModeButton, g_object_unref)
GType gnonograms_game_state_get_type (void) G_GNUC_CONST;
GnonogramsViewModeButton* gnonograms_view_mode_button_new (void);
GnonogramsViewModeButton* gnonograms_view_mode_button_construct (GType object_type);
GnonogramsGameState gnonograms_view_mode_button_get_mode (GnonogramsViewModeButton* self);
void gnonograms_view_mode_button_set_mode (GnonogramsViewModeButton* self,
                                           GnonogramsGameState value);
GType gnonograms_difficulty_get_type (void) G_GNUC_CONST;
void gnonograms_view_mode_button_set_grade (GnonogramsViewModeButton* self,
                                            GnonogramsDifficulty value);
gchar* gnonograms_difficulty_to_string (GnonogramsDifficulty self);
static GObject * gnonograms_view_mode_button_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _gnonograms_view_mode_button___lambda24_ (GnonogramsViewModeButton* self);
static void __gnonograms_view_mode_button___lambda24__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                         GtkWidget* widget,
                                                                                         gpointer self);
static void _gnonograms_view_mode_button___lambda25_ (GnonogramsViewModeButton* self);
static void __gnonograms_view_mode_button___lambda25__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void gnonograms_view_mode_button_finalize (GObject * obj);
static void _vala_gnonograms_view_mode_button_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_gnonograms_view_mode_button_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
gnonograms_view_mode_button_get_instance_private (GnonogramsViewModeButton* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsViewModeButton_private_offset);
}

GnonogramsViewModeButton*
gnonograms_view_mode_button_construct (GType object_type)
{
	GnonogramsViewModeButton * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	self = (GnonogramsViewModeButton*) granite_widgets_mode_button_construct (object_type);
	_tmp0_ = self->priv->setting_icon;
	self->priv->setting_index = granite_widgets_mode_button_append ((GraniteWidgetsModeButton*) self, (GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->solving_icon;
	self->priv->solving_index = granite_widgets_mode_button_append ((GraniteWidgetsModeButton*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->generating_icon;
	self->priv->generating_index = granite_widgets_mode_button_append ((GraniteWidgetsModeButton*) self, (GtkWidget*) _tmp2_);
	return self;
}

GnonogramsViewModeButton*
gnonograms_view_mode_button_new (void)
{
	return gnonograms_view_mode_button_construct (GNONOGRAMS_TYPE_VIEW_MODE_BUTTON);
}

GnonogramsGameState
gnonograms_view_mode_button_get_mode (GnonogramsViewModeButton* self)
{
	GnonogramsGameState result;
	GnonogramsGameState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_mode;
	result = _tmp0_;
	return result;
}

void
gnonograms_view_mode_button_set_mode (GnonogramsViewModeButton* self,
                                      GnonogramsGameState value)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_view_mode_button_get_mode (self) != value) {
		self->priv->_mode = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_mode_button_properties[GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY]);
	}
}

void
gnonograms_view_mode_button_set_grade (GnonogramsViewModeButton* self,
                                       GnonogramsDifficulty value)
{
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->generating_icon;
	_tmp1_ = gnonograms_difficulty_to_string (value);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf (_ ("Generate %s puzzle"), _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_view_mode_button_properties[GNONOGRAMS_VIEW_MODE_BUTTON_GRADE_PROPERTY]);
}

static void
_gnonograms_view_mode_button___lambda24_ (GnonogramsViewModeButton* self)
{
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = granite_widgets_mode_button_get_selected ((GraniteWidgetsModeButton*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == self->priv->setting_index) {
		gnonograms_view_mode_button_set_mode (self, GNONOGRAMS_GAME_STATE_SETTING);
	} else {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = granite_widgets_mode_button_get_selected ((GraniteWidgetsModeButton*) self);
		_tmp3_ = _tmp2_;
		if (_tmp3_ == self->priv->solving_index) {
			gnonograms_view_mode_button_set_mode (self, GNONOGRAMS_GAME_STATE_SOLVING);
		} else {
			gint _tmp4_;
			gint _tmp5_;
			_tmp4_ = granite_widgets_mode_button_get_selected ((GraniteWidgetsModeButton*) self);
			_tmp5_ = _tmp4_;
			if (_tmp5_ == self->priv->generating_index) {
				gnonograms_view_mode_button_set_mode (self, GNONOGRAMS_GAME_STATE_GENERATING);
			} else {
				gnonograms_view_mode_button_set_mode (self, GNONOGRAMS_GAME_STATE_UNDEFINED);
			}
		}
	}
}

static void
__gnonograms_view_mode_button___lambda24__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                    GtkWidget* widget,
                                                                                    gpointer self)
{
	_gnonograms_view_mode_button___lambda24_ ((GnonogramsViewModeButton*) self);
}

static void
_gnonograms_view_mode_button___lambda25_ (GnonogramsViewModeButton* self)
{
	GnonogramsGameState _tmp0_;
	_tmp0_ = self->priv->_mode;
	switch (_tmp0_) {
		case GNONOGRAMS_GAME_STATE_SETTING:
		{
			granite_widgets_mode_button_set_active ((GraniteWidgetsModeButton*) self, self->priv->setting_index);
			break;
		}
		case GNONOGRAMS_GAME_STATE_SOLVING:
		{
			granite_widgets_mode_button_set_active ((GraniteWidgetsModeButton*) self, self->priv->solving_index);
			break;
		}
		case GNONOGRAMS_GAME_STATE_GENERATING:
		{
			granite_widgets_mode_button_set_active ((GraniteWidgetsModeButton*) self, self->priv->generating_index);
			break;
		}
		default:
		{
			break;
		}
	}
}

static void
__gnonograms_view_mode_button___lambda25__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
	_gnonograms_view_mode_button___lambda25_ ((GnonogramsViewModeButton*) self);
}

static GObject *
gnonograms_view_mode_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewModeButton * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkImage* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkImage* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	parent_class = G_OBJECT_CLASS (gnonograms_view_mode_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->setting_icon);
	self->priv->setting_icon = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("process-working-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->solving_icon);
	self->priv->solving_icon = _tmp1_;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->generating_icon);
	self->priv->generating_icon = _tmp2_;
	_tmp3_ = self->priv->setting_icon;
	g_object_set_data_full ((GObject*) _tmp3_, "mode", (gpointer) ((gintptr) GNONOGRAMS_GAME_STATE_SETTING), NULL);
	_tmp4_ = self->priv->solving_icon;
	g_object_set_data_full ((GObject*) _tmp4_, "mode", (gpointer) ((gintptr) GNONOGRAMS_GAME_STATE_SOLVING), NULL);
	_tmp5_ = self->priv->generating_icon;
	g_object_set_data_full ((GObject*) _tmp5_, "mode", (gpointer) ((gintptr) GNONOGRAMS_GAME_STATE_GENERATING), NULL);
	_tmp6_ = self->priv->setting_icon;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "linked");
	_tmp8_ = self->priv->solving_icon;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "linked");
	_tmp10_ = self->priv->generating_icon;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, "linked");
	_tmp12_ = self->priv->setting_icon;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("Draw pattern"));
	_tmp13_ = self->priv->solving_icon;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Solve puzzle"));
	_tmp14_ = self->priv->generating_icon;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _ ("Generate new random puzzle"));
	g_signal_connect_object ((GraniteWidgetsModeButton*) self, "mode-changed", (GCallback) __gnonograms_view_mode_button___lambda24__granite_widgets_mode_button_mode_changed, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::mode", (GCallback) __gnonograms_view_mode_button___lambda25__g_object_notify, self, 0);
	return obj;
}

static void
gnonograms_view_mode_button_class_init (GnonogramsViewModeButtonClass * klass,
                                        gpointer klass_data)
{
	gnonograms_view_mode_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsViewModeButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_mode_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_mode_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_mode_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_mode_button_finalize;
	/** PUBLIC **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY, gnonograms_view_mode_button_properties[GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", GNONOGRAMS_TYPE_GAME_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_MODE_BUTTON_GRADE_PROPERTY, gnonograms_view_mode_button_properties[GNONOGRAMS_VIEW_MODE_BUTTON_GRADE_PROPERTY] = g_param_spec_enum ("grade", "grade", "grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
gnonograms_view_mode_button_instance_init (GnonogramsViewModeButton * self,
                                           gpointer klass)
{
	self->priv = gnonograms_view_mode_button_get_instance_private (self);
}

static void
gnonograms_view_mode_button_finalize (GObject * obj)
{
	GnonogramsViewModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton);
	_g_object_unref0 (self->priv->setting_icon);
	_g_object_unref0 (self->priv->solving_icon);
	_g_object_unref0 (self->priv->generating_icon);
	G_OBJECT_CLASS (gnonograms_view_mode_button_parent_class)->finalize (obj);
}

/** ModeButton used by View in headbar to switch between SETTING and SOLVING modes **/
GType
gnonograms_view_mode_button_get_type (void)
{
	static volatile gsize gnonograms_view_mode_button_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_view_mode_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewModeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_mode_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewModeButton), 0, (GInstanceInitFunc) gnonograms_view_mode_button_instance_init, NULL };
		GType gnonograms_view_mode_button_type_id;
		gnonograms_view_mode_button_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_MODE_BUTTON, "GnonogramsViewModeButton", &g_define_type_info, 0);
		GnonogramsViewModeButton_private_offset = g_type_add_instance_private (gnonograms_view_mode_button_type_id, sizeof (GnonogramsViewModeButtonPrivate));
		g_once_init_leave (&gnonograms_view_mode_button_type_id__volatile, gnonograms_view_mode_button_type_id);
	}
	return gnonograms_view_mode_button_type_id__volatile;
}

static void
_vala_gnonograms_view_mode_button_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	GnonogramsViewModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_mode_button_get_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_mode_button_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	GnonogramsViewModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODE_BUTTON_MODE_PROPERTY:
		gnonograms_view_mode_button_set_mode (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_MODE_BUTTON_GRADE_PROPERTY:
		gnonograms_view_mode_button_set_grade (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

