/* Region.c generated by valac 0.46.6, the Vala compiler
 * generated from Region.vala, do not modify */

/* Represents a linear region of cells for gnonograms -elementary
 * Copyright (C) 2010 -2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see  < http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten  <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

#define GNONOGRAMS_TYPE_REGION (gnonograms_region_get_type ())
#define GNONOGRAMS_REGION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegion))
#define GNONOGRAMS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))
#define GNONOGRAMS_IS_REGION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_IS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_REGION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))

typedef struct _GnonogramsRegion GnonogramsRegion;
typedef struct _GnonogramsRegionClass GnonogramsRegionClass;
typedef struct _GnonogramsRegionPrivate GnonogramsRegionPrivate;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GNONOGRAMS_TYPE_RANGE (gnonograms_range_get_type ())
#define GNONOGRAMS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_RANGE, GnonogramsRange))
#define GNONOGRAMS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_RANGE, GnonogramsRangeClass))
#define GNONOGRAMS_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_RANGE))
#define GNONOGRAMS_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_RANGE))
#define GNONOGRAMS_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_RANGE, GnonogramsRangeClass))

typedef struct _GnonogramsRange GnonogramsRange;
typedef struct _GnonogramsRangeClass GnonogramsRangeClass;
#define _gnonograms_range_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_range_unref (var), NULL)))
typedef struct _GnonogramsRangePrivate GnonogramsRangePrivate;
typedef struct _GnonogramsParamSpecRegion GnonogramsParamSpecRegion;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsRegion {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsRegionPrivate * priv;
	gchar* message;
};

struct _GnonogramsRegionClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsRegion *self);
};

struct _GnonogramsRegionPrivate {
	gboolean _is_column;
	gboolean _in_error;
	gboolean _is_completed;
	guint _index;
	gint _n_cells;
	gint _block_total;
	guint _value_as_permute_region;
	GnonogramsMy2DCellArray* grid;
	gboolean is_completed_backup;
	gboolean* completed_blocks;
	gint completed_blocks_length1;
	gint _completed_blocks_size_;
	gboolean* completed_blocks_backup;
	gint completed_blocks_backup_length1;
	gint _completed_blocks_backup_size_;
	gboolean* tags;
	gint tags_length1;
	gint tags_length2;
	gboolean* tags_backup;
	gint tags_backup_length1;
	gint tags_backup_length2;
	GnonogramsCellState* status;
	gint status_length1;
	gint _status_size_;
	GnonogramsCellState* temp_status;
	gint temp_status_length1;
	gint _temp_status_size_;
	GnonogramsCellState* temp_status2;
	gint temp_status2_length1;
	gint _temp_status2_size_;
	GnonogramsCellState* status_backup;
	gint status_backup_length1;
	gint _status_backup_size_;
	gint unchanged_count;
	gint n_blocks;
	gint block_extent;
	gint can_be_empty_pointer;
	gint is_finished_pointer;
	gint current_index;
	gint current_block_number;
	gint unknown;
	gint unknown_backup;
	gint filled;
	gint filled_backup;
	gint* blocks;
	gint blocks_length1;
	gint _blocks_size_;
	gint* ranges;
	gint ranges_length1;
	gint ranges_length2;
	gint* ranges_backup;
	gint ranges_backup_length1;
	gint ranges_backup_length2;
	gchar* clue;
	gboolean debugging;
};

struct _GnonogramsRange {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsRangePrivate * priv;
	gint start;
	gint end;
	gint filled;
	gint unknown;
};

struct _GnonogramsRangeClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsRange *self);
};

struct _GnonogramsParamSpecRegion {
	GParamSpec parent_instance;
};

static gint GnonogramsRegion_private_offset;
static gpointer gnonograms_region_parent_class = NULL;

gpointer gnonograms_region_ref (gpointer instance);
void gnonograms_region_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_region (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void gnonograms_value_set_region (GValue* value,
                                  gpointer v_object);
void gnonograms_value_take_region (GValue* value,
                                   gpointer v_object);
gpointer gnonograms_value_get_region (const GValue* value);
GType gnonograms_region_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRegion, gnonograms_region_unref)
GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
GType gnonograms_cell_state_get_type (void) G_GNUC_CONST;
#define GNONOGRAMS_REGION_MAXCYCLES 2
#define GNONOGRAMS_REGION_FORWARDS 1
#define GNONOGRAMS_REGION_BACKWARDS -1
GnonogramsRegion* gnonograms_region_new (GnonogramsMy2DCellArray* grid);
GnonogramsRegion* gnonograms_region_construct (GType object_type,
                                               GnonogramsMy2DCellArray* grid);
guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
void gnonograms_region_initialize (GnonogramsRegion* self,
                                   guint index,
                                   gboolean is_column,
                                   guint n_cells,
                                   const gchar* clue);
static void gnonograms_region_set_index (GnonogramsRegion* self,
                                  guint value);
static void gnonograms_region_set_is_column (GnonogramsRegion* self,
                                      gboolean value);
static void gnonograms_region_set_n_cells (GnonogramsRegion* self,
                                    gint value);
gint* gnonograms_utils_block_array_from_clue (const gchar* s,
                                              gint* result_length1);
static void gnonograms_region_set_block_total (GnonogramsRegion* self,
                                        gint value);
gint gnonograms_region_get_block_total (GnonogramsRegion* self);
void gnonograms_region_set_to_initial_state (GnonogramsRegion* self);
static void gnonograms_region_set_is_completed (GnonogramsRegion* self,
                                         gboolean value);
gint gnonograms_region_get_n_cells (GnonogramsRegion* self);
static void gnonograms_region_set_in_error (GnonogramsRegion* self,
                                     gboolean value);
gboolean gnonograms_region_get_is_completed (GnonogramsRegion* self);
#define GNONOGRAMS_MAXSIZE 50
static void gnonograms_region_get_status (GnonogramsRegion* self);
static void gnonograms_region_initial_fix (GnonogramsRegion* self);
static void gnonograms_region_tags_to_status (GnonogramsRegion* self);
static void gnonograms_region_put_status (GnonogramsRegion* self);
gboolean gnonograms_region_debug (GnonogramsRegion* self);
gboolean gnonograms_region_solve (GnonogramsRegion* self);
gchar* gnonograms_region_to_string (GnonogramsRegion* self);
gboolean gnonograms_region_get_in_error (GnonogramsRegion* self);
static gboolean gnonograms_region_totals_changed (GnonogramsRegion* self);
static gboolean gnonograms_region_full_fix (GnonogramsRegion* self);
void gnonograms_region_save_state (GnonogramsRegion* self);
void gnonograms_region_restore_state (GnonogramsRegion* self);
gchar* gnonograms_region_get_id (GnonogramsRegion* self);
gboolean gnonograms_region_get_is_column (GnonogramsRegion* self);
guint gnonograms_region_get_index (GnonogramsRegion* self);
GnonogramsCellState gnonograms_region_get_cell_state (GnonogramsRegion* self,
                                                      guint index);
static guint gnonograms_region_calc_value_as_permute_region (GnonogramsRegion* self);
static gint gnonograms_region_count_available_ranges (GnonogramsRegion* self,
                                               gboolean notempty);
static gboolean gnonograms_region_set_range_owner (GnonogramsRegion* self,
                                            gint owner,
                                            gint start,
                                            gint length,
                                            gboolean exclusive,
                                            gboolean can_be_empty);
static gboolean gnonograms_region_do_edge (GnonogramsRegion* self,
                                    gint direction);
static gboolean gnonograms_region_available_filled_subregion_audit (GnonogramsRegion* self);
static gboolean gnonograms_region_possibilities_audit (GnonogramsRegion* self);
static gboolean gnonograms_region_fill_gaps (GnonogramsRegion* self);
static gboolean gnonograms_region_only_possibility (GnonogramsRegion* self);
static gboolean gnonograms_region_free_cell_audit (GnonogramsRegion* self);
static gboolean gnonograms_region_fix_blocks_in_ranges (GnonogramsRegion* self);
static gboolean gnonograms_region_capped_range_audit (GnonogramsRegion* self);
static gboolean gnonograms_region_filled_subregion_audit (GnonogramsRegion* self);
static gboolean gnonograms_region_check_collisions (GnonogramsRegion* self);
static gint gnonograms_region_seek_next_required_status (GnonogramsRegion* self,
                                                  gint cs,
                                                  gint idx,
                                                  gint limit,
                                                  gint direction);
static gint gnonograms_region_count_consecutive_with_state_from (GnonogramsRegion* self,
                                                          gint cs,
                                                          gint idx,
                                                          gboolean forwards);
static void gnonograms_region_assign_and_cap_range (GnonogramsRegion* self,
                                             gint start,
                                             gint length);
static gint gnonograms_region_find_largest_possible_block_for_cell (GnonogramsRegion* self,
                                                             gint cell);
static gint gnonograms_region_find_smallest_possible_block_for_cell (GnonogramsRegion* self,
                                                              gint cell);
static gint gnonograms_region_get_sole_owner (GnonogramsRegion* self,
                                       gint cell);
static void gnonograms_region_set_cell_empty (GnonogramsRegion* self,
                                       gint cell);
static gint gnonograms_region_have_same_owner (GnonogramsRegion* self,
                                        gint cell1,
                                        gint cell2);
static gint gnonograms_region_count_contiguous_with_same_owner_from (GnonogramsRegion* self,
                                                              gint owner,
                                                              gint idx);
static void gnonograms_region_remove_block_from_range (GnonogramsRegion* self,
                                                gint block,
                                                gint start,
                                                gint length,
                                                gint direction);
static gboolean gnonograms_region_fix_block_in_range (GnonogramsRegion* self,
                                               gint block,
                                               gint start,
                                               gint length);
static gboolean gnonograms_region_set_block_complete_and_cap (GnonogramsRegion* self,
                                                       gint block,
                                                       gint start,
                                                       gint direction);
static void gnonograms_region_remove_block_from_cell_to_end (GnonogramsRegion* self,
                                                      gint block,
                                                      gint start,
                                                      gint direction);
static gint gnonograms_region_count_cell_state (GnonogramsRegion* self,
                                         gint cs);
static void gnonograms_region_set_cell_complete (GnonogramsRegion* self,
                                          gint cell);
static gboolean gnonograms_region_find_edge (GnonogramsRegion* self,
                                      gint limit,
                                      gint direction);
static gboolean gnonograms_region_set_cell_owner (GnonogramsRegion* self,
                                           gint cell,
                                           gint owner,
                                           gboolean exclusive,
                                           gboolean can_be_empty);
static gint* gnonograms_region_get_blocks_available (GnonogramsRegion* self,
                                              gint* result_length1);
static gint gnonograms_region_count_capped_ranges (GnonogramsRegion* self);
static void gnonograms_region_record_error (GnonogramsRegion* self,
                                     const gchar* method,
                                     const gchar* errmessage);
gpointer gnonograms_range_ref (gpointer instance);
void gnonograms_range_unref (gpointer instance);
GParamSpec* gnonograms_param_spec_range (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gnonograms_value_set_range (GValue* value,
                                 gpointer v_object);
void gnonograms_value_take_range (GValue* value,
                                  gpointer v_object);
gpointer gnonograms_value_get_range (const GValue* value);
GType gnonograms_range_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRange, gnonograms_range_unref)
GnonogramsRange* gnonograms_range_new (gint start,
                                       gint end,
                                       gint filled,
                                       gint unknown);
GnonogramsRange* gnonograms_range_construct (GType object_type,
                                             gint start,
                                             gint end,
                                             gint filled,
                                             gint unknown);
gint gnonograms_range_length (GnonogramsRange* self);
static gboolean gnonograms_region_match_clue (GnonogramsRegion* self);
static gint gnonograms_region_count_possible_owners_and_can_be_empty (GnonogramsRegion* self,
                                                               gint cell);
static gboolean gnonograms_region_is_invalid_data (GnonogramsRegion* self,
                                            gint start,
                                            gint block,
                                            gint length);
static void _vala_array_add3 (gint* * array,
                       int* length,
                       int* size,
                       gint value);
static gboolean gnonograms_region_is_cell_filled (GnonogramsRegion* self,
                                           gint cell);
void gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState** sa,
                                           gint* sa_length1,
                                           guint start);
static void gnonograms_region_status_to_tags (GnonogramsRegion* self);
void gnonograms_my2_dcell_array_set_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState* sa,
                                           gint sa_length1,
                                           guint start);
guint gnonograms_region_get_value_as_permute_region (GnonogramsRegion* self);
void gnonograms_region_set_value_as_permute_region (GnonogramsRegion* self,
                                                    guint value);
static void gnonograms_region_finalize (GnonogramsRegion * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gnonograms_region_get_instance_private (GnonogramsRegion* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsRegion_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GnonogramsRegion*
gnonograms_region_construct (GType object_type,
                             GnonogramsMy2DCellArray* grid)
{
	GnonogramsRegion* self = NULL;
	GnonogramsMy2DCellArray* _tmp0_;
	guint max_len = 0U;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	GnonogramsCellState* _tmp5_;
	GnonogramsCellState* _tmp6_;
	guint max_blocks = 0U;
	gint* _tmp7_;
	gint* _tmp8_;
	gint* _tmp9_;
	gboolean* _tmp10_;
	gboolean* _tmp11_;
	gboolean* _tmp12_;
	gboolean* _tmp13_;
	g_return_val_if_fail (grid != NULL, NULL);
	self = (GnonogramsRegion*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (grid);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp0_;
	_tmp1_ = gnonograms_my2_dcell_array_get_rows (grid);
	_tmp2_ = _tmp1_;
	_tmp3_ = gnonograms_my2_dcell_array_get_cols (grid);
	_tmp4_ = _tmp3_;
	max_len = MAX (_tmp2_, _tmp4_);
	_tmp5_ = g_new0 (GnonogramsCellState, max_len);
	self->priv->status = (g_free (self->priv->status), NULL);
	self->priv->status = _tmp5_;
	self->priv->status_length1 = max_len;
	self->priv->_status_size_ = self->priv->status_length1;
	_tmp6_ = g_new0 (GnonogramsCellState, max_len);
	self->priv->status_backup = (g_free (self->priv->status_backup), NULL);
	self->priv->status_backup = _tmp6_;
	self->priv->status_backup_length1 = max_len;
	self->priv->_status_backup_size_ = self->priv->status_backup_length1;
	max_blocks = (max_len / 2) + 2;
	_tmp7_ = g_new0 (gint, max_blocks * 4);
	self->priv->ranges = (g_free (self->priv->ranges), NULL);
	self->priv->ranges = _tmp7_;
	self->priv->ranges_length1 = max_blocks;
	self->priv->ranges_length2 = 4;
	_tmp8_ = g_new0 (gint, max_blocks * 4);
	self->priv->ranges_backup = (g_free (self->priv->ranges_backup), NULL);
	self->priv->ranges_backup = _tmp8_;
	self->priv->ranges_backup_length1 = max_blocks;
	self->priv->ranges_backup_length2 = 4;
	_tmp9_ = g_new0 (gint, max_blocks);
	self->priv->blocks = (g_free (self->priv->blocks), NULL);
	self->priv->blocks = _tmp9_;
	self->priv->blocks_length1 = max_blocks;
	self->priv->_blocks_size_ = self->priv->blocks_length1;
	_tmp10_ = g_new0 (gboolean, max_blocks);
	self->priv->completed_blocks = (g_free (self->priv->completed_blocks), NULL);
	self->priv->completed_blocks = _tmp10_;
	self->priv->completed_blocks_length1 = max_blocks;
	self->priv->_completed_blocks_size_ = self->priv->completed_blocks_length1;
	_tmp11_ = g_new0 (gboolean, max_blocks);
	self->priv->completed_blocks_backup = (g_free (self->priv->completed_blocks_backup), NULL);
	self->priv->completed_blocks_backup = _tmp11_;
	self->priv->completed_blocks_backup_length1 = max_blocks;
	self->priv->_completed_blocks_backup_size_ = self->priv->completed_blocks_backup_length1;
	_tmp12_ = g_new0 (gboolean, max_len * (max_blocks + 2));
	self->priv->tags = (g_free (self->priv->tags), NULL);
	self->priv->tags = _tmp12_;
	self->priv->tags_length1 = max_len;
	self->priv->tags_length2 = max_blocks + 2;
	_tmp13_ = g_new0 (gboolean, max_len * (max_blocks + 2));
	self->priv->tags_backup = (g_free (self->priv->tags_backup), NULL);
	self->priv->tags_backup = _tmp13_;
	self->priv->tags_backup_length1 = max_len;
	self->priv->tags_backup_length2 = max_blocks + 2;
	return self;
}

GnonogramsRegion*
gnonograms_region_new (GnonogramsMy2DCellArray* grid)
{
	return gnonograms_region_construct (GNONOGRAMS_TYPE_REGION, grid);
}

void
gnonograms_region_initialize (GnonogramsRegion* self,
                              guint index,
                              gboolean is_column,
                              guint n_cells,
                              const gchar* clue)
{
	gchar* _tmp0_;
	GnonogramsCellState* _tmp1_;
	GnonogramsCellState* _tmp2_;
	gint* clue_blocks = NULL;
	gint _tmp3_ = 0;
	gint* _tmp4_;
	gint clue_blocks_length1;
	gint _clue_blocks_size_;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clue != NULL);
	gnonograms_region_set_index (self, index);
	gnonograms_region_set_is_column (self, is_column);
	gnonograms_region_set_n_cells (self, (gint) n_cells);
	_tmp0_ = g_strdup (clue);
	_g_free0 (self->priv->clue);
	self->priv->clue = _tmp0_;
	_tmp1_ = g_new0 (GnonogramsCellState, n_cells);
	self->priv->temp_status = (g_free (self->priv->temp_status), NULL);
	self->priv->temp_status = _tmp1_;
	self->priv->temp_status_length1 = n_cells;
	self->priv->_temp_status_size_ = self->priv->temp_status_length1;
	_tmp2_ = g_new0 (GnonogramsCellState, n_cells);
	self->priv->temp_status2 = (g_free (self->priv->temp_status2), NULL);
	self->priv->temp_status2 = _tmp2_;
	self->priv->temp_status2_length1 = n_cells;
	self->priv->_temp_status2_size_ = self->priv->temp_status2_length1;
	_tmp4_ = gnonograms_utils_block_array_from_clue (clue, &_tmp3_);
	clue_blocks = _tmp4_;
	clue_blocks_length1 = _tmp3_;
	_clue_blocks_size_ = clue_blocks_length1;
	_tmp5_ = clue_blocks;
	_tmp5__length1 = clue_blocks_length1;
	self->priv->n_blocks = _tmp5__length1;
	self->priv->can_be_empty_pointer = self->priv->n_blocks;
	self->priv->is_finished_pointer = self->priv->n_blocks + 1;
	gnonograms_region_set_block_total (self, 0);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint* _tmp8_;
				gint _tmp8__length1;
				gint* _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				gint _tmp11_;
				gint* _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp8_ = self->priv->blocks;
				_tmp8__length1 = self->priv->blocks_length1;
				_tmp9_ = clue_blocks;
				_tmp9__length1 = clue_blocks_length1;
				_tmp10_ = _tmp9_[i];
				_tmp8_[i] = _tmp10_;
				_tmp11_ = self->priv->_block_total;
				_tmp12_ = self->priv->blocks;
				_tmp12__length1 = self->priv->blocks_length1;
				_tmp13_ = _tmp12_[i];
				gnonograms_region_set_block_total (self, _tmp11_ + _tmp13_);
			}
		}
	}
	_tmp14_ = self->priv->_block_total;
	self->priv->block_extent = (_tmp14_ + self->priv->n_blocks) - 1;
	gnonograms_region_set_to_initial_state (self);
	if (n_cells == ((guint) 1)) {
		gnonograms_region_set_is_completed (self, TRUE);
	}
	self->priv->_value_as_permute_region = G_MAXUINT;
	clue_blocks = (g_free (clue_blocks), NULL);
}

void
gnonograms_region_set_to_initial_state (GnonogramsRegion* self)
{
	gint _tmp16_;
	gboolean _tmp17_;
	gint* _tmp18_;
	gint _tmp18__length1;
	gint _tmp19_;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean* _tmp3_;
				gint _tmp3__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp2_ = self->priv->completed_blocks;
				_tmp2__length1 = self->priv->completed_blocks_length1;
				_tmp2_[i] = FALSE;
				_tmp3_ = self->priv->completed_blocks_backup;
				_tmp3__length1 = self->priv->completed_blocks_backup_length1;
				_tmp3_[i] = FALSE;
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gboolean* _tmp12_;
				gint _tmp12__length1;
				gint _tmp12__length2;
				GnonogramsCellState* _tmp13_;
				gint _tmp13__length1;
				GnonogramsCellState* _tmp14_;
				gint _tmp14__length1;
				GnonogramsCellState* _tmp15_;
				gint _tmp15__length1;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = self->priv->_n_cells;
				if (!(i < _tmp6_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gboolean* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gboolean* _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							if (!_tmp7_) {
								gint _tmp8_;
								_tmp8_ = j;
								j = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							if (!(j < self->priv->n_blocks)) {
								break;
							}
							_tmp9_ = self->priv->tags;
							_tmp9__length1 = self->priv->tags_length1;
							_tmp9__length2 = self->priv->tags_length2;
							_tmp9_[(i * _tmp9__length2) + j] = FALSE;
							_tmp10_ = self->priv->tags_backup;
							_tmp10__length1 = self->priv->tags_backup_length1;
							_tmp10__length2 = self->priv->tags_backup_length2;
							_tmp10_[(i * _tmp10__length2) + j] = FALSE;
						}
					}
				}
				_tmp11_ = self->priv->tags;
				_tmp11__length1 = self->priv->tags_length1;
				_tmp11__length2 = self->priv->tags_length2;
				_tmp11_[(i * _tmp11__length2) + self->priv->can_be_empty_pointer] = TRUE;
				_tmp12_ = self->priv->tags;
				_tmp12__length1 = self->priv->tags_length1;
				_tmp12__length2 = self->priv->tags_length2;
				_tmp12_[(i * _tmp12__length2) + self->priv->is_finished_pointer] = FALSE;
				_tmp13_ = self->priv->status;
				_tmp13__length1 = self->priv->status_length1;
				_tmp13_[i] = GNONOGRAMS_CELL_STATE_UNKNOWN;
				_tmp14_ = self->priv->temp_status;
				_tmp14__length1 = self->priv->temp_status_length1;
				_tmp14_[i] = GNONOGRAMS_CELL_STATE_UNKNOWN;
				_tmp15_ = self->priv->temp_status2;
				_tmp15__length1 = self->priv->temp_status2_length1;
				_tmp15_[i] = GNONOGRAMS_CELL_STATE_UNKNOWN;
			}
		}
	}
	gnonograms_region_set_in_error (self, FALSE);
	_tmp16_ = self->priv->_n_cells;
	gnonograms_region_set_is_completed (self, _tmp16_ == 1);
	_tmp17_ = self->priv->_is_completed;
	if (_tmp17_) {
		return;
	}
	self->priv->unknown = GNONOGRAMS_MAXSIZE;
	self->priv->filled = GNONOGRAMS_MAXSIZE;
	gnonograms_region_get_status (self);
	_tmp18_ = self->priv->blocks;
	_tmp18__length1 = self->priv->blocks_length1;
	_tmp19_ = _tmp18_[0];
	if (_tmp19_ == 0) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp20_ = FALSE;
				_tmp20_ = TRUE;
				while (TRUE) {
					gint _tmp22_;
					gboolean* _tmp26_;
					gint _tmp26__length1;
					gint _tmp26__length2;
					gboolean* _tmp27_;
					gint _tmp27__length1;
					gint _tmp27__length2;
					GnonogramsCellState* _tmp28_;
					gint _tmp28__length1;
					GnonogramsCellState* _tmp29_;
					gint _tmp29__length1;
					GnonogramsCellState* _tmp30_;
					gint _tmp30__length1;
					if (!_tmp20_) {
						gint _tmp21_;
						_tmp21_ = i;
						i = _tmp21_ + 1;
					}
					_tmp20_ = FALSE;
					_tmp22_ = self->priv->_n_cells;
					if (!(i < _tmp22_)) {
						break;
					}
					{
						gint j = 0;
						j = 0;
						{
							gboolean _tmp23_ = FALSE;
							_tmp23_ = TRUE;
							while (TRUE) {
								gboolean* _tmp25_;
								gint _tmp25__length1;
								gint _tmp25__length2;
								if (!_tmp23_) {
									gint _tmp24_;
									_tmp24_ = j;
									j = _tmp24_ + 1;
								}
								_tmp23_ = FALSE;
								if (!(j < self->priv->n_blocks)) {
									break;
								}
								_tmp25_ = self->priv->tags;
								_tmp25__length1 = self->priv->tags_length1;
								_tmp25__length2 = self->priv->tags_length2;
								_tmp25_[(i * _tmp25__length2) + j] = FALSE;
							}
						}
					}
					_tmp26_ = self->priv->tags;
					_tmp26__length1 = self->priv->tags_length1;
					_tmp26__length2 = self->priv->tags_length2;
					_tmp26_[(i * _tmp26__length2) + self->priv->can_be_empty_pointer] = FALSE;
					_tmp27_ = self->priv->tags;
					_tmp27__length1 = self->priv->tags_length1;
					_tmp27__length2 = self->priv->tags_length2;
					_tmp27_[(i * _tmp27__length2) + self->priv->is_finished_pointer] = TRUE;
					_tmp28_ = self->priv->status;
					_tmp28__length1 = self->priv->status_length1;
					_tmp28_[i] = GNONOGRAMS_CELL_STATE_EMPTY;
					_tmp29_ = self->priv->temp_status;
					_tmp29__length1 = self->priv->temp_status_length1;
					_tmp29_[i] = GNONOGRAMS_CELL_STATE_EMPTY;
					_tmp30_ = self->priv->temp_status2;
					_tmp30__length1 = self->priv->temp_status2_length1;
					_tmp30_[i] = GNONOGRAMS_CELL_STATE_EMPTY;
				}
			}
		}
		gnonograms_region_set_is_completed (self, TRUE);
	} else {
		gnonograms_region_initial_fix (self);
	}
	gnonograms_region_tags_to_status (self);
	gnonograms_region_put_status (self);
}

gboolean
gnonograms_region_debug (GnonogramsRegion* self)
{
	gboolean changed = FALSE;
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	FILE* _tmp3_;
	const gchar* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->debugging = TRUE;
	gnonograms_region_set_to_initial_state (self);
	changed = gnonograms_region_solve (self);
	self->priv->debugging = FALSE;
	_tmp0_ = stdout;
	_tmp1_ = gnonograms_region_to_string (self);
	_tmp2_ = _tmp1_;
	fprintf (_tmp0_, "%s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = stdout;
	_tmp4_ = self->message;
	fprintf (_tmp3_, "%s", _tmp4_);
	result = changed;
	return result;
}

gboolean
gnonograms_region_solve (GnonogramsRegion* self)
{
	gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint count = 0;
	gboolean made_changes = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	_g_free0 (self->message);
	self->message = _tmp0_;
	gnonograms_region_set_in_error (self, FALSE);
	gnonograms_region_get_status (self);
	_tmp1_ = self->priv->_in_error;
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	if (!gnonograms_region_totals_changed (self)) {
		gint _tmp2_;
		_tmp2_ = self->priv->unchanged_count;
		self->priv->unchanged_count = _tmp2_ + 1;
	} else {
		self->priv->unchanged_count = 0;
	}
	_tmp4_ = self->priv->_is_completed;
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = self->priv->unchanged_count > 2;
	}
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	count = 0;
	made_changes = FALSE;
	while (TRUE) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gint _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_ = FALSE;
		_tmp6_ = self->priv->_is_completed;
		if (!_tmp6_) {
			_tmp5_ = count < GNONOGRAMS_REGION_MAXCYCLES;
		} else {
			_tmp5_ = FALSE;
		}
		if (!_tmp5_) {
			break;
		}
		_tmp7_ = count;
		count = _tmp7_ + 1;
		gnonograms_region_full_fix (self);
		_tmp8_ = self->priv->_in_error;
		if (_tmp8_) {
			break;
		}
		gnonograms_region_tags_to_status (self);
		if (!gnonograms_region_totals_changed (self)) {
			_tmp9_ = TRUE;
		} else {
			gboolean _tmp10_;
			_tmp10_ = self->priv->_in_error;
			_tmp9_ = _tmp10_;
		}
		if (_tmp9_) {
			break;
		}
		made_changes = TRUE;
	}
	gnonograms_region_put_status (self);
	result = made_changes;
	return result;
}

void
gnonograms_region_save_state (GnonogramsRegion* self)
{
	gboolean _tmp21_;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState* _tmp4_;
				gint _tmp4__length1;
				GnonogramsCellState _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp3_ = self->priv->status_backup;
				_tmp3__length1 = self->priv->status_backup_length1;
				_tmp4_ = self->priv->status;
				_tmp4__length1 = self->priv->status_length1;
				_tmp5_ = _tmp4_[i];
				_tmp3_[i] = _tmp5_;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							gboolean* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gboolean* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gboolean _tmp10_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(j < (self->priv->n_blocks + 2))) {
								break;
							}
							_tmp8_ = self->priv->tags_backup;
							_tmp8__length1 = self->priv->tags_backup_length1;
							_tmp8__length2 = self->priv->tags_backup_length2;
							_tmp9_ = self->priv->tags;
							_tmp9__length1 = self->priv->tags_length1;
							_tmp9__length2 = self->priv->tags_length2;
							_tmp10_ = _tmp9_[(i * _tmp9__length2) + j];
							_tmp8_[(i * _tmp8__length2) + j] = _tmp10_;
						}
					}
				}
			}
		}
	}
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gboolean* _tmp13_;
				gint _tmp13__length1;
				gboolean* _tmp14_;
				gint _tmp14__length1;
				gboolean _tmp15_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = j;
					j = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				if (!(j < self->priv->n_blocks)) {
					break;
				}
				_tmp13_ = self->priv->completed_blocks_backup;
				_tmp13__length1 = self->priv->completed_blocks_backup_length1;
				_tmp14_ = self->priv->completed_blocks;
				_tmp14__length1 = self->priv->completed_blocks_length1;
				_tmp15_ = _tmp14_[j];
				_tmp13_[j] = _tmp15_;
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							gint* _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							gint* _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							gint _tmp20_;
							if (!_tmp16_) {
								gint _tmp17_;
								_tmp17_ = i;
								i = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							if (!(i < 4)) {
								break;
							}
							_tmp18_ = self->priv->ranges_backup;
							_tmp18__length1 = self->priv->ranges_backup_length1;
							_tmp18__length2 = self->priv->ranges_backup_length2;
							_tmp19_ = self->priv->ranges;
							_tmp19__length1 = self->priv->ranges_length1;
							_tmp19__length2 = self->priv->ranges_length2;
							_tmp20_ = _tmp19_[(j * _tmp19__length2) + i];
							_tmp18_[(j * _tmp18__length2) + i] = _tmp20_;
						}
					}
				}
			}
		}
	}
	_tmp21_ = self->priv->_is_completed;
	self->priv->is_completed_backup = _tmp21_;
	self->priv->filled_backup = self->priv->filled;
	self->priv->unknown_backup = self->priv->unknown;
}

void
gnonograms_region_restore_state (GnonogramsRegion* self)
{
	gchar* _tmp21_;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState* _tmp4_;
				gint _tmp4__length1;
				GnonogramsCellState _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = self->priv->status_backup;
				_tmp4__length1 = self->priv->status_backup_length1;
				_tmp5_ = _tmp4_[i];
				_tmp3_[i] = _tmp5_;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							gboolean* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gboolean* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gboolean _tmp10_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(j < (self->priv->n_blocks + 2))) {
								break;
							}
							_tmp8_ = self->priv->tags;
							_tmp8__length1 = self->priv->tags_length1;
							_tmp8__length2 = self->priv->tags_length2;
							_tmp9_ = self->priv->tags_backup;
							_tmp9__length1 = self->priv->tags_backup_length1;
							_tmp9__length2 = self->priv->tags_backup_length2;
							_tmp10_ = _tmp9_[(i * _tmp9__length2) + j];
							_tmp8_[(i * _tmp8__length2) + j] = _tmp10_;
						}
					}
				}
			}
		}
	}
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gboolean* _tmp13_;
				gint _tmp13__length1;
				gboolean* _tmp14_;
				gint _tmp14__length1;
				gboolean _tmp15_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = j;
					j = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				if (!(j < self->priv->n_blocks)) {
					break;
				}
				_tmp13_ = self->priv->completed_blocks;
				_tmp13__length1 = self->priv->completed_blocks_length1;
				_tmp14_ = self->priv->completed_blocks_backup;
				_tmp14__length1 = self->priv->completed_blocks_backup_length1;
				_tmp15_ = _tmp14_[j];
				_tmp13_[j] = _tmp15_;
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							gint* _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							gint* _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							gint _tmp20_;
							if (!_tmp16_) {
								gint _tmp17_;
								_tmp17_ = i;
								i = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							if (!(i < 4)) {
								break;
							}
							_tmp18_ = self->priv->ranges;
							_tmp18__length1 = self->priv->ranges_length1;
							_tmp18__length2 = self->priv->ranges_length2;
							_tmp19_ = self->priv->ranges_backup;
							_tmp19__length1 = self->priv->ranges_backup_length1;
							_tmp19__length2 = self->priv->ranges_backup_length2;
							_tmp20_ = _tmp19_[(j * _tmp19__length2) + i];
							_tmp18_[(j * _tmp18__length2) + i] = _tmp20_;
						}
					}
				}
			}
		}
	}
	gnonograms_region_set_is_completed (self, self->priv->is_completed_backup);
	self->priv->filled = self->priv->filled_backup;
	self->priv->unknown = self->priv->unknown_backup;
	gnonograms_region_set_in_error (self, FALSE);
	_tmp21_ = g_strdup ("");
	_g_free0 (self->message);
	self->message = _tmp21_;
	self->priv->unchanged_count = 0;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

gchar*
gnonograms_region_get_id (GnonogramsRegion* self)
{
	gchar* column_or_row = NULL;
	GString* sb = NULL;
	GString* _tmp0_;
	gboolean _tmp1_;
	GString* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GString* _tmp7_;
	GString* _tmp8_;
	guint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GString* _tmp12_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GString* _tmp16_;
	GString* _tmp17_;
	gboolean _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GString* _tmp21_;
	GString* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	_tmp1_ = self->priv->_is_column;
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("Column");
		_g_free0 (column_or_row);
		column_or_row = _tmp2_;
	} else {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("Row");
		_g_free0 (column_or_row);
		column_or_row = _tmp3_;
	}
	_tmp4_ = sb;
	_tmp5_ = column_or_row;
	_tmp6_ = string_to_string (_tmp5_);
	g_string_append (_tmp4_, _tmp6_);
	_tmp7_ = sb;
	g_string_append (_tmp7_, " ");
	_tmp8_ = sb;
	_tmp9_ = self->priv->_index;
	_tmp10_ = g_strdup_printf ("%u", _tmp9_);
	_tmp11_ = _tmp10_;
	g_string_append (_tmp8_, _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = sb;
	g_string_append (_tmp12_, " Clue: ");
	_tmp13_ = sb;
	_tmp14_ = self->priv->clue;
	_tmp15_ = string_to_string (_tmp14_);
	g_string_append (_tmp13_, _tmp15_);
	_tmp16_ = sb;
	g_string_append (_tmp16_, " Is Completed ");
	_tmp17_ = sb;
	_tmp18_ = self->priv->_is_completed;
	_tmp19_ = bool_to_string (_tmp18_);
	_tmp20_ = _tmp19_;
	g_string_append (_tmp17_, _tmp20_);
	_g_free0 (_tmp20_);
	_tmp21_ = sb;
	g_string_append (_tmp21_, "] ");
	_tmp22_ = sb;
	_tmp23_ = _tmp22_->str;
	_tmp24_ = g_strdup (_tmp23_);
	result = _tmp24_;
	_g_string_free0 (sb);
	_g_free0 (column_or_row);
	return result;
}

GnonogramsCellState
gnonograms_region_get_cell_state (GnonogramsRegion* self,
                                  guint index)
{
	gint _tmp0_;
	GnonogramsCellState _tmp1_ = 0;
	GnonogramsCellState* _tmp2_;
	gint _tmp2__length1;
	GnonogramsCellState _tmp3_;
	GnonogramsCellState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_n_cells;
	_vala_assert (index < ((guint) _tmp0_), "index < n_cells");
	_tmp2_ = self->priv->status;
	_tmp2__length1 = self->priv->status_length1;
	_tmp3_ = _tmp2_[index];
	if (_tmp3_ == GNONOGRAMS_CELL_STATE_COMPLETED) {
		_tmp1_ = GNONOGRAMS_CELL_STATE_FILLED;
	} else {
		GnonogramsCellState* _tmp4_;
		gint _tmp4__length1;
		GnonogramsCellState _tmp5_;
		_tmp4_ = self->priv->status;
		_tmp4__length1 = self->priv->status_length1;
		_tmp5_ = _tmp4_[index];
		_tmp1_ = _tmp5_;
	}
	result = _tmp1_;
	return result;
}

gchar*
gnonograms_region_to_string (GnonogramsRegion* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GString* _tmp4_;
	GString* _tmp14_;
	GString* _tmp24_;
	GString* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	_tmp1_ = sb;
	_tmp2_ = gnonograms_region_get_id (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = sb;
	g_string_append (_tmp4_, "\n\r status before:\n\r");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				GString* _tmp8_;
				GnonogramsCellState* _tmp9_;
				gint _tmp9__length1;
				GnonogramsCellState _tmp10_;
				GEnumValue* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->priv->_n_cells;
				if (!(i < _tmp7_)) {
					break;
				}
				_tmp8_ = sb;
				_tmp9_ = self->priv->temp_status;
				_tmp9__length1 = self->priv->temp_status_length1;
				_tmp10_ = _tmp9_[i];
				_tmp11_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_CELL_STATE), _tmp10_);
				_tmp12_ = g_strconcat ((_tmp11_ != NULL) ? _tmp11_->value_name : NULL, "\n\r", NULL);
				_tmp13_ = _tmp12_;
				g_string_append (_tmp8_, _tmp13_);
				_g_free0 (_tmp13_);
			}
		}
	}
	_tmp14_ = sb;
	g_string_append (_tmp14_, "\n\r status now:\n\r");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				GString* _tmp18_;
				GnonogramsCellState* _tmp19_;
				gint _tmp19__length1;
				GnonogramsCellState _tmp20_;
				GEnumValue* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = i;
					i = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = self->priv->_n_cells;
				if (!(i < _tmp17_)) {
					break;
				}
				_tmp18_ = sb;
				_tmp19_ = self->priv->status;
				_tmp19__length1 = self->priv->status_length1;
				_tmp20_ = _tmp19_[i];
				_tmp21_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_CELL_STATE), _tmp20_);
				_tmp22_ = g_strconcat ((_tmp21_ != NULL) ? _tmp21_->value_name : NULL, "\n\r", NULL);
				_tmp23_ = _tmp22_;
				g_string_append (_tmp18_, _tmp23_);
				_g_free0 (_tmp23_);
			}
		}
	}
	_tmp24_ = sb;
	g_string_append (_tmp24_, "\n\rCell Status and Tags:\n\r");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				GString* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				GString* _tmp35_;
				GnonogramsCellState* _tmp36_;
				gint _tmp36__length1;
				GnonogramsCellState _tmp37_;
				GEnumValue* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gint j = 0;
				GString* _tmp50_;
				gboolean* _tmp51_;
				gint _tmp51__length1;
				gint _tmp51__length2;
				gboolean _tmp52_;
				gint _tmp54_;
				gboolean* _tmp55_;
				gint _tmp55__length1;
				gint _tmp55__length2;
				gboolean _tmp56_;
				GString* _tmp58_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = self->priv->_n_cells;
				if (!(i < _tmp27_)) {
					break;
				}
				_tmp28_ = sb;
				_tmp29_ = g_strdup_printf ("%i", i);
				_tmp30_ = _tmp29_;
				_tmp31_ = g_strconcat ("Cell ", _tmp30_, NULL);
				_tmp32_ = _tmp31_;
				_tmp33_ = g_strconcat (_tmp32_, " Status: ", NULL);
				_tmp34_ = _tmp33_;
				g_string_append (_tmp28_, _tmp34_);
				_g_free0 (_tmp34_);
				_g_free0 (_tmp32_);
				_g_free0 (_tmp30_);
				_tmp35_ = sb;
				_tmp36_ = self->priv->status;
				_tmp36__length1 = self->priv->status_length1;
				_tmp37_ = _tmp36_[i];
				_tmp38_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_CELL_STATE), _tmp37_);
				_tmp39_ = g_strconcat ((_tmp38_ != NULL) ? _tmp38_->value_name : NULL, "\n\rOWNERS ", NULL);
				_tmp40_ = _tmp39_;
				g_string_append (_tmp35_, _tmp40_);
				_g_free0 (_tmp40_);
				{
					gboolean _tmp41_ = FALSE;
					j = 0;
					_tmp41_ = TRUE;
					while (TRUE) {
						gboolean* _tmp43_;
						gint _tmp43__length1;
						gint _tmp43__length2;
						gboolean _tmp44_;
						if (!_tmp41_) {
							gint _tmp42_;
							_tmp42_ = j;
							j = _tmp42_ + 1;
						}
						_tmp41_ = FALSE;
						if (!(j < self->priv->n_blocks)) {
							break;
						}
						_tmp43_ = self->priv->tags;
						_tmp43__length1 = self->priv->tags_length1;
						_tmp43__length2 = self->priv->tags_length2;
						_tmp44_ = _tmp43_[(i * _tmp43__length2) + j];
						if (_tmp44_) {
							GString* _tmp45_;
							gint* _tmp46_;
							gint _tmp46__length1;
							gint _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
							_tmp45_ = sb;
							_tmp46_ = self->priv->blocks;
							_tmp46__length1 = self->priv->blocks_length1;
							_tmp47_ = _tmp46_[j];
							_tmp48_ = g_strdup_printf ("[%i]", _tmp47_);
							_tmp49_ = _tmp48_;
							g_string_append (_tmp45_, _tmp49_);
							_g_free0 (_tmp49_);
						}
					}
				}
				_tmp50_ = sb;
				g_string_append (_tmp50_, " : ");
				_tmp51_ = self->priv->tags;
				_tmp51__length1 = self->priv->tags_length1;
				_tmp51__length2 = self->priv->tags_length2;
				_tmp52_ = _tmp51_[(i * _tmp51__length2) + j];
				if (_tmp52_) {
					GString* _tmp53_;
					_tmp53_ = sb;
					g_string_append (_tmp53_, "ALLOW EMPTY ");
				}
				_tmp54_ = j;
				j = _tmp54_ + 1;
				_tmp55_ = self->priv->tags;
				_tmp55__length1 = self->priv->tags_length1;
				_tmp55__length2 = self->priv->tags_length2;
				_tmp56_ = _tmp55_[(i * _tmp55__length2) + j];
				if (_tmp56_) {
					GString* _tmp57_;
					_tmp57_ = sb;
					g_string_append (_tmp57_, "COMPLETE");
				}
				_tmp58_ = sb;
				g_string_append (_tmp58_, "\n\r");
			}
		}
	}
	_tmp59_ = sb;
	_tmp60_ = _tmp59_->str;
	_tmp61_ = g_strdup (_tmp60_);
	result = _tmp61_;
	_g_string_free0 (sb);
	return result;
}

/** Try and choose more restricted regions to permute to reduce number of possible
      * combinations.
    **/
static guint
gnonograms_region_calc_value_as_permute_region (GnonogramsRegion* self)
{
	gboolean _tmp0_;
	gint n_available_ranges = 0;
	gint block_extent = 0;
	gint count = 0;
	gint largest = 0;
	gint pvalue = 0;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_is_completed;
	if (_tmp0_) {
		result = (guint) 0;
		return result;
	}
	n_available_ranges = gnonograms_region_count_available_ranges (self, FALSE);
	if (n_available_ranges != 1) {
		result = (guint) 0;
		return result;
	}
	block_extent = 0;
	count = 0;
	largest = 0;
	{
		gint b = 0;
		b = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gboolean _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = b;
					b = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(b < self->priv->n_blocks)) {
					break;
				}
				_tmp3_ = self->priv->completed_blocks;
				_tmp3__length1 = self->priv->completed_blocks_length1;
				_tmp4_ = _tmp3_[b];
				if (!_tmp4_) {
					gint* _tmp5_;
					gint _tmp5__length1;
					gint _tmp6_;
					gint _tmp7_;
					gint* _tmp8_;
					gint _tmp8__length1;
					gint _tmp9_;
					_tmp5_ = self->priv->blocks;
					_tmp5__length1 = self->priv->blocks_length1;
					_tmp6_ = _tmp5_[b];
					block_extent += _tmp6_;
					_tmp7_ = count;
					count = _tmp7_ + 1;
					_tmp8_ = self->priv->blocks;
					_tmp8__length1 = self->priv->blocks_length1;
					_tmp9_ = _tmp8_[b];
					largest = MAX (largest, _tmp9_);
				}
			}
		}
	}
	pvalue = (largest - 1) * block_extent;
	if (count == 1) {
		pvalue = pvalue * 2;
	}
	result = (guint) pvalue;
	return result;
}

static void
gnonograms_region_initial_fix (GnonogramsRegion* self)
{
	gint freedom = 0;
	gint _tmp0_;
	gint start = 0;
	gint length = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_n_cells;
	freedom = _tmp0_ - self->priv->block_extent;
	start = 0;
	length = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint* _tmp3_;
				gint _tmp3__length1;
				gint _tmp4_;
				gint* _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				gint* _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp3_ = self->priv->blocks;
				_tmp3__length1 = self->priv->blocks_length1;
				_tmp4_ = _tmp3_[i];
				length = _tmp4_ + freedom;
				{
					gint j = 0;
					j = start;
					{
						gboolean _tmp5_ = FALSE;
						_tmp5_ = TRUE;
						while (TRUE) {
							gboolean* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							if (!_tmp5_) {
								gint _tmp6_;
								_tmp6_ = j;
								j = _tmp6_ + 1;
							}
							_tmp5_ = FALSE;
							if (!(j < (start + length))) {
								break;
							}
							_tmp7_ = self->priv->tags;
							_tmp7__length1 = self->priv->tags_length1;
							_tmp7__length2 = self->priv->tags_length2;
							_tmp7_[(j * _tmp7__length2) + i] = TRUE;
						}
					}
				}
				_tmp8_ = self->priv->blocks;
				_tmp8__length1 = self->priv->blocks_length1;
				_tmp9_ = _tmp8_[i];
				if (freedom < _tmp9_) {
					gint* _tmp10_;
					gint _tmp10__length1;
					gint _tmp11_;
					_tmp10_ = self->priv->blocks;
					_tmp10__length1 = self->priv->blocks_length1;
					_tmp11_ = _tmp10_[i];
					gnonograms_region_set_range_owner (self, i, start + freedom, _tmp11_ - freedom, TRUE, FALSE);
				}
				_tmp12_ = self->priv->blocks;
				_tmp12__length1 = self->priv->blocks_length1;
				_tmp13_ = _tmp12_[i];
				start = (start + _tmp13_) + 1;
			}
		}
	}
	if (freedom == 0) {
		gnonograms_region_set_is_completed (self, TRUE);
	}
}

static gboolean
gnonograms_region_full_fix (GnonogramsRegion* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (gnonograms_region_do_edge (self, 1)) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_;
		_tmp1_ = self->priv->_in_error;
		_tmp0_ = _tmp1_;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_do_edge (self, -1)) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->priv->_in_error;
		_tmp2_ = _tmp3_;
	}
	if (_tmp2_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_available_filled_subregion_audit (self)) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp5_;
		_tmp5_ = self->priv->_in_error;
		_tmp4_ = _tmp5_;
	}
	if (_tmp4_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_possibilities_audit (self)) {
		_tmp6_ = TRUE;
	} else {
		gboolean _tmp7_;
		_tmp7_ = self->priv->_in_error;
		_tmp6_ = _tmp7_;
	}
	if (_tmp6_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_fill_gaps (self)) {
		_tmp8_ = TRUE;
	} else {
		gboolean _tmp9_;
		_tmp9_ = self->priv->_in_error;
		_tmp8_ = _tmp9_;
	}
	if (_tmp8_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_only_possibility (self)) {
		_tmp10_ = TRUE;
	} else {
		gboolean _tmp11_;
		_tmp11_ = self->priv->_in_error;
		_tmp10_ = _tmp11_;
	}
	if (_tmp10_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_free_cell_audit (self)) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp13_;
		_tmp13_ = self->priv->_in_error;
		_tmp12_ = _tmp13_;
	}
	if (_tmp12_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_fix_blocks_in_ranges (self)) {
		_tmp14_ = TRUE;
	} else {
		gboolean _tmp15_;
		_tmp15_ = self->priv->_in_error;
		_tmp14_ = _tmp15_;
	}
	if (_tmp14_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_capped_range_audit (self)) {
		_tmp16_ = TRUE;
	} else {
		gboolean _tmp17_;
		_tmp17_ = self->priv->_in_error;
		_tmp16_ = _tmp17_;
	}
	if (_tmp16_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_filled_subregion_audit (self)) {
		_tmp18_ = TRUE;
	} else {
		gboolean _tmp19_;
		_tmp19_ = self->priv->_in_error;
		_tmp18_ = _tmp19_;
	}
	if (_tmp18_) {
		result = TRUE;
		return result;
	}
	if (gnonograms_region_check_collisions (self)) {
		_tmp20_ = TRUE;
	} else {
		gboolean _tmp21_;
		_tmp21_ = self->priv->_in_error;
		_tmp20_ = _tmp21_;
	}
	if (_tmp20_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_filled_subregion_audit (GnonogramsRegion* self)
{
	gboolean changed = FALSE;
	gboolean start_is_capped = FALSE;
	gboolean end_is_capped = FALSE;
	gint length = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	self->priv->current_index = 0;
	while (TRUE) {
		gint _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gboolean* _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		gboolean _tmp4_;
		gboolean _tmp6_ = FALSE;
		gint lastcell = 0;
		gboolean _tmp9_ = FALSE;
		gint _tmp10_;
		gboolean _tmp13_ = FALSE;
		_tmp0_ = self->priv->_n_cells;
		if (!(self->priv->current_index < _tmp0_)) {
			break;
		}
		start_is_capped = FALSE;
		end_is_capped = FALSE;
		_tmp1_ = self->priv->_n_cells;
		self->priv->current_index = gnonograms_region_seek_next_required_status (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, self->priv->current_index, _tmp1_, 1);
		_tmp2_ = self->priv->_n_cells;
		if (self->priv->current_index == _tmp2_) {
			break;
		}
		_tmp3_ = self->priv->tags;
		_tmp3__length1 = self->priv->tags_length1;
		_tmp3__length2 = self->priv->tags_length2;
		_tmp4_ = _tmp3_[(self->priv->current_index * _tmp3__length2) + self->priv->is_finished_pointer];
		if (_tmp4_) {
			gint _tmp5_;
			_tmp5_ = self->priv->current_index;
			self->priv->current_index = _tmp5_ + 1;
			continue;
		}
		if (self->priv->current_index == 0) {
			_tmp6_ = TRUE;
		} else {
			GnonogramsCellState* _tmp7_;
			gint _tmp7__length1;
			GnonogramsCellState _tmp8_;
			_tmp7_ = self->priv->status;
			_tmp7__length1 = self->priv->status_length1;
			_tmp8_ = _tmp7_[self->priv->current_index - 1];
			_tmp6_ = _tmp8_ == GNONOGRAMS_CELL_STATE_EMPTY;
		}
		if (_tmp6_) {
			start_is_capped = TRUE;
		}
		length = gnonograms_region_count_consecutive_with_state_from (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, self->priv->current_index, TRUE);
		lastcell = (self->priv->current_index + length) - 1;
		_tmp10_ = self->priv->_n_cells;
		if (lastcell == (_tmp10_ - 1)) {
			_tmp9_ = TRUE;
		} else {
			GnonogramsCellState* _tmp11_;
			gint _tmp11__length1;
			GnonogramsCellState _tmp12_;
			_tmp11_ = self->priv->status;
			_tmp11__length1 = self->priv->status_length1;
			_tmp12_ = _tmp11_[lastcell + 1];
			_tmp9_ = _tmp12_ == GNONOGRAMS_CELL_STATE_EMPTY;
		}
		if (_tmp9_) {
			end_is_capped = TRUE;
		}
		if (start_is_capped) {
			_tmp13_ = end_is_capped;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			gnonograms_region_assign_and_cap_range (self, self->priv->current_index, length);
			self->priv->current_index = self->priv->current_index + (length + 1);
			continue;
		} else {
			gint largest = 0;
			gint start = 0;
			gint end = 0;
			gint _tmp33_;
			gboolean _tmp43_ = FALSE;
			largest = gnonograms_region_find_largest_possible_block_for_cell (self, self->priv->current_index);
			if (largest == length) {
				gnonograms_region_assign_and_cap_range (self, self->priv->current_index, length);
				self->priv->current_index = self->priv->current_index + (length + 1);
				changed = TRUE;
				continue;
			}
			start = self->priv->current_index;
			end = (self->priv->current_index + length) - 1;
			{
				gint bl = 0;
				bl = 0;
				{
					gboolean _tmp14_ = FALSE;
					_tmp14_ = TRUE;
					while (TRUE) {
						if (!_tmp14_) {
							gint _tmp15_;
							_tmp15_ = bl;
							bl = _tmp15_ + 1;
						}
						_tmp14_ = FALSE;
						if (!(bl < self->priv->n_blocks)) {
							break;
						}
						{
							gint i = 0;
							i = start;
							{
								gboolean _tmp16_ = FALSE;
								_tmp16_ = TRUE;
								while (TRUE) {
									gboolean _tmp18_ = FALSE;
									gboolean* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
									gboolean _tmp20_;
									if (!_tmp16_) {
										gint _tmp17_;
										_tmp17_ = i;
										i = _tmp17_ + 1;
									}
									_tmp16_ = FALSE;
									if (!(i <= end)) {
										break;
									}
									_tmp19_ = self->priv->tags;
									_tmp19__length1 = self->priv->tags_length1;
									_tmp19__length2 = self->priv->tags_length2;
									_tmp20_ = _tmp19_[(i * _tmp19__length2) + bl];
									if (_tmp20_) {
										gint* _tmp21_;
										gint _tmp21__length1;
										gint _tmp22_;
										_tmp21_ = self->priv->blocks;
										_tmp21__length1 = self->priv->blocks_length1;
										_tmp22_ = _tmp21_[bl];
										_tmp18_ = _tmp22_ < length;
									} else {
										_tmp18_ = FALSE;
									}
									if (_tmp18_) {
										gboolean* _tmp23_;
										gint _tmp23__length1;
										gint _tmp23__length2;
										_tmp23_ = self->priv->tags;
										_tmp23__length1 = self->priv->tags_length1;
										_tmp23__length2 = self->priv->tags_length2;
										_tmp23_[(i * _tmp23__length2) + bl] = FALSE;
									}
								}
							}
						}
					}
				}
			}
			if (start > 0) {
				gint _tmp24_;
				_tmp24_ = start;
				start = _tmp24_ - 1;
				{
					gint bl = 0;
					bl = 0;
					{
						gboolean _tmp25_ = FALSE;
						_tmp25_ = TRUE;
						while (TRUE) {
							gboolean _tmp27_ = FALSE;
							gboolean* _tmp28_;
							gint _tmp28__length1;
							gint _tmp28__length2;
							gboolean _tmp29_;
							if (!_tmp25_) {
								gint _tmp26_;
								_tmp26_ = bl;
								bl = _tmp26_ + 1;
							}
							_tmp25_ = FALSE;
							if (!(bl < self->priv->n_blocks)) {
								break;
							}
							_tmp28_ = self->priv->tags;
							_tmp28__length1 = self->priv->tags_length1;
							_tmp28__length2 = self->priv->tags_length2;
							_tmp29_ = _tmp28_[(start * _tmp28__length2) + bl];
							if (_tmp29_) {
								gint* _tmp30_;
								gint _tmp30__length1;
								gint _tmp31_;
								_tmp30_ = self->priv->blocks;
								_tmp30__length1 = self->priv->blocks_length1;
								_tmp31_ = _tmp30_[bl];
								_tmp27_ = _tmp31_ < (length + 1);
							} else {
								_tmp27_ = FALSE;
							}
							if (_tmp27_) {
								gboolean* _tmp32_;
								gint _tmp32__length1;
								gint _tmp32__length2;
								_tmp32_ = self->priv->tags;
								_tmp32__length1 = self->priv->tags_length1;
								_tmp32__length2 = self->priv->tags_length2;
								_tmp32_[(start * _tmp32__length2) + bl] = FALSE;
							}
						}
					}
				}
			}
			_tmp33_ = self->priv->_n_cells;
			if (end < (_tmp33_ - 1)) {
				gint _tmp34_;
				_tmp34_ = end;
				end = _tmp34_ + 1;
				{
					gint bl = 0;
					bl = 0;
					{
						gboolean _tmp35_ = FALSE;
						_tmp35_ = TRUE;
						while (TRUE) {
							gboolean _tmp37_ = FALSE;
							gboolean* _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							gboolean _tmp39_;
							if (!_tmp35_) {
								gint _tmp36_;
								_tmp36_ = bl;
								bl = _tmp36_ + 1;
							}
							_tmp35_ = FALSE;
							if (!(bl < self->priv->n_blocks)) {
								break;
							}
							_tmp38_ = self->priv->tags;
							_tmp38__length1 = self->priv->tags_length1;
							_tmp38__length2 = self->priv->tags_length2;
							_tmp39_ = _tmp38_[(end * _tmp38__length2) + bl];
							if (_tmp39_) {
								gint* _tmp40_;
								gint _tmp40__length1;
								gint _tmp41_;
								_tmp40_ = self->priv->blocks;
								_tmp40__length1 = self->priv->blocks_length1;
								_tmp41_ = _tmp40_[bl];
								_tmp37_ = _tmp41_ < (length + 1);
							} else {
								_tmp37_ = FALSE;
							}
							if (_tmp37_) {
								gboolean* _tmp42_;
								gint _tmp42__length1;
								gint _tmp42__length2;
								_tmp42_ = self->priv->tags;
								_tmp42__length1 = self->priv->tags_length1;
								_tmp42__length2 = self->priv->tags_length2;
								_tmp42_[(end * _tmp42__length2) + bl] = FALSE;
							}
						}
					}
				}
			}
			if (start_is_capped) {
				_tmp43_ = TRUE;
			} else {
				_tmp43_ = end_is_capped;
			}
			if (_tmp43_) {
				gint smallest = 0;
				smallest = gnonograms_region_find_smallest_possible_block_for_cell (self, self->priv->current_index);
				if (smallest > length) {
					gint ptr = 0;
					if (start_is_capped) {
						ptr = self->priv->current_index + length;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp44_ = FALSE;
								_tmp44_ = TRUE;
								while (TRUE) {
									gint _tmp46_;
									if (!_tmp44_) {
										gint _tmp45_;
										_tmp45_ = i;
										i = _tmp45_ + 1;
									}
									_tmp44_ = FALSE;
									if (!(i < (smallest - length))) {
										break;
									}
									_tmp46_ = self->priv->_n_cells;
									if (ptr < _tmp46_) {
										gboolean* _tmp47_;
										gint _tmp47__length1;
										gint _tmp47__length2;
										gint _tmp48_;
										_tmp47_ = self->priv->tags;
										_tmp47__length1 = self->priv->tags_length1;
										_tmp47__length2 = self->priv->tags_length2;
										_tmp47_[(ptr * _tmp47__length2) + self->priv->can_be_empty_pointer] = FALSE;
										_tmp48_ = ptr;
										ptr = _tmp48_ + 1;
									}
								}
							}
						}
					} else {
						ptr = self->priv->current_index - 1;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp49_ = FALSE;
								_tmp49_ = TRUE;
								while (TRUE) {
									if (!_tmp49_) {
										gint _tmp50_;
										_tmp50_ = i;
										i = _tmp50_ + 1;
									}
									_tmp49_ = FALSE;
									if (!(i < (smallest - length))) {
										break;
									}
									if (ptr >= 0) {
										gboolean* _tmp51_;
										gint _tmp51__length1;
										gint _tmp51__length2;
										gint _tmp52_;
										_tmp51_ = self->priv->tags;
										_tmp51__length1 = self->priv->tags_length1;
										_tmp51__length2 = self->priv->tags_length2;
										_tmp51_[(ptr * _tmp51__length2) + self->priv->can_be_empty_pointer] = FALSE;
										_tmp52_ = ptr;
										ptr = _tmp52_ - 1;
									}
								}
							}
						}
					}
					gnonograms_region_tags_to_status (self);
					changed = TRUE;
				}
			}
		}
		self->priv->current_index = self->priv->current_index + length;
	}
	result = changed;
	return result;
}

static gboolean
gnonograms_region_fill_gaps (GnonogramsRegion* self)
{
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	{
		gint idx = 0;
		idx = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState _tmp4_;
				GnonogramsCellState* _tmp5_;
				gint _tmp5__length1;
				GnonogramsCellState _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = idx;
					idx = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(idx < (_tmp2_ - 2))) {
					break;
				}
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = _tmp3_[idx];
				if (_tmp4_ != GNONOGRAMS_CELL_STATE_FILLED) {
					continue;
				}
				_tmp5_ = self->priv->status;
				_tmp5__length1 = self->priv->status_length1;
				_tmp6_ = _tmp5_[idx + 1];
				if (_tmp6_ != GNONOGRAMS_CELL_STATE_UNKNOWN) {
					continue;
				}
				if (gnonograms_region_get_sole_owner (self, idx) < 0) {
					GnonogramsCellState* _tmp7_;
					gint _tmp7__length1;
					GnonogramsCellState _tmp8_;
					gint block_length = 0;
					gboolean must_be_empty = FALSE;
					_tmp7_ = self->priv->status;
					_tmp7__length1 = self->priv->status_length1;
					_tmp8_ = _tmp7_[idx + 2];
					if (_tmp8_ != GNONOGRAMS_CELL_STATE_FILLED) {
						continue;
					}
					block_length = (gnonograms_region_count_consecutive_with_state_from (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, idx + 2, TRUE) + gnonograms_region_count_consecutive_with_state_from (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, idx, FALSE)) + 1;
					must_be_empty = TRUE;
					{
						gint bl = 0;
						bl = 0;
						{
							gboolean _tmp9_ = FALSE;
							_tmp9_ = TRUE;
							while (TRUE) {
								gboolean _tmp11_ = FALSE;
								gboolean* _tmp12_;
								gint _tmp12__length1;
								gint _tmp12__length2;
								gboolean _tmp13_;
								if (!_tmp9_) {
									gint _tmp10_;
									_tmp10_ = bl;
									bl = _tmp10_ + 1;
								}
								_tmp9_ = FALSE;
								if (!(bl < self->priv->n_blocks)) {
									break;
								}
								_tmp12_ = self->priv->tags;
								_tmp12__length1 = self->priv->tags_length1;
								_tmp12__length2 = self->priv->tags_length2;
								_tmp13_ = _tmp12_[(idx * _tmp12__length2) + bl];
								if (_tmp13_) {
									gint* _tmp14_;
									gint _tmp14__length1;
									gint _tmp15_;
									_tmp14_ = self->priv->blocks;
									_tmp14__length1 = self->priv->blocks_length1;
									_tmp15_ = _tmp14_[bl];
									_tmp11_ = _tmp15_ >= block_length;
								} else {
									_tmp11_ = FALSE;
								}
								if (_tmp11_) {
									must_be_empty = FALSE;
									break;
								}
							}
						}
					}
					if (must_be_empty) {
						gnonograms_region_set_cell_empty (self, idx + 1);
						changed = TRUE;
					} else {
						gboolean must_not_be_empty = FALSE;
						gint length_to_the_left = 0;
						gint length_to_the_right = 0;
						gint ptr = 0;
						gint count_to_the_left = 0;
						gint count_to_the_right = 0;
						gint total_count = 0;
						must_not_be_empty = FALSE;
						length_to_the_left = 0;
						length_to_the_right = 0;
						ptr = idx;
						while (TRUE) {
							gboolean _tmp16_ = FALSE;
							gint _tmp19_;
							gint _tmp20_;
							if (ptr >= 0) {
								gboolean* _tmp17_;
								gint _tmp17__length1;
								gint _tmp17__length2;
								gboolean _tmp18_;
								_tmp17_ = self->priv->tags;
								_tmp17__length1 = self->priv->tags_length1;
								_tmp17__length2 = self->priv->tags_length2;
								_tmp18_ = _tmp17_[(ptr * _tmp17__length2) + self->priv->is_finished_pointer];
								_tmp16_ = !_tmp18_;
							} else {
								_tmp16_ = FALSE;
							}
							if (!_tmp16_) {
								break;
							}
							_tmp19_ = ptr;
							ptr = _tmp19_ - 1;
							_tmp20_ = length_to_the_left;
							length_to_the_left = _tmp20_ + 1;
						}
						ptr = idx + 2;
						while (TRUE) {
							gboolean _tmp21_ = FALSE;
							gint _tmp22_;
							gint _tmp25_;
							gint _tmp26_;
							_tmp22_ = self->priv->_n_cells;
							if (ptr < _tmp22_) {
								gboolean* _tmp23_;
								gint _tmp23__length1;
								gint _tmp23__length2;
								gboolean _tmp24_;
								_tmp23_ = self->priv->tags;
								_tmp23__length1 = self->priv->tags_length1;
								_tmp23__length2 = self->priv->tags_length2;
								_tmp24_ = _tmp23_[(ptr * _tmp23__length2) + self->priv->is_finished_pointer];
								_tmp21_ = !_tmp24_;
							} else {
								_tmp21_ = FALSE;
							}
							if (!_tmp21_) {
								break;
							}
							_tmp25_ = ptr;
							ptr = _tmp25_ + 1;
							_tmp26_ = length_to_the_right;
							length_to_the_right = _tmp26_ + 1;
						}
						count_to_the_left = 0;
						count_to_the_right = 0;
						ptr = idx;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp27_ = FALSE;
								_tmp27_ = TRUE;
								while (TRUE) {
									gboolean _tmp29_ = FALSE;
									gboolean* _tmp30_;
									gint _tmp30__length1;
									gint _tmp30__length2;
									gboolean _tmp31_;
									if (!_tmp27_) {
										gint _tmp28_;
										_tmp28_ = i;
										i = _tmp28_ + 1;
									}
									_tmp27_ = FALSE;
									if (!(i < self->priv->n_blocks)) {
										break;
									}
									_tmp30_ = self->priv->tags;
									_tmp30__length1 = self->priv->tags_length1;
									_tmp30__length2 = self->priv->tags_length2;
									_tmp31_ = _tmp30_[(ptr * _tmp30__length2) + i];
									if (_tmp31_) {
										gint* _tmp32_;
										gint _tmp32__length1;
										gint _tmp33_;
										_tmp32_ = self->priv->blocks;
										_tmp32__length1 = self->priv->blocks_length1;
										_tmp33_ = _tmp32_[i];
										_tmp29_ = _tmp33_ <= length_to_the_left;
									} else {
										_tmp29_ = FALSE;
									}
									if (_tmp29_) {
										gint _tmp34_;
										_tmp34_ = count_to_the_left;
										count_to_the_left = _tmp34_ + 1;
									}
								}
							}
						}
						ptr = idx + 2;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp35_ = FALSE;
								_tmp35_ = TRUE;
								while (TRUE) {
									gboolean _tmp37_ = FALSE;
									gboolean* _tmp38_;
									gint _tmp38__length1;
									gint _tmp38__length2;
									gboolean _tmp39_;
									if (!_tmp35_) {
										gint _tmp36_;
										_tmp36_ = i;
										i = _tmp36_ + 1;
									}
									_tmp35_ = FALSE;
									if (!(i < self->priv->n_blocks)) {
										break;
									}
									_tmp38_ = self->priv->tags;
									_tmp38__length1 = self->priv->tags_length1;
									_tmp38__length2 = self->priv->tags_length2;
									_tmp39_ = _tmp38_[(ptr * _tmp38__length2) + i];
									if (_tmp39_) {
										gint* _tmp40_;
										gint _tmp40__length1;
										gint _tmp41_;
										_tmp40_ = self->priv->blocks;
										_tmp40__length1 = self->priv->blocks_length1;
										_tmp41_ = _tmp40_[i];
										_tmp37_ = _tmp41_ <= length_to_the_right;
									} else {
										_tmp37_ = FALSE;
									}
									if (_tmp37_) {
										gint _tmp42_;
										_tmp42_ = count_to_the_right;
										count_to_the_right = _tmp42_ + 1;
									}
								}
							}
						}
						total_count = count_to_the_left + count_to_the_right;
						if (total_count == 2) {
							{
								gint i = 0;
								i = 0;
								{
									gboolean _tmp43_ = FALSE;
									_tmp43_ = TRUE;
									while (TRUE) {
										gboolean _tmp45_ = FALSE;
										gboolean* _tmp46_;
										gint _tmp46__length1;
										gint _tmp46__length2;
										gboolean _tmp47_;
										if (!_tmp43_) {
											gint _tmp44_;
											_tmp44_ = i;
											i = _tmp44_ + 1;
										}
										_tmp43_ = FALSE;
										if (!(i < self->priv->n_blocks)) {
											break;
										}
										_tmp46_ = self->priv->tags;
										_tmp46__length1 = self->priv->tags_length1;
										_tmp46__length2 = self->priv->tags_length2;
										_tmp47_ = _tmp46_[(ptr * _tmp46__length2) + i];
										if (_tmp47_) {
											gint* _tmp48_;
											gint _tmp48__length1;
											gint _tmp49_;
											_tmp48_ = self->priv->blocks;
											_tmp48__length1 = self->priv->blocks_length1;
											_tmp49_ = _tmp48_[i];
											_tmp45_ = _tmp49_ <= length_to_the_right;
										} else {
											_tmp45_ = FALSE;
										}
										if (_tmp45_) {
											gboolean _tmp50_ = FALSE;
											gboolean* _tmp51_;
											gint _tmp51__length1;
											gint _tmp51__length2;
											gboolean _tmp52_;
											_tmp51_ = self->priv->tags;
											_tmp51__length1 = self->priv->tags_length1;
											_tmp51__length2 = self->priv->tags_length2;
											_tmp52_ = _tmp51_[(idx * _tmp51__length2) + i];
											if (_tmp52_) {
												gint* _tmp53_;
												gint _tmp53__length1;
												gint _tmp54_;
												_tmp53_ = self->priv->blocks;
												_tmp53__length1 = self->priv->blocks_length1;
												_tmp54_ = _tmp53_[i];
												_tmp50_ = _tmp54_ <= length_to_the_left;
											} else {
												_tmp50_ = FALSE;
											}
											if (_tmp50_) {
												must_not_be_empty = TRUE;
											}
										}
									}
								}
							}
						} else {
							if (total_count < 2) {
								must_not_be_empty = TRUE;
							}
						}
						if (must_not_be_empty) {
							gboolean* _tmp55_;
							gint _tmp55__length1;
							gint _tmp55__length2;
							_tmp55_ = self->priv->tags;
							_tmp55__length1 = self->priv->tags_length1;
							_tmp55__length2 = self->priv->tags_length2;
							_tmp55_[((idx + 1) * _tmp55__length2) + self->priv->can_be_empty_pointer] = FALSE;
							changed = TRUE;
						}
					}
					idx += 2;
				} else {
					gint cell1 = 0;
					gint _tmp56_;
					GnonogramsCellState* _tmp62_;
					gint _tmp62__length1;
					GnonogramsCellState _tmp63_;
					cell1 = idx;
					_tmp56_ = idx;
					idx = _tmp56_ + 1;
					while (TRUE) {
						gboolean _tmp57_ = FALSE;
						gint _tmp58_;
						gint _tmp61_;
						_tmp58_ = self->priv->_n_cells;
						if (idx < (_tmp58_ - 1)) {
							GnonogramsCellState* _tmp59_;
							gint _tmp59__length1;
							GnonogramsCellState _tmp60_;
							_tmp59_ = self->priv->status;
							_tmp59__length1 = self->priv->status_length1;
							_tmp60_ = _tmp59_[idx];
							_tmp57_ = _tmp60_ == GNONOGRAMS_CELL_STATE_UNKNOWN;
						} else {
							_tmp57_ = FALSE;
						}
						if (!_tmp57_) {
							break;
						}
						_tmp61_ = idx;
						idx = _tmp61_ + 1;
					}
					_tmp62_ = self->priv->status;
					_tmp62__length1 = self->priv->status_length1;
					_tmp63_ = _tmp62_[idx];
					if (_tmp63_ != GNONOGRAMS_CELL_STATE_FILLED) {
						continue;
					} else {
						gint owner = 0;
						gint _tmp65_;
						owner = gnonograms_region_have_same_owner (self, cell1, idx);
						if (owner >= 0) {
							gboolean _tmp64_ = FALSE;
							if (gnonograms_region_set_range_owner (self, owner, cell1, (idx - cell1) + 1, TRUE, FALSE)) {
								_tmp64_ = TRUE;
							} else {
								_tmp64_ = changed;
							}
							changed = _tmp64_;
						}
						_tmp65_ = idx;
						idx = _tmp65_ - 1;
					}
				}
			}
		}
	}
	result = changed;
	return result;
}

static gboolean
gnonograms_region_possibilities_audit (GnonogramsRegion* self)
{
	gint start = 0;
	gint length = 0;
	gint count = 0;
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp2_ = self->priv->completed_blocks;
				_tmp2__length1 = self->priv->completed_blocks_length1;
				_tmp3_ = _tmp2_[i];
				if (_tmp3_) {
					continue;
				}
				start = 0;
				length = 0;
				count = 0;
				{
					gint idx = 0;
					idx = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gint _tmp6_;
							gboolean _tmp7_ = FALSE;
							gboolean* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gboolean _tmp9_;
							gint s = 0;
							gint l = 0;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp13_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = idx;
								idx = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = self->priv->_n_cells;
							if (!(idx < _tmp6_)) {
								break;
							}
							if (count > 1) {
								break;
							}
							_tmp8_ = self->priv->tags;
							_tmp8__length1 = self->priv->tags_length1;
							_tmp8__length2 = self->priv->tags_length2;
							_tmp9_ = _tmp8_[(idx * _tmp8__length2) + i];
							if (!_tmp9_) {
								_tmp7_ = TRUE;
							} else {
								gboolean* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gboolean _tmp11_;
								_tmp10_ = self->priv->tags;
								_tmp10__length1 = self->priv->tags_length1;
								_tmp10__length2 = self->priv->tags_length2;
								_tmp11_ = _tmp10_[(idx * _tmp10__length2) + self->priv->is_finished_pointer];
								_tmp7_ = _tmp11_;
							}
							if (_tmp7_) {
								continue;
							}
							s = idx;
							l = gnonograms_region_count_contiguous_with_same_owner_from (self, i, idx);
							_tmp12_ = self->priv->blocks;
							_tmp12__length1 = self->priv->blocks_length1;
							_tmp13_ = _tmp12_[i];
							if (l < _tmp13_) {
								gnonograms_region_remove_block_from_range (self, i, s, l, 1);
							} else {
								gint _tmp14_;
								length = l;
								start = s;
								_tmp14_ = count;
								count = _tmp14_ + 1;
							}
							idx += l - 1;
						}
					}
				}
				if (count != 1) {
					continue;
				} else {
					gboolean _tmp15_ = FALSE;
					if (gnonograms_region_fix_block_in_range (self, i, start, length)) {
						_tmp15_ = TRUE;
					} else {
						_tmp15_ = changed;
					}
					changed = _tmp15_;
				}
			}
		}
	}
	result = changed;
	return result;
}

static void
gnonograms_region_assign_and_cap_range (GnonogramsRegion* self,
                                        gint start,
                                        gint length)
{
	gint count = 0;
	gint* max_blocks = NULL;
	gint* _tmp0_;
	gint max_blocks_length1;
	gint _max_blocks_size_;
	gint first = 0;
	gint last = 0;
	gint end = 0;
	g_return_if_fail (self != NULL);
	count = 0;
	_tmp0_ = g_new0 (gint, self->priv->n_blocks);
	max_blocks = _tmp0_;
	max_blocks_length1 = self->priv->n_blocks;
	_max_blocks_size_ = max_blocks_length1;
	first = self->priv->n_blocks;
	last = 0;
	end = (start + length) - 1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gboolean _tmp4_;
				gint* _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean* _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gboolean _tmp9_;
				gint* _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp3_ = self->priv->completed_blocks;
				_tmp3__length1 = self->priv->completed_blocks_length1;
				_tmp4_ = _tmp3_[i];
				if (_tmp4_) {
					continue;
				}
				_tmp5_ = self->priv->blocks;
				_tmp5__length1 = self->priv->blocks_length1;
				_tmp6_ = _tmp5_[i];
				if (_tmp6_ != length) {
					continue;
				}
				_tmp8_ = self->priv->tags;
				_tmp8__length1 = self->priv->tags_length1;
				_tmp8__length2 = self->priv->tags_length2;
				_tmp9_ = _tmp8_[(start * _tmp8__length2) + i];
				if (!_tmp9_) {
					_tmp7_ = TRUE;
				} else {
					gboolean* _tmp10_;
					gint _tmp10__length1;
					gint _tmp10__length2;
					gboolean _tmp11_;
					_tmp10_ = self->priv->tags;
					_tmp10__length1 = self->priv->tags_length1;
					_tmp10__length2 = self->priv->tags_length2;
					_tmp11_ = _tmp10_[(end * _tmp10__length2) + i];
					_tmp7_ = !_tmp11_;
				}
				if (_tmp7_) {
					continue;
				}
				_tmp12_ = max_blocks;
				_tmp12__length1 = max_blocks_length1;
				_tmp12_[count] = i;
				_tmp13_ = count;
				count = _tmp13_ + 1;
				if (i < first) {
					first = i;
				}
				if (i > last) {
					last = i;
				}
			}
		}
	}
	if (count == 0) {
		max_blocks = (g_free (max_blocks), NULL);
		return;
	}
	if (count == 1) {
		gint* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		_tmp14_ = max_blocks;
		_tmp14__length1 = max_blocks_length1;
		_tmp15_ = _tmp14_[0];
		gnonograms_region_set_block_complete_and_cap (self, _tmp15_, start, 1);
	} else {
		gint _tmp28_;
		{
			gint i = 0;
			i = last + 1;
			{
				gboolean _tmp16_ = FALSE;
				_tmp16_ = TRUE;
				while (TRUE) {
					if (!_tmp16_) {
						gint _tmp17_;
						_tmp17_ = i;
						i = _tmp17_ + 1;
					}
					_tmp16_ = FALSE;
					if (!(i < self->priv->n_blocks)) {
						break;
					}
					gnonograms_region_remove_block_from_cell_to_end (self, i, (start + length) - 1, -1);
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp18_ = FALSE;
				_tmp18_ = TRUE;
				while (TRUE) {
					if (!_tmp18_) {
						gint _tmp19_;
						_tmp19_ = i;
						i = _tmp19_ + 1;
					}
					_tmp18_ = FALSE;
					if (!(i < first)) {
						break;
					}
					gnonograms_region_remove_block_from_cell_to_end (self, i, start, 1);
				}
			}
		}
		{
			gint i = 0;
			i = first + 1;
			{
				gboolean _tmp20_ = FALSE;
				_tmp20_ = TRUE;
				while (TRUE) {
					gint* _tmp22_;
					gint _tmp22__length1;
					gint _tmp23_;
					if (!_tmp20_) {
						gint _tmp21_;
						_tmp21_ = i;
						i = _tmp21_ + 1;
					}
					_tmp20_ = FALSE;
					if (!(i < last)) {
						break;
					}
					_tmp22_ = self->priv->blocks;
					_tmp22__length1 = self->priv->blocks_length1;
					_tmp23_ = _tmp22_[i];
					if (_tmp23_ == length) {
						continue;
					}
					gnonograms_region_remove_block_from_range (self, i, start, length, 1);
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp24_ = FALSE;
				_tmp24_ = TRUE;
				while (TRUE) {
					gint* _tmp26_;
					gint _tmp26__length1;
					gint _tmp27_;
					if (!_tmp24_) {
						gint _tmp25_;
						_tmp25_ = i;
						i = _tmp25_ + 1;
					}
					_tmp24_ = FALSE;
					if (!(i < count)) {
						break;
					}
					_tmp26_ = max_blocks;
					_tmp26__length1 = max_blocks_length1;
					_tmp27_ = _tmp26_[i];
					gnonograms_region_set_range_owner (self, _tmp27_, start, length, FALSE, FALSE);
				}
			}
		}
		if (start > 0) {
			gnonograms_region_set_cell_empty (self, start - 1);
		}
		_tmp28_ = self->priv->_n_cells;
		if ((start + length) < _tmp28_) {
			gnonograms_region_set_cell_empty (self, start + length);
		}
	}
	max_blocks = (g_free (max_blocks), NULL);
}

static gboolean
gnonograms_region_only_possibility (GnonogramsRegion* self)
{
	gint owner = 0;
	gint length = 0;
	gint start = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				gboolean _tmp4_;
				GnonogramsCellState* _tmp5_;
				gint _tmp5__length1;
				GnonogramsCellState _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp3_ = self->priv->tags;
				_tmp3__length1 = self->priv->tags_length1;
				_tmp3__length2 = self->priv->tags_length2;
				_tmp4_ = _tmp3_[(i * _tmp3__length2) + self->priv->is_finished_pointer];
				if (_tmp4_) {
					continue;
				}
				_tmp5_ = self->priv->status;
				_tmp5__length1 = self->priv->status_length1;
				_tmp6_ = _tmp5_[i];
				if (_tmp6_ == GNONOGRAMS_CELL_STATE_FILLED) {
					owner = gnonograms_region_get_sole_owner (self, i);
					if (owner >= 0) {
						gint* _tmp7_;
						gint _tmp7__length1;
						gint _tmp8_;
						gint _tmp9_;
						_tmp7_ = self->priv->blocks;
						_tmp7__length1 = self->priv->blocks_length1;
						_tmp8_ = _tmp7_[owner];
						length = _tmp8_;
						start = i - length;
						if (start >= 0) {
							gnonograms_region_remove_block_from_cell_to_end (self, owner, start, GNONOGRAMS_REGION_BACKWARDS);
						}
						start = i + length;
						_tmp9_ = self->priv->_n_cells;
						if (start < _tmp9_) {
							gnonograms_region_remove_block_from_cell_to_end (self, owner, start, GNONOGRAMS_REGION_FORWARDS);
						}
					}
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_free_cell_audit (GnonogramsRegion* self)
{
	gint free_cells = 0;
	gint filled_cells = 0;
	gint completed_cells = 0;
	gint to_be_located = 0;
	gint _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	free_cells = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_UNKNOWN);
	if (free_cells == 0) {
		result = FALSE;
		return result;
	}
	filled_cells = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_FILLED);
	completed_cells = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_COMPLETED);
	_tmp0_ = self->priv->_block_total;
	to_be_located = (_tmp0_ - filled_cells) - completed_cells;
	if (free_cells == to_be_located) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp1_ = FALSE;
				_tmp1_ = TRUE;
				while (TRUE) {
					gint _tmp3_;
					gboolean _tmp4_ = FALSE;
					GnonogramsCellState* _tmp5_;
					gint _tmp5__length1;
					GnonogramsCellState _tmp6_;
					if (!_tmp1_) {
						gint _tmp2_;
						_tmp2_ = i;
						i = _tmp2_ + 1;
					}
					_tmp1_ = FALSE;
					_tmp3_ = self->priv->_n_cells;
					if (!(i < _tmp3_)) {
						break;
					}
					_tmp5_ = self->priv->status;
					_tmp5__length1 = self->priv->status_length1;
					_tmp6_ = _tmp5_[i];
					if (_tmp6_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
						_tmp4_ = TRUE;
					} else {
						GnonogramsCellState* _tmp7_;
						gint _tmp7__length1;
						GnonogramsCellState _tmp8_;
						_tmp7_ = self->priv->status;
						_tmp7__length1 = self->priv->status_length1;
						_tmp8_ = _tmp7_[i];
						_tmp4_ = _tmp8_ == GNONOGRAMS_CELL_STATE_FILLED;
					}
					if (_tmp4_) {
						gnonograms_region_set_cell_complete (self, i);
					}
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp9_ = FALSE;
				_tmp9_ = TRUE;
				while (TRUE) {
					gboolean* _tmp11_;
					gint _tmp11__length1;
					if (!_tmp9_) {
						gint _tmp10_;
						_tmp10_ = i;
						i = _tmp10_ + 1;
					}
					_tmp9_ = FALSE;
					if (!(i < self->priv->n_blocks)) {
						break;
					}
					_tmp11_ = self->priv->completed_blocks;
					_tmp11__length1 = self->priv->completed_blocks_length1;
					_tmp11_[i] = TRUE;
				}
			}
		}
		result = TRUE;
		return result;
	} else {
		if (to_be_located == 0) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp12_ = FALSE;
					_tmp12_ = TRUE;
					while (TRUE) {
						gint _tmp14_;
						GnonogramsCellState* _tmp15_;
						gint _tmp15__length1;
						GnonogramsCellState _tmp16_;
						if (!_tmp12_) {
							gint _tmp13_;
							_tmp13_ = i;
							i = _tmp13_ + 1;
						}
						_tmp12_ = FALSE;
						_tmp14_ = self->priv->_n_cells;
						if (!(i < _tmp14_)) {
							break;
						}
						_tmp15_ = self->priv->status;
						_tmp15__length1 = self->priv->status_length1;
						_tmp16_ = _tmp15_[i];
						if (_tmp16_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
							gnonograms_region_set_cell_empty (self, i);
						}
					}
				}
			}
			result = TRUE;
			return result;
		}
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_do_edge (GnonogramsRegion* self,
                           gint direction)
{
	gint limit = 0;
	gboolean dir = FALSE;
	GnonogramsCellState* _tmp2_;
	gint _tmp2__length1;
	GnonogramsCellState _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	dir = direction == GNONOGRAMS_REGION_FORWARDS;
	if (dir) {
		gint _tmp0_;
		self->priv->current_index = 0;
		self->priv->current_block_number = 0;
		_tmp0_ = self->priv->_n_cells;
		limit = _tmp0_;
	} else {
		gint _tmp1_;
		_tmp1_ = self->priv->_n_cells;
		self->priv->current_index = _tmp1_ - 1;
		self->priv->current_block_number = self->priv->n_blocks - 1;
		limit = -1;
	}
	if (!gnonograms_region_find_edge (self, limit, direction)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->status;
	_tmp2__length1 = self->priv->status_length1;
	_tmp3_ = _tmp2_[self->priv->current_index];
	if (_tmp3_ == GNONOGRAMS_CELL_STATE_FILLED) {
		result = gnonograms_region_set_block_complete_and_cap (self, self->priv->current_block_number, self->priv->current_index, direction);
		return result;
	} else {
		gint start_of_edge = 0;
		gint start_of_filling = 0;
		gint block_length = 0;
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp5_;
		gint _tmp6_ = 0;
		gint blocklimit = 0;
		gboolean _tmp7_ = FALSE;
		start_of_edge = self->priv->current_index;
		start_of_filling = -1;
		_tmp4_ = self->priv->blocks;
		_tmp4__length1 = self->priv->blocks_length1;
		_tmp5_ = _tmp4_[self->priv->current_block_number];
		block_length = _tmp5_;
		if (dir) {
			_tmp6_ = self->priv->current_index + block_length;
		} else {
			_tmp6_ = self->priv->current_index - block_length;
		}
		blocklimit = _tmp6_;
		if (blocklimit < -1) {
			gint _tmp8_;
			_tmp8_ = self->priv->_n_cells;
			_tmp7_ = blocklimit > _tmp8_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			gchar* _tmp9_;
			gnonograms_region_set_in_error (self, TRUE);
			_tmp9_ = g_strdup ("Invalid blocklimit");
			_g_free0 (self->message);
			self->message = _tmp9_;
			result = FALSE;
			return result;
		}
		self->priv->current_index = gnonograms_region_seek_next_required_status (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, self->priv->current_index, blocklimit, direction);
		if (self->priv->current_index != blocklimit) {
			gboolean changed = FALSE;
			start_of_filling = self->priv->current_index;
			changed = FALSE;
			while (TRUE) {
				GnonogramsCellState* _tmp10_;
				gint _tmp10__length1;
				GnonogramsCellState _tmp11_;
				if (!(self->priv->current_index != blocklimit)) {
					break;
				}
				_tmp10_ = self->priv->status;
				_tmp10__length1 = self->priv->status_length1;
				_tmp11_ = _tmp10_[self->priv->current_index];
				if (_tmp11_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
					gnonograms_region_set_cell_owner (self, self->priv->current_index, self->priv->current_block_number, TRUE, FALSE);
				}
				if (dir) {
					gint _tmp12_;
					_tmp12_ = self->priv->current_index;
					self->priv->current_index = _tmp12_ + 1;
				} else {
					gint _tmp13_;
					_tmp13_ = self->priv->current_index;
					self->priv->current_index = _tmp13_ - 1;
				}
			}
			while (TRUE) {
				gboolean _tmp14_ = FALSE;
				if (self->priv->current_index != blocklimit) {
					GnonogramsCellState* _tmp15_;
					gint _tmp15__length1;
					GnonogramsCellState _tmp16_;
					_tmp15_ = self->priv->status;
					_tmp15__length1 = self->priv->status_length1;
					_tmp16_ = _tmp15_[self->priv->current_index];
					_tmp14_ = _tmp16_ == GNONOGRAMS_CELL_STATE_FILLED;
				} else {
					_tmp14_ = FALSE;
				}
				if (!_tmp14_) {
					break;
				}
				gnonograms_region_set_cell_owner (self, self->priv->current_index, self->priv->current_block_number, TRUE, FALSE);
				gnonograms_region_set_cell_empty (self, start_of_edge);
				changed = TRUE;
				if (dir) {
					gint _tmp17_;
					gint _tmp18_;
					_tmp17_ = self->priv->current_index;
					self->priv->current_index = _tmp17_ + 1;
					_tmp18_ = start_of_edge;
					start_of_edge = _tmp18_ + 1;
				} else {
					gint _tmp19_;
					gint _tmp20_;
					_tmp19_ = self->priv->current_index;
					self->priv->current_index = _tmp19_ - 1;
					_tmp20_ = start_of_edge;
					start_of_edge = _tmp20_ - 1;
				}
			}
			if (start_of_filling > 0) {
				gint _tmp21_ = 0;
				gboolean _tmp22_ = FALSE;
				if (dir) {
					_tmp21_ = block_length;
				} else {
					_tmp21_ = -block_length;
				}
				self->priv->current_index = start_of_filling + _tmp21_;
				if (self->priv->current_index >= 0) {
					gint _tmp23_;
					_tmp23_ = self->priv->_n_cells;
					_tmp22_ = self->priv->current_index < _tmp23_;
				} else {
					_tmp22_ = FALSE;
				}
				if (_tmp22_) {
					gnonograms_region_remove_block_from_cell_to_end (self, self->priv->current_block_number, self->priv->current_index, direction);
				}
			}
			result = changed;
			return result;
		}
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_find_edge (GnonogramsRegion* self,
                             gint limit,
                             gint direction)
{
	gboolean dir = FALSE;
	gint _tmp0_ = 0;
	gint loop_step = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	dir = direction == GNONOGRAMS_REGION_FORWARDS;
	if (dir) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = -1;
	}
	loop_step = _tmp0_;
	{
		gint i = 0;
		i = self->priv->current_index;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				GnonogramsCellState* _tmp4_;
				gint _tmp4__length1;
				GnonogramsCellState _tmp5_;
				gboolean* _tmp6_;
				gint _tmp6__length1;
				gint _tmp6__length2;
				gboolean _tmp7_;
				if (!_tmp1_) {
					i += loop_step;
				}
				_tmp1_ = FALSE;
				if (i >= 0) {
					gint _tmp3_;
					_tmp3_ = self->priv->_n_cells;
					_tmp2_ = i < _tmp3_;
				} else {
					_tmp2_ = FALSE;
				}
				if (!_tmp2_) {
					break;
				}
				_tmp4_ = self->priv->status;
				_tmp4__length1 = self->priv->status_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ == GNONOGRAMS_CELL_STATE_EMPTY) {
					continue;
				}
				_tmp6_ = self->priv->tags;
				_tmp6__length1 = self->priv->tags_length1;
				_tmp6__length2 = self->priv->tags_length2;
				_tmp7_ = _tmp6_[(i * _tmp6__length2) + self->priv->is_finished_pointer];
				if (_tmp7_) {
					gint _tmp8_ = 0;
					gint next_block = 0;
					gboolean _tmp13_ = FALSE;
					if (dir) {
						gint* _tmp9_;
						gint _tmp9__length1;
						gint _tmp10_;
						_tmp9_ = self->priv->blocks;
						_tmp9__length1 = self->priv->blocks_length1;
						_tmp10_ = _tmp9_[self->priv->current_block_number];
						_tmp8_ = _tmp10_ - 1;
					} else {
						gint* _tmp11_;
						gint _tmp11__length1;
						gint _tmp12_;
						_tmp11_ = self->priv->blocks;
						_tmp11__length1 = self->priv->blocks_length1;
						_tmp12_ = _tmp11_[self->priv->current_block_number];
						_tmp8_ = 1 - _tmp12_;
					}
					i += _tmp8_;
					next_block = self->priv->current_block_number + loop_step;
					if (next_block >= 0) {
						_tmp13_ = TRUE;
					} else {
						_tmp13_ = next_block < (self->priv->n_blocks - 1);
					}
					if (_tmp13_) {
						self->priv->current_block_number = next_block;
					} else {
						result = FALSE;
						return result;
					}
				} else {
					self->priv->current_index = i;
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_fix_blocks_in_ranges (GnonogramsRegion* self)
{
	gint* available_blocks = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint available_blocks_length1;
	gint _available_blocks_size_;
	gint bl = 0;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint n_available_ranges = 0;
	gint* block_start = NULL;
	gint* _tmp3_;
	gint block_start_length1;
	gint block_start_length2;
	gint* block_end = NULL;
	gint* _tmp4_;
	gint block_end_length1;
	gint block_end_length2;
	gint rng = 0;
	gint offset = 0;
	gint length = 0;
	gint ptr = 0;
	gint start = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = gnonograms_region_get_blocks_available (self, &_tmp0_);
	available_blocks = _tmp1_;
	available_blocks_length1 = _tmp0_;
	_available_blocks_size_ = available_blocks_length1;
	_tmp2_ = available_blocks;
	_tmp2__length1 = available_blocks_length1;
	bl = _tmp2__length1;
	if (bl == 0) {
		result = FALSE;
		available_blocks = (g_free (available_blocks), NULL);
		return result;
	}
	n_available_ranges = gnonograms_region_count_available_ranges (self, FALSE);
	if (n_available_ranges == 0) {
		result = FALSE;
		available_blocks = (g_free (available_blocks), NULL);
		return result;
	}
	_tmp3_ = g_new0 (gint, bl * 2);
	block_start = _tmp3_;
	block_start_length1 = bl;
	block_start_length2 = 2;
	_tmp4_ = g_new0 (gint, bl * 2);
	block_end = _tmp4_;
	block_end_length1 = bl;
	block_end_length2 = 2;
	rng = 0;
	offset = 0;
	length = 0;
	ptr = 0;
	start = 0;
	{
		gint b = 0;
		b = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint* _tmp7_;
				gint _tmp7__length1;
				gint* _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				gint _tmp10_;
				gint* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gint _tmp12_;
				gint* _tmp18_;
				gint _tmp18__length1;
				gint _tmp18__length2;
				gint _tmp19_;
				gint* _tmp26_;
				gint _tmp26__length1;
				gint _tmp26__length2;
				gint* _tmp27_;
				gint _tmp27__length1;
				gint _tmp27__length2;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = b;
					b = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(b < bl)) {
					break;
				}
				_tmp7_ = self->priv->blocks;
				_tmp7__length1 = self->priv->blocks_length1;
				_tmp8_ = available_blocks;
				_tmp8__length1 = available_blocks_length1;
				_tmp9_ = _tmp8_[b];
				_tmp10_ = _tmp7_[_tmp9_];
				length = _tmp10_;
				_tmp11_ = self->priv->ranges;
				_tmp11__length1 = self->priv->ranges_length1;
				_tmp11__length2 = self->priv->ranges_length2;
				_tmp12_ = _tmp11_[(rng * _tmp11__length2) + 1];
				if (_tmp12_ < (length + offset)) {
					gint _tmp13_;
					_tmp13_ = rng;
					rng = _tmp13_ + 1;
					offset = 0;
					while (TRUE) {
						gboolean _tmp14_ = FALSE;
						gint _tmp17_;
						if (rng < n_available_ranges) {
							gint* _tmp15_;
							gint _tmp15__length1;
							gint _tmp15__length2;
							gint _tmp16_;
							_tmp15_ = self->priv->ranges;
							_tmp15__length1 = self->priv->ranges_length1;
							_tmp15__length2 = self->priv->ranges_length2;
							_tmp16_ = _tmp15_[(rng * _tmp15__length2) + 1];
							_tmp14_ = _tmp16_ < length;
						} else {
							_tmp14_ = FALSE;
						}
						if (!_tmp14_) {
							break;
						}
						_tmp17_ = rng;
						rng = _tmp17_ + 1;
					}
					if (rng >= n_available_ranges) {
						result = FALSE;
						block_end = (g_free (block_end), NULL);
						block_start = (g_free (block_start), NULL);
						available_blocks = (g_free (available_blocks), NULL);
						return result;
					}
				}
				_tmp18_ = self->priv->ranges;
				_tmp18__length1 = self->priv->ranges_length1;
				_tmp18__length2 = self->priv->ranges_length2;
				_tmp19_ = _tmp18_[(rng * _tmp18__length2) + 0];
				ptr = (_tmp19_ + offset) + length;
				start = ptr;
				while (TRUE) {
					gboolean _tmp20_ = FALSE;
					gint _tmp21_;
					gint _tmp24_;
					gint _tmp25_;
					_tmp21_ = self->priv->_n_cells;
					if (ptr < _tmp21_) {
						gboolean* _tmp22_;
						gint _tmp22__length1;
						gint _tmp22__length2;
						gboolean _tmp23_;
						_tmp22_ = self->priv->tags;
						_tmp22__length1 = self->priv->tags_length1;
						_tmp22__length2 = self->priv->tags_length2;
						_tmp23_ = _tmp22_[(ptr * _tmp22__length2) + self->priv->can_be_empty_pointer];
						_tmp20_ = !_tmp23_;
					} else {
						_tmp20_ = FALSE;
					}
					if (!_tmp20_) {
						break;
					}
					_tmp24_ = ptr;
					ptr = _tmp24_ + 1;
					_tmp25_ = offset;
					offset = _tmp25_ + 1;
				}
				_tmp26_ = block_start;
				_tmp26__length1 = block_start_length1;
				_tmp26__length2 = block_start_length2;
				_tmp26_[(b * _tmp26__length2) + 0] = rng;
				_tmp27_ = block_start;
				_tmp27__length1 = block_start_length1;
				_tmp27__length2 = block_start_length2;
				_tmp27_[(b * _tmp27__length2) + 1] = offset;
				offset += length + 1;
			}
		}
	}
	rng = n_available_ranges - 1;
	offset = 0;
	{
		gint b = 0;
		b = bl - 1;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				gint* _tmp30_;
				gint _tmp30__length1;
				gint* _tmp31_;
				gint _tmp31__length1;
				gint _tmp32_;
				gint _tmp33_;
				gint* _tmp34_;
				gint _tmp34__length1;
				gint _tmp34__length2;
				gint _tmp35_;
				gint* _tmp41_;
				gint _tmp41__length1;
				gint _tmp41__length2;
				gint _tmp42_;
				gint* _tmp43_;
				gint _tmp43__length1;
				gint _tmp43__length2;
				gint _tmp44_;
				gint* _tmp50_;
				gint _tmp50__length1;
				gint _tmp50__length2;
				gint* _tmp51_;
				gint _tmp51__length1;
				gint _tmp51__length2;
				gint* _tmp52_;
				gint _tmp52__length1;
				gint _tmp52__length2;
				gint _tmp53_;
				if (!_tmp28_) {
					gint _tmp29_;
					_tmp29_ = b;
					b = _tmp29_ - 1;
				}
				_tmp28_ = FALSE;
				if (!(b >= 0)) {
					break;
				}
				_tmp30_ = self->priv->blocks;
				_tmp30__length1 = self->priv->blocks_length1;
				_tmp31_ = available_blocks;
				_tmp31__length1 = available_blocks_length1;
				_tmp32_ = _tmp31_[b];
				_tmp33_ = _tmp30_[_tmp32_];
				length = _tmp33_;
				_tmp34_ = self->priv->ranges;
				_tmp34__length1 = self->priv->ranges_length1;
				_tmp34__length2 = self->priv->ranges_length2;
				_tmp35_ = _tmp34_[(rng * _tmp34__length2) + 1];
				if (_tmp35_ < (length + offset)) {
					gint _tmp36_;
					_tmp36_ = rng;
					rng = _tmp36_ - 1;
					offset = 0;
					while (TRUE) {
						gboolean _tmp37_ = FALSE;
						gint _tmp40_;
						if (rng >= 0) {
							gint* _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							gint _tmp39_;
							_tmp38_ = self->priv->ranges;
							_tmp38__length1 = self->priv->ranges_length1;
							_tmp38__length2 = self->priv->ranges_length2;
							_tmp39_ = _tmp38_[(rng * _tmp38__length2) + 1];
							_tmp37_ = _tmp39_ < length;
						} else {
							_tmp37_ = FALSE;
						}
						if (!_tmp37_) {
							break;
						}
						_tmp40_ = rng;
						rng = _tmp40_ - 1;
					}
					if (rng < 0) {
						result = FALSE;
						block_end = (g_free (block_end), NULL);
						block_start = (g_free (block_start), NULL);
						available_blocks = (g_free (available_blocks), NULL);
						return result;
					}
				}
				_tmp41_ = self->priv->ranges;
				_tmp41__length1 = self->priv->ranges_length1;
				_tmp41__length2 = self->priv->ranges_length2;
				_tmp42_ = _tmp41_[(rng * _tmp41__length2) + 0];
				_tmp43_ = self->priv->ranges;
				_tmp43__length1 = self->priv->ranges_length1;
				_tmp43__length2 = self->priv->ranges_length2;
				_tmp44_ = _tmp43_[(rng * _tmp43__length2) + 1];
				ptr = ((_tmp42_ + _tmp44_) - (offset + length)) - 1;
				start = ptr;
				while (TRUE) {
					gboolean _tmp45_ = FALSE;
					gint _tmp48_;
					gint _tmp49_;
					if (ptr >= 0) {
						gboolean* _tmp46_;
						gint _tmp46__length1;
						gint _tmp46__length2;
						gboolean _tmp47_;
						_tmp46_ = self->priv->tags;
						_tmp46__length1 = self->priv->tags_length1;
						_tmp46__length2 = self->priv->tags_length2;
						_tmp47_ = _tmp46_[(ptr * _tmp46__length2) + self->priv->can_be_empty_pointer];
						_tmp45_ = !_tmp47_;
					} else {
						_tmp45_ = FALSE;
					}
					if (!_tmp45_) {
						break;
					}
					_tmp48_ = ptr;
					ptr = _tmp48_ - 1;
					_tmp49_ = offset;
					offset = _tmp49_ + 1;
				}
				_tmp50_ = block_end;
				_tmp50__length1 = block_end_length1;
				_tmp50__length2 = block_end_length2;
				_tmp50_[(b * _tmp50__length2) + 0] = rng;
				_tmp51_ = block_end;
				_tmp51__length1 = block_end_length1;
				_tmp51__length2 = block_end_length2;
				_tmp52_ = self->priv->ranges;
				_tmp52__length1 = self->priv->ranges_length1;
				_tmp52__length2 = self->priv->ranges_length2;
				_tmp53_ = _tmp52_[(rng * _tmp52__length2) + 1];
				_tmp51_[(b * _tmp51__length2) + 1] = _tmp53_ - offset;
				offset += length + 1;
			}
		}
	}
	{
		gint b = 0;
		b = 0;
		{
			gboolean _tmp54_ = FALSE;
			_tmp54_ = TRUE;
			while (TRUE) {
				gint* _tmp56_;
				gint _tmp56__length1;
				gint _tmp56__length2;
				gint _tmp57_;
				gint* _tmp58_;
				gint _tmp58__length1;
				gint _tmp58__length2;
				gint _tmp59_;
				gint* _tmp60_;
				gint _tmp60__length1;
				gint _tmp60__length2;
				gint _tmp61_;
				gint* _tmp62_;
				gint _tmp62__length1;
				gint _tmp62__length2;
				gint _tmp63_;
				gint* _tmp82_;
				gint _tmp82__length1;
				gint _tmp82__length2;
				gint _tmp83_;
				gint* _tmp84_;
				gint _tmp84__length1;
				gint _tmp84__length2;
				gint _tmp85_;
				gint* _tmp86_;
				gint _tmp86__length1;
				gint _tmp86__length2;
				gint _tmp87_;
				gint* _tmp88_;
				gint _tmp88__length1;
				gint _tmp88__length2;
				gint _tmp89_;
				gint* _tmp90_;
				gint _tmp90__length1;
				gint _tmp90__length2;
				gint _tmp91_;
				if (!_tmp54_) {
					gint _tmp55_;
					_tmp55_ = b;
					b = _tmp55_ + 1;
				}
				_tmp54_ = FALSE;
				if (!(b < bl)) {
					break;
				}
				_tmp56_ = block_start;
				_tmp56__length1 = block_start_length1;
				_tmp56__length2 = block_start_length2;
				_tmp57_ = _tmp56_[(b * _tmp56__length2) + 0];
				rng = _tmp57_;
				_tmp58_ = block_start;
				_tmp58__length1 = block_start_length1;
				_tmp58__length2 = block_start_length2;
				_tmp59_ = _tmp58_[(b * _tmp58__length2) + 1];
				offset = _tmp59_;
				_tmp60_ = self->priv->ranges;
				_tmp60__length1 = self->priv->ranges_length1;
				_tmp60__length2 = self->priv->ranges_length2;
				_tmp61_ = _tmp60_[(rng * _tmp60__length2) + 0];
				start = _tmp61_;
				_tmp62_ = block_end;
				_tmp62__length1 = block_end_length1;
				_tmp62__length2 = block_end_length2;
				_tmp63_ = _tmp62_[(b * _tmp62__length2) + 0];
				if (rng == _tmp63_) {
					gint* _tmp64_;
					gint _tmp64__length1;
					gint _tmp64__length2;
					gint _tmp65_;
					gint* _tmp66_;
					gint _tmp66__length1;
					gint _tmp66__length2;
					gint _tmp67_;
					gint* _tmp68_;
					gint _tmp68__length1;
					gint _tmp69_;
					_tmp64_ = block_end;
					_tmp64__length1 = block_end_length1;
					_tmp64__length2 = block_end_length2;
					_tmp65_ = _tmp64_[(b * _tmp64__length2) + 1];
					_tmp66_ = block_start;
					_tmp66__length1 = block_start_length1;
					_tmp66__length2 = block_start_length2;
					_tmp67_ = _tmp66_[(b * _tmp66__length2) + 1];
					length = _tmp65_ - _tmp67_;
					_tmp68_ = available_blocks;
					_tmp68__length1 = available_blocks_length1;
					_tmp69_ = _tmp68_[b];
					gnonograms_region_fix_block_in_range (self, _tmp69_, start + offset, length);
				}
				if (offset > 1) {
					gint* _tmp70_;
					gint _tmp70__length1;
					gint _tmp71_;
					_tmp70_ = available_blocks;
					_tmp70__length1 = available_blocks_length1;
					_tmp71_ = _tmp70_[b];
					gnonograms_region_remove_block_from_range (self, _tmp71_, start, offset - 1, 1);
				}
				{
					gint r = 0;
					r = 0;
					{
						gboolean _tmp72_ = FALSE;
						_tmp72_ = TRUE;
						while (TRUE) {
							gint* _tmp74_;
							gint _tmp74__length1;
							gint _tmp74__length2;
							gint _tmp75_;
							gint* _tmp76_;
							gint _tmp76__length1;
							gint _tmp77_;
							gint* _tmp78_;
							gint _tmp78__length1;
							gint _tmp78__length2;
							gint _tmp79_;
							gint* _tmp80_;
							gint _tmp80__length1;
							gint _tmp80__length2;
							gint _tmp81_;
							if (!_tmp72_) {
								gint _tmp73_;
								_tmp73_ = r;
								r = _tmp73_ + 1;
							}
							_tmp72_ = FALSE;
							_tmp74_ = block_start;
							_tmp74__length1 = block_start_length1;
							_tmp74__length2 = block_start_length2;
							_tmp75_ = _tmp74_[(b * _tmp74__length2) + 0];
							if (!(r < _tmp75_)) {
								break;
							}
							_tmp76_ = available_blocks;
							_tmp76__length1 = available_blocks_length1;
							_tmp77_ = _tmp76_[b];
							_tmp78_ = self->priv->ranges;
							_tmp78__length1 = self->priv->ranges_length1;
							_tmp78__length2 = self->priv->ranges_length2;
							_tmp79_ = _tmp78_[(r * _tmp78__length2) + 0];
							_tmp80_ = self->priv->ranges;
							_tmp80__length1 = self->priv->ranges_length1;
							_tmp80__length2 = self->priv->ranges_length2;
							_tmp81_ = _tmp80_[(r * _tmp80__length2) + 1];
							gnonograms_region_remove_block_from_range (self, _tmp77_, _tmp79_, _tmp81_, 1);
						}
					}
				}
				_tmp82_ = block_end;
				_tmp82__length1 = block_end_length1;
				_tmp82__length2 = block_end_length2;
				_tmp83_ = _tmp82_[(b * _tmp82__length2) + 0];
				rng = _tmp83_;
				_tmp84_ = self->priv->ranges;
				_tmp84__length1 = self->priv->ranges_length1;
				_tmp84__length2 = self->priv->ranges_length2;
				_tmp85_ = _tmp84_[(rng * _tmp84__length2) + 0];
				_tmp86_ = block_end;
				_tmp86__length1 = block_end_length1;
				_tmp86__length2 = block_end_length2;
				_tmp87_ = _tmp86_[(b * _tmp86__length2) + 1];
				start = _tmp85_ + _tmp87_;
				_tmp88_ = self->priv->ranges;
				_tmp88__length1 = self->priv->ranges_length1;
				_tmp88__length2 = self->priv->ranges_length2;
				_tmp89_ = _tmp88_[(rng * _tmp88__length2) + 1];
				_tmp90_ = block_end;
				_tmp90__length1 = block_end_length1;
				_tmp90__length2 = block_end_length2;
				_tmp91_ = _tmp90_[(b * _tmp90__length2) + 1];
				length = _tmp89_ - _tmp91_;
				if (length > 0) {
					gint* _tmp92_;
					gint _tmp92__length1;
					gint _tmp93_;
					_tmp92_ = available_blocks;
					_tmp92__length1 = available_blocks_length1;
					_tmp93_ = _tmp92_[b];
					gnonograms_region_remove_block_from_range (self, _tmp93_, start, length, 1);
				}
				{
					gint r = 0;
					r = n_available_ranges - 1;
					{
						gboolean _tmp94_ = FALSE;
						_tmp94_ = TRUE;
						while (TRUE) {
							gint* _tmp96_;
							gint _tmp96__length1;
							gint _tmp96__length2;
							gint _tmp97_;
							gint* _tmp98_;
							gint _tmp98__length1;
							gint _tmp99_;
							gint* _tmp100_;
							gint _tmp100__length1;
							gint _tmp100__length2;
							gint _tmp101_;
							gint* _tmp102_;
							gint _tmp102__length1;
							gint _tmp102__length2;
							gint _tmp103_;
							if (!_tmp94_) {
								gint _tmp95_;
								_tmp95_ = r;
								r = _tmp95_ - 1;
							}
							_tmp94_ = FALSE;
							_tmp96_ = block_end;
							_tmp96__length1 = block_end_length1;
							_tmp96__length2 = block_end_length2;
							_tmp97_ = _tmp96_[(b * _tmp96__length2) + 0];
							if (!(r > _tmp97_)) {
								break;
							}
							_tmp98_ = available_blocks;
							_tmp98__length1 = available_blocks_length1;
							_tmp99_ = _tmp98_[b];
							_tmp100_ = self->priv->ranges;
							_tmp100__length1 = self->priv->ranges_length1;
							_tmp100__length2 = self->priv->ranges_length2;
							_tmp101_ = _tmp100_[(r * _tmp100__length2) + 0];
							_tmp102_ = self->priv->ranges;
							_tmp102__length1 = self->priv->ranges_length1;
							_tmp102__length2 = self->priv->ranges_length2;
							_tmp103_ = _tmp102_[(r * _tmp102__length2) + 1];
							gnonograms_region_remove_block_from_range (self, _tmp99_, _tmp101_, _tmp103_, 1);
						}
					}
				}
			}
		}
	}
	result = FALSE;
	block_end = (g_free (block_end), NULL);
	block_start = (g_free (block_start), NULL);
	available_blocks = (g_free (available_blocks), NULL);
	return result;
}

static gboolean
gnonograms_region_capped_range_audit (GnonogramsRegion* self)
{
	gint start = 0;
	gint length = 0;
	gint idx = 0;
	gint n_ranges = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	start = 0;
	length = 0;
	idx = 0;
	n_ranges = gnonograms_region_count_capped_ranges (self);
	if (n_ranges == 0) {
		result = FALSE;
		return result;
	}
	{
		gint rng = 0;
		rng = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				gint _tmp3_;
				gint* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = rng;
					rng = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(rng < n_ranges)) {
					break;
				}
				_tmp2_ = self->priv->ranges;
				_tmp2__length1 = self->priv->ranges_length1;
				_tmp2__length2 = self->priv->ranges_length2;
				_tmp3_ = _tmp2_[(rng * _tmp2__length2) + 0];
				start = _tmp3_;
				_tmp4_ = self->priv->ranges;
				_tmp4__length1 = self->priv->ranges_length1;
				_tmp4__length2 = self->priv->ranges_length2;
				_tmp5_ = _tmp4_[(rng * _tmp4__length2) + 1];
				length = _tmp5_;
				{
					gboolean _tmp6_ = FALSE;
					idx = start;
					_tmp6_ = TRUE;
					while (TRUE) {
						gint count = 0;
						gint impossible = 0;
						if (!_tmp6_) {
							gint _tmp7_;
							_tmp7_ = idx;
							idx = _tmp7_ + 1;
						}
						_tmp6_ = FALSE;
						if (!(idx < (start + length))) {
							break;
						}
						count = 0;
						impossible = 0;
						{
							gint b = 0;
							b = 0;
							{
								gboolean _tmp8_ = FALSE;
								_tmp8_ = TRUE;
								while (TRUE) {
									gboolean* _tmp10_;
									gint _tmp10__length1;
									gint _tmp10__length2;
									gboolean _tmp11_;
									if (!_tmp8_) {
										gint _tmp9_;
										_tmp9_ = b;
										b = _tmp9_ + 1;
									}
									_tmp8_ = FALSE;
									if (!(b < self->priv->n_blocks)) {
										break;
									}
									_tmp10_ = self->priv->tags;
									_tmp10__length1 = self->priv->tags_length1;
									_tmp10__length2 = self->priv->tags_length2;
									_tmp11_ = _tmp10_[(idx * _tmp10__length2) + b];
									if (_tmp11_) {
										gint _tmp12_;
										gint* _tmp13_;
										gint _tmp13__length1;
										gint _tmp14_;
										_tmp12_ = count;
										count = _tmp12_ + 1;
										_tmp13_ = self->priv->blocks;
										_tmp13__length1 = self->priv->blocks_length1;
										_tmp14_ = _tmp13_[b];
										if (_tmp14_ != length) {
											gboolean* _tmp15_;
											gint _tmp15__length1;
											gint _tmp15__length2;
											gint _tmp16_;
											_tmp15_ = self->priv->tags;
											_tmp15__length1 = self->priv->tags_length1;
											_tmp15__length2 = self->priv->tags_length2;
											_tmp15_[(idx * _tmp15__length2) + b] = FALSE;
											_tmp16_ = impossible;
											impossible = _tmp16_ + 1;
										}
									}
								}
							}
						}
						if (count == impossible) {
							gchar* _tmp17_;
							gchar* _tmp18_;
							_tmp17_ = g_strdup_printf ("start %i len %i, n_blocks %u count %i, impossible %i filled cell with " \
"no owners", start, length, (guint) self->priv->n_blocks, count, impossible);
							_tmp18_ = _tmp17_;
							gnonograms_region_record_error (self, "capped range audit", _tmp18_);
							_g_free0 (_tmp18_);
							result = FALSE;
							return result;
						}
					}
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_region_available_filled_subregion_audit (GnonogramsRegion* self)
{
	gint idx = 0;
	gint start = 0;
	gint end = 0;
	gint _tmp0_;
	gint region_count = 0;
	GnonogramsRange** available_subregions = NULL;
	gint _tmp1_;
	GnonogramsRange** _tmp2_;
	gint available_subregions_length1;
	gint _available_subregions_size_;
	gboolean _tmp15_ = FALSE;
	gint* available_blocks = NULL;
	gint _tmp16_ = 0;
	gint* _tmp17_;
	gint available_blocks_length1;
	gint _available_blocks_size_;
	gint n_available_blocks = 0;
	gint* _tmp18_;
	gint _tmp18__length1;
	gint first_start = 0;
	GnonogramsRange** _tmp19_;
	gint _tmp19__length1;
	GnonogramsRange* _tmp20_;
	gint length = 0;
	GnonogramsRange** _tmp21_;
	gint _tmp21__length1;
	GnonogramsRange* _tmp22_;
	gint last_end = 0;
	GnonogramsRange** _tmp23_;
	gint _tmp23__length1;
	GnonogramsRange* _tmp24_;
	gint block_count = 0;
	gint bl = 0;
	gint* candidates = NULL;
	gint* _tmp42_;
	gint candidates_length1;
	gint _candidates_size_;
	gint candidates_count = 0;
	gint combined_length = 0;
	gint overall_length = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	idx = 0;
	start = 0;
	_tmp0_ = self->priv->_n_cells;
	end = _tmp0_;
	region_count = 0;
	_tmp1_ = self->priv->_n_cells;
	_tmp2_ = g_new0 (GnonogramsRange*, (_tmp1_ / 2) + 1);
	available_subregions = _tmp2_;
	available_subregions_length1 = _tmp1_ / 2;
	_available_subregions_size_ = available_subregions_length1;
	while (TRUE) {
		gint _tmp3_;
		GnonogramsCellState* _tmp4_;
		gint _tmp4__length1;
		GnonogramsCellState _tmp5_;
		gint _tmp7_;
		GnonogramsRange** _tmp13_;
		gint _tmp13__length1;
		GnonogramsRange* _tmp14_;
		_tmp3_ = self->priv->_n_cells;
		if (!(idx < _tmp3_)) {
			break;
		}
		_tmp4_ = self->priv->status;
		_tmp4__length1 = self->priv->status_length1;
		_tmp5_ = _tmp4_[idx];
		if (_tmp5_ != GNONOGRAMS_CELL_STATE_FILLED) {
			gint _tmp6_;
			_tmp6_ = idx;
			idx = _tmp6_ + 1;
			continue;
		}
		_tmp7_ = region_count;
		region_count = _tmp7_ + 1;
		if (region_count <= self->priv->n_blocks) {
			start = idx;
		} else {
			result = FALSE;
			available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
			return result;
		}
		while (TRUE) {
			gboolean _tmp8_ = FALSE;
			gint _tmp9_;
			gint _tmp12_;
			_tmp9_ = self->priv->_n_cells;
			if (idx < _tmp9_) {
				GnonogramsCellState* _tmp10_;
				gint _tmp10__length1;
				GnonogramsCellState _tmp11_;
				_tmp10_ = self->priv->status;
				_tmp10__length1 = self->priv->status_length1;
				_tmp11_ = _tmp10_[idx];
				_tmp8_ = _tmp11_ == GNONOGRAMS_CELL_STATE_FILLED;
			} else {
				_tmp8_ = FALSE;
			}
			if (!_tmp8_) {
				break;
			}
			_tmp12_ = idx;
			idx = _tmp12_ + 1;
		}
		end = idx - 1;
		_tmp13_ = available_subregions;
		_tmp13__length1 = available_subregions_length1;
		_tmp14_ = gnonograms_range_new (start, end, -1, -1);
		_gnonograms_range_unref0 (_tmp13_[region_count - 1]);
		_tmp13_[region_count - 1] = _tmp14_;
	}
	if (region_count < 2) {
		_tmp15_ = TRUE;
	} else {
		_tmp15_ = region_count > self->priv->n_blocks;
	}
	if (_tmp15_) {
		result = FALSE;
		available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
		return result;
	}
	_tmp17_ = gnonograms_region_get_blocks_available (self, &_tmp16_);
	available_blocks = _tmp17_;
	available_blocks_length1 = _tmp16_;
	_available_blocks_size_ = available_blocks_length1;
	_tmp18_ = available_blocks;
	_tmp18__length1 = available_blocks_length1;
	n_available_blocks = _tmp18__length1;
	if (region_count > n_available_blocks) {
		result = FALSE;
		available_blocks = (g_free (available_blocks), NULL);
		available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
		return result;
	}
	_tmp19_ = available_subregions;
	_tmp19__length1 = available_subregions_length1;
	_tmp20_ = _tmp19_[0];
	first_start = _tmp20_->start;
	_tmp21_ = available_subregions;
	_tmp21__length1 = available_subregions_length1;
	_tmp22_ = _tmp21_[0];
	length = gnonograms_range_length (_tmp22_);
	_tmp23_ = available_subregions;
	_tmp23__length1 = available_subregions_length1;
	_tmp24_ = _tmp23_[region_count - 1];
	last_end = _tmp24_->end;
	block_count = n_available_blocks;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint* _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_;
				gboolean* _tmp29_;
				gint _tmp29__length1;
				gint _tmp29__length2;
				gboolean _tmp30_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				if (!(i < n_available_blocks)) {
					break;
				}
				_tmp27_ = available_blocks;
				_tmp27__length1 = available_blocks_length1;
				_tmp28_ = _tmp27_[i];
				bl = _tmp28_;
				_tmp29_ = self->priv->tags;
				_tmp29__length1 = self->priv->tags_length1;
				_tmp29__length2 = self->priv->tags_length2;
				_tmp30_ = _tmp29_[(first_start * _tmp29__length2) + bl];
				if (!_tmp30_) {
					gint* _tmp31_;
					gint _tmp31__length1;
					gint _tmp32_;
					_tmp31_ = available_blocks;
					_tmp31__length1 = available_blocks_length1;
					_tmp31_[i] = -1;
					_tmp32_ = block_count;
					block_count = _tmp32_ - 1;
				} else {
					break;
				}
			}
		}
	}
	{
		gint i = 0;
		i = n_available_blocks - 1;
		{
			gboolean _tmp33_ = FALSE;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint* _tmp35_;
				gint _tmp35__length1;
				gint _tmp36_;
				gboolean _tmp37_ = FALSE;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = i;
					i = _tmp34_ - 1;
				}
				_tmp33_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp35_ = available_blocks;
				_tmp35__length1 = available_blocks_length1;
				_tmp36_ = _tmp35_[i];
				bl = _tmp36_;
				if (bl >= 0) {
					gboolean* _tmp38_;
					gint _tmp38__length1;
					gint _tmp38__length2;
					gboolean _tmp39_;
					_tmp38_ = self->priv->tags;
					_tmp38__length1 = self->priv->tags_length1;
					_tmp38__length2 = self->priv->tags_length2;
					_tmp39_ = _tmp38_[(last_end * _tmp38__length2) + bl];
					_tmp37_ = !_tmp39_;
				} else {
					_tmp37_ = FALSE;
				}
				if (_tmp37_) {
					gint* _tmp40_;
					gint _tmp40__length1;
					gint _tmp41_;
					_tmp40_ = available_blocks;
					_tmp40__length1 = available_blocks_length1;
					_tmp40_[i] = -1;
					_tmp41_ = block_count;
					block_count = _tmp41_ - 1;
				} else {
					break;
				}
			}
		}
	}
	if (block_count != region_count) {
		result = FALSE;
		available_blocks = (g_free (available_blocks), NULL);
		available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
		return result;
	}
	_tmp42_ = g_new0 (gint, block_count);
	candidates = _tmp42_;
	candidates_length1 = block_count;
	_candidates_size_ = candidates_length1;
	candidates_count = 0;
	combined_length = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp43_ = FALSE;
			_tmp43_ = TRUE;
			while (TRUE) {
				gint* _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_;
				if (!_tmp43_) {
					gint _tmp44_;
					_tmp44_ = i;
					i = _tmp44_ + 1;
				}
				_tmp43_ = FALSE;
				if (!(i < n_available_blocks)) {
					break;
				}
				_tmp45_ = available_blocks;
				_tmp45__length1 = available_blocks_length1;
				_tmp46_ = _tmp45_[i];
				if (_tmp46_ < 0) {
					continue;
				} else {
					gint* _tmp47_;
					gint _tmp47__length1;
					gint* _tmp48_;
					gint _tmp48__length1;
					gint _tmp49_;
					gint* _tmp50_;
					gint _tmp50__length1;
					gint* _tmp51_;
					gint _tmp51__length1;
					gint _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
					_tmp47_ = candidates;
					_tmp47__length1 = candidates_length1;
					_tmp48_ = available_blocks;
					_tmp48__length1 = available_blocks_length1;
					_tmp49_ = _tmp48_[i];
					_tmp47_[candidates_count] = _tmp49_;
					_tmp50_ = self->priv->blocks;
					_tmp50__length1 = self->priv->blocks_length1;
					_tmp51_ = available_blocks;
					_tmp51__length1 = available_blocks_length1;
					_tmp52_ = _tmp51_[i];
					_tmp53_ = _tmp50_[_tmp52_];
					combined_length += _tmp53_;
					_tmp54_ = candidates_count;
					candidates_count = _tmp54_ + 1;
				}
			}
		}
	}
	combined_length += candidates_count - 1;
	overall_length = (last_end - first_start) + 1;
	if (overall_length < combined_length) {
		result = FALSE;
		candidates = (g_free (candidates), NULL);
		available_blocks = (g_free (available_blocks), NULL);
		available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
		return result;
	}
	{
		gint ar = 0;
		ar = 0;
		{
			gboolean _tmp55_ = FALSE;
			_tmp55_ = TRUE;
			while (TRUE) {
				gboolean regions_are_separate = FALSE;
				if (!_tmp55_) {
					gint _tmp56_;
					_tmp56_ = ar;
					ar = _tmp56_ + 1;
				}
				_tmp55_ = FALSE;
				if (!(ar < (region_count - 1))) {
					break;
				}
				regions_are_separate = FALSE;
				{
					gint i = 0;
					GnonogramsRange** _tmp57_;
					gint _tmp57__length1;
					GnonogramsRange* _tmp58_;
					_tmp57_ = available_subregions;
					_tmp57__length1 = available_subregions_length1;
					_tmp58_ = _tmp57_[ar];
					i = _tmp58_->end;
					{
						gboolean _tmp59_ = FALSE;
						_tmp59_ = TRUE;
						while (TRUE) {
							GnonogramsRange** _tmp61_;
							gint _tmp61__length1;
							GnonogramsRange* _tmp62_;
							gboolean* _tmp63_;
							gint _tmp63__length1;
							gint _tmp63__length2;
							gboolean _tmp64_;
							if (!_tmp59_) {
								gint _tmp60_;
								_tmp60_ = i;
								i = _tmp60_ + 1;
							}
							_tmp59_ = FALSE;
							_tmp61_ = available_subregions;
							_tmp61__length1 = available_subregions_length1;
							_tmp62_ = _tmp61_[ar + 1];
							if (!(i < _tmp62_->start)) {
								break;
							}
							_tmp63_ = self->priv->tags;
							_tmp63__length1 = self->priv->tags_length1;
							_tmp63__length2 = self->priv->tags_length2;
							_tmp64_ = _tmp63_[(i * _tmp63__length2) + self->priv->is_finished_pointer];
							if (_tmp64_) {
								regions_are_separate = TRUE;
								break;
							}
						}
					}
				}
				if (regions_are_separate) {
					continue;
				} else {
					GnonogramsRange** _tmp65_;
					gint _tmp65__length1;
					GnonogramsRange* _tmp66_;
					GnonogramsRange** _tmp67_;
					gint _tmp67__length1;
					GnonogramsRange* _tmp68_;
					gboolean _tmp69_ = FALSE;
					gint* _tmp70_;
					gint _tmp70__length1;
					gint* _tmp71_;
					gint _tmp71__length1;
					gint _tmp72_;
					gint _tmp73_;
					_tmp65_ = available_subregions;
					_tmp65__length1 = available_subregions_length1;
					_tmp66_ = _tmp65_[ar];
					start = _tmp66_->start;
					_tmp67_ = available_subregions;
					_tmp67__length1 = available_subregions_length1;
					_tmp68_ = _tmp67_[ar + 1];
					end = _tmp68_->end;
					length = (end - start) + 1;
					_tmp70_ = self->priv->blocks;
					_tmp70__length1 = self->priv->blocks_length1;
					_tmp71_ = candidates;
					_tmp71__length1 = candidates_length1;
					_tmp72_ = _tmp71_[ar];
					_tmp73_ = _tmp70_[_tmp72_];
					if (length <= _tmp73_) {
						_tmp69_ = TRUE;
					} else {
						gint* _tmp74_;
						gint _tmp74__length1;
						gint* _tmp75_;
						gint _tmp75__length1;
						gint _tmp76_;
						gint _tmp77_;
						_tmp74_ = self->priv->blocks;
						_tmp74__length1 = self->priv->blocks_length1;
						_tmp75_ = candidates;
						_tmp75__length1 = candidates_length1;
						_tmp76_ = _tmp75_[ar + 1];
						_tmp77_ = _tmp74_[_tmp76_];
						_tmp69_ = length <= _tmp77_;
					}
					if (_tmp69_) {
						result = FALSE;
						candidates = (g_free (candidates), NULL);
						available_blocks = (g_free (available_blocks), NULL);
						available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
						return result;
					}
				}
			}
		}
	}
	if (region_count > candidates_count) {
		gchar* _tmp78_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp78_ = g_strdup ("region_count > candidates_count");
		_g_free0 (self->message);
		self->message = _tmp78_;
		result = FALSE;
		candidates = (g_free (candidates), NULL);
		available_blocks = (g_free (available_blocks), NULL);
		available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
		return result;
	}
	{
		gint ar = 0;
		ar = 0;
		{
			gboolean _tmp79_ = FALSE;
			_tmp79_ = TRUE;
			while (TRUE) {
				gint* _tmp81_;
				gint _tmp81__length1;
				gint _tmp82_;
				gint* _tmp83_;
				gint _tmp83__length1;
				gint _tmp84_;
				GnonogramsRange** _tmp85_;
				gint _tmp85__length1;
				GnonogramsRange* _tmp86_;
				GnonogramsRange** _tmp87_;
				gint _tmp87__length1;
				GnonogramsRange* _tmp88_;
				if (!_tmp79_) {
					gint _tmp80_;
					_tmp80_ = ar;
					ar = _tmp80_ + 1;
				}
				_tmp79_ = FALSE;
				if (!(ar < region_count)) {
					break;
				}
				_tmp81_ = candidates;
				_tmp81__length1 = candidates_length1;
				_tmp82_ = _tmp81_[ar];
				bl = _tmp82_;
				_tmp83_ = self->priv->blocks;
				_tmp83__length1 = self->priv->blocks_length1;
				_tmp84_ = _tmp83_[bl];
				length = _tmp84_;
				_tmp85_ = available_subregions;
				_tmp85__length1 = available_subregions_length1;
				_tmp86_ = _tmp85_[ar];
				_tmp87_ = available_subregions;
				_tmp87__length1 = available_subregions_length1;
				_tmp88_ = _tmp87_[ar];
				gnonograms_region_set_range_owner (self, bl, _tmp86_->start, gnonograms_range_length (_tmp88_), TRUE, FALSE);
			}
		}
	}
	result = FALSE;
	candidates = (g_free (candidates), NULL);
	available_blocks = (g_free (available_blocks), NULL);
	available_subregions = (_vala_array_free (available_subregions, available_subregions_length1, (GDestroyNotify) gnonograms_range_unref), NULL);
	return result;
}

static gboolean
gnonograms_region_check_collisions (GnonogramsRegion* self)
{
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gboolean _tmp5_;
				gint owner = 0;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < (_tmp2_ - 2))) {
					break;
				}
				_tmp4_ = self->priv->tags;
				_tmp4__length1 = self->priv->tags_length1;
				_tmp4__length2 = self->priv->tags_length2;
				_tmp5_ = _tmp4_[(i * _tmp4__length2) + self->priv->can_be_empty_pointer];
				if (_tmp5_) {
					_tmp3_ = TRUE;
				} else {
					gboolean* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					gboolean _tmp7_;
					_tmp6_ = self->priv->tags;
					_tmp6__length1 = self->priv->tags_length1;
					_tmp6__length2 = self->priv->tags_length2;
					_tmp7_ = _tmp6_[(i * _tmp6__length2) + self->priv->is_finished_pointer];
					_tmp3_ = _tmp7_;
				}
				if (_tmp3_) {
					continue;
				}
				owner = gnonograms_region_get_sole_owner (self, i);
				if (owner >= 0) {
					gint next_owner = 0;
					gboolean _tmp8_ = FALSE;
					next_owner = gnonograms_region_get_sole_owner (self, i + 1);
					if (next_owner >= 0) {
						gboolean* _tmp9_;
						gint _tmp9__length1;
						gint _tmp9__length2;
						gboolean _tmp10_;
						_tmp9_ = self->priv->tags;
						_tmp9__length1 = self->priv->tags_length1;
						_tmp9__length2 = self->priv->tags_length2;
						_tmp10_ = _tmp9_[((i + 1) * _tmp9__length2) + self->priv->can_be_empty_pointer];
						_tmp8_ = !_tmp10_;
					} else {
						_tmp8_ = FALSE;
					}
					if (_tmp8_) {
						if (owner != next_owner) {
							gchar* _tmp11_;
							gchar* _tmp12_;
							_tmp11_ = g_strdup_printf ("Adjacent different sole owners idxs %i, %i", i, i + 1);
							_tmp12_ = _tmp11_;
							gnonograms_region_record_error (self, "check_collisions", _tmp12_);
							_g_free0 (_tmp12_);
							result = FALSE;
							return result;
						} else {
							continue;
						}
					} else {
						if (next_owner < 0) {
							gnonograms_region_set_cell_owner (self, i + 1, owner, TRUE, TRUE);
							if (owner < (self->priv->n_blocks - 2)) {
								gint start = 0;
								gint length = 0;
								gint* _tmp13_;
								gint _tmp13__length1;
								gint _tmp14_;
								gint limit = 0;
								gint filled_idx = 0;
								start = i + 1;
								_tmp13_ = self->priv->blocks;
								_tmp13__length1 = self->priv->blocks_length1;
								_tmp14_ = _tmp13_[owner + 1];
								length = _tmp14_;
								limit = start + length;
								filled_idx = gnonograms_region_seek_next_required_status (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, start, limit, 1);
								if (filled_idx < limit) {
									{
										gint j = 0;
										j = filled_idx;
										{
											gboolean _tmp15_ = FALSE;
											_tmp15_ = TRUE;
											while (TRUE) {
												if (!_tmp15_) {
													gint _tmp16_;
													_tmp16_ = j;
													j = _tmp16_ + 1;
												}
												_tmp15_ = FALSE;
												if (!(j < limit)) {
													break;
												}
												gnonograms_region_set_cell_owner (self, j, owner + 1, TRUE, FALSE);
											}
										}
									}
								}
								changed = TRUE;
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		gint _tmp17_;
		_tmp17_ = self->priv->_n_cells;
		i = _tmp17_ - 1;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				gboolean _tmp20_ = FALSE;
				gboolean* _tmp21_;
				gint _tmp21__length1;
				gint _tmp21__length2;
				gboolean _tmp22_;
				gint owner = 0;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ - 1;
				}
				_tmp18_ = FALSE;
				if (!(i > 1)) {
					break;
				}
				_tmp21_ = self->priv->tags;
				_tmp21__length1 = self->priv->tags_length1;
				_tmp21__length2 = self->priv->tags_length2;
				_tmp22_ = _tmp21_[(i * _tmp21__length2) + self->priv->can_be_empty_pointer];
				if (_tmp22_) {
					_tmp20_ = TRUE;
				} else {
					gboolean* _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					gboolean _tmp24_;
					_tmp23_ = self->priv->tags;
					_tmp23__length1 = self->priv->tags_length1;
					_tmp23__length2 = self->priv->tags_length2;
					_tmp24_ = _tmp23_[(i * _tmp23__length2) + self->priv->is_finished_pointer];
					_tmp20_ = _tmp24_;
				}
				if (_tmp20_) {
					continue;
				}
				owner = gnonograms_region_get_sole_owner (self, i);
				if (owner >= 0) {
					gint next_owner = 0;
					gboolean _tmp25_ = FALSE;
					next_owner = gnonograms_region_get_sole_owner (self, i - 1);
					if (next_owner >= 0) {
						gboolean* _tmp26_;
						gint _tmp26__length1;
						gint _tmp26__length2;
						gboolean _tmp27_;
						_tmp26_ = self->priv->tags;
						_tmp26__length1 = self->priv->tags_length1;
						_tmp26__length2 = self->priv->tags_length2;
						_tmp27_ = _tmp26_[((i - 1) * _tmp26__length2) + self->priv->can_be_empty_pointer];
						_tmp25_ = !_tmp27_;
					} else {
						_tmp25_ = FALSE;
					}
					if (_tmp25_) {
						if (owner != next_owner) {
							gchar* _tmp28_;
							gchar* _tmp29_;
							_tmp28_ = g_strdup_printf ("Adjacent different sole owners idxs %i, %i", i - 1, GNONOGRAMS_REGION_FORWARDS);
							_tmp29_ = _tmp28_;
							gnonograms_region_record_error (self, "check_collisions", _tmp29_);
							_g_free0 (_tmp29_);
							result = FALSE;
							return result;
						} else {
							continue;
						}
					} else {
						if (next_owner < 0) {
							gnonograms_region_set_cell_owner (self, i - 1, owner, TRUE, TRUE);
							if (owner > 0) {
								gint start = 0;
								gint length = 0;
								gint* _tmp30_;
								gint _tmp30__length1;
								gint _tmp31_;
								gint limit = 0;
								gint filled_idx = 0;
								start = i - 1;
								_tmp30_ = self->priv->blocks;
								_tmp30__length1 = self->priv->blocks_length1;
								_tmp31_ = _tmp30_[owner - 1];
								length = _tmp31_;
								limit = start - length;
								filled_idx = gnonograms_region_seek_next_required_status (self, (gint) GNONOGRAMS_CELL_STATE_FILLED, start, limit, GNONOGRAMS_REGION_BACKWARDS);
								if (filled_idx < limit) {
									{
										gint j = 0;
										j = filled_idx;
										{
											gboolean _tmp32_ = FALSE;
											_tmp32_ = TRUE;
											while (TRUE) {
												if (!_tmp32_) {
													gint _tmp33_;
													_tmp33_ = j;
													j = _tmp33_ + 1;
												}
												_tmp32_ = FALSE;
												if (!(j < limit)) {
													break;
												}
												gnonograms_region_set_cell_owner (self, j, owner - 1, TRUE, FALSE);
											}
										}
									}
								}
								changed = TRUE;
							}
						}
					}
				}
			}
		}
	}
	result = changed;
	return result;
}

static gint
gnonograms_region_seek_next_required_status (GnonogramsRegion* self,
                                             gint cs,
                                             gint idx,
                                             gint limit,
                                             gint direction)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (limit < -1) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = self->priv->_n_cells;
		_tmp0_ = limit > _tmp1_;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp2_ = g_strdup ("limit < -1 || limit > n_cells");
		_g_free0 (self->message);
		self->message = _tmp2_;
		result = 0;
		return result;
	}
	if (direction == GNONOGRAMS_REGION_FORWARDS) {
		_tmp3_ = idx >= limit;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = limit;
		return result;
	} else {
		gboolean _tmp4_ = FALSE;
		if (direction == GNONOGRAMS_REGION_BACKWARDS) {
			_tmp4_ = idx <= limit;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			result = limit;
			return result;
		}
	}
	{
		gint i = 0;
		i = idx;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				GnonogramsCellState* _tmp6_;
				gint _tmp6__length1;
				GnonogramsCellState _tmp7_;
				if (!_tmp5_) {
					i += direction;
				}
				_tmp5_ = FALSE;
				if (!(i != limit)) {
					break;
				}
				_tmp6_ = self->priv->status;
				_tmp6__length1 = self->priv->status_length1;
				_tmp7_ = _tmp6_[i];
				if (_tmp7_ == cs) {
					result = i;
					return result;
				}
			}
		}
	}
	result = limit;
	return result;
}

static gint
gnonograms_region_count_consecutive_with_state_from (GnonogramsRegion* self,
                                                     gint cs,
                                                     gint idx,
                                                     gboolean forwards)
{
	gint count = 0;
	gboolean _tmp0_ = FALSE;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	if (forwards) {
		_tmp0_ = idx >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			gint _tmp2_;
			gint _tmp5_;
			gint _tmp6_;
			_tmp2_ = self->priv->_n_cells;
			if (idx < _tmp2_) {
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState _tmp4_;
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = _tmp3_[idx];
				_tmp1_ = _tmp4_ == cs;
			} else {
				_tmp1_ = FALSE;
			}
			if (!_tmp1_) {
				break;
			}
			_tmp5_ = count;
			count = _tmp5_ + 1;
			_tmp6_ = idx;
			idx = _tmp6_ + 1;
		}
	} else {
		gboolean _tmp7_ = FALSE;
		if (!forwards) {
			gint _tmp8_;
			_tmp8_ = self->priv->_n_cells;
			_tmp7_ = idx < _tmp8_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			while (TRUE) {
				gboolean _tmp9_ = FALSE;
				gint _tmp12_;
				gint _tmp13_;
				if (idx >= 0) {
					GnonogramsCellState* _tmp10_;
					gint _tmp10__length1;
					GnonogramsCellState _tmp11_;
					_tmp10_ = self->priv->status;
					_tmp10__length1 = self->priv->status_length1;
					_tmp11_ = _tmp10_[idx];
					_tmp9_ = _tmp11_ == cs;
				} else {
					_tmp9_ = FALSE;
				}
				if (!_tmp9_) {
					break;
				}
				_tmp12_ = count;
				count = _tmp12_ + 1;
				_tmp13_ = idx;
				idx = _tmp13_ - 1;
			}
		} else {
			gchar* _tmp14_;
			gnonograms_region_set_in_error (self, TRUE);
			_tmp14_ = g_strdup ("count_consecutive_with_state_from");
			_g_free0 (self->message);
			self->message = _tmp14_;
		}
	}
	result = count;
	return result;
}

static gint
gnonograms_region_count_contiguous_with_same_owner_from (GnonogramsRegion* self,
                                                         gint owner,
                                                         gint idx)
{
	gint count = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	if (idx >= 0) {
		while (TRUE) {
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
			gint _tmp2_;
			gint _tmp7_;
			gint _tmp8_;
			_tmp2_ = self->priv->_n_cells;
			if (idx < _tmp2_) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				gboolean _tmp4_;
				_tmp3_ = self->priv->tags;
				_tmp3__length1 = self->priv->tags_length1;
				_tmp3__length2 = self->priv->tags_length2;
				_tmp4_ = _tmp3_[(idx * _tmp3__length2) + owner];
				_tmp1_ = _tmp4_;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gboolean _tmp6_;
				_tmp5_ = self->priv->tags;
				_tmp5__length1 = self->priv->tags_length1;
				_tmp5__length2 = self->priv->tags_length2;
				_tmp6_ = _tmp5_[(idx * _tmp5__length2) + self->priv->is_finished_pointer];
				_tmp0_ = !_tmp6_;
			} else {
				_tmp0_ = FALSE;
			}
			if (!_tmp0_) {
				break;
			}
			_tmp7_ = count;
			count = _tmp7_ + 1;
			_tmp8_ = idx;
			idx = _tmp8_ + 1;
		}
	} else {
		gchar* _tmp9_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp9_ = g_strdup ("count_contiguous_with_same_owner_from");
		_g_free0 (self->message);
		self->message = _tmp9_;
	}
	result = count;
	return result;
}

static gint
gnonograms_region_count_available_ranges (GnonogramsRegion* self,
                                          gboolean notempty)
{
	gint range = 0;
	gint start = 0;
	gint length = 0;
	gint idx = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	range = 0;
	start = 0;
	length = 0;
	idx = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
		gint _tmp4_;
		_tmp1_ = self->priv->_n_cells;
		if (idx < _tmp1_) {
			gboolean* _tmp2_;
			gint _tmp2__length1;
			gint _tmp2__length2;
			gboolean _tmp3_;
			_tmp2_ = self->priv->tags;
			_tmp2__length1 = self->priv->tags_length1;
			_tmp2__length2 = self->priv->tags_length2;
			_tmp3_ = _tmp2_[(idx * _tmp2__length2) + self->priv->is_finished_pointer];
			_tmp0_ = _tmp3_;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp4_ = idx;
		idx = _tmp4_ + 1;
	}
	while (TRUE) {
		gint _tmp5_;
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		gboolean _tmp21_ = FALSE;
		gint _tmp26_;
		_tmp5_ = self->priv->_n_cells;
		if (!(idx < _tmp5_)) {
			break;
		}
		length = 0;
		start = idx;
		_tmp6_ = self->priv->ranges;
		_tmp6__length1 = self->priv->ranges_length1;
		_tmp6__length2 = self->priv->ranges_length2;
		_tmp6_[(range * _tmp6__length2) + 0] = start;
		_tmp7_ = self->priv->ranges;
		_tmp7__length1 = self->priv->ranges_length1;
		_tmp7__length2 = self->priv->ranges_length2;
		_tmp7_[(range * _tmp7__length2) + 2] = 0;
		_tmp8_ = self->priv->ranges;
		_tmp8__length1 = self->priv->ranges_length1;
		_tmp8__length2 = self->priv->ranges_length2;
		_tmp8_[(range * _tmp8__length2) + 3] = 0;
		while (TRUE) {
			gboolean _tmp9_ = FALSE;
			gint _tmp10_;
			gboolean* _tmp13_;
			gint _tmp13__length1;
			gint _tmp13__length2;
			gboolean _tmp14_;
			gint _tmp19_;
			gint _tmp20_;
			_tmp10_ = self->priv->_n_cells;
			if (idx < _tmp10_) {
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gboolean _tmp12_;
				_tmp11_ = self->priv->tags;
				_tmp11__length1 = self->priv->tags_length1;
				_tmp11__length2 = self->priv->tags_length2;
				_tmp12_ = _tmp11_[(idx * _tmp11__length2) + self->priv->is_finished_pointer];
				_tmp9_ = !_tmp12_;
			} else {
				_tmp9_ = FALSE;
			}
			if (!_tmp9_) {
				break;
			}
			_tmp13_ = self->priv->tags;
			_tmp13__length1 = self->priv->tags_length1;
			_tmp13__length2 = self->priv->tags_length2;
			_tmp14_ = _tmp13_[(idx * _tmp13__length2) + self->priv->can_be_empty_pointer];
			if (!_tmp14_) {
				gint* _tmp15_;
				gint _tmp15__length1;
				gint _tmp15__length2;
				gint _tmp16_;
				_tmp15_ = self->priv->ranges;
				_tmp15__length1 = self->priv->ranges_length1;
				_tmp15__length2 = self->priv->ranges_length2;
				_tmp16_ = _tmp15_[(range * _tmp15__length2) + 2];
				_tmp15_[(range * _tmp15__length2) + 2] = _tmp16_ + 1;
			} else {
				gint* _tmp17_;
				gint _tmp17__length1;
				gint _tmp17__length2;
				gint _tmp18_;
				_tmp17_ = self->priv->ranges;
				_tmp17__length1 = self->priv->ranges_length1;
				_tmp17__length2 = self->priv->ranges_length2;
				_tmp18_ = _tmp17_[(range * _tmp17__length2) + 3];
				_tmp17_[(range * _tmp17__length2) + 3] = _tmp18_ + 1;
			}
			_tmp19_ = idx;
			idx = _tmp19_ + 1;
			_tmp20_ = length;
			length = _tmp20_ + 1;
		}
		if (!notempty) {
			_tmp21_ = TRUE;
		} else {
			gint* _tmp22_;
			gint _tmp22__length1;
			gint _tmp22__length2;
			gint _tmp23_;
			_tmp22_ = self->priv->ranges;
			_tmp22__length1 = self->priv->ranges_length1;
			_tmp22__length2 = self->priv->ranges_length2;
			_tmp23_ = _tmp22_[(range * _tmp22__length2) + 2];
			_tmp21_ = _tmp23_ != 0;
		}
		if (_tmp21_) {
			gint* _tmp24_;
			gint _tmp24__length1;
			gint _tmp24__length2;
			gint _tmp25_;
			_tmp24_ = self->priv->ranges;
			_tmp24__length1 = self->priv->ranges_length1;
			_tmp24__length2 = self->priv->ranges_length2;
			_tmp24_[(range * _tmp24__length2) + 1] = length;
			_tmp25_ = range;
			range = _tmp25_ + 1;
		}
		_tmp26_ = idx;
		idx = _tmp26_ + 1;
		while (TRUE) {
			gboolean _tmp27_ = FALSE;
			gint _tmp28_;
			gint _tmp31_;
			_tmp28_ = self->priv->_n_cells;
			if (idx < _tmp28_) {
				gboolean* _tmp29_;
				gint _tmp29__length1;
				gint _tmp29__length2;
				gboolean _tmp30_;
				_tmp29_ = self->priv->tags;
				_tmp29__length1 = self->priv->tags_length1;
				_tmp29__length2 = self->priv->tags_length2;
				_tmp30_ = _tmp29_[(idx * _tmp29__length2) + self->priv->is_finished_pointer];
				_tmp27_ = _tmp30_;
			} else {
				_tmp27_ = FALSE;
			}
			if (!_tmp27_) {
				break;
			}
			_tmp31_ = idx;
			idx = _tmp31_ + 1;
		}
	}
	result = range;
	return result;
}

static gboolean
gnonograms_region_match_clue (GnonogramsRegion* self)
{
	gint count = 0;
	gint idx = 0;
	gint blk_ptr = 0;
	gint blk_counter = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	count = 0;
	idx = 0;
	blk_ptr = 0;
	blk_counter = 0;
	while (TRUE) {
		gint _tmp0_;
		gint _tmp6_;
		gint* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		_tmp0_ = self->priv->_n_cells;
		if (!(idx < _tmp0_)) {
			break;
		}
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			gint _tmp2_;
			gint _tmp5_;
			_tmp2_ = self->priv->_n_cells;
			if (idx < _tmp2_) {
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState _tmp4_;
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = _tmp3_[idx];
				_tmp1_ = _tmp4_ == GNONOGRAMS_CELL_STATE_EMPTY;
			} else {
				_tmp1_ = FALSE;
			}
			if (!_tmp1_) {
				break;
			}
			_tmp5_ = idx;
			idx = _tmp5_ + 1;
		}
		_tmp6_ = self->priv->_n_cells;
		if (idx < _tmp6_) {
			gint _tmp7_;
			_tmp7_ = count;
			count = _tmp7_ + 1;
		} else {
			break;
		}
		while (TRUE) {
			gboolean _tmp8_ = FALSE;
			gint _tmp9_;
			gint _tmp12_;
			gint _tmp13_;
			_tmp9_ = self->priv->_n_cells;
			if (idx < _tmp9_) {
				GnonogramsCellState* _tmp10_;
				gint _tmp10__length1;
				GnonogramsCellState _tmp11_;
				_tmp10_ = self->priv->status;
				_tmp10__length1 = self->priv->status_length1;
				_tmp11_ = _tmp10_[idx];
				_tmp8_ = _tmp11_ != GNONOGRAMS_CELL_STATE_EMPTY;
			} else {
				_tmp8_ = FALSE;
			}
			if (!_tmp8_) {
				break;
			}
			_tmp12_ = blk_counter;
			blk_counter = _tmp12_ + 1;
			_tmp13_ = idx;
			idx = _tmp13_ + 1;
		}
		_tmp14_ = self->priv->blocks;
		_tmp14__length1 = self->priv->blocks_length1;
		_tmp15_ = _tmp14_[blk_ptr];
		if (_tmp15_ != blk_counter) {
			result = FALSE;
			return result;
		} else {
			gint _tmp16_;
			_tmp16_ = blk_ptr;
			blk_ptr = _tmp16_ + 1;
			blk_counter = 0;
		}
	}
	if (count != self->priv->n_blocks) {
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp17_ = g_strdup_printf ("%i", count);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat ("Wrong number of blocks found ", _tmp18_, NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat (_tmp20_, " should be ", NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strdup_printf ("%i", self->priv->n_blocks);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strconcat (_tmp22_, _tmp24_, NULL);
		_tmp26_ = _tmp25_;
		gnonograms_region_record_error (self, "Check n_blocks", _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp22_);
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

static gint
gnonograms_region_count_capped_ranges (GnonogramsRegion* self)
{
	gint range = 0;
	gint start = 0;
	gint length = 0;
	gint idx = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	range = 0;
	start = 0;
	length = 0;
	idx = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
		gint _tmp4_;
		_tmp1_ = self->priv->_n_cells;
		if (idx < _tmp1_) {
			GnonogramsCellState* _tmp2_;
			gint _tmp2__length1;
			GnonogramsCellState _tmp3_;
			_tmp2_ = self->priv->status;
			_tmp2__length1 = self->priv->status_length1;
			_tmp3_ = _tmp2_[idx];
			_tmp0_ = _tmp3_ != GNONOGRAMS_CELL_STATE_FILLED;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp4_ = idx;
		idx = _tmp4_ + 1;
	}
	while (TRUE) {
		gint _tmp5_;
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gint _tmp25_;
		_tmp5_ = self->priv->_n_cells;
		if (!(idx < _tmp5_)) {
			break;
		}
		length = 0;
		start = idx;
		_tmp6_ = self->priv->ranges;
		_tmp6__length1 = self->priv->ranges_length1;
		_tmp6__length2 = self->priv->ranges_length2;
		_tmp6_[(range * _tmp6__length2) + 0] = start;
		_tmp7_ = self->priv->ranges;
		_tmp7__length1 = self->priv->ranges_length1;
		_tmp7__length2 = self->priv->ranges_length2;
		_tmp7_[(range * _tmp7__length2) + 2] = 0;
		_tmp8_ = self->priv->ranges;
		_tmp8__length1 = self->priv->ranges_length1;
		_tmp8__length2 = self->priv->ranges_length2;
		_tmp8_[(range * _tmp8__length2) + 3] = 0;
		while (TRUE) {
			gboolean _tmp9_ = FALSE;
			gint _tmp10_;
			gint _tmp13_;
			gint _tmp14_;
			_tmp10_ = self->priv->_n_cells;
			if (idx < _tmp10_) {
				GnonogramsCellState* _tmp11_;
				gint _tmp11__length1;
				GnonogramsCellState _tmp12_;
				_tmp11_ = self->priv->status;
				_tmp11__length1 = self->priv->status_length1;
				_tmp12_ = _tmp11_[idx];
				_tmp9_ = _tmp12_ == GNONOGRAMS_CELL_STATE_FILLED;
			} else {
				_tmp9_ = FALSE;
			}
			if (!_tmp9_) {
				break;
			}
			_tmp13_ = idx;
			idx = _tmp13_ + 1;
			_tmp14_ = length;
			length = _tmp14_ + 1;
		}
		if (start == 0) {
			_tmp16_ = TRUE;
		} else {
			GnonogramsCellState* _tmp17_;
			gint _tmp17__length1;
			GnonogramsCellState _tmp18_;
			_tmp17_ = self->priv->status;
			_tmp17__length1 = self->priv->status_length1;
			_tmp18_ = _tmp17_[start - 1];
			_tmp16_ = _tmp18_ == GNONOGRAMS_CELL_STATE_EMPTY;
		}
		if (_tmp16_) {
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			_tmp20_ = self->priv->_n_cells;
			if (idx == _tmp20_) {
				_tmp19_ = TRUE;
			} else {
				GnonogramsCellState* _tmp21_;
				gint _tmp21__length1;
				GnonogramsCellState _tmp22_;
				_tmp21_ = self->priv->status;
				_tmp21__length1 = self->priv->status_length1;
				_tmp22_ = _tmp21_[idx];
				_tmp19_ = _tmp22_ == GNONOGRAMS_CELL_STATE_EMPTY;
			}
			_tmp15_ = _tmp19_;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			gint* _tmp23_;
			gint _tmp23__length1;
			gint _tmp23__length2;
			gint _tmp24_;
			_tmp23_ = self->priv->ranges;
			_tmp23__length1 = self->priv->ranges_length1;
			_tmp23__length2 = self->priv->ranges_length2;
			_tmp23_[(range * _tmp23__length2) + 1] = length;
			_tmp24_ = range;
			range = _tmp24_ + 1;
		}
		_tmp25_ = idx;
		idx = _tmp25_ + 1;
		while (TRUE) {
			gboolean _tmp26_ = FALSE;
			gint _tmp27_;
			gint _tmp30_;
			_tmp27_ = self->priv->_n_cells;
			if (idx < _tmp27_) {
				GnonogramsCellState* _tmp28_;
				gint _tmp28__length1;
				GnonogramsCellState _tmp29_;
				_tmp28_ = self->priv->status;
				_tmp28__length1 = self->priv->status_length1;
				_tmp29_ = _tmp28_[idx];
				_tmp26_ = _tmp29_ != GNONOGRAMS_CELL_STATE_FILLED;
			} else {
				_tmp26_ = FALSE;
			}
			if (!_tmp26_) {
				break;
			}
			_tmp30_ = idx;
			idx = _tmp30_ + 1;
		}
	}
	result = range;
	return result;
}

static gint
gnonograms_region_count_possible_owners_and_can_be_empty (GnonogramsRegion* self,
                                                          gint cell)
{
	gint count = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	if (gnonograms_region_is_invalid_data (self, cell, 0, 1)) {
		gchar* _tmp0_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp0_ = g_strdup ("count_possible_owners_and_can_be_empty 1");
		_g_free0 (self->message);
		self->message = _tmp0_;
	} else {
		gboolean* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gboolean _tmp7_;
		{
			gint j = 0;
			j = 0;
			{
				gboolean _tmp1_ = FALSE;
				_tmp1_ = TRUE;
				while (TRUE) {
					gboolean* _tmp3_;
					gint _tmp3__length1;
					gint _tmp3__length2;
					gboolean _tmp4_;
					if (!_tmp1_) {
						gint _tmp2_;
						_tmp2_ = j;
						j = _tmp2_ + 1;
					}
					_tmp1_ = FALSE;
					if (!(j < self->priv->n_blocks)) {
						break;
					}
					_tmp3_ = self->priv->tags;
					_tmp3__length1 = self->priv->tags_length1;
					_tmp3__length2 = self->priv->tags_length2;
					_tmp4_ = _tmp3_[(cell * _tmp3__length2) + j];
					if (_tmp4_) {
						gint _tmp5_;
						_tmp5_ = count;
						count = _tmp5_ + 1;
					}
				}
			}
		}
		_tmp6_ = self->priv->tags;
		_tmp6__length1 = self->priv->tags_length1;
		_tmp6__length2 = self->priv->tags_length2;
		_tmp7_ = _tmp6_[(cell * _tmp6__length2) + self->priv->can_be_empty_pointer];
		if (_tmp7_) {
			gint _tmp8_;
			_tmp8_ = count;
			count = _tmp8_ + 1;
		}
	}
	if (count == 0) {
		gchar* _tmp9_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp9_ = g_strdup ("count_possible_owners_and_can_be_empty 2");
		_g_free0 (self->message);
		self->message = _tmp9_;
	}
	result = count;
	return result;
}

static gint
gnonograms_region_count_cell_state (GnonogramsRegion* self,
                                    gint cs)
{
	gint count = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = _tmp3_[i];
				if (_tmp4_ == cs) {
					gint _tmp5_;
					_tmp5_ = count;
					count = _tmp5_ + 1;
				}
			}
		}
	}
	result = count;
	return result;
}

static void
_vala_array_add3 (gint* * array,
                  int* length,
                  int* size,
                  gint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static gint*
gnonograms_region_get_blocks_available (GnonogramsRegion* self,
                                        gint* result_length1)
{
	gint* blocks = NULL;
	gint* _tmp0_;
	gint blocks_length1;
	gint _blocks_size_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gint, 0);
	blocks = _tmp0_;
	blocks_length1 = 0;
	_blocks_size_ = blocks_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gboolean _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp3_ = self->priv->completed_blocks;
				_tmp3__length1 = self->priv->completed_blocks_length1;
				_tmp4_ = _tmp3_[i];
				if (!_tmp4_) {
					gint* _tmp5_;
					gint _tmp5__length1;
					_tmp5_ = blocks;
					_tmp5__length1 = blocks_length1;
					_vala_array_add3 (&blocks, &blocks_length1, &_blocks_size_, i);
				}
			}
		}
	}
	_tmp6_ = blocks;
	_tmp6__length1 = blocks_length1;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	return result;
}

static gint
gnonograms_region_have_same_owner (GnonogramsRegion* self,
                                   gint cell1,
                                   gint cell2)
{
	gint count = 0;
	gint owner = 0;
	gboolean tmp = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	owner = -1;
	if (cell1 < 0) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp3_;
		_tmp3_ = self->priv->_n_cells;
		_tmp2_ = cell1 >= _tmp3_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = cell2 < 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp4_;
		_tmp4_ = self->priv->_n_cells;
		_tmp0_ = cell2 >= _tmp4_;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp5_ = g_strdup ("have_same_owner");
		_g_free0 (self->message);
		self->message = _tmp5_;
	} else {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp6_ = FALSE;
				_tmp6_ = TRUE;
				while (TRUE) {
					gboolean* _tmp8_;
					gint _tmp8__length1;
					gint _tmp8__length2;
					gboolean _tmp9_;
					gboolean _tmp10_ = FALSE;
					if (!_tmp6_) {
						gint _tmp7_;
						_tmp7_ = i;
						i = _tmp7_ + 1;
					}
					_tmp6_ = FALSE;
					if (!(i < self->priv->n_blocks)) {
						break;
					}
					_tmp8_ = self->priv->tags;
					_tmp8__length1 = self->priv->tags_length1;
					_tmp8__length2 = self->priv->tags_length2;
					_tmp9_ = _tmp8_[(cell1 * _tmp8__length2) + i];
					tmp = _tmp9_;
					if (count > 1) {
						_tmp10_ = TRUE;
					} else {
						gboolean* _tmp11_;
						gint _tmp11__length1;
						gint _tmp11__length2;
						gboolean _tmp12_;
						_tmp11_ = self->priv->tags;
						_tmp11__length1 = self->priv->tags_length1;
						_tmp11__length2 = self->priv->tags_length2;
						_tmp12_ = _tmp11_[(cell2 * _tmp11__length2) + i];
						_tmp10_ = tmp != _tmp12_;
					}
					if (_tmp10_) {
						owner = -1;
						break;
					} else {
						if (tmp) {
							gint _tmp13_;
							_tmp13_ = count;
							count = _tmp13_ + 1;
							owner = i;
						}
					}
				}
			}
		}
	}
	result = owner;
	return result;
}

static gint
gnonograms_region_get_sole_owner (GnonogramsRegion* self,
                                  gint cell)
{
	gint count = 0;
	gint owner = 0;
	gint _tmp5_ = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	owner = -1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				gboolean _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp2_ = self->priv->tags;
				_tmp2__length1 = self->priv->tags_length1;
				_tmp2__length2 = self->priv->tags_length2;
				_tmp3_ = _tmp2_[(cell * _tmp2__length2) + i];
				if (_tmp3_) {
					gint _tmp4_;
					owner = i;
					_tmp4_ = count;
					count = _tmp4_ + 1;
				}
				if (count > 1) {
					break;
				}
			}
		}
	}
	if (count == 1) {
		_tmp5_ = owner;
	} else {
		_tmp5_ = -1;
	}
	result = _tmp5_;
	return result;
}

static gboolean
gnonograms_region_fix_block_in_range (GnonogramsRegion* self,
                                      gint block,
                                      gint start,
                                      gint length)
{
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	if (gnonograms_region_is_invalid_data (self, start, block, length)) {
		gchar* _tmp0_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp0_ = g_strdup ("fix_block_in_range");
		_g_free0 (self->message);
		self->message = _tmp0_;
	} else {
		gint blocklength = 0;
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp2_;
		gint freedom = 0;
		_tmp1_ = self->priv->blocks;
		_tmp1__length1 = self->priv->blocks_length1;
		_tmp2_ = _tmp1_[block];
		blocklength = _tmp2_;
		freedom = length - blocklength;
		if (freedom < 0) {
			gnonograms_region_record_error (self, "Fix block in range", "block longer than range");
			result = FALSE;
			return result;
		}
		if (freedom < blocklength) {
			if (freedom == 0) {
				gnonograms_region_set_block_complete_and_cap (self, block, start, 1);
				changed = TRUE;
			} else {
				gnonograms_region_set_range_owner (self, block, start + freedom, blocklength - freedom, TRUE, FALSE);
			}
		}
	}
	result = changed;
	return result;
}

static gint
gnonograms_region_find_largest_possible_block_for_cell (GnonogramsRegion* self,
                                                        gint cell)
{
	gint maxsize = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	maxsize = -1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				gboolean _tmp3_;
				gint* _tmp4_;
				gint _tmp4__length1;
				gint _tmp5_;
				gint* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp2_ = self->priv->tags;
				_tmp2__length1 = self->priv->tags_length1;
				_tmp2__length2 = self->priv->tags_length2;
				_tmp3_ = _tmp2_[(cell * _tmp2__length2) + i];
				if (!_tmp3_) {
					continue;
				}
				_tmp4_ = self->priv->blocks;
				_tmp4__length1 = self->priv->blocks_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ <= maxsize) {
					continue;
				}
				_tmp6_ = self->priv->blocks;
				_tmp6__length1 = self->priv->blocks_length1;
				_tmp7_ = _tmp6_[i];
				maxsize = _tmp7_;
			}
		}
	}
	result = maxsize;
	return result;
}

static gint
gnonograms_region_find_smallest_possible_block_for_cell (GnonogramsRegion* self,
                                                         gint cell)
{
	gint minsize = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	minsize = 9999;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				gboolean _tmp3_;
				gint* _tmp4_;
				gint _tmp4__length1;
				gint _tmp5_;
				gint* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->n_blocks)) {
					break;
				}
				_tmp2_ = self->priv->tags;
				_tmp2__length1 = self->priv->tags_length1;
				_tmp2__length2 = self->priv->tags_length2;
				_tmp3_ = _tmp2_[(cell * _tmp2__length2) + i];
				if (!_tmp3_) {
					continue;
				}
				_tmp4_ = self->priv->blocks;
				_tmp4__length1 = self->priv->blocks_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ >= minsize) {
					continue;
				}
				_tmp6_ = self->priv->blocks;
				_tmp6__length1 = self->priv->blocks_length1;
				_tmp7_ = _tmp6_[i];
				minsize = _tmp7_;
			}
		}
	}
	if (minsize == 9999) {
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp8_ = g_strdup_printf ("%i", cell);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strconcat ("No block possible in ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		gnonograms_region_record_error (self, "findsmallest possible in cell", _tmp11_);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		result = 0;
		return result;
	}
	result = minsize;
	return result;
}

static void
gnonograms_region_remove_block_from_cell_to_end (GnonogramsRegion* self,
                                                 gint block,
                                                 gint start,
                                                 gint direction)
{
	gint _tmp0_ = 0;
	gint length = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	if (direction > 0) {
		gint _tmp1_;
		_tmp1_ = self->priv->_n_cells;
		_tmp0_ = _tmp1_ - start;
	} else {
		_tmp0_ = start + 1;
	}
	length = _tmp0_;
	if (direction > 0) {
		_tmp2_ = start;
	} else {
		_tmp2_ = 0;
	}
	start = _tmp2_;
	if (length > 0) {
		gnonograms_region_remove_block_from_range (self, block, start, length, 1);
	}
}

static void
gnonograms_region_remove_block_from_range (GnonogramsRegion* self,
                                           gint block,
                                           gint start,
                                           gint length,
                                           gint direction)
{
	g_return_if_fail (self != NULL);
	if (direction < 0) {
		start = (start - length) + 1;
	}
	if (gnonograms_region_is_invalid_data (self, start, block, length)) {
		gchar* _tmp0_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp0_ = g_strdup ("remove_block_from_range");
		_g_free0 (self->message);
		self->message = _tmp0_;
	} else {
		{
			gint i = 0;
			i = start;
			{
				gboolean _tmp1_ = FALSE;
				_tmp1_ = TRUE;
				while (TRUE) {
					gboolean* _tmp3_;
					gint _tmp3__length1;
					gint _tmp3__length2;
					if (!_tmp1_) {
						gint _tmp2_;
						_tmp2_ = i;
						i = _tmp2_ + 1;
					}
					_tmp1_ = FALSE;
					if (!(i < (start + length))) {
						break;
					}
					_tmp3_ = self->priv->tags;
					_tmp3__length1 = self->priv->tags_length1;
					_tmp3__length2 = self->priv->tags_length2;
					_tmp3_[(i * _tmp3__length2) + block] = FALSE;
				}
			}
		}
	}
}

static gboolean
gnonograms_region_set_block_complete_and_cap (GnonogramsRegion* self,
                                              gint block,
                                              gint start,
                                              gint direction)
{
	gboolean changed = FALSE;
	gint length = 0;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gboolean _tmp3_ = FALSE;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gboolean _tmp5_;
	gboolean* _tmp9_;
	gint _tmp9__length1;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gint l = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	_tmp0_ = self->priv->blocks;
	_tmp0__length1 = self->priv->blocks_length1;
	_tmp1_ = _tmp0_[block];
	length = _tmp1_;
	if (direction < 0) {
		start = (start - length) + 1;
	}
	if (gnonograms_region_is_invalid_data (self, start, block, length)) {
		gchar* _tmp2_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp2_ = g_strdup ("set_block_complete_and_cap 1");
		_g_free0 (self->message);
		self->message = _tmp2_;
		result = FALSE;
		return result;
	}
	_tmp4_ = self->priv->completed_blocks;
	_tmp4__length1 = self->priv->completed_blocks_length1;
	_tmp5_ = _tmp4_[block];
	if (_tmp5_ == TRUE) {
		gboolean* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gboolean _tmp7_;
		_tmp6_ = self->priv->tags;
		_tmp6__length1 = self->priv->tags_length1;
		_tmp6__length2 = self->priv->tags_length2;
		_tmp7_ = _tmp6_[(start * _tmp6__length2) + block];
		_tmp3_ = _tmp7_ == FALSE;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gchar* _tmp8_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp8_ = g_strdup ("set_block_complete_and_cap 2");
		_g_free0 (self->message);
		self->message = _tmp8_;
		result = FALSE;
		return result;
	}
	_tmp9_ = self->priv->completed_blocks;
	_tmp9__length1 = self->priv->completed_blocks_length1;
	_tmp9_[block] = TRUE;
	gnonograms_region_set_range_owner (self, block, start, length, TRUE, FALSE);
	if (start > 0) {
		gboolean* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		gboolean _tmp12_;
		_tmp11_ = self->priv->tags;
		_tmp11__length1 = self->priv->tags_length1;
		_tmp11__length2 = self->priv->tags_length2;
		_tmp12_ = _tmp11_[((start - 1) * _tmp11__length2) + self->priv->is_finished_pointer];
		_tmp10_ = !_tmp12_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		changed = TRUE;
		gnonograms_region_set_cell_empty (self, start - 1);
	}
	_tmp14_ = self->priv->_n_cells;
	if ((start + length) < _tmp14_) {
		gboolean* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gboolean _tmp16_;
		_tmp15_ = self->priv->tags;
		_tmp15__length1 = self->priv->tags_length1;
		_tmp15__length2 = self->priv->tags_length2;
		_tmp16_ = _tmp15_[((start + length) * _tmp15__length2) + self->priv->is_finished_pointer];
		_tmp13_ = !_tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		changed = TRUE;
		gnonograms_region_set_cell_empty (self, start + length);
	}
	{
		gint cell = 0;
		cell = start;
		{
			gboolean _tmp17_ = FALSE;
			_tmp17_ = TRUE;
			while (TRUE) {
				if (!_tmp17_) {
					gint _tmp18_;
					_tmp18_ = cell;
					cell = _tmp18_ + 1;
				}
				_tmp17_ = FALSE;
				if (!(cell < (start + length))) {
					break;
				}
				gnonograms_region_set_cell_complete (self, cell);
			}
		}
	}
	if (block > 1) {
		l = 0;
		{
			gint bl = 0;
			bl = block - 2;
			{
				gboolean _tmp19_ = FALSE;
				_tmp19_ = TRUE;
				while (TRUE) {
					gint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					if (!_tmp19_) {
						gint _tmp20_;
						_tmp20_ = bl;
						bl = _tmp20_ - 1;
					}
					_tmp19_ = FALSE;
					if (!(bl >= 0)) {
						break;
					}
					_tmp21_ = self->priv->blocks;
					_tmp21__length1 = self->priv->blocks_length1;
					_tmp22_ = _tmp21_[bl + 1];
					l = (l + _tmp22_) + 1;
					gnonograms_region_remove_block_from_range (self, bl, start - 2, l, -1);
				}
			}
		}
	}
	if (block < (self->priv->n_blocks - 2)) {
		l = 0;
		{
			gint bl = 0;
			bl = block + 2;
			{
				gboolean _tmp23_ = FALSE;
				_tmp23_ = TRUE;
				while (TRUE) {
					gint* _tmp25_;
					gint _tmp25__length1;
					gint _tmp26_;
					if (!_tmp23_) {
						gint _tmp24_;
						_tmp24_ = bl;
						bl = _tmp24_ + 1;
					}
					_tmp23_ = FALSE;
					if (!(bl <= (self->priv->n_blocks - 1))) {
						break;
					}
					_tmp25_ = self->priv->blocks;
					_tmp25__length1 = self->priv->blocks_length1;
					_tmp26_ = _tmp25_[bl - 1];
					l = (l + _tmp26_) + 1;
					gnonograms_region_remove_block_from_range (self, bl, (start + length) + 1, l, 1);
				}
			}
		}
	}
	result = changed;
	return result;
}

static gboolean
gnonograms_region_set_range_owner (GnonogramsRegion* self,
                                   gint owner,
                                   gint start,
                                   gint length,
                                   gboolean exclusive,
                                   gboolean can_be_empty)
{
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	if (gnonograms_region_is_invalid_data (self, start, owner, length)) {
		gchar* _tmp0_;
		gnonograms_region_set_in_error (self, TRUE);
		_tmp0_ = g_strdup ("set_range_owner 1");
		_g_free0 (self->message);
		self->message = _tmp0_;
		result = FALSE;
		return result;
	} else {
		gint blocklength = 0;
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp2_;
		_tmp1_ = self->priv->blocks;
		_tmp1__length1 = self->priv->blocks_length1;
		_tmp2_ = _tmp1_[owner];
		blocklength = _tmp2_;
		{
			gint cell = 0;
			cell = start;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = cell;
						cell = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					if (!(cell < (start + length))) {
						break;
					}
					gnonograms_region_set_cell_owner (self, cell, owner, exclusive, can_be_empty);
				}
			}
		}
		if (exclusive) {
			gboolean _tmp5_ = FALSE;
			gint bstart = 0;
			gint bend = 0;
			gint _tmp7_;
			gint earliestend = 0;
			gint lateststart = 0;
			if (blocklength < length) {
				_tmp5_ = !can_be_empty;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				gchar* _tmp6_;
				gnonograms_region_set_in_error (self, TRUE);
				_tmp6_ = g_strdup ("set_range_owner 2");
				_g_free0 (self->message);
				self->message = _tmp6_;
				result = FALSE;
				return result;
			}
			bstart = MIN (start - 1, (start + length) - blocklength);
			if (bstart >= 0) {
				gnonograms_region_remove_block_from_cell_to_end (self, owner, bstart - 1, -1);
			}
			bend = MAX (start + length, start + blocklength);
			_tmp7_ = self->priv->_n_cells;
			if (bend < _tmp7_) {
				gnonograms_region_remove_block_from_cell_to_end (self, owner, bend, 1);
			}
			earliestend = start + length;
			{
				gint bl = 0;
				bl = self->priv->n_blocks - 1;
				{
					gboolean _tmp8_ = FALSE;
					_tmp8_ = TRUE;
					while (TRUE) {
						if (!_tmp8_) {
							gint _tmp9_;
							_tmp9_ = bl;
							bl = _tmp9_ - 1;
						}
						_tmp8_ = FALSE;
						if (!(bl > owner)) {
							break;
						}
						gnonograms_region_remove_block_from_cell_to_end (self, bl, earliestend, -1);
					}
				}
			}
			lateststart = start - 1;
			{
				gint bl = 0;
				bl = 0;
				{
					gboolean _tmp10_ = FALSE;
					_tmp10_ = TRUE;
					while (TRUE) {
						if (!_tmp10_) {
							gint _tmp11_;
							_tmp11_ = bl;
							bl = _tmp11_ + 1;
						}
						_tmp10_ = FALSE;
						if (!(bl < owner)) {
							break;
						}
						gnonograms_region_remove_block_from_cell_to_end (self, bl, lateststart, 1);
					}
				}
			}
		}
	}
	result = changed;
	return result;
}

static gboolean
gnonograms_region_set_cell_owner (GnonogramsRegion* self,
                                  gint cell,
                                  gint owner,
                                  gboolean exclusive,
                                  gboolean can_be_empty)
{
	gboolean changed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	if (gnonograms_region_is_invalid_data (self, cell, owner, 1)) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = bool_to_string (exclusive);
		_tmp1_ = _tmp0_;
		_tmp2_ = bool_to_string (can_be_empty);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strdup_printf ("invalid data %i, %i, %s, %s", cell, owner, _tmp1_, _tmp3_);
		_tmp5_ = _tmp4_;
		gnonograms_region_record_error (self, "set_cell_owner", _tmp5_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
		_g_free0 (_tmp1_);
	} else {
		GnonogramsCellState* _tmp6_;
		gint _tmp6__length1;
		GnonogramsCellState _tmp7_;
		_tmp6_ = self->priv->status;
		_tmp6__length1 = self->priv->status_length1;
		_tmp7_ = _tmp6_[cell];
		if (_tmp7_ == GNONOGRAMS_CELL_STATE_EMPTY) {
		} else {
			gboolean _tmp8_ = FALSE;
			GnonogramsCellState* _tmp9_;
			gint _tmp9__length1;
			GnonogramsCellState _tmp10_;
			_tmp9_ = self->priv->status;
			_tmp9__length1 = self->priv->status_length1;
			_tmp10_ = _tmp9_[cell];
			if (_tmp10_ == GNONOGRAMS_CELL_STATE_COMPLETED) {
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gboolean _tmp12_;
				_tmp11_ = self->priv->tags;
				_tmp11__length1 = self->priv->tags_length1;
				_tmp11__length2 = self->priv->tags_length2;
				_tmp12_ = _tmp11_[(cell * _tmp11__length2) + owner];
				_tmp8_ = _tmp12_ == FALSE;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp13_ = g_strdup_printf ("%i", cell);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_strconcat ("contradiction cell ", _tmp14_, NULL);
				_tmp16_ = _tmp15_;
				_tmp17_ = g_strconcat (_tmp16_, " filled but cannot be owner", NULL);
				_tmp18_ = _tmp17_;
				gnonograms_region_record_error (self, "set_cell_owner", _tmp18_);
				_g_free0 (_tmp18_);
				_g_free0 (_tmp16_);
				_g_free0 (_tmp14_);
			} else {
				gboolean* _tmp24_;
				gint _tmp24__length1;
				gint _tmp24__length2;
				if (exclusive) {
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp19_ = FALSE;
							_tmp19_ = TRUE;
							while (TRUE) {
								gboolean* _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								if (!_tmp19_) {
									gint _tmp20_;
									_tmp20_ = i;
									i = _tmp20_ + 1;
								}
								_tmp19_ = FALSE;
								if (!(i < self->priv->n_blocks)) {
									break;
								}
								_tmp21_ = self->priv->tags;
								_tmp21__length1 = self->priv->tags_length1;
								_tmp21__length2 = self->priv->tags_length2;
								_tmp21_[(cell * _tmp21__length2) + i] = FALSE;
							}
						}
					}
				}
				if (!can_be_empty) {
					GnonogramsCellState* _tmp22_;
					gint _tmp22__length1;
					gboolean* _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					_tmp22_ = self->priv->status;
					_tmp22__length1 = self->priv->status_length1;
					_tmp22_[cell] = GNONOGRAMS_CELL_STATE_FILLED;
					changed = TRUE;
					_tmp23_ = self->priv->tags;
					_tmp23__length1 = self->priv->tags_length1;
					_tmp23__length2 = self->priv->tags_length2;
					_tmp23_[(cell * _tmp23__length2) + self->priv->can_be_empty_pointer] = FALSE;
				}
				_tmp24_ = self->priv->tags;
				_tmp24__length1 = self->priv->tags_length1;
				_tmp24__length2 = self->priv->tags_length2;
				_tmp24_[(cell * _tmp24__length2) + owner] = TRUE;
			}
		}
	}
	result = changed;
	return result;
}

static void
gnonograms_region_set_cell_empty (GnonogramsRegion* self,
                                  gint cell)
{
	g_return_if_fail (self != NULL);
	if (gnonograms_region_is_invalid_data (self, cell, 0, 1)) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = g_strdup_printf ("%i", cell);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strconcat ("cell ", _tmp1_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strconcat (_tmp3_, " invalid data", NULL);
		_tmp5_ = _tmp4_;
		gnonograms_region_record_error (self, "set_cell_empty", _tmp5_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
		_g_free0 (_tmp1_);
	} else {
		gboolean* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gboolean _tmp7_;
		_tmp6_ = self->priv->tags;
		_tmp6__length1 = self->priv->tags_length1;
		_tmp6__length2 = self->priv->tags_length2;
		_tmp7_ = _tmp6_[(cell * _tmp6__length2) + self->priv->can_be_empty_pointer];
		if (_tmp7_ == FALSE) {
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp8_ = g_strdup_printf ("%i", cell);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strconcat ("cell ", _tmp9_, NULL);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strconcat (_tmp11_, " cannot be empty", NULL);
			_tmp13_ = _tmp12_;
			gnonograms_region_record_error (self, "set_cell_empty", _tmp13_);
			_g_free0 (_tmp13_);
			_g_free0 (_tmp11_);
			_g_free0 (_tmp9_);
		} else {
			if (gnonograms_region_is_cell_filled (self, cell)) {
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				_tmp14_ = g_strdup_printf ("%i", cell);
				_tmp15_ = _tmp14_;
				_tmp16_ = g_strconcat ("cell ", _tmp15_, NULL);
				_tmp17_ = _tmp16_;
				_tmp18_ = g_strconcat (_tmp17_, " is filled", NULL);
				_tmp19_ = _tmp18_;
				gnonograms_region_record_error (self, "set_cell_empty", _tmp19_);
				_g_free0 (_tmp19_);
				_g_free0 (_tmp17_);
				_g_free0 (_tmp15_);
			} else {
				gboolean* _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
				gboolean* _tmp24_;
				gint _tmp24__length1;
				gint _tmp24__length2;
				GnonogramsCellState* _tmp25_;
				gint _tmp25__length1;
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp20_ = FALSE;
						_tmp20_ = TRUE;
						while (TRUE) {
							gboolean* _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							if (!_tmp20_) {
								gint _tmp21_;
								_tmp21_ = i;
								i = _tmp21_ + 1;
							}
							_tmp20_ = FALSE;
							if (!(i < self->priv->n_blocks)) {
								break;
							}
							_tmp22_ = self->priv->tags;
							_tmp22__length1 = self->priv->tags_length1;
							_tmp22__length2 = self->priv->tags_length2;
							_tmp22_[(cell * _tmp22__length2) + i] = FALSE;
						}
					}
				}
				_tmp23_ = self->priv->tags;
				_tmp23__length1 = self->priv->tags_length1;
				_tmp23__length2 = self->priv->tags_length2;
				_tmp23_[(cell * _tmp23__length2) + self->priv->can_be_empty_pointer] = TRUE;
				_tmp24_ = self->priv->tags;
				_tmp24__length1 = self->priv->tags_length1;
				_tmp24__length2 = self->priv->tags_length2;
				_tmp24_[(cell * _tmp24__length2) + self->priv->is_finished_pointer] = TRUE;
				_tmp25_ = self->priv->status;
				_tmp25__length1 = self->priv->status_length1;
				_tmp25_[cell] = GNONOGRAMS_CELL_STATE_EMPTY;
			}
		}
	}
}

static void
gnonograms_region_set_cell_complete (GnonogramsRegion* self,
                                     gint cell)
{
	GnonogramsCellState* _tmp0_;
	gint _tmp0__length1;
	GnonogramsCellState _tmp1_;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gboolean* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	GnonogramsCellState* _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->status;
	_tmp0__length1 = self->priv->status_length1;
	_tmp1_ = _tmp0_[cell];
	if (_tmp1_ == GNONOGRAMS_CELL_STATE_EMPTY) {
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp2_ = g_strdup_printf ("%i", cell);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strconcat ("cell ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat (_tmp5_, " already set empty", NULL);
		_tmp7_ = _tmp6_;
		gnonograms_region_record_error (self, "set_cell_complete", _tmp7_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
	}
	_tmp8_ = self->priv->tags;
	_tmp8__length1 = self->priv->tags_length1;
	_tmp8__length2 = self->priv->tags_length2;
	_tmp8_[(cell * _tmp8__length2) + self->priv->is_finished_pointer] = TRUE;
	_tmp9_ = self->priv->tags;
	_tmp9__length1 = self->priv->tags_length1;
	_tmp9__length2 = self->priv->tags_length2;
	_tmp9_[(cell * _tmp9__length2) + self->priv->can_be_empty_pointer] = FALSE;
	_tmp10_ = self->priv->status;
	_tmp10__length1 = self->priv->status_length1;
	_tmp10_[cell] = GNONOGRAMS_CELL_STATE_COMPLETED;
}

static gboolean
gnonograms_region_is_invalid_data (GnonogramsRegion* self,
                                   gint start,
                                   gint block,
                                   gint length)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (start < 0) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp5_;
		_tmp5_ = self->priv->_n_cells;
		_tmp4_ = start >= _tmp5_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = length < 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_n_cells;
		_tmp2_ = (start + length) > _tmp6_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = block < 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = block >= self->priv->n_blocks;
	}
	result = _tmp0_;
	return result;
}

static gboolean
gnonograms_region_is_cell_filled (GnonogramsRegion* self,
                                  gint cell)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsCellState* _tmp1_;
	gint _tmp1__length1;
	GnonogramsCellState _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->status;
	_tmp1__length1 = self->priv->status_length1;
	_tmp2_ = _tmp1_[cell];
	if (_tmp2_ == GNONOGRAMS_CELL_STATE_FILLED) {
		_tmp0_ = TRUE;
	} else {
		GnonogramsCellState* _tmp3_;
		gint _tmp3__length1;
		GnonogramsCellState _tmp4_;
		_tmp3_ = self->priv->status;
		_tmp3__length1 = self->priv->status_length1;
		_tmp4_ = _tmp3_[cell];
		_tmp0_ = _tmp4_ == GNONOGRAMS_CELL_STATE_COMPLETED;
	}
	result = _tmp0_;
	return result;
}

static gboolean
gnonograms_region_totals_changed (GnonogramsRegion* self)
{
	gboolean changed = FALSE;
	gint _unknown = 0;
	gint _filled = 0;
	gint _completed = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	changed = FALSE;
	_unknown = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_UNKNOWN);
	_filled = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_FILLED);
	_completed = gnonograms_region_count_cell_state (self, (gint) GNONOGRAMS_CELL_STATE_COMPLETED);
	if (_unknown != self->priv->unknown) {
		gint _tmp0_;
		changed = TRUE;
		self->priv->unknown = _unknown;
		self->priv->filled = _filled;
		_tmp0_ = self->priv->_block_total;
		if ((_filled + _completed) > _tmp0_) {
			gint _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->_block_total;
			_tmp2_ = g_strdup_printf ("too many filled cells filled %i, completed %i, block total %i", _filled, _completed, _tmp1_);
			_tmp3_ = _tmp2_;
			gnonograms_region_record_error (self, "totals changed", _tmp3_);
			_g_free0 (_tmp3_);
		} else {
			if (self->priv->unknown == 0) {
				gint _tmp4_;
				_tmp4_ = self->priv->_block_total;
				if ((_filled + _completed) < _tmp4_) {
					gint _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					_tmp5_ = self->priv->_block_total;
					_tmp6_ = g_strdup_printf ("too few filled cells filled %i, completed %i, block total %i", _filled, _completed, _tmp5_);
					_tmp7_ = _tmp6_;
					gnonograms_region_record_error (self, "totals changed", _tmp7_);
					_g_free0 (_tmp7_);
				} else {
					if (gnonograms_region_match_clue (self)) {
						gnonograms_region_set_is_completed (self, TRUE);
					} else {
						gchar* _tmp8_;
						gnonograms_region_set_in_error (self, TRUE);
						_tmp8_ = g_strdup ("totals_changed");
						_g_free0 (self->message);
						self->message = _tmp8_;
						result = FALSE;
						return result;
					}
				}
			}
		}
	}
	result = changed;
	return result;
}

static void
gnonograms_region_get_status (GnonogramsRegion* self)
{
	GnonogramsMy2DCellArray* _tmp0_;
	guint _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->grid;
	_tmp1_ = self->priv->_index;
	_tmp2_ = self->priv->_is_column;
	gnonograms_my2_dcell_array_get_array (_tmp0_, _tmp1_, _tmp2_, &self->priv->temp_status, (gint*) (&self->priv->temp_status_length1), (guint) 0);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				GnonogramsCellState* _tmp6_;
				gint _tmp6__length1;
				GnonogramsCellState _tmp7_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->_n_cells;
				if (!(i < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->temp_status;
				_tmp6__length1 = self->priv->temp_status_length1;
				_tmp7_ = _tmp6_[i];
				switch (_tmp7_) {
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						gboolean* _tmp8_;
						gint _tmp8__length1;
						gint _tmp8__length2;
						gboolean _tmp9_;
						_tmp8_ = self->priv->tags;
						_tmp8__length1 = self->priv->tags_length1;
						_tmp8__length2 = self->priv->tags_length2;
						_tmp9_ = _tmp8_[(i * _tmp8__length2) + self->priv->can_be_empty_pointer];
						if (!_tmp9_) {
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							_tmp10_ = g_strdup_printf ("%i", i);
							_tmp11_ = _tmp10_;
							_tmp12_ = g_strconcat ("cell ", _tmp11_, NULL);
							_tmp13_ = _tmp12_;
							_tmp14_ = g_strconcat (_tmp13_, " cannot be empty", NULL);
							_tmp15_ = _tmp14_;
							gnonograms_region_record_error (self, "get_status", _tmp15_);
							_g_free0 (_tmp15_);
							_g_free0 (_tmp13_);
							_g_free0 (_tmp11_);
						} else {
							GnonogramsCellState* _tmp16_;
							gint _tmp16__length1;
							_tmp16_ = self->priv->status;
							_tmp16__length1 = self->priv->status_length1;
							_tmp16_[i] = GNONOGRAMS_CELL_STATE_EMPTY;
						}
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						GnonogramsCellState* _tmp17_;
						gint _tmp17__length1;
						GnonogramsCellState _tmp18_;
						GnonogramsCellState* _tmp25_;
						gint _tmp25__length1;
						GnonogramsCellState _tmp26_;
						_tmp17_ = self->priv->status;
						_tmp17__length1 = self->priv->status_length1;
						_tmp18_ = _tmp17_[i];
						if (_tmp18_ == GNONOGRAMS_CELL_STATE_EMPTY) {
							gchar* _tmp19_;
							gchar* _tmp20_;
							gchar* _tmp21_;
							gchar* _tmp22_;
							gchar* _tmp23_;
							gchar* _tmp24_;
							_tmp19_ = g_strdup_printf ("%i", i);
							_tmp20_ = _tmp19_;
							_tmp21_ = g_strconcat ("cell ", _tmp20_, NULL);
							_tmp22_ = _tmp21_;
							_tmp23_ = g_strconcat (_tmp22_, " cannot be filled", NULL);
							_tmp24_ = _tmp23_;
							gnonograms_region_record_error (self, "get_status", _tmp24_);
							_g_free0 (_tmp24_);
							_g_free0 (_tmp22_);
							_g_free0 (_tmp20_);
						}
						_tmp25_ = self->priv->status;
						_tmp25__length1 = self->priv->status_length1;
						_tmp26_ = _tmp25_[i];
						if (_tmp26_ == GNONOGRAMS_CELL_STATE_UNKNOWN) {
							GnonogramsCellState* _tmp27_;
							gint _tmp27__length1;
							_tmp27_ = self->priv->status;
							_tmp27__length1 = self->priv->status_length1;
							_tmp27_[i] = GNONOGRAMS_CELL_STATE_FILLED;
						}
						break;
					}
					default:
					{
						break;
					}
				}
				gnonograms_region_status_to_tags (self);
			}
		}
	}
}

static void
gnonograms_region_put_status (GnonogramsRegion* self)
{
	GnonogramsMy2DCellArray* _tmp9_;
	guint _tmp10_;
	gboolean _tmp11_;
	GnonogramsCellState* _tmp12_;
	gint _tmp12__length1;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState _tmp3_ = 0;
				GnonogramsCellState* _tmp4_;
				gint _tmp4__length1;
				GnonogramsCellState _tmp5_;
				GnonogramsCellState* _tmp8_;
				gint _tmp8__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp4_ = self->priv->status;
				_tmp4__length1 = self->priv->status_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ == GNONOGRAMS_CELL_STATE_COMPLETED) {
					_tmp3_ = GNONOGRAMS_CELL_STATE_FILLED;
				} else {
					GnonogramsCellState* _tmp6_;
					gint _tmp6__length1;
					GnonogramsCellState _tmp7_;
					_tmp6_ = self->priv->status;
					_tmp6__length1 = self->priv->status_length1;
					_tmp7_ = _tmp6_[i];
					_tmp3_ = _tmp7_;
				}
				_tmp8_ = self->priv->temp_status2;
				_tmp8__length1 = self->priv->temp_status2_length1;
				_tmp8_[i] = _tmp3_;
			}
		}
	}
	_tmp9_ = self->priv->grid;
	_tmp10_ = self->priv->_index;
	_tmp11_ = self->priv->_is_column;
	_tmp12_ = self->priv->temp_status2;
	_tmp12__length1 = self->priv->temp_status2_length1;
	gnonograms_my2_dcell_array_set_array (_tmp9_, _tmp10_, _tmp11_, _tmp12_, (gint) _tmp12__length1, (guint) 0);
}

static void
gnonograms_region_status_to_tags (GnonogramsRegion* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GnonogramsCellState* _tmp3_;
				gint _tmp3__length1;
				GnonogramsCellState _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp3_ = self->priv->status;
				_tmp3__length1 = self->priv->status_length1;
				_tmp4_ = _tmp3_[i];
				switch (_tmp4_) {
					case GNONOGRAMS_CELL_STATE_COMPLETED:
					{
						gboolean* _tmp5_;
						gint _tmp5__length1;
						gint _tmp5__length2;
						gboolean* _tmp6_;
						gint _tmp6__length1;
						gint _tmp6__length2;
						_tmp5_ = self->priv->tags;
						_tmp5__length1 = self->priv->tags_length1;
						_tmp5__length2 = self->priv->tags_length2;
						_tmp5_[(i * _tmp5__length2) + self->priv->is_finished_pointer] = TRUE;
						_tmp6_ = self->priv->tags;
						_tmp6__length1 = self->priv->tags_length1;
						_tmp6__length2 = self->priv->tags_length2;
						_tmp6_[(i * _tmp6__length2) + self->priv->can_be_empty_pointer] = FALSE;
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						gboolean* _tmp7_;
						gint _tmp7__length1;
						gint _tmp7__length2;
						_tmp7_ = self->priv->tags;
						_tmp7__length1 = self->priv->tags_length1;
						_tmp7__length2 = self->priv->tags_length2;
						_tmp7_[(i * _tmp7__length2) + self->priv->can_be_empty_pointer] = FALSE;
						break;
					}
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						gboolean* _tmp11_;
						gint _tmp11__length1;
						gint _tmp11__length2;
						gboolean* _tmp12_;
						gint _tmp12__length1;
						gint _tmp12__length2;
						{
							gint j = 0;
							j = 0;
							{
								gboolean _tmp8_ = FALSE;
								_tmp8_ = TRUE;
								while (TRUE) {
									gboolean* _tmp10_;
									gint _tmp10__length1;
									gint _tmp10__length2;
									if (!_tmp8_) {
										gint _tmp9_;
										_tmp9_ = j;
										j = _tmp9_ + 1;
									}
									_tmp8_ = FALSE;
									if (!(j < self->priv->n_blocks)) {
										break;
									}
									_tmp10_ = self->priv->tags;
									_tmp10__length1 = self->priv->tags_length1;
									_tmp10__length2 = self->priv->tags_length2;
									_tmp10_[(i * _tmp10__length2) + j] = FALSE;
								}
							}
						}
						_tmp11_ = self->priv->tags;
						_tmp11__length1 = self->priv->tags_length1;
						_tmp11__length2 = self->priv->tags_length2;
						_tmp11_[(i * _tmp11__length2) + self->priv->can_be_empty_pointer] = TRUE;
						_tmp12_ = self->priv->tags;
						_tmp12__length1 = self->priv->tags_length1;
						_tmp12__length2 = self->priv->tags_length2;
						_tmp12_[(i * _tmp12__length2) + self->priv->is_finished_pointer] = TRUE;
						break;
					}
					default:
					{
						break;
					}
				}
			}
		}
	}
}

static void
gnonograms_region_tags_to_status (GnonogramsRegion* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gboolean _tmp3_ = FALSE;
				GnonogramsCellState* _tmp4_;
				gint _tmp4__length1;
				GnonogramsCellState _tmp5_;
				GnonogramsCellState* _tmp9_;
				gint _tmp9__length1;
				GnonogramsCellState _tmp10_;
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gboolean _tmp12_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_n_cells;
				if (!(i < _tmp2_)) {
					break;
				}
				_tmp4_ = self->priv->status;
				_tmp4__length1 = self->priv->status_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ == GNONOGRAMS_CELL_STATE_FILLED) {
					gboolean* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					gboolean _tmp7_;
					_tmp6_ = self->priv->tags;
					_tmp6__length1 = self->priv->tags_length1;
					_tmp6__length2 = self->priv->tags_length2;
					_tmp7_ = _tmp6_[(i * _tmp6__length2) + self->priv->is_finished_pointer];
					_tmp3_ = _tmp7_;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					GnonogramsCellState* _tmp8_;
					gint _tmp8__length1;
					_tmp8_ = self->priv->status;
					_tmp8__length1 = self->priv->status_length1;
					_tmp8_[i] = GNONOGRAMS_CELL_STATE_COMPLETED;
				}
				_tmp9_ = self->priv->status;
				_tmp9__length1 = self->priv->status_length1;
				_tmp10_ = _tmp9_[i];
				if (_tmp10_ != GNONOGRAMS_CELL_STATE_UNKNOWN) {
					continue;
				}
				_tmp11_ = self->priv->tags;
				_tmp11__length1 = self->priv->tags_length1;
				_tmp11__length2 = self->priv->tags_length2;
				_tmp12_ = _tmp11_[(i * _tmp11__length2) + self->priv->can_be_empty_pointer];
				if (!_tmp12_) {
					GnonogramsCellState _tmp13_ = 0;
					gboolean* _tmp14_;
					gint _tmp14__length1;
					gint _tmp14__length2;
					gboolean _tmp15_;
					GnonogramsCellState* _tmp16_;
					gint _tmp16__length1;
					_tmp14_ = self->priv->tags;
					_tmp14__length1 = self->priv->tags_length1;
					_tmp14__length2 = self->priv->tags_length2;
					_tmp15_ = _tmp14_[(i * _tmp14__length2) + self->priv->is_finished_pointer];
					if (_tmp15_) {
						_tmp13_ = GNONOGRAMS_CELL_STATE_COMPLETED;
					} else {
						_tmp13_ = GNONOGRAMS_CELL_STATE_FILLED;
					}
					_tmp16_ = self->priv->status;
					_tmp16__length1 = self->priv->status_length1;
					_tmp16_[i] = _tmp13_;
					continue;
				}
				if (gnonograms_region_count_possible_owners_and_can_be_empty (self, i) <= 1) {
					GnonogramsCellState* _tmp17_;
					gint _tmp17__length1;
					gboolean* _tmp18_;
					gint _tmp18__length1;
					gint _tmp18__length2;
					_tmp17_ = self->priv->status;
					_tmp17__length1 = self->priv->status_length1;
					_tmp17_[i] = GNONOGRAMS_CELL_STATE_EMPTY;
					_tmp18_ = self->priv->tags;
					_tmp18__length1 = self->priv->tags_length1;
					_tmp18__length2 = self->priv->tags_length2;
					_tmp18_[(i * _tmp18__length2) + self->priv->is_finished_pointer] = TRUE;
				}
			}
		}
	}
}

static void
gnonograms_region_record_error (GnonogramsRegion* self,
                                const gchar* method,
                                const gchar* errmessage)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	guint _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (errmessage != NULL);
	gnonograms_region_set_in_error (self, TRUE);
	_tmp1_ = self->priv->_is_column;
	if (_tmp1_) {
		_tmp0_ = "COL";
	} else {
		_tmp0_ = "ROW";
	}
	_tmp2_ = self->priv->_index;
	_tmp3_ = g_strdup_printf ("%s Region %u Record error in %s : %s \n", _tmp0_, _tmp2_, method, errmessage);
	_g_free0 (self->message);
	self->message = _tmp3_;
}

gboolean
gnonograms_region_get_is_column (GnonogramsRegion* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_column;
	return result;
}

static void
gnonograms_region_set_is_column (GnonogramsRegion* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_column = value;
}

gboolean
gnonograms_region_get_in_error (GnonogramsRegion* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_in_error;
	return result;
}

static void
gnonograms_region_set_in_error (GnonogramsRegion* self,
                                gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_in_error = value;
}

gboolean
gnonograms_region_get_is_completed (GnonogramsRegion* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_completed;
	return result;
}

static void
gnonograms_region_set_is_completed (GnonogramsRegion* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_completed = value;
}

guint
gnonograms_region_get_index (GnonogramsRegion* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_index;
	return result;
}

static void
gnonograms_region_set_index (GnonogramsRegion* self,
                             guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_index = value;
}

gint
gnonograms_region_get_n_cells (GnonogramsRegion* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_n_cells;
	return result;
}

static void
gnonograms_region_set_n_cells (GnonogramsRegion* self,
                               gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_n_cells = value;
}

gint
gnonograms_region_get_block_total (GnonogramsRegion* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_block_total;
	return result;
}

static void
gnonograms_region_set_block_total (GnonogramsRegion* self,
                                   gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_block_total = value;
}

guint
gnonograms_region_get_value_as_permute_region (GnonogramsRegion* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	if (self->priv->_value_as_permute_region == G_MAXUINT) {
		self->priv->_value_as_permute_region = gnonograms_region_calc_value_as_permute_region (self);
	}
	result = self->priv->_value_as_permute_region;
	return result;
}

void
gnonograms_region_set_value_as_permute_region (GnonogramsRegion* self,
                                               guint value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (self->priv->_value_as_permute_region < G_MAXUINT) {
		_tmp0_ = self->priv->_value_as_permute_region > ((guint) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		self->priv->_value_as_permute_region = (guint) 0;
	}
}

static void
gnonograms_value_region_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_value_region_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_region_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_value_region_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_region_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_value_region_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_value_region_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsRegion * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_region_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_value_region_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	GnonogramsRegion ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_region_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gnonograms_param_spec_region (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	GnonogramsParamSpecRegion* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_TYPE_REGION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gnonograms_value_get_region (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_REGION), NULL);
	return value->data[0].v_pointer;
}

void
gnonograms_value_set_region (GValue* value,
                             gpointer v_object)
{
	GnonogramsRegion * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_REGION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_TYPE_REGION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_region_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_region_unref (old);
	}
}

void
gnonograms_value_take_region (GValue* value,
                              gpointer v_object)
{
	GnonogramsRegion * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_TYPE_REGION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_TYPE_REGION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_region_unref (old);
	}
}

static void
gnonograms_region_class_init (GnonogramsRegionClass * klass,
                              gpointer klass_data)
{
	gnonograms_region_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsRegionClass *) klass)->finalize = gnonograms_region_finalize;
	g_type_class_adjust_private_offset (klass, &GnonogramsRegion_private_offset);
}

static void
gnonograms_region_instance_init (GnonogramsRegion * self,
                                 gpointer klass)
{
	self->priv = gnonograms_region_get_instance_private (self);
	self->priv->_in_error = FALSE;
	self->priv->_is_completed = FALSE;
	self->priv->_value_as_permute_region = G_MAXUINT;
	self->priv->unchanged_count = 0;
	self->priv->debugging = FALSE;
	self->ref_count = 1;
}

static void
gnonograms_region_finalize (GnonogramsRegion * obj)
{
	GnonogramsRegion * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_REGION, GnonogramsRegion);
	g_signal_handlers_destroy (self);
	_g_free0 (self->message);
	_g_object_unref0 (self->priv->grid);
	self->priv->completed_blocks = (g_free (self->priv->completed_blocks), NULL);
	self->priv->completed_blocks_backup = (g_free (self->priv->completed_blocks_backup), NULL);
	self->priv->tags = (g_free (self->priv->tags), NULL);
	self->priv->tags_backup = (g_free (self->priv->tags_backup), NULL);
	self->priv->status = (g_free (self->priv->status), NULL);
	self->priv->temp_status = (g_free (self->priv->temp_status), NULL);
	self->priv->temp_status2 = (g_free (self->priv->temp_status2), NULL);
	self->priv->status_backup = (g_free (self->priv->status_backup), NULL);
	self->priv->blocks = (g_free (self->priv->blocks), NULL);
	self->priv->ranges = (g_free (self->priv->ranges), NULL);
	self->priv->ranges_backup = (g_free (self->priv->ranges_backup), NULL);
	_g_free0 (self->priv->clue);
}

/** A region consists of a one dimensional array of cells, corresponding
 *  to a row or column of the puzzle. Associated with this are:
 *
  1) A list of block lengths (clues)
  2) A 'tag' bool array for each cell with
    *   a flag for each block indicating whether that block is still a possible owner
    *   two extra flags  - ' is completed' and ' can be empty'
  3) A 'completed blocks' bool array with
    *   a flag for each block indicating whether it is completed.
  4) A status array, one per cell indicating the status of that cell as either
    * UNKNOWN,
    * FILLED (but not necessarily assigned to a completed block),
    * EMPTY, or
    * COMPLETED (assigned to a completed block).
    *
  5) Can save and restore its state  - used to implement (one level)
     back tracking during trial and error solution ('advanced solver').

  6) Re-used if grid dimensions do not change.

**/
GType
gnonograms_region_get_type (void)
{
	static volatile gsize gnonograms_region_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_region_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gnonograms_value_region_init, gnonograms_value_region_free_value, gnonograms_value_region_copy_value, gnonograms_value_region_peek_pointer, "p", gnonograms_value_region_collect_value, "p", gnonograms_value_region_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnonogramsRegionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_region_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsRegion), 0, (GInstanceInitFunc) gnonograms_region_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gnonograms_region_type_id;
		gnonograms_region_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsRegion", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GnonogramsRegion_private_offset = g_type_add_instance_private (gnonograms_region_type_id, sizeof (GnonogramsRegionPrivate));
		g_once_init_leave (&gnonograms_region_type_id__volatile, gnonograms_region_type_id);
	}
	return gnonograms_region_type_id__volatile;
}

gpointer
gnonograms_region_ref (gpointer instance)
{
	GnonogramsRegion * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gnonograms_region_unref (gpointer instance)
{
	GnonogramsRegion * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_REGION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

